''' $Header:$
''' 
''' $Log:$
.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
'''
'''     Set up \*(-- to give an unbreakable dash;
'''     string Tr holds user defined translation string.
'''     Bell System Logo is used as a dummy character.
'''
.ie n \{\
.tr \(bs-\*(Tr
.ds -- \(bs-
.if (\n(.H=4u)&(1m=24u) .ds -- \(bs\h'-12u'\(bs\h'-12u'-\" diablo 10 pitch
.if (\n(.H=4u)&(1m=20u) .ds -- \(bs\h'-12u'\(bs\h'-8u'-\" diablo 12 pitch
.ds L" ""
.ds R" ""
.ds L' '
.ds R' '
'br\}
.el\{\
.ds -- \(em\|
.tr \*(Tr
.ds L" ``
.ds R" ''
.ds L' `
.ds R' '
'br\}
.TH LSACL 1 LOCAL
.SH NAME
lsacl - list the access control lists for files
.SH SYNOPSIS
.B lsacl
file ...
.SH DESCRIPTION
.I lsacl
lists the access control lists for one or more files.  The access control list
and the file's ownership are used to determine which users can access
the file.
.PP
For each file,
.I lsacl
prints the file name alone on a line.  Following that,
.I lsacl
prints the access control list entries, one per line.  The entries are
indented by a tab to make them easily distinguishable from the file name.
Each entry has a user or group name, and the mode granted to
that user or group.  The mode is a single digit in the range [0-7],
indicating read-write-execute permission ala
.IR chmod .
.SH DIAGNOSTICS
.I lsacl
returns with exit status 0 if all is well;  or with exit status greater
than 0 if it cannot get the access control lists for some files.
.SH SEE ALSO
chacl(1),
cpacl(1),
edacl(1),
getacl(2),
setacl(2)
.SH CAVEAT
The implementation of access control lists is an experiment.  This
implementation stores the access control list in a (formerly) unused field
in the inode.
There is no guarantee that future versions of Unix will not use this field
for something else.
.PP
Therefore, you should only use access control lists with the full
understanding that you are participating in an experiment.
.SH BUGS
The entire mechanism hasn't been fully tested.
.PP
It might be nice if the mode were given symbolically ("rwx" instead
of "7").
.PP
.I lsacl
should become yet another option to
.IR ls .
