%{
/**************************************************************************/
/*                 Ada for SCRIBE PRINTER                                 */
/**************************************************************************/
/*------------------------------------------------------------------------*/
/* Lexical input for LEX for LALR(1) Grammar for ANSI Ada                 */
/*                                                                        */
/*              Herman Fischer                                            */
/*            Litton Data Systems                                         */
/*              March 26, 1984                                            */
/*                                                                        */
/*------------------------------------------------------------------------*/
	int	my_start   = 0; /* indicates that it's startup time       */
	int	ignore_next_subprog = 0;  /* when in a generic parameter  */
					  /* declaration, indicates that  */
					  /* the next subprogram is a     */
					  /* formal parameter, and not    */
					  /* the actual generic thing.    */
	int	funct_defn = 0;  /* indicates that this return is part    */
				 /* of a function declaration, and should */
				 /* not be capitalized			  */ 
	char	class[20];
#include "stdio.h"
#include "ctype.h"
%}

%e      3500  /* tree nodes array size    */
%p      9500  /* positions                */
%a      10000  /* transitions array size   */
%k      500   /* packed character classes */
%o      10000  /* output array size        */
%n	2000   /* states ?!		  */

%START IDENT Z COMMENT OTHERCMT PRAGMA KEEPNAME GENERICSPEC

%%
 	{BEGIN Z;}
<Z,IDENT>(ABORT|abort)|(ABS|abs)|(ACCEPT|accept)|(ACCESS|access)	|
<Z,IDENT>(ALL|all)|(AND|and)|(ARRAY|array)|(AT|at)			|
<Z,IDENT>(BEGIN|begin)|(BODY|body)|(CASE|case)|(CONSTANT|constant)	|
<Z,IDENT>(DECLARE|declare)|(DELAY|delay)|(DELTA|delta)|(DIGITS|digits)	|
<Z,IDENT>(DO|do)|(ELSE|else)|(ELSIF|elsif)|(END|end)|(ENTRY|entry)	|
<Z,IDENT>(EXCEPTION|exception)|(FOR|for)				|
<Z,IDENT>(IF|if)|(IN|in)|(IS|is)|(LIMITED|limited)|(LOOP|loop)		|
<Z,IDENT>(MOD|mod)|(NEW|new)|(NOT|not)|(NULL|null)|(OF|of)|(OR|or)	|
<Z,IDENT>(OTHERS|others)|(OUT|out)|(PRIVATE|private)			|
<Z,IDENT>(RANGE|range)|(RECORD|record)|(REM|rem)			|
<Z,IDENT>(RENAMES|renames)|(REVERSE|reverse)				|
<Z,IDENT>(SELECT|select)|(SEPARATE|separate)				|
<Z,IDENT>(TERMINATE|terminate)|(THEN|then)|(USE|use)			|
<Z,IDENT>(WHEN|when)|(WHILE|while)|(XOR|xor)				{
			MAKELOWER(yytext); hilite(yytext); BEGIN Z;	}

<Z,IDENT>(WITH|with)							{
			printf("\n@newpage\n");
			MAKELOWER(yytext); hilite(yytext);
			BEGIN Z;					}


<Z,IDENT>(GOTO|goto)|(EXIT|exit)|(RAISE|raise)				{
			MAKEUPPER(yytext); hilite(yytext); BEGIN Z;	}

<Z,IDENT>(RETURN|return)						{
			if (funct_defn) 
				funct_defn = 0;
			 else   {MAKEUPPER(yytext);
				 funct_defn = 0;};
			hilite(yytext); BEGIN Z;			}

<Z,IDENT>("=>")|("..")|("**")|(":=")|("/=")|(">=")|("<=")|("<<")	|
<Z,IDENT>(">>")|("<>")|("&")|("(")|("*")|("+")|(",")|("-")|(".")	|
<Z,IDENT>("/")|(":")|(";")|("<")|("=")|(">")|("|")			{
						ECHO; BEGIN Z;		}

<Z,IDENT>")"     		{ECHO; BEGIN IDENT;}

"\t"				{unput('\'); unput('@');}

<Z,IDENT>(PRAGMA|pragma)	{
				MAKELOWER(yytext);
				hilite(yytext);
				BEGIN PRAGMA;
				}

<PRAGMA>[" "(@\)]+(PAGE|page)[ (@\)]*;	{
					ECHO;
					printf("\n@newpage\n");
					BEGIN Z;
					}

<PRAGMA>.			{
				unput(yytext[0]);
				BEGIN Z;
				}

<Z,IDENT>TYPE|type		|
<Z,IDENT>SUBTYPE|subtype	|
<Z,IDENT>TASK|task		|
<Z,IDENT>(PROCEDURE|procedure)	|
<Z,IDENT>(PACKAGE|package) 	{
				MAKELOWER(yytext);
				hilite(yytext); strcpy(class, yytext);
				BEGIN KEEPNAME;}


<Z,IDENT>(FUNCTION|function)	{
				MAKELOWER(yytext);
				hilite(yytext); strcpy(class, yytext);
				funct_defn = 1;
				BEGIN KEEPNAME;}


<KEEPNAME>[a-zA-Z][a-z_A-Z0-9]*       {
				ECHO; printf("@index(%s, %s)", yytext, class);
           printf("@indexsecondary(primary=%s, secondary=%s)", class, yytext);
				BEGIN Z;}

<Z,IDENT>(GENERIC|generic)	{
				MAKELOWER(yytext); hilite(yytext); 
				BEGIN GENERICSPEC;}

<GENERICSPEC>(WITH|with)						{
				MAKELOWER(yytext); hilite(yytext);
				ignore_next_subprog = 1;}

<GENERICSPEC>(PROCEDURE|procedure)|(FUNCTION|function)			{
				MAKELOWER(yytext); hilite(yytext);
				{if (ignore_next_subprog)
					ignore_next_subprog = 0;
				 else {
				        {if (strcmp(yytext,"procedure"))
					    strcpy(class,"generic procedure");
					 else    
					    strcpy(class,"generic function");
					    funct_defn = 1;
					};
					ignore_next_subprog = 0;
					BEGIN KEEPNAME;
				       };
				};
									}

<GENERICSPEC>(PACKAGE|package)						{
				MAKELOWER(yytext); hilite(yytext);
				strcpy(class,"generic package");
				BEGIN KEEPNAME;}


<GENERICSPEC>(ACCESS|access)|(ARRAY|array)|(CONSTANT|constant)		|
<GENERICSPEC>(DELTA|delta)|(DIGITS|digits)|(IN|in)|(IS|is)		|
<GENERICSPEC>(LIMITED|limited)|(OF|of)|(OTHERS|others)|(OUT|out)	|
<GENERICSPEC>(PRIVATE|private)|(RANGE|range)|(RETURN|return)		|
<GENERICSPEC>(SUBTYPE|subtype)|(TYPE|type)				{
				MAKELOWER(yytext); hilite(yytext);	}

<GENERICSPEC>[a-zA-Z][a-z_A-Z0-9]*	{ECHO;}

<GENERICSPEC>.				{ECHO;}


<IDENT>\'  {ECHO; BEGIN Z;}   /* type mark only */

<Z,IDENT>[a-zA-Z][a-z_A-Z0-9]*       {ECHO; BEGIN IDENT; }

<Z,IDENT>[0-9][0-9_]*([.][0-9_]+)?([Ee][-+]?[0-9_]+)?  {
						         ECHO; BEGIN Z; }

<Z,IDENT>[0-9][0-9_]*#[0-9a-fA-F_]+([.][0-9a-fA-F_]+)?#([Ee][-+]?[0-9_]+)? {
			      ECHO; BEGIN Z; }

<Z,IDENT>\"([^\"]*(\"\")*)*\" {ECHO; BEGIN Z; }

<Z>\'([^\']|\'\')\'    {ECHO; BEGIN Z; }

<Z,IDENT>[" "(@\)]   {ECHO;}          /* ignore spaces and tabs */

<Z,IDENT>.       {ECHO; printf("?? lexical error [%s] ??\n(@\)", yytext);}

<Z,IDENT>"--"([" "(@\)]*)	{ECHO; BEGIN COMMENT;}

<COMMENT,OTHERCMT>"-"+	{ECHO;}
<COMMENT,OTHERCMT>[\n]	{ECHO; BEGIN Z;}

<COMMENT>(("Function"[" "(@\)]*":")|("Reference"[" "(@\)]*":"))		|
<COMMENT>(("History"[" "(@\)]*":")|("Exceptions"[" "(@\)]*":"))		|
<COMMENT>(("Authorization"[" "(@\)]*":")|("Pre-conditions"[" "(@\)]*":"))	|
<COMMENT>(("Post-conditions"[" "(@\)]*":")|("EXCEPTIONS"[" "(@\)]*":"))	{
				printf("@AdaCommentWord(%s)", yytext);
				BEGIN OTHERCMT;
									}

<COMMENT>.	{
		 unput(yytext[0]); 
		 BEGIN OTHERCMT;
		}

<OTHERCMT>.*	{
		 printf("@begin(AdaComment)%s@end(AdaComment)", yytext);
		 BEGIN Z;
		}

%%
hilite(it)	
	char 	*it;
{printf("@AdaResWord(%s)", it);}

MAKEUPPER(s)
	char	*s;
{
	for (; *s != NULL; ++s)
		*s = (islower(*s) ? toupper(*s) : *s);
}
MAKELOWER(s)
	char	*s;
{
	for (; *s != NULL; ++s)
		*s = (isupper(*s) ? tolower(*s) : *s);
}

