.TH killaport 1
.SH NAME
killaport \- manually kill an attachport
.SH SYNTAX
killaport
[
\fB\-ACHUVW\fI
]
port
.SH DESCRIPTION
.I killaport
kills the
.I attachport
serving
connections to
the given TCP
.I port,
provided you are
the owner of that
.I attachport
and
it is authenticated.
.PP
.I port
can be given as a name
or number.
.PP
The
.I attachport
won't actually die
until all its children have exited.
It will, however, wither away slowly,
not accepting any new connections on the port.
.PP
Options
.B ACHUVW
print the authorship notice,
copyright notice,
help notice,
short usage summary,
version number,
and warranty information respectively.
.SH FILES
/usr/etc/auth/tcp
Authentication directory
.SH "EXIT VALUE"
0 upon success;
1 for usage messages;
2 if
.I killaport
can't get into the authentication directory;
4 if you're not listed in your password file;
5 if nobody is authenticated on that port;
6 if the lock file is unreadable;
7 if the lock file is corrupted;
8 if the port is not an
.I attachport;
9 if the port belongs to someone else;
10 if the
.I attachport
has silently died;
11 if the
.I attachport
is unkillable for some other reason.
.SH DIAGNOSTICS
.TP
.I cannot change to directory
.I killaport
does not have access to the authentication directory.
.TP
.I who are you?
You're not listed in your password file.
.TP
.I cannot open lock file
There are no authenticated utilities running on that port.
.TP
.I cannot read lock file
Shouldn't happen.
.TP
.I corrupted lock file
Someone has attempted to breach
.I attachport
security on this port.
Report this condition to your system administrator.
.TP
.I port not owned by an attachport
Probably an
.I authtcp
is running on that port.
.TP
.I cannot kill port
The
.I attachport
belongs to somebody else.
.TP
.I port in trauma
Probably the machine crashed
and your machine's boot sequence
doesn't clear old authentications.
.TP
.I can't kill attachport?
This shouldn't happen.
.TP
.I port killed
Success.
.SH RESTRICTIONS
There's no way for anyone except root
to kill an attachport started with
.B\-X
and without
.B\-0.
.SH BUGS
None known.
.SH MACHINES
.I killaport
has been tested
on an Astronautics ZS-2 running ZSUnix.
.SH VERSION
killaport version 1.0, dated 4/23/90.
.SH AUTHOR
Copyright 1990, Daniel J. Bernstein.
.SH "SEE ALSO"
attachport(1),
listaport(1),
checkaport(8)
