/* tamdel version 1.0, 4/23/90. */

#include <stdio.h>
#include <sys/file.h>
#ifdef BSD
#include <limits.h>
#endif
#include <pwd.h>

#ifndef TAMDIR
#define TAMDIR "/usr/spool/tam"
#endif

#ifndef BUFSIZ
#define BUFSIZ 1024
#endif

main()
{
 struct passwd *pw;
 char path[sizeof(TAMDIR) + 11];
 char pathnew[sizeof(TAMDIR) + 16];
 int fd;
 int fdnew;
 char buf[BUFSIZ];
 int r;

 if (!(pw = getpwuid(getuid())))
  {
   fprintf(stderr,"tamdel: fatal: who are you?\n");
   exit(1);
  }
 (void) sprintf(path,"%s/%s",TAMDIR,pw->pw_name);
 if ((fd = open(path,O_RDONLY)) == -1)
  {
   perror("tamdel: fatal: can't read tam spool file");
   exit(2);
  }
 if (flock(fd,LOCK_EX) == -1)
  {
   perror("tamdel: fatal: can't lock tam spool file");
   exit(3);
  }

 while ((r = read(fd,buf,sizeof(buf))) > 0)
   if (write(1,buf,r) < r)
    {
     /* This may happen, incorrectly, if the output is nonblocking. */
     /* We assume the usual convention that you never pass nonblocking fds. */
     perror("tamdel: fatal: write error");
     exit(5);
    }
 if (r < 0)
  {
   perror("tamdel: fatal: read error");
   exit(4);
  }
 else
  {
   (void) sprintf(pathnew,"%s/%s.new!",TAMDIR,pw->pw_name);
   if ((fdnew = open(pathnew,O_WRONLY | O_CREAT | O_EXCL,0600)) == -1)
    {
     perror("tamdel: fatal: can't create new tam spool file");
     exit(6);
    }
   if (rename(pathnew,path) == -1)
    {
     perror("tamdel: fatal: can't recreate tam spool file");
     (void) unlink(pathnew);
     exit(7);
    }
  }
 exit(0);
}
