%{

/*
 * This program has been written by Kannan Varadhan.  You are welcome to
 * use, copy, modify, or circulate as you please, provided you do not
 * charge any fee for any of it, and you do not remove these header
 * comments from any of these files.
 *
 *		-- kva	Mon Dec  4 11:26:37 EST 1989
 */

#include	"bibc.h"
#undef	YY_INPUT
#define	YY_INPUT(buf,reslt,msize)	my_input (buf, &reslt, msize)

my_input (buf,reslt, size)
char	*buf;
int	*reslt;
int	size;

{
char	inputln[80];

	bzero (inputln, 80);
	if (! GETS (inputln, 80))
	  Strcpy (buf, "EOF");
	else
	  Strncpy (buf, inputln, size);
	Strcat (buf, "!");
#ifdef	FLEX_DEBUG
	Fprintf (stderr, "buf contains: %s\n", buf);
#endif
	return *reslt = strlen (buf);
}


my_yylex ()

{
#define	PROMPTSTR			"\
What kind of record would you like to enter (one of the following)?\n\
	article		book		booklet		conference\n\
	inbook		incollection	inproceedings	manual\n\
	mastersthesis	msthesis	misc		phdthesis\n\
	proceedings	techreport	unpublished\n\
or	EDIT		quit\n"
	
	Fprintf (stderr, PROMPTSTR);
	return yylex ();
}

%}

%%
"a!"		return ARTICLE;
"ar!"		return ARTICLE;
"art!"		return ARTICLE;
"arti!"		return ARTICLE;
"artic!"		return ARTICLE;
"articl!"		return ARTICLE;
"article!"		return ARTICLE;
"book!"		return BOOK;
"bookl!"		return BOOKLET;
"bookle!"		return BOOKLET;
"booklet!"		return BOOKLET;
"c!"		return CONFERENCE;
"co!"		return CONFERENCE;
"con!"		return CONFERENCE;
"conf!"		return CONFERENCE;
"confe!"		return CONFERENCE;
"confer!"		return CONFERENCE;
"confere!"		return CONFERENCE;
"conferen!"		return CONFERENCE;
"conferenc!"		return CONFERENCE;
"conference!"		return CONFERENCE;
"inb!"		return INBOOK;
"inbo!"		return INBOOK;
"inboo!"		return INBOOK;
"inbook!"		return INBOOK;
"inc!"		return INCOLLECTION;
"inco!"		return INCOLLECTION;
"incol!"		return INCOLLECTION;
"incoll!"		return INCOLLECTION;
"incolle!"		return INCOLLECTION;
"incollec!"		return INCOLLECTION;
"incollect!"		return INCOLLECTION;
"incollecti!"		return INCOLLECTION;
"incollectio!"		return INCOLLECTION;
"incollection!"		return INCOLLECTION;
"inp!"		return INPROCEEDINGS;
"inpr!"		return INPROCEEDINGS;
"inpro!"		return INPROCEEDINGS;
"inproc!"		return INPROCEEDINGS;
"inproce!"		return INPROCEEDINGS;
"inprocee!"		return INPROCEEDINGS;
"inproceed!"		return INPROCEEDINGS;
"inproceedi!"		return INPROCEEDINGS;
"inproceedin!"		return INPROCEEDINGS;
"inproceeding!"		return INPROCEEDINGS;
"inproceedings!"		return INPROCEEDINGS;
"man!"		return MANUAL;
"manu!"		return MANUAL;
"manua!"		return MANUAL;
"manual!"		return MANUAL;
"mas!"		return MASTERSTHESIS;
"mast!"		return MASTERSTHESIS;
"maste!"		return MASTERSTHESIS;
"master!"		return MASTERSTHESIS;
"masters!"		return MASTERSTHESIS;
"masterst!"		return MASTERSTHESIS;
"mastersth!"		return MASTERSTHESIS;
"mastersthe!"		return MASTERSTHESIS;
"mastersthes!"		return MASTERSTHESIS;
"mastersthesi!"		return MASTERSTHESIS;
"mastersthesis!"		return MASTERSTHESIS;
"ms!"		return MASTERSTHESIS;
"mst!"		return MASTERSTHESIS;
"msth!"		return MASTERSTHESIS;
"msthe!"		return MASTERSTHESIS;
"msthes!"		return MASTERSTHESIS;
"msthesi!"		return MASTERSTHESIS;
"msthesis!"		return MASTERSTHESIS;
"mi!"		return MISC;
"mis!"		return MISC;
"misc!"		return MISC;
"ph!"		return PHDTHESIS;
"phd!"		return PHDTHESIS;
"phdt!"		return PHDTHESIS;
"phdth!"		return PHDTHESIS;
"phdthe!"		return PHDTHESIS;
"phdthes!"		return PHDTHESIS;
"phdthesi!"		return PHDTHESIS;
"phdthesis!"		return PHDTHESIS;
"pr!"		return PROCEEDINGS;
"pro!"		return PROCEEDINGS;
"proc!"		return PROCEEDINGS;
"proce!"		return PROCEEDINGS;
"procee!"		return PROCEEDINGS;
"procees!"		return PROCEEDINGS;
"proceesi!"		return PROCEEDINGS;
"proceesin!"		return PROCEEDINGS;
"proceesing!"		return PROCEEDINGS;
"proceesings!"		return PROCEEDINGS;
"t!"		return TECHREPORT;
"te!"		return TECHREPORT;
"tec!"		return TECHREPORT;
"tech!"		return TECHREPORT;
"techr!"		return TECHREPORT;
"techre!"		return TECHREPORT;
"techrep!"		return TECHREPORT;
"techrepo!"		return TECHREPORT;
"techrepor!"		return TECHREPORT;
"techreport!"		return TECHREPORT;
"u!"		return UNPUBLISHED;
"un!"		return UNPUBLISHED;
"unp!"		return UNPUBLISHED;
"unpu!"		return UNPUBLISHED;
"unpub!"		return UNPUBLISHED;
"unpubl!"		return UNPUBLISHED;
"unpubli!"		return UNPUBLISHED;
"unpublis!"		return UNPUBLISHED;
"unpublish!"		return UNPUBLISHED;
"unpublishe!"		return UNPUBLISHED;
"unpublished!"		return UNPUBLISHED;
"quit!"			return FLD_NULL;
"EOF!"			return FLD_NULL;
"EDIT!"			return FLD_EDITOR;
[a-zA-Z0-9]*!		return FLD_ERROR;
%%

