.\" @(#)bibtools.1 (beta version) Sept 15 89
.TH BIBTOOLS 1 "15 September 1989"
.SH NAME
.sp1
.nf
\fBbibtools\fP
	\fBbibc\fP \- Create BibTeX and scribe style bibliographies
	\fBbibv\fP \- Verify a series of BibTeX style bibliographies for
			citation conflicts
	\fBshbib\fP \- Display one or more records fromthe specified bib files
	\fBrmbib\fP \- Delete one or more records fromthe specified bib files
.fi
.SH SYNOPSIS
.sp1
.nf
\fBbibc\fP [-verify|-i] [-|+pester] [-|+verbose] [-file \fIfilename\fP] [-help]
\fBbibv\fP [-s <style>] [-h] [ \fIfilename\fP ... ]
\fBshbib\fP [-f|-g|-l] [-s] [-r] [-h] \fIregexp\fP [ \fIfilename\fP... ]
\fBrmbib\fP [-f|-g|-l] [-s] [-i] [-h] \fIregexp\fP [ \fIfilename\fP... ]
.fi
.SH DESCRIPTION
.sp 1
\fIbibc\fP (mnemonic for BIB-Creator) is a prompt based tool for
creating bibliographies in the BibTeX format.  \fIbibc\fP first queries the
user for the kind of record they wish to create.  \fIbibc\fP understands
the various fields required for the kind of record specified, and will
query the user for the values for each of these fields.  \fIbibc\fP can
distinguish between required and optional fields, and will, by default
insist once on the user specifying the required fields.

.nf
	Once it has obtained a complete record, it will write it to the
	file specified using the \fB-file\fP option, or to stdout.

	\fIbibc\fP's  insistence can be turned off by using the
	\fB-pester\fP flag.  Specifying \fB+pester\fP will reverse this
	flag.  Default is \fB+pester\fP.

	One can require \fIbibc\fP to confirm every record before it is
	entered into the bib-file by using the \fB-verify,\fP or
	\fB-i\fP option.  The default is "do not verify".

	If the \fB-verbose\fP option is specified, \fIbibc\fP will not echo the
	record to stdout.  \fB+verbose\fP will cause every record to be
	echoed.  Default is \fB+verbose\fP.

	The \fB-help\fP option causes \fIbibc\fP to print out a short usage
	summary, describing all the options available to it.
.fi

Typing a '?' will cause \fIbibc\fP to print out one or two lines of help about
the concerned field.  One can abort the current record, and restart a
new one by typing "xx" to a field.

A field that begins with a '\\' is assumed to flag a macro, and will
therefore not be quoted in the output.

Specifying "EDIT" (case is important here), will cause \fIbibc\fP to fork an
editor on the current file.  \fIbibc\fP will first attempt to fork off an
editor using the "TEXEDIT" environment variable.  Then, it will
sucessively try "VISUAL", and "EDITOR", failing which it will try to
fork off a default editor, fixed by your system administrator.

It is possible for a user to define a maximum of 5 fields for
themselves.  This is done by setting an environment variable called
\fBBIBCINIT\fP.  The syntax of this variable is similar to the MAILPATH
variable in ksh, and is 'FIELD1?help_string1:FIELD2?help_string2:...'
These fields are queried at the very end, the help_strings are the
strings put out when one types a '?' to get information on the specific
field.  By default, these fields are considered optional.

See the USAGE section for more help.

\fIbibv\fP (mnemonic for BIB Verifier) creates a small sample LaTeX file,
containing just citations for every entry in the bib files specified,
and runs this file sucessively through latex, bibtex, latex, latex to
produce bibtex.tex and bibtex.dvi files.  The run through bibtex causes
any duplicate citations to be flagged.  One can print the dvi file, and
get a hardcopy record of all the entries in the specified bib files.

.nf
	\fIbibv\fP uses a special kind of bst file, called
	\fBspecl\fP.  This style file causes the bibitem keys to be the
	same as the \\cite-keys that are used in the bib files
	themselves. This is a convenient style for keeping hardcopies
	of the bibliographies for reference.
	One can use the \fB-s\fP option to specify a different style to
	be used.

	The \fB-h\fP option causes a brief help message to get printed out.
.fi

\fIshbib\fP (mnemonic for SHow BIB entry) is used to view records in the
given bib files.  The records matching the specific regular expression
are printed on stdout.

.nf
	The \fB-f\fP option specifies that only the first matching record is
	to be printed out.  This is the default.

	The \fB-g\fP option specifies the all records matching the expression
	amongst all the files is to be printed out.  This is a mnemonic
	for "globally match".

	The \fB-l\fP option specifies that only the last matching record is
	to be  printed out.

	The \fB-r\fP option asks shbib to remove all records that get printed
	out, from the respective files.  Note that this option can be
	dangerous when used carelessly,  and is not always recommended.

	If more than one files is given to \fIshbib\fP, the file where the
	corresponding match is made is also echoed to stdout.  The \fB-s\fP
	option, for silent, asks \fIshbib\fP not to do this echoing.

	The \fI-h\fP option causes a brief help message to get printed out.
.fi

\fIrmbib\fP (mnemonic for ReMove BIB entry) is a tool to remove records
matching the given regular expression from the corresponding bib
files.  The records that are deleted are also echoed to stdout.

.nf
	The \fB-f\fP option, the default specifies that only the first
	matching record is to be deleted.

	The \fB-g\fP option, requires all matching records are to be deleted.

	The \fB-l\fP option requires that only the last matching record is to
	be deleted.

	The \fB-s\fP option asks \fIrmbib\fP not to echo the filename
	matched, if more than one bibfile has been specified.

	The \fB-i\fP option requires \fIrmbib\fP to inquire the user before
	deleting any record.

	The \fB-h\fP option causes a brief help message to get printed out.
.fi

.sp1
.SH USAGE
.sp1

See the sample walkthrough of usage of \fIbibc\fP, and a brief use of
\fIshbib\fP.  \fBBold\fP lettering indicates characters that the user
types in.

.nf
Script started on Sun Dec  3 00:47:28 1989
cheops Bibcreate. \fBbibc -help\fP
Usage: bibc [-i|-verify] [+|-verbose] [+|-pester] [-file <filename>] [-help]
	-i			Inquire whether to commit a record
	-verify			Same as above, a duplicate form
	-verbose		Turn off verbose flag
	+verbose		Turn on verbose flag
	-pester			Do not insist, even for required fields
	+pester			Insist once for required fields
	-file <filename>	Output bib entries to <filename>
	-help			Print this help output
cheops Bibcreate. \fBbibc -file foo.bib\fP
What kind of record would you like to enter (one of the following)?
	article		book		booklet		conference
	inbook		incollection	inproceedings	manual
	mastersthesis	msthesis	misc		phdthesis
	proceedings	techreport	unpublished
or	EDIT		quit
\fBinb\fP
CITEKEY? \fBNAR88\fP
AUTHOR? \fBNarayan, R. K.\fP
TITLE? \fBA Writer's Nightmare\fP
CHAPTER? 
ERROR: CHAPTER is a REQUIRED FIELD for INBOOK. Let's try that again...sigh...
CHAPTER? 
ERROR: Frankly my dear, I don't give a damn...
PAGES (optional)? \fB164--166\fP
PUBLISHER? \fBPenguin Books\fP
YEAR? \fB1988\fP
VOLUME (optional)? \fB1\fP
SERIES (optional)? 
ADDRESS (optional)? 
EDITION (optional)? 
MONTH (optional)? 
NOTE (optional)? 
KEY (optional)? \fB?\fP
Used for alphabetising and creating a label when the author and
  editor fields are missing.
KEY (optional)? 
COMMENT (optional)? 
CROSS-REFERENCE (optional)? 
@INBOOK { NAR88 ,
	AUTHOR = "Narayan, R. K." ,
	PAGES = "164--166" ,
	PUBLISHER = "Penguin Books" ,
	TITLE = "A Writer's Nightmare" ,
	VOLUME = "1" ,
	YEAR = "1988"
	}

What kind of record would you like to enter (one of the following)?
	article		book		booklet		conference
	inbook		incollection	inproceedings	manual
	mastersthesis	msthesis	misc		phdthesis
	proceedings	techreport	unpublished
or	EDIT		quit
\fBin\fP
Uh oh! no no no
What kind of record would you like to enter (one of the following)?
	article		book		booklet		conference
	inbook		incollection	inproceedings	manual
	mastersthesis	msthesis	misc		phdthesis
	proceedings	techreport	unpublished
or	EDIT		quit
\fBmi\fP
CITEKEY? \fBxx\fP
Abort? [y|n] \fBy\fP
What kind of record would you like to enter (one of the following)?
	article		book		booklet		conference
	inbook		incollection	inproceedings	manual
	mastersthesis	msthesis	misc		phdthesis
	proceedings	techreport	unpublished
or	EDIT		quit
\fB^D\fP
cheops Bibcreate. \fBBIBCINIT="USR_FIELD1:USR_FIELD2?Bah Humbug" export BIBCINIT\fP
cheops Bibcreate. \fBbibc -file foo.bib\fP
What kind of record would you like to enter (one of the following)?
	article		book		booklet		conference
	inbook		incollection	inproceedings	manual
	mastersthesis	msthesis	misc		phdthesis
	proceedings	techreport	unpublished
or	EDIT		quit
\fBa\fP
CITEKEY? \fBLAM78\fP
AUTHOR? \fBLamport, Leslie\fP
TITLE? \fBTime, Clocks, and the Ordering of Events in a Distributed System\fP
JOURNAL? \fB\\jacm\fP
YEAR? \fB1978\fP
VOLUME (optional)? \fB21\fP
NUMBER (optional)? \fB7\fP
PAGES (optional)? \fB558--565\fP
MONTH (optional)? \fB\\jul\fP
NOTE (optional)? 
KEY (optional)? 
COMMENT (optional)? 
CROSS-REFERENCE (optional)? 
USR_FIELD1 (optional)? \fB?\fP
You asked for it, buster, so you figure it out...
USR_FIELD1 (optional)? \fBThis wasn't in the jacm, sigh\fP
USR_FIELD2 (optional)? \fB?\fP
Bah Humbug
USR_FIELD2 (optional)? \fBThere we go, it was in the cacm, so we can EDIT and change the entry\fP
@ARTICLE { LAM78 ,
	AUTHOR = "Lamport, Leslie" ,
	JOURNAL =   jacm  ,
	MONTH =   jul  ,
	NUMBER = "7" ,
	PAGES = "558--565" ,
	TITLE = "Time, Clocks, and the Ordering of Events in a Distributed System" ,
	VOLUME = "21" ,
	YEAR = "1978" ,
	USR_FIELD1 = "This wasn't in the jacm, sigh" ,
	USR_FIELD2 = "There we go, it was in the cacm, so we can EDIT and change the entry"
	}

What kind of record would you like to enter (one of the following)?
	article		book		booklet		conference
	inbook		incollection	inproceedings	manual
	mastersthesis	msthesis	misc		phdthesis
	proceedings	techreport	unpublished
or	EDIT		quit
\fB^D\fP
cheops Bibcreate. \fBshbib lam78 foo.bib\fP
@ARTICLE { LAM78 ,
	AUTHOR = "Lamport, Leslie" ,
	JOURNAL =   jacm  ,
	MONTH =   jul  ,
	NUMBER = "7" ,
	PAGES = "558--565" ,
	TITLE = "Time, Clocks, and the Ordering of Events in a Distributed System" ,
	VOLUME = "21" ,
	YEAR = "1978" ,
	USR_FIELD1 = "This wasn't in the jacm, sigh" ,
	USR_FIELD2 = "There we go, it was in the cacm, so we can EDIT and change the entry"
	}
cheops Bibcreate. 

script done on Sun Dec  3 00:57:11 1989
.fi

.sp1
.SH BUGS
.sp1
The order of entries in the bib file will not be the same as one had
originally started out with if one uses the \fB-r -l\fP option to
\fIshbib\fP, or uses the \fB-l\fP option to \fIrmbib\fP.

One might like to have a tool for sorting entries in a file based on
some specified keys.

Exiting in the middle of a entering a record via \fBbibc\fP causes some
unnecessary garbage to appear on the screen.  The output file is always
consistent though.

These tools may crash if the bib files specified are not complete and
consistent.

The method of delineating records is to locate a '\\n@', ie, a newline
followed by an '@' as the next character.

The \fB-i\fP option to \fIbibc\fP and \fIrmbib\fP will cause the record
to be seemingly displayed twice.  This is not so.  The first time, the
write is to stderr, the final write is to stdout.  This is so one can
redirect stdout to correct places, such as doing

.nf
		\fBrmbib -g -i -s Concurrency bib-files > concurrency.bib\fP
.fi

Hopefully, not much else.

.sp1
.SH AUTHOR
.sp1
.LP
.nf
	Kannan Varadhan  - kannan@osc.edu
.fi
.sp1
.SH SEE ALSO
.sp1
.nf
\fBegrep(1)\fP, \fBmh(1)\fP, \fBprompter(1)\fP, \fBaddbib(1)\fP, \fPlookbib(1)\fP
.fi
