.TH CK 1L "4 February 1988" " " " "

.SH NAME
ck, ckd - report newly arrived mail

.SH SYNOPSIS
.B ck
[ 
.B \-v
] 
[ 
.B \-o 
.I outfile 
]
[ 
.I mailbox 
]
.br
.B ckd
[ 
.B \-v
] 
[ 
.B \-o 
.I outfile 
]
[ 
.BI \-i interval 
] 
[ 
.I mailbox 
]

.SH DESCRIPTION
.I ck 
and 
.I ckd
are, respectively, the command line and daemon versions of a program
to monitor your incoming mail.  They examine mailbox files and report
the sender and subject of each message contained in the file.  If a
mailbox is not specified, 
.I $HOME/mailbox
will be used.  If the user does not have read access to
the mailbox, an attempt will be made to report the size of the
file and when it was last modified.  This allows the user to check
if someone else recently received mail.

Although there are dozens of similar programs wandering around UNIX
land, many don't work on common system configurations.  (E.g.,
.I from 
only works if the mailbox lives in 
.BR /usr/spool/mail ";  "
.I biff 
and 
.I rcvalert
don't get along well with the SunView windows; etc.)  
.I ck 
and 
.I ckd 
contribute to this parochial mass, since currently they only work
with MMDF format files (or more specifically, files in which
each message is separated by a line containing four Control-A's).
But they do try to be more flexible about how they notify the user.

.I ck 
reports the status of the mailbox once and exits.  
.I ckd 
runs in the background and reports whenever it notices that 
the mailbox has been modified.  
.I ckd 
terminates automatically when it sees that the process from which it
was invoked has also terminated.  For example, if you run
.I ckd 
from your 
.I .login 
file, it will terminate shortly after you logout.

.I ck 
normally prints to the standard output, and 
.I ckd 
to the standard error.  This can be changed via the 
.B \-o 
option described below.  
.I ckd
will try to ring the bell on the output device whenever it
detects new mail.

.SH OPTIONS
.TP
.B \-v
After listing the contents of the mailbox, display its size and
time of modification.
.TP
.BI \-o " outfile"
Redirect output to the file or device specified by 
.I outfile.  
If the file already exists, the output is appended to it.
.TP
.BI \-i interval
Check the mailbox every 
.I interval 
seconds instead of the default, 120.  This option is only meaningful
in 
.IR ckd .  

.SH FILES
.TP
.B $HOME/mailbox
default mailbox file to monitor

.SH DIAGNOSTICS
Exit status is -1 if the file specified in the 
.B \-o 
option can't be opened.  Otherwise, 
.IR ck 's 
exit status is equal to the number of messages found in the
mailbox, and 
.IR ckd 's 
is 0.


.SH BUGS
Only handles MMDF format files.

There should be an option to turn the bell on or off.

Ckd should be smarter about reporting changes in the file.  Right
now it announces any change which leaves messages in the file (even
deleting some messages).  A better approach would be to do some
smart-work to see if it looks like new messages were added.

.SH AUTHOR

Wayne Mesard, MESARD@BBN.COM

