.TH DISKDUMP 1 "LOCAL"
.SH NAME
diskdump \- produce CMS disk dump file
.SH SYNOPSIS
diskdump [-n <name> -t <type> <file>]
.SH DESCRIPTION
Diskdump converts a standard text file into CMS disk dump format
and writes it to standard output as a
stream of 80-byte binary and EBCDIC card images.
This allows a text file with lines longer than 80 characters to be
"punched" to a CMS user.
If <file> is not specified, standard input is used.
The command line options are:
.TP 12
-n <name>
Specifies an internal filename for the CMS file.
The default is "MAILER".
.TP 12
-t <type>
Specifies an internal filetype for the CMS file.
The default is "MAIL".
.SH EXAMPLES
Send a file to user MAILER on node UOFMCC:
.ti+8n
diskdump hello.c | lp -db -o"-r -v uofmcc.mailer"
.SH SEE ALSO
lp(1), netdata(1x)
.SH BUGS
Diskdump will fold input lines longer than 254 characters.
It will not handle binary files.
The CMS file produced is always format V.
The ASCII to EBCDIC translation may not conform to what is expected
on the receiving system.
