Dir=`pwd`
Sdir=`pwd`/../pi

RHDRS=	../h/rt.h ../h/config.h ../h/define.h ../h/cpuconf.h ../h/memsize.h
LHDRS=	../std/ilink.h $(RHDRS)
#
#  To add or replace object files, add their names to the OBJS list below.
#  For example, to add nfncs.o and iolib.o, use:
#
#	OBJS=nfncs.o iolib.o         # this is a sample line
#
#  For each object file added to OBJS, add a dependency line to reflect files
#  that are depended on.  In general, new functions depend on $(RHDRS).
#  For example, if nfncs.c contains new functions, use
#  	
#	nfncs.o:	$(RHDRS)
#
#  Such additions to this Makefile should go at the end.

OBJS=
LIB=

RTOBJS=../std/imain.o ../std/rconv.o ../std/idata.o $(OBJS)

Pi:	picont piconx pilink piconx.hdr

picont:	../std/icont.c ../h/config.h ../h/define.h ../h/paths.h
	rm -f ../picont picont
	$(CC) $(CFLAGS) -o picont -DItran="\"$(Dir)/pitran\""\
 		-DIconx="\"$(Dir)/piconx\"" \
		-DIlink="\"$(Dir)/pilink\""  ../std/icont.c
	strip picont
	ln picont ../picont

pilink:	../std/linklib ../std/lsym.o ../std/ilink.o ../std/lcode.o ../std/lmem.o
	rm -f ../pilink pilink
	$(CC) $(LDFLAGS) -o pilink ../std/lsym.o ../std/ilink.o\
		 ../std/lcode.o ../std/lmem.o ../std/linklib
	strip pilink
	ln pilink ../pilink

../std/ixhdr.o:	../h/config.h ../h/define.h
	cd ../std;	$(CC) -c $(XCFLAGS) -DIconx="\"$(Sdir)/piconx\"" ixhdr.c

piconx.hdr:	../std/ixhdr.o
	rm -f ../piconx.hdr piconx.hdr
	$(CC) $(XLDFLAGS) ../std/ixhdr.o -o piconx.hdr
	strip piconx.hdr
	ln piconx.hdr ../piconx.hdr

piconx:	../std/rtlib $(RTOBJS)
	rm -f ../piconx piconx
	$(CC) $(LDFLAGS) -o piconx $(RTOBJS) ../std/rtlib $(LIB) -lm
	ln piconx ../piconx
	

../std/idata.o:		$(RHDRS) ../h/fdefs.h fdefs.h
	cd ../std;	$(CC) -c -DPI $(CFLAGS) idata.c

../std/imain.o:		$(RHDRS) ../h/header.h ../h/version.h ../std/gc.h \
			   ../h/opdefs.h
	cd ../std;	$(CC) -c $(CFLAGS) imain.c

../std/rconv.o:		$(RHDRS) ../h/fdefs.h fdefs.h
	cd ../std;	$(CC) -c -DPI $(CFLAGS) rconv.c

../std/lsym.o:	$(LHDRS) ../h/fdefs.h fdefs.h
	cd ../std;	$(CC) -c -DPI $(CFLAGS) lsym.c

../std/lmem.o:	$(LHDRS)
	cd ../std;	$(CC) -c -DPI $(CFLAGS) lmem.c

../std/ilink.o:		$(LHDRS) ../h/header.h ../h/paths.h
	cd ../std;	$(CC) -c $(CFLAGS) -DHeader="\"$(Sdir)/piconx.hdr\""  ilink.c

../std/lcode.o:		$(LHDRS) ../h/header.h ../h/paths.h ../std/opcode.h \
			   ../h/keyword.h ../h/opdefs.h ../h/version.h
	cd ../std;	$(CC) -c $(CFLAGS) lcode.c

Stripx:	piconx
	strip piconx
