
OBJS=		cat.o err.o itran.o  lex.o  mem.o optab.o parse.o sym.o\
		   toktab.o tree.o variant.o

../itran:	$(OBJS)
		$(CC) $(LDFLAGS) -o ../vitran $(OBJS)

$(OBJS):	../h/config.h ../h/define.h

cat.o:		tree.h ../cat.c
		cc -c $(CFLAGS) ../cat.c

variant.o:	../variant.c
		cc -c $(CFLAGS) ../variant.c
		
err.o:		itran.h lex.h token.h tree.h
itran.o:	itran.h sym.h token.h tree.h ../h/config.h ../h/define.h
lex.o:		itran.h lex.h token.h tree.h
mem.o:		itran.h sym.h tree.h ../h/memsize.h
optab.o:	lex.h
parse.o:	itran.h sym.h tree.h ../h/config.h ../h/define.h
sym.o:		itran.h sym.h token.h
toktab.o:	itran.h lex.h token.h
tree.o:		tree.h

parse.c token.h:	expanded.g
		yacc -d expanded.g	# expect 214 shift/reduce conflicts
		mv y.tab.c parse.c
		ed - parse.c <pscript
		mv y.tab.h token.h

expanded.g:	icon_g.c gdefs.h fixgram
		cc -E icon_g.c | ./fixgram >expanded.g

gdefs.h:	../bsyms ../usyms ../ident.defs ../variant.defs
		cd ..;	./define ident.defs variant.defs >gdefs.h
		mv ../gdefs.h .

toktab.c optab.c:	tokens optab mktoktab
		./mktoktab

mktoktab:	mktoktab.icn
		icont -s mktoktab.icn

fixgram:	fixgram.icn
		icont -s fixgram.icn
