/  Long integer arithmetic routines with overflow checking.

extrn fatalerr           /  Run-time error routine

/  Addition.

/ MACRO Start(11,ckadd)
.text
entry ckadd
ckadd:                / routine ckadd
stm   11,14,44(13)   / save registers in space allocated
lr    12,13        / set frame pointer
lr    11,15      / address of entry
using ckadd,11       / base register for routine
/ END OF MACRO - input comment:
balr   14,0           / get program mask
sr     1,1
spm    1               / set program mask to prevent interupt
l      0,64(12)
a      0,68(12)        / perform addition
bo     addover          / branch if overflow
spm    14              / restore progam mask
/ MACRO Finish(11)
lm    11,14,44(12)  / restore registers
b     2(14)       / return - to 2 bytes past call
/ END OF MACRO - input comment:             / return result in 0

addover:
la     11,oflow         / set up new base address
br     11               / branch to overflow exit

/  Subtraction.

/ MACRO Start(11,cksub)
.text
entry cksub
cksub:                / routine cksub
stm   11,14,44(13)   / save registers in space allocated
lr    12,13        / set frame pointer
lr    11,15      / address of entry
using cksub,11       / base register for routine
/ END OF MACRO - input comment:
balr   14,0           / get program mask
sr     1,1
spm    1               / set program mask to prevent interupt
l      0,64(12)
s      0,68(12)        / perform subtraction
bo     subover          / branch if overflow
spm    14              / restore progam mask
/ MACRO Finish(11)
lm    11,14,44(12)  / restore registers
b     2(14)       / return - to 2 bytes past call
/ END OF MACRO - input comment:             / return result in 0

subover:
la     11,oflow        / set up new base address
br     11              / branch to overflow exit

/  Multiplication.

/ MACRO Start(11,ckmul)
.text
entry ckmul
ckmul:                / routine ckmul
stm   11,14,44(13)   / save registers in space allocated
lr    12,13        / set frame pointer
lr    11,15      / address of entry
using ckmul,11       / base register for routine
/ END OF MACRO - input comment:
l      15,64(12)       / load into 14,15 pair
m      14,68(12)       / perform multiplication
lr     0,15           / result to be returned in 0
srda   14,31           /  now check for overflow
cr     14,15          /  ok if all ones or all zeros
bne    mulover
/ MACRO Finish(11)
lm    11,14,44(12)  / restore registers
b     2(14)       / return - to 2 bytes past call
/ END OF MACRO - input comment:             / return value in 0

mulover:
la     11,oflow        / set up new base address

oflow:                  / an overflow on arithmetic operation
using  oflow,11
spm    14              / restore program mask
/ MACRO Push_K(0)
s     13,=f'4'
l     0,=f'0'      / load word of storage
st    0,0(13)     / and push onto the stack
/ END OF MACRO - input comment:
/ MACRO Push_K(-203)
s     13,=f'4'
l     0,=f'-203'      / load word of storage
st    0,0(13)     / and push onto the stack
/ END OF MACRO - input comment:
/ MACRO Calls(2,fatalerr)
s     13,=f'64'    / allocate space in stack for registers
l     15,=a(fatalerr)    / load routine address
balr  14,15        / branch to routine
dc    h'8'   / number of bytes for arguments - 4 each
la    13,72(13)    / pop arguments and registers from stack
/ END OF MACRO - input comment:         / fatalerr(-203,0)

end
