
/  coswitch(old_cs,new_cs,first) - switch to another expression stack

/  int *old_cs, new_cs, first;

/  This code is consistent with the UTS C compiler, whose assembler
/  demands absolute values for registers (eg 13 instead of sp) and:
/
/      0,1   - are not saved
/      12    - frame pointer (same as stack pointer at start of routine)
/      13    - stack pointer
/      14,15 - to call subroutines

extrn interp, syserr

.text
entry coswitch
coswitch:
l     1,64(13)          / old_cs
st    13,0(1)           / save stack pointer in old_cs[0]
stm   2,14,4(1)         / save registers in old_cs
lr    11,15             / address of entry
using coswitch,11       / base register for routine

lm    2,3,68(13)        / pick up new_cs and first from stack

ltr   3,3               / check value of first
bnz   not_first         / non-zero then go and restore new_cs

l     13,0(2)           / otherwise just set stack pointer to new_cs[0]
                        / and call interp(0,0)

s     13,=f'72'         / two integer arguments and 64 bytes for registers
xc    64(8,13),64(13)   / set both arguments to zero
l     15,=a(interp)     / load routine address
balr  14,15             / branch to routine
dc    h'8'              / number of bytes for arguments - 4 each

la    0,errmess         / set up error message as only parameter
st    0,64(13)
l     15,=a(syserr)     / load routine address
balr  14,15             / branch to routine
dc    h'4'              / number of bytes for arguments - 4 each

not_first:
lm    2,14,4(2)         / restore new_cs
b     2(14)             / return - to 2 bytes past call of new context
ltorg
errmess:
dc    c'interp() returned in coswitch\0'
