| NOTE:  There are three occurrences of the "bpl" instruction in this
|	 file.  All of them can be changed to "bpls" instructions as
|	 soon as the assembler is fixed so that it will assemble "bpls"
|	 instructions.  At the time of this writing, "bpls" is rejected
|	 with a "can't decode instruction" error.

|
|  Integer Arithmetic Overflow for DIAB D-NIX Icon
|

	.text
|
|  ckadd -- Long integer addition with overflow check.
|
	.globl	_ckadd
_ckadd:
	movl	4(sp),d0	|Get first operand
	addl	8(sp),d0	|Add second operand
	bvss	oflow		|Jump if overflow
	rts			|Return

|
|  cksub -- Long integer subtraction with overflow check.
|
	.globl	_cksub
_cksub:
	movl	4(sp),d0	|Get first operand
	subl	8(sp),d0	|Subtract second operand
	bvss	oflow		|Jump if overflow
	rts			|Return

|
|  Come here if overflow detected -- terminate Icon run with
|  run error 203 -- integer overflow.
|
oflow:
	movl	#0,-(sp)	|Push NULL
	movl	#-203,-(sp)	|Push error code -203
	jbsr	_fatalerr		|Go terminate the run

|
|  ckmul -- Long integer multiplication with overflow check.
|
	.globl	_ckmul
_ckmul:
	lea	4(sp),a1
	lea	8(sp),a0
	tstl	(a0)+
	smi	d1
	bpl	1$
	negl	-4(a0)
1$:	tstl	(a1)+
	bpl	2$
	notb	d1
	negl	-4(a1)
2$:	movw	-(a1),d0
	mulu	-(a0),d0
	movl	d0,product+4
	movw	-(a1),d0
	mulu	-(a0),d0
	movl	d0,product+0
	movw	(a1)+,d0
	mulu	2(a0),d0
	addl	d0,product+2
	bccs	3$
	addqw	#1,product
3$:	movw	(a0),d0
	mulu	(a1),d0
	addl	d0,product+2
	bccs	4$
	addqw	#1,product
4$:	tstb	d1
	beqs	5$
	negl	product+4
	negxl	product
5$:	movl	product+4,d0	|GET low 32 bits of result
|
|  Check for 32 bit overflow.
|
	movl	product+0,d1	|Get the high 32 bits of result
	tstl	d0		|Test sign of result
	bpl	6$		|Jump if positive
	notl	d1		|Else flip bits of high 32 bits
6$:	tstl	d1		|Test high 32 bits
	bne	oflow		|Jump if not all zero -- overflow
	rts			|Return
|
|  Data for ckmul
|
	.data
product:	.long	0,0		|Location for 64-bit product
