|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
|
| ckmul - do 32 x 32 multiplication, checking for overflow.
|
|	Since the 68000 does not do longword multiplies, we have
|	to do it ourselves here.
|	I doubt that this is significantly slower than the routine
|	`lmul' used by the C runtime to do longword multiplies.
|
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
	.file	"rover.s"
	.text
	.even
	.globl	_ckmul
MArg1 = 8	|argment offsets.
MArg2 = 12
FrameSize = 24	|frame is only used to hold regs (d1-d6)
RegMask = 126	|mask for reg. saving

_ckmul:
	link	a6,#-FrameSize-4
	tstl	sp@(-136)
	moveml	#RegMask,a6@(-FrameSize)
	movl	a6@(MArg1),d2	|pick up first arg
	movl	a6@(MArg2),d3	|pick up second arg
	movl	d2,d4
	movl	d3,d5
	swap	d4		|d4 = d2H
	swap	d5		|d5 = d3H
| Create all four products
	movw	d2,d0
	mulu	d3,d0		|d0 = d3L*d2L
	movw	d4,d1
	mulu	d5,d1		|d1 = d3H*d2H
	mulu	d2,d5		|d5 = d2L*d3H
	mulu	d3,d4		|d4 = d3L*d2H
|Add in cross product
	addl	d4,d5
	movw	d5,d4
	swap	d4
	clrw	d4
	clrw	d5
	addxw	d4,d5
	swap	d5
	addl	d4,d0
	addxl	d5,d1
|now, adjust for sign if necessary
	tstl	d2
	bpls	.L1
	subl	d3,d1
.L1:	tstl	d3
	bpls	.L2
	subl	d2,d1
|now we have 64-bit result with lo part in d0 and hi part in d1
|Check for overflow
.L2:	tstl	d0
	bmi	.L3
	tstl	d1	|if lo part is positive, hi part
	bnes	MOflow	|better be zero
	bras	.L4
.L3:	notl	d1	|else, hi part better be all ones
	bnes	MOflow
.L4:
	moveml	a6@(-FrameSize),#RegMask
	unlk	a6
	rts

|Come here to report an overflow. 
|  NOTE that we are behaving as if fatalerr is going to return, even though
|  it never should.
MOflow:	moveml	a6@(-FrameSize),#RegMask
	unlk	a6
Oflow:	clrl	sp@
	movl	#-203,sp@-
	jsr	_fatalerr
	addql	#4,sp	|should never return from fatalerr, but what the heck
	rts

|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
|
| ckadd, cksub - do integer addition and subtraction checking for overflow
|
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
	.globl	_ckadd
	.globl	_cksub

Arg1 = 4
Arg2 = 8
_ckadd:	movl	sp@(Arg1),d0
	addl	sp@(Arg2),d0
	bvss	Oflow
	rts

_cksub:	movl	sp@(Arg1),d0
	subl	sp@(Arg2),d0
	bvss	Oflow
	rts

