	global	ckadd
	global	cksub
	global	ckmul

	text

# 32-bit addition-- bail out on overflow.
	even
ckadd:
	link	%a6,&-4
	mov.l	8(%a6),%d0	# Perform addition
	add.l	12(%a6),%d0
	bvs	oflow		# Branch if overflow
	unlk	%a6
	rts			# Return result in d0


# 32-bit subtraction-- bail out on overflow.
	even
cksub:
	link	%a6,&-4
	mov.l	8(%a6),%d0	# Perform subtraction
	sub.l	12(%a6),%d0
	bvs	oflow		# Branch if overflow
        unlk    %a6
	rts			# Return result in d0


# 32-bit multiplication-- bail out on overflow.
# This code was cribbed wholesale from the plexus_68 installation.
#  Thank you, it works nicely.

	even
ckmul:
	link	%a6, &-28	# Link space for 6 regs.
	movm.l 	&126, -28(%a6)	# Save d6-d1

	mov.l	8(%a6), %d2
	mov.l	12(%a6), %d3
	mov.l	%d2, %d4
	mov.l	%d3, %d5
	swap.w	%d4
	swap.w	%d5

# Create all four products
	mov.w	%d2, %d0
	mulu.w	%d3, %d0
	mov.w	%d4, %d1
	mulu.w	%d5, %d1
	mulu.w	%d2, %d5
	mulu.w	%d3, %d4

# Add in cross product
	add.l	%d4, %d5
	mov.w	%d5, %d4
	swap.w	%d4
	clr.w	%d4
	clr.w	%d5
	addx.w	%d4, %d5
	swap.w	%d5
	add.l	%d4, %d0
	addx.l	%d5, %d1

# Adjust sign, if necessary
	tst.l	%d2
	bpl.b	L%1
	sub.l	%d3, %d1
L%1:	tst.l	%d3
	bpl.b	L%2
	sub.l	%d2, %d1

# 64-bit result: low word in %d0, high in %d1
L%2:	tst.l	%d0
	bmi.b	L%3
	tst.l	%d1
	bne.b	oflow
	bra.b	L%4
L%3:	not.l	%d1
	bne.b	oflow
L%4:	movm.l	-28(%a6), &126
	unlk	%a6
	rts


# Handle an arithmetic overflow.-- 
#   Calls the external function fatalerr which should NOT return.
oflow:
	link	%a6,&-4
	mov.l	&0, (%sp)
	mov.l	&-203, -(%sp)
	jsr	fatalerr	# fatalerr(-203,0)
	unlk	%a6		# Should never return, but...
	rts
