PROCEDURE OPTION( S : STRING);
(* BEHANDEL ASSEMBLER OPTIONS *)
BEGIN
    IF S = 'L     ' THEN OPTLIST := TRUE ELSE
    IF S = 'NOL   ' THEN OPTLIST := FALSE ELSE
    IF S = 'O     ' THEN OPTBIN  := TRUE ELSE
    IF S = 'NOO   ' THEN OPTBIN  := FALSE ELSE
    IF S = 'S     ' THEN OPTSYM  := TRUE ELSE
    IF S = 'NOS   ' THEN OPTSYM  := FALSE ELSE
    IF S = 'DEBUG ' THEN DEBUG := TRUE ELSE
    IF INITIALIZING THEN WRITELN('UNKNOWN OPTION "',S,'"')
    ELSE ERROR('U');
END (* OPTION *);

PROCEDURE DOINIT;
BEGIN
   INXREG:= [ REGX .. REGPC ];
   ACCREG:= [ REGD ,REGA ,REGB];
   ASSOPC:= [ OPNAM .. OPOPT];
   PROOPC:= [ OP0 .. OPSTK];
   DIRPAG:= 0;
END;

PROCEDURE DOSTMT(SPTR:STMT);
CONST
        MNRMB    = 1;
        MNORG    = 2;
        MNFCB    = 1;
        MNFDB    = 2;

VAR
        OPERAND,OPEXT,
        POSTB,LEN,
        OPCODE,VAL,
        DIST,SECBYT        : INTEGER;
        OPT                   : OPTYPE;
        OPRPTR                : OPLIST ;
        STRPTR                : VARSTRING;
        DOPOST                : BOOLEAN;

   PROCEDURE REMTITLE;
   (*     REMTITLE VERWIJDERD DE TITLE STRING  VAN HET    *)
   (*     TYPE VARSTRING                                  *)
   VAR         OP,P        : VARSTRING;
   BEGIN
      P:= TITLE;
      WHILE P <> NIL DO
         BEGIN
            OP := P;
            P := P^.NEXT;
            DISPOSE(OP);
         END;
   END; (* PROCEDURE REMTITLE  *)

   PROCEDURE REMSTMT;

      PROCEDURE REMOPLIST(P :OPLIST);
      VAR        NP        :OPLIST;
      BEGIN
         WHILE P<>NIL DO
         BEGIN
            IF P^.ARGTP = ARGIND
               THEN REMOPLIST(P^.AILIST);
               NP:= P^.NEXT;
               DISPOSE(P);
               P:= NP;
         END;
      END;

   BEGIN
      OPRPTR := SPTR^.OPERANDS;
      DISPOSE(SPTR);
      REMOPLIST(OPRPTR);
   END;

   FUNCTION REGNYB(REG:REGISTER):INTEGER;
   BEGIN
      CASE REG OF
         REGX  : REGNYB := 1;
         REGY  : REGNYB := 2;
         REGU  : REGNYB := 3;
         REGS  : REGNYB := 4;
         REGPC : REGNYB := 5;
         REGD  : REGNYB := 0;
         REGA  : REGNYB := 8;
         REGB  : REGNYB := 9;
         REGDP : REGNYB := 11;
         REGCC : REGNYB := 10;
      END;
   END; (*  FUNCTION REGNYB *)

   FUNCTION REGBIT(REG:REGISTER):INTEGER;
   BEGIN
      CASE REG OF
         REGX  : REGBIT := 16;
         REGY  : REGBIT := 32;
         REGU,
         REGS  : REGBIT := 64;
         REGPC : REGBIT := 128;
         REGD  : REGBIT := 6; (*  REGISTER A + B  *)
         REGA  : REGBIT := 2;
         REGB  : REGBIT := 4;
         REGDP : REGBIT := 8;
         REGCC : REGBIT := 1;
      END;
   END;  (*  FUNCTION REGBIT *)

   PROCEDURE MKLEBEL(NAME :STRING; WAARDE:INTEGER);
   VAR        IDPTR        : IDRECORD;
   BEGIN
      NEW(IDPTR);
      IDPTR^.DEFLIN := LINCNTR;
      IDPTR^.WAARDE  := WAARDE;
      IF NOT NEWNAM(NAME,IDPTR)
         THEN ERROR('M');
   END;

   PROCEDURE DOOPER(OPPTR : OPLIST);
   VAR     INC      : INTEGER;
           OPCLEN   : INTEGER;

      PROCEDURE DOREGX;
      BEGIN
         IF OPPTR^.NEXT <> NIL THEN ERROR('S');
         CASE OPPTR^.ARREG OF
            REGX : POSTB := POSTB + 0 ;
            REGY : POSTB := POSTB + 32;
            REGU : POSTB := POSTB + 64;
            REGS : POSTB := POSTB + 96;
            REGPC: POSTB := POSTB + 12;
         END;
         IF OPPTR^.ARREG <> REGPC THEN
         BEGIN
            (*   INC / DEC OMREKENING:  *)
            (* ,--X  ,-X  ,X  ,X+  ,X++ *)
            (*    3    2   4   0    1   *)
            INC:= OPPTR^.ARINC -1;
            IF INC = -1 THEN INC := 4
            ELSE INC := ABS(INC);
            POSTB := POSTB + INC;
         END ELSE
            IF OPPTR^.ARINC <> 0
            THEN ERROR('+');
      END;  (* INDEX REGISTER HANDLING *)

      PROCEDURE DOREGA;
      BEGIN
         IF OPPTR^.NEXT = NIL THEN BEGIN
            ERROR('A'); (* NEED INDEX REG AFTER ACCU*)
         END ELSE BEGIN   (* MORE OPERANDS *)
            DOOPER(OPPTR^.NEXT); (* DO NEXT FIRST *)
            IF (POSTB MOD 16 ) <> 4 THEN ERROR('A')
            ELSE (* CAME BACK WITH ZERO OFFSET *)
               CASE OPPTR^.ARREG OF
                  REGD : POSTB := POSTB +7;
                  REGA : POSTB := POSTB +2;
                  REGB : POSTB := POSTB +1;
               END;
         END;
      END; (* DOREGA *)

      PROCEDURE DOINDIRECT;
      BEGIN
         IF OPPTR^.NEXT <> NIL THEN ERROR ('S') ELSE
         IF OPPTR^.AILIST = NIL THEN ERROR('E')
         ELSE BEGIN
            DOOPER(OPPTR^.AILIST);
            IF NOT DOPOST
            THEN BEGIN
               POSTB := 159; (*        $9F  *)
               LEN := 2 ;     (* EXTENDED INDIRECT *)
               DOPOST := TRUE;
               OPEXT := 32;
            END ELSE BEGIN
               IF POSTB < 128 THEN BEGIN
                  LEN := 1;
                  OPERAND := POSTB MOD 16;
                  IF POSTB > 15 THEN OPERAND := OPERAND -32;
                     POSTB := ((POSTB DIV 32)*32)+136;
                    (* CHANGE 5 BIT OFFSET IN 8 BIT *)
               END ELSE
                  IF ((POSTB MOD 32)=0) OR ((POSTB MOD 32)=2)
                  THEN ERROR('+');
               POSTB := POSTB + 16; (* MAKE IT INDIRECT *)
            END; (*   DOPOST = TRUE *)
         END;
      END;

      PROCEDURE DONUM;
      BEGIN
         DOPOST := FALSE;
         OPERAND := OPPTR^.ANVAL;
         IF OPPTR^.ANFORC THEN
            IF OPPTR^.ANLONG
            THEN LEN := 2
            ELSE LEN := 1
         ELSE
#ifdef PRIME
            IF (IAND(OPERAND,-256) DIV 256 = DIRPAG )
#else
            IF ((OPERAND>=0) AND (OPERAND DIV 256=DIRPAG))
            OR ((OPERAND<0) AND ((OPERAND-(OPERAND MOD 256))
            = (DIRPAG * 256)))
#endif
            THEN LEN := 1
            ELSE LEN := 2;
         IF LEN = 2
         THEN OPEXT := 48
         ELSE OPEXT := 16;
      END; (* DIRECT & EXTENDED *)

      PROCEDURE DOPCR;
      BEGIN
         (* Altered 23-oct-84, Hans. *)
         IF OPCODE > 256 THEN  OPCLEN := 2
         ELSE OPCLEN := 1;
         IF OPPTR^.ANLONG THEN LEN := 2
         ELSE LEN := 1;
         OPERAND := OPERAND - OLOCCNTR - OPCLEN -1 -LEN;
         IF((OPERAND > 127) OR (OPERAND < -128)) AND
            (LEN <> 2) AND NOT OPPTR^.ANFORC THEN BEGIN
            LEN := 2;
            OPERAND := OPERAND -1;
         END;
         IF LEN = 2 THEN POSTB := POSTB +1 ;
      END; (* OFFSET FROM PCR *)

      PROCEDURE DOOFFSET;
      BEGIN
         IF OPERAND <> 0 THEN
            IF (POSTB MOD 16) = 4 (* OFFSET FROM REGISTER *)
            THEN
               IF (OPERAND>127) OR (OPERAND<-128)
                  (* Added 9-feb-84, Jack. *)
               OR ( OPPTR^.ANFORC AND OPPTR^.ANLONG)
                  (* Added 23-oct-84, Hans. *)
               AND NOT ( OPPTR^.ANFORC AND NOT OPPTR^.ANLONG )
               THEN BEGIN
                  POSTB := POSTB + 5; (* 16 BIT OFF- *)
                  LEN := 2;                (* SET FORM R  *)
               END ELSE
                  IF (OPERAND>15) OR (OPERAND<-16)
                  THEN BEGIN
                     POSTB := POSTB +4; (* 8 BIT  *)
                     LEN := 1;             (* OFFSET *)
                  END ELSE BEGIN           (* FROM R *)
                     IF OPERAND < 0 THEN
                        OPERAND:=32+OPERAND;
                     POSTB := POSTB - 132 + OPERAND;
                     LEN := 0; (* 5 BIT OFFSET FROM R *)
                  END
            ELSE
               ERROR('C')   (* OFFSET NOT ALLOWED *)
         ELSE
            LEN := 0
      END;  (* OFFSET FROM INDEX REG *)

   BEGIN
   CASE OPPTR^.ARGTP OF
      ARGREG : BEGIN
                  POSTB := 128;
                  LEN := 0;
                  DOPOST := TRUE;
                  OPEXT := 32;
                  IF OPPTR^.ARREG IN INXREG THEN
                     DOREGX
                  ELSE
                     IF NOT (OPPTR^.ARREG IN ACCREG) THEN ERROR('V')
                     ELSE   (* ACCU OFSET *)
                        DOREGA;
               END; (* REGISTER OPERANDS *)
      ARGIMM : BEGIN
                  IF OPPTR^.NEXT <> NIL THEN ERROR('S')
                     ELSE
                        BEGIN
                           LEN := -1;
                           OPERAND := OPPTR^.AIVAL;
                           OPEXT := 0;
                           DOPOST := FALSE;
                        END;  (* IMMIDIATE MODE *)
                END;
      ARGIND : BEGIN
                  DOINDIRECT;
               END; (* INDIRECT MODE *)
      ARGNUM : BEGIN
                  IF OPPTR^.NEXT = NIL THEN
                     DONUM
                  ELSE BEGIN (* INDEXED ? *)
                     DOOPER(OPPTR^.NEXT);
                     IF NOT DOPOST OR (LEN <> 0) THEN ERROR('C')
                     ELSE
                        OPERAND := OPPTR^.ANVAL;
                     IF POSTB = 140 (* OFFSET FROM PCR *)
                     THEN
                        DOPCR
                     ELSE
                        DOOFFSET;
                  END;
               END;      (*  ARGNUM *)
      END;  (* CASE STATEMENT *)
   END; (* DOOPER *)

BEGIN
   OPCODE := SPTR^.OPCODE;
   OPT := SPTR^.OPT ;
   OPRPTR:=SPTR^.OPERANDS;
   IF (OPRPTR = NIL) AND NOT( (OPT = OP0) OR (OPT = OPEND))
      THEN ERROR('E')
      ELSE
      IF OPT IN ASSOPC THEN
         CASE OPT OF
            OPNAM : BEGIN
                       REMTITLE;
                       TITLE := OPRPTR^.ASTEXT;
                    END;
            OPFCB : BEGIN
                       (*  ZOWEL FCB ALS FDB *)
                       IF OPCODE = MNFCB THEN LEN := 1
                       ELSE
                          IF OPCODE = MNFDB THEN LEN := 2
                          ELSE ERROR('?');
                       WHILE OPRPTR <> NIL DO
                       BEGIN
                          IF OPRPTR^.ARGTP <> ARGNUM THEN ERROR('G')
                          ELSE
                             OUTHEX(OPRPTR^.ANVAL,LEN);
                          OPRPTR := OPRPTR^.NEXT;
                       END;
                    END;
            OPFCC : BEGIN
                       STRPTR := OPRPTR^.ASTEXT;
                       WHILE STRPTR <> NIL DO
                          BEGIN
                             VAL := ORD( STRPTR^.INHOUD) MOD 128;
                             STRPTR := STRPTR^.NEXT ;
                             OUTHEX( VAL , 1);
                          END;
                    END;
            OPRMB : BEGIN   (*        ZOWEL RMB ALS ORG KOMEN HIER *)
                       IF OPRPTR^.ARGTP <> ARGNUM THEN ERROR('G')
                       ELSE BEGIN
                          IF OPCODE = MNORG THEN BEGIN
                             LOCCNTR := OPRPTR^.ANVAL;
                             FLUSHEX(FALSE);
			  END ELSE
			     IF OPRPTR^.ANVAL <> 0 THEN
                                IF OPCODE = MNRMB THEN BEGIN
                                   LOCCNTR := OLOCCNTR + OPRPTR^.ANVAL;
                                   FLUSHEX(FALSE);
                                END ELSE
                                    ERROR('?');  (* NO ORG OR RMB *)
                       END;
                    END;
            OPEQU : BEGIN
                       IF SPTR^.LEBEL = LEGEID THEN ERROR('L')
                       ELSE
                          IF OPRPTR^.ARGTP <> ARGNUM THEN ERROR('G')
                          ELSE
                             BEGIN
                                MKLEBEL(SPTR^.LEBEL,OPRPTR^.ANVAL);
                                SPTR^.LEBEL := LEGEID;
                                (* PREVENT DUBBEL DEFINING *)
                             END;
                       OLOCCNTR := OPRPTR^.ANVAL;
                    END;
            OPSDP : BEGIN
                       IF OPRPTR^.ARGTP <> ARGNUM THEN ERROR('G')
                       ELSE
                          DIRPAG := OPRPTR^.ANVAL MOD 256 ;
                    OLOCCNTR := OPRPTR^.ANVAL;
                    END;
            OPEND : BEGIN
                        IF OPRPTR <> NIL THEN
                            IF OPRPTR^.ARGTP = ARGNUM THEN
                                STARTADR := OPRPTR^.ANVAL;
                        STOPPED := TRUE;
                    END;
            OPOPT : OPTION(OPRPTR^.AOOPT);
         END   (* CASE *)
      ELSE
         BEGIN
            IF OPT IN PROOPC THEN
               CASE OPT OF
               OP0  : IF OPCODE > 255
                         THEN OUTHEX(OPCODE ,2)
                         ELSE OUTHEX(OPCODE ,1);
               OP1B,
               OP1W : BEGIN
                         DOOPER(OPRPTR);
                         IF OPEXT = 0 (* IMMEDIATE MODE *)
                            THEN
                            IF OPT = OP1B
                               THEN LEN := 1
                               ELSE LEN := 2;
                            (*  EERST EENS KIJKEN OF ALLES MAG *)
                         IF (OPCODE >= 64) AND (OPCODE <= 79)
                             (*  NEG .. CLR  *)
                            THEN
                            IF OPEXT = 16 (* DIRECT *)
                               THEN OPEXT := -64 (* SPECIAL *)
                               ELSE
                               IF OPEXT = 0 THEN ERROR('I');
                                 (* AND IMM NOT ALLOWED *)
                         IF ((OPCODE = 26) OR (OPCODE = 28))
                                (*  ORCC  AND  ANDCC  *)
                              AND (OPEXT <> 0) THEN ERROR('I');
                                (*  ONLY IMM MODE *)
                         IF (  (OPCODE = 135)             (* STA *)
                            OR (OPCODE = 199)             (* STB *)
                            OR (OPCODE = 205)             (* STD *)
                            OR (OPCODE = 143)             (* STX *)
                            OR (OPCODE = 207)             (* STU *)
                            OR (OPCODE = 16*256+143) (* STY *)
                            OR (OPCODE = 16*256+207) (* STS *)
                            OR (OPCODE = 141))             (* JSR *)
                           AND (OPEXT = 0)
                         THEN ERROR('I'); (* HAVE NO IMM MODES *)
                         IF ((OPCODE>16) AND (OPCODE<19))AND
                             (* LEAX .. LEAU *)
                             (OPEXT <> 32)  (* ONLY INDEXED MODE *)
                            THEN ERROR('I');
                         OPCODE := OPCODE + OPEXT;
                         IF OPCODE > 255
                            THEN OUTHEX(OPCODE,2)
                            ELSE OUTHEX(OPCODE,1);
                         IF DOPOST THEN OUTHEX(POSTB,1);
                         OUTHEX(OPERAND,LEN)
                      END;

              OPEMT : BEGIN
                         IF OPRPTR^.ARGTP <> ARGNUM
                            THEN ERROR('G')
                            ELSE
                               BEGIN
                                  OUTHEX(OPCODE,1);
                                  OUTHEX(OPRPTR^.ANVAL,1);
                               END;
                         END;
              OPREL : BEGIN
                         IF OPRPTR^.ARGTP <> ARGNUM
                            THEN ERROR('G')
                         ELSE
                            BEGIN
                               DIST := OPRPTR^.ANVAL -OLOCCNTR - 4;
                               IF OPCODE > 255
                                  THEN
                                     BEGIN
                                        OUTHEX(OPCODE ,2);
                                        OUTHEX(DIST   ,2);
                                     END
                                  ELSE
                                     BEGIN
                                     OUTHEX(OPCODE ,1);
                                     IF (OPCODE=22) OR (OPCODE=23) THEN
                 (*  LBRA EN LBSR  ZIJN 1 BYT INSTR. MET 2 BYT OFFS. *)
                                        BEGIN
                                        DIST := DIST +1;
                                        OUTHEX(DIST,2);
                                        END
                                     ELSE
                                        BEGIN
                                        DIST := DIST + 2;
                                        IF (DIST>127) OR (DIST<-128) THEN
                                           BEGIN
                                              ERROR('R');
                                              DIST := -4;
                                           END;
                                        OUTHEX(DIST   ,1);
                                        END;  (* SHORT BRANCH *)
                                     END;  (* 1 BYTE OPCODE *)
                            END;  (* NUMERIC OPERAND *)
                      END;  (* OPREL*)
              OPREG : BEGIN
                         IF OPRPTR^.ARGTP <> ARGREG
                            THEN ERROR('V')
                         ELSE
                            IF OPRPTR^.NEXT <> NIL THEN
                               BEGIN
                               OUTHEX(OPCODE,1);
                               SECBYT := REGNYB(OPRPTR^.ARREG);
                               OPRPTR := OPRPTR^.NEXT;
                               IF OPRPTR^.NEXT <> NIL
                                  THEN ERROR('C');
                               IF OPRPTR^.ARGTP <> ARGREG
                                  THEN ERROR('V')
                               ELSE
                                  BEGIN
                                  SECBYT := SECBYT*16+REGNYB(OPRPTR^.ARREG);
                                  OUTHEX (SECBYT , 1);
                                  END;
                               END
                            ELSE ERROR('C'); (*  NO SECOND REG *)
                      END;
              OPSTK : BEGIN
                         IF OPCODE > 255
                            THEN OUTHEX(OPCODE,2)
                            ELSE OUTHEX(OPCODE,1);
                         SECBYT :=0;
                         WHILE OPRPTR <> NIL DO
                            BEGIN
                            IF OPRPTR^.ARGTP <> ARGREG
                               THEN ERROR('V')
                            ELSE
                               SECBYT := SECBYT+REGBIT(OPRPTR^.ARREG);
                            OPRPTR := OPRPTR^.NEXT;
                            END;
                         OUTHEX(SECBYT,1);
                      END;
               END   (*  CASE  *)
            ELSE     (* NOT ( PROOPC OR ASSOPC )  *)
               ERROR('?');
         END;
   IF SPTR^.LEBEL <> LEGEID
      THEN MKLEBEL(SPTR^.LEBEL,OLOCCNTR);
   REMSTMT;
END;  (*  OF ROUTINE DO STATEMENT *)
