#
PROGRAM MKMNEM(INPUT,OUTPUT,INFILE,OUTFILE);
(* Make mnemonic file for A6809 *)

(* #define PRIME	(* For the PRIME, or *)
#define UNIX		(* For UNIX *)

CONST
    MAXMNEM = 160;
    STRSIZE = 6;

TYPE
    STRING = PACKED ARRAY [1..STRSIZE] OF CHAR;
    OPTYPE = ( OPNAM, OPFCB, OPFCC, OPRMB, OPEQU, OPSDP, OPEND,
                OPOPT, OP0, OP1B, OP1W, OPEMT, OPREL, OPREG, OPSTK );

    MNEMRECORD = RECORD
        NAME : STRING;
        OPT  : OPTYPE;
        OPC  : INTEGER;
    END;

VAR
    CONV : ARRAY [ 0 .. 14 ] OF OPTYPE;
    INFILE : TEXT;
    OUTFILE : FILE OF MNEMRECORD;
    TABLE : ARRAY[1..MAXMNEM] OF MNEMRECORD;
    NROFELEM , I , J : INTEGER;
#ifdef PRIME
    FNAME : PACKED ARRAY [1..32] OF CHAR;
#endif

#ifdef PRIME
VALUE
    CONV = ( OPNAM,OPFCB,OPFCC,OPRMB,OPEQU,OPSDP,OPEND,
             OPOPT,OP0,OP1B,OP1W,OPEMT,OPREL,OPREG,OPSTK );

PROCEDURE GETFNAM;
VAR I : INTEGER;
BEGIN
    WHILE INPUT^ = ' ' DO GET(INPUT);
    FOR I := 1 TO 32 DO
        IF EOLN(INPUT) THEN FNAME[I] := ' ' ELSE READ(FNAME[I]);
END(*GETFNAM*);
#endif

PROCEDURE INSTR( VAR S : STRING);
VAR I : INTEGER;
BEGIN
    WHILE INFILE^ = ' ' DO GET(INFILE);
    FOR I := 1 TO STRSIZE DO
        IF INFILE^ = ' ' THEN S[I] := ' ' ELSE READ(INFILE,S[I]);
END(* INSTR *);

PROCEDURE INHEX(VAR N : INTEGER);
VAR D : INTEGER;
BEGIN
    N := 0;
    WHILE INFILE^ = ' ' DO GET(INFILE);
    WHILE INFILE^ IN ['A'..'F','0'..'9'] DO BEGIN
        IF INFILE^ IN ['A'..'F']
           THEN D := ORD(INFILE^)-ORD('A')+10
           ELSE D := ORD(INFILE^)-ORD('0');
        N := N*16+D;
        GET(INFILE);
    END;
END (* INHEX *);

PROCEDURE SORT;
VAR I,J : INTEGER;
    DUMMY : MNEMRECORD;
BEGIN
    FOR I := 1 TO NROFELEM DO
        FOR J := 2 TO NROFELEM DO
            IF TABLE[J].NAME < TABLE[J-1].NAME THEN BEGIN
                DUMMY := TABLE[J];
                TABLE[J] := TABLE[J-1];
                TABLE[J-1] := DUMMY;
            END;
END (* SORT *);

BEGIN
#ifdef PRIME
    WRITE('Input filename - ');
    GETFNAM;
    RESET(INFILE,FNAME);
    WRITE('Output filename - ');
    GETFNAM;
    REWRITE(OUTFILE,FNAME);
#else
    RESET(INFILE);
    REWRITE(OUTFILE);

    CONV[ 0] := OPNAM;
    CONV[ 1] := OPFCB;
    CONV[ 2] := OPFCC;
    CONV[ 3] := OPRMB;
    CONV[ 4] := OPEQU;
    CONV[ 5] := OPSDP;
    CONV[ 6] := OPEND;
    CONV[ 7] := OPOPT;
    CONV[ 8] := OP0  ;
    CONV[ 9] := OP1B ;
    CONV[10] := OP1W ;
    CONV[11] := OPEMT;
    CONV[12] := OPREL;
    CONV[13] := OPREG;
    CONV[14] := OPSTK;
#endif
    WRITE('Reading...');
    I := 0;
    WHILE NOT EOF(INFILE) DO BEGIN
        I := I+1;
        REPEAT
            INSTR(TABLE[I].NAME);
            IF TABLE[I].NAME[1] = '*' THEN
                READLN(INFILE);
        UNTIL TABLE[I].NAME[1] <> '*';
        READ(INFILE,J);
        TABLE[I].OPT := CONV[J];
        INHEX(TABLE[I].OPC);
        WRITE(OUTPUT,'.');
        WHILE (INFILE^ = ' ') AND NOT EOF(INFILE) DO GET(INFILE);
    END;
    NROFELEM := I;
    WRITELN;
    WRITE('Sorting...');
    SORT;
    WRITELN;
    WRITELN('Writing...');
    FOR I := 1 TO NROFELEM DO BEGIN
        OUTFILE^ := TABLE[I];
        PUT(OUTFILE);
    END;
    WRITELN;
END .
