(*
                A68K OPERAND DECODING.
                ==== ======= =========
*)

FUNCTION MAKESTR(ENDC : CHAR) : OPLIST;
(* NAKESTRING LEEST TOT END-OF-LINE OF TOT 'ENDC'                *)
VAR Q : OPLIST;

   FUNCTION MAKST( ENDC : CHAR) : VARSTRING;
   VAR P : VARSTRING;
   BEGIN
       P := NIL;
       IF C<>ENDC THEN BEGIN
           NEW(P);
           P^.INHOUD := C;
           NEXTCH;
           P^.NEXT := NIL;
       END;
       IF (C<>ENDC) AND NOT (EOLN(INP) AND (C = ' ')) THEN P^.NEXT := MAKST(ENDC);
      MAKST := P;
   END (* MAKST *);

BEGIN (* OF MAKESTR *)
    NEW(Q);
    Q^.NEXT := NIL;
    Q^.ARGTP := ARGSTR;
    Q^.ASTEXT := MAKST(ENDC);
    MAKESTR := Q;
END (* FUNCTION MAKESTR *);

FUNCTION MAKEOPER : OPLIST;
(*  MAKEOPER LEEST EEN LIJST OPERANDEN EN RETURNT DIE.  *)
VAR
    RR : REGISTER;
    P    : OPLIST;
    RINC : INTEGER;             (* NUMBER OF MINUS SYMBOLS ON FRONT *)
    NEGATIVE,                        (* TRUE IF A MINUS HAS BEEN SKPD*)
    FLONG : BOOLEAN;                (* FOR FORCING LONG DATA, IF    *)
                                (* DEFLIN > CURLIN.                *)

   FUNCTION MAKEXPR : INTEGER;
   (* MAKEXPR LEEST EEN EXPRESSIE.                                        *)
   VAR
       OLDSY : SYMBOL;
       N,NUMBER : INTEGER;
   
      FUNCTION MAK1NUM : INTEGER;
      (* MAK1NUM LEEST 1 GETAL ( NUMMER,NAAM OF * )  *)
      VAR
          N : INTEGER;
          P : IDRECORD;
      BEGIN
          IF SY = MULSY THEN N := OLOCCNTR ELSE
          IF SY = NUMSY THEN N := SYNUM ELSE
          BEGIN
              P := GETNAM(SYNAM);
              IF P = NIL THEN BEGIN
                  IF PASS2 THEN ERROR('U');
                  FLONG := TRUE;
                  N := -1;
              END ELSE BEGIN
                  IF P^.DEFLIN > LINCNTR THEN FLONG := TRUE;
                  N := P^.WAARDE;
              END;
          END;
          INSYMBOL;
          MAK1NUM := N;
      END (* FUNCTION MAK1NUM *);
   
   BEGIN (* OF FUNCTION MAKEXPR *)
       IF SY IN [NAMSY,NUMSY,MULSY] THEN NUMBER := MAK1NUM
                                    ELSE NUMBER := 0;
       IF NEGATIVE THEN BEGIN
           NUMBER := -NUMBER;
           NEGATIVE := FALSE;
           IF RINC > 1 THEN ERROR('+');
           RINC := 0;
       END;
       WHILE SY IN [ADDSY,MINSY,MULSY,DIVSY,MODSY,ANDSY,ORSY] DO BEGIN
           OLDSY := SY;
           INSYMBOL;
           IF SY IN [NAMSY,NUMSY,MULSY] THEN N := MAK1NUM
            ELSE BEGIN
               SY := ERRORSY;
               ERROR('N');
               N := 1;
           END;
           CASE OLDSY OF
             ADDSY : NUMBER := NUMBER + N;
             MINSY : NUMBER := NUMBER - N;
             MULSY : NUMBER := NUMBER * N;
             DIVSY : IF N = 0 THEN ERROR('/') ELSE NUMBER := NUMBER DIV N;
             MODSY : IF N = 0 THEN ERROR('/') ELSE NUMBER := NUMBER MOD N;
             ANDSY : NUMBER := IAND(NUMBER,N);
             ORSY  : NUMBER := IOR (NUMBER,N);
           END;
       END;
       MAKEXPR := NUMBER;
   END (* FUNCTION MAKEXPR *);
   
   FUNCTION ISREG( VAR RR:REGISTER ):BOOLEAN;
   VAR R  : REGISTER;
   BEGIN
      RR := NOREG;
      FOR R := REGX TO REGDP DO
         IF SYNAM = REGNAME[R] THEN RR:=R;
      IF RR = PCREG THEN RR := REGPC;
      ISREG := RR <> NOREG;
   END; (* ISREG *)
   
BEGIN (* OF FUNCTION MAKEOPER *)
  FLONG := FALSE;
  NEGATIVE := FALSE;
  NEW(P);
  RINC := 0;
  WHILE SY = MINSY DO BEGIN
     NEGATIVE := TRUE;
     INSYMBOL;
     RINC := RINC +1;
  END;
  WITH P^ DO
    IF SY IN [ LBRACKSY ,IMMSY ,NAMSY ,NUMSY, ADDSY, MULSY, GREATERSY,
               LESSY,COMMASY ] THEN
    CASE SY OF
    LBRACKSY : BEGIN
                  ARGTP := ARGIND;
                  INSYMBOL;
                  AILIST := MAKEOPER;
                  IF SY <> RBRACKSY THEN ERROR(']');
                  INSYMBOL;
               END;

    IMMSY   :  BEGIN
                  ARGTP := ARGIMM;
                  INSYMBOL;
                  IF SY IN [NUMSY,NAMSY,ADDSY,MINSY,MULSY] THEN
                     AIVAL := MAKEXPR
                  ELSE BEGIN
                     AIVAL := -1;
                     ERROR('N');
                  END;
               END;

    GREATERSY,LESSY,ADDSY,
    NUMSY,MULSY : BEGIN
                     ARGTP := ARGNUM;
                     ANFORC := (SY=GREATERSY) OR (SY=LESSY);
                     ANLONG := (SY=GREATERSY);
                     IF ANFORC THEN INSYMBOL;
                     ANVAL := MAKEXPR;
                     IF FLONG AND NOT ANFORC THEN BEGIN
                        ANFORC := TRUE;
                        ANLONG := TRUE;
                     END;
                  END;
    NAMSY :  BEGIN
                IF ISREG(RR) THEN BEGIN
                   ARGTP := ARGREG;
                   ARINC := 0;
                   ARREG := RR;
                   INSYMBOL;
                   IF NOT NEGATIVE THEN BEGIN
                      WHILE SY = ADDSY DO BEGIN
                         ARINC := ARINC+1;
                         INSYMBOL;
                      END;
                   END ELSE BEGIN
                      ARINC := -RINC;
		      NEGATIVE := FALSE;
		   END;
                   IF ABS(ARINC) > 2 THEN ERROR('+');
                END ELSE BEGIN
                   ARGTP := ARGNUM;
                   ANVAL := MAKEXPR;
                   ANFORC := FLONG;
                   ANLONG := FLONG;
                END;
             END;
    COMMASY :  BEGIN  (* ONLY , SO MAKE 0 PARAMETER *)
		  ARGTP := ARGNUM;
		  ANVAL := 0;
		  ANFORC := FALSE;
		  ANLONG := FALSE;
	       END;
    END (* CASE STAEMENT *)
  ELSE BEGIN
    DISPOSE (P);
    P := NIL;
  END;
  IF NEGATIVE THEN (* ONLY A MINUS *) ERROR('+');
  IF ( SY = COMMASY ) AND ( P <> NIL ) THEN BEGIN
    INSYMBOL;
    P^.NEXT := MAKEOPER;
  END
  ELSE P^.NEXT := NIL;
  MAKEOPER := P;
END (* FUNCTION MAKEOPER *);

FUNCTION MAKESTMT : STMT;
(* MAKESTMT LEEST EEN STATEMENT MBV INSYMBOL EN NEXTCH, EN *)
(* STUURT DAT TERUG ALS RETURNWAARDE. ALS HET EEN COMMENT  *)
(* IS WORDT COMMENT OP TRUE GEZET.                           *)
CONST
    MNNAM = 'NAM   ';
    MNOPT = 'OPT   ';
    MNFCC = 'FCC   ';
VAR
    P : STMT;
    ENDC : CHAR;
    MNEMON : STRING ;
BEGIN
    INSYMBOL;
    IF (SY = MULSY) OR (SY = EOLNSY) THEN BEGIN (* COMMENTAARREGEL *)
        P := NIL;
        COMMENT := TRUE;
    END ELSE BEGIN
        COMMENT := FALSE;
        NEW(P);
        IF SY = NAMSY THEN BEGIN
            P^.LEBEL := SYNAM;
            INSYMBOL;
        END ELSE P^.LEBEL := LEGEID;
        IF SY = SPACESY THEN INSYMBOL ELSE ERROR('L');
        IF SY = NAMSY THEN BEGIN
            MNEMON := SYNAM;
        END ELSE IF SY = EOFSY THEN MNEMON := 'END   '
        ELSE MNEMON := LEGEID;
        IF (MNEMON[4]=' ') AND (C = ' ') THEN BEGIN
            NEXTCH;
            IF (C<>' ') AND (C<>'	') THEN BEGIN
                MNEMON[4] := C;
                NEXTCH;
            END;
        END;
        INSYMBOL;
        FIND ( MNEMON,P^.OPCODE,P^.OPT);
        IF (P^.OPT <> OP0) THEN BEGIN
(*  PARAMETER DECODERING VOOR 'NAM','OPT' EN 'FCC' *)
           IF( SY=SPACESY) AND (MNEMON<>MNFCC) AND (MNEMON<>MNNAM) THEN
                INSYMBOL;
           IF MNEMON = MNOPT THEN BEGIN
              IF SY = SPACESY THEN INSYMBOL;
              NEW(P^.OPERANDS);
              P^.OPERANDS^.ARGTP := ARGOPT;
              P^.OPERANDS^.AOOPT := SYNAM;
           END ELSE IF MNEMON = MNNAM THEN BEGIN
                 P^.OPERANDS := MAKESTR(CHR(0)); (* LEES TOT EOLN *)
              NEXTCH;
              INSYMBOL;
           END ELSE IF MNEMON = MNFCC THEN BEGIN
              WHILE C = ' ' DO NEXTCH;
              ENDC := C;
              NEXTCH;
              P^.OPERANDS := MAKESTR(ENDC);
              IF C <> ENDC THEN ERROR('Q');
              NEXTCH;
              INSYMBOL;
           END
           ELSE P^.OPERANDS := MAKEOPER;
           END ELSE P^.OPERANDS := NIL ;
        IF ( SY<>SPACESY) AND (SY<>EOLNSY) THEN ERROR('S');
    END;
    WHILE NOT EOLN(INP) DO NEXTCH;
    MAKESTMT := P;
END (* FUNCTION MAKESTMT *);
