(*
                A???? SYMBOLTABLE HANDLING.
                ===== =========== =========
*)

PROCEDURE MNEMINIT;
(*  MNEMINIT LEEST DE TABEL 'MNEMTAB' VAN DE FILE 'MNEMFILE'.  *)
(* UITEINDELIJKE LENGTE KOMT IN MNEMLEN. MAX LEN IN 'MAXMNEM'. *)
(* DE FILE MOET GESORTEERD ZIJN, EN DE NAAM MOET IN 'MNEMNAM'  *)
(* STAAN.                                   *)
VAR
    I : INTEGER;
BEGIN
#ifdef PRIME
    RESET(MNEMFILE,MNEMNAM);
#else
    RESET(MNEMFILE);
#endif
    I := 0;
    WHILE NOT EOF(MNEMFILE) DO BEGIN
        I := I + 1;
        IF I < MAXMNEM THEN MNEMTAB[I] := MNEMFILE^;
        GET(MNEMFILE);
    END;
(*DBG  writeln(i,' Mnemonics gelezen.');*)
    MNEMLEN := I;
    IF I > MAXMNEM THEN BEGIN
        WRITELN(OUTPUT,'**FATAL ERROR : MNEMONIC TABLE TOO LONG');
        MNEMLEN := 0;
    END;
END (* MNEMINIT *);

PROCEDURE FIND(MNEM : STRING; VAR OPC : INTEGER; VAR TP : OPTYPE);
(* FIND ZOEKT EEN MNEMONIC OP EN RETURNT OPC EN TP  *)
VAR
    OLOW, OHIGH, LOW, MID, HIGH : INTEGER;
BEGIN
    LOW := 1;
    HIGH := MNEMLEN;
    MID := (LOW+HIGH) DIV 2;
    OLOW := LOW-1;
    OHIGH := HIGH;
    WHILE (MNEMTAB[MID].NAME<>MNEM)AND((OLOW<>LOW)OR(OHIGH<>HIGH)) DO BEGIN
        OLOW := LOW;
        OHIGH := HIGH;
        IF MNEMTAB[MID].NAME < MNEM THEN LOW := MID
                                     ELSE HIGH := MID;
        MID := (LOW+HIGH) DIV 2;
    END;
    IF MNEMTAB[MID].NAME <> MNEM THEN BEGIN
        ERROR('O');
        TP := OP0;
        OPC := 254;
    END ELSE BEGIN
        TP := MNEMTAB[MID].OPT;
        OPC:= MNEMTAB[MID].OPC;
    END;
END (* FIND *);


FUNCTION GETNAM(NAME : STRING) : IDRECORD;
(* GETNAM ZOEKT DE NODE MET NAAM 'NAME' OP, EN RETURN HET  *)
(* IDRECORD DAT ERBIJ HOORT, OF NIL ALS 'NAME' NIET BESTAAT*)

VAR
    FOUND : BOOLEAN;
    P     : TREE;
BEGIN
    P := ROOT;
    FOUND := P=NIL;
    IF NOT FOUND THEN FOUND := P^.NAME = NAME;
    WHILE NOT FOUND DO BEGIN
        IF P^.NAME < NAME THEN P := P^.LLINK
                          ELSE P := P^.RLINK;
        FOUND := P = NIL;
        IF NOT FOUND THEN FOUND := P^.NAME = NAME;
    END;
    IF P = NIL THEN GETNAM := NIL
               ELSE GETNAM := P^.DATA;
END (* FUNCTION GETNAM *);

FUNCTION NEWNAM(NAME : STRING; DATA : IDRECORD):BOOLEAN;
(* NEWNAM ZET 'NAME' IN DE BOOM, ALS HIJ NOG NIET BESTAAT, *)
(* EN RETURNT 'TRUE' ALS ER GEEN VERSCHIL IS TUSSEN DE     *)
(* NIEUWE EN (EVENTUELE) OUDE DATA.                           *)
VAR
    P,OLDP : TREE;
    SIGN,FOUND : BOOLEAN;
BEGIN
    OLDP := NIL;
    P := ROOT;
    FOUND := P=NIL;
    IF NOT FOUND THEN FOUND := P^.NAME=NAME;
    WHILE NOT FOUND DO BEGIN
        OLDP := P;
        SIGN := P^.NAME < NAME;
        IF SIGN THEN P := P^.LLINK
                ELSE P := P^.RLINK;
        FOUND := P = NIL;
        IF NOT FOUND THEN FOUND := P^.NAME = NAME;
    END;
    IF P <> NIL THEN BEGIN
        NEWNAM := (P^.DATA^.WAARDE=DATA^.WAARDE)AND
                  (P^.DATA^.DEFLIN=DATA^.DEFLIN);
        P^.DATA := DATA;
    END ELSE BEGIN
        NEW(P);
        P^.NAME := NAME;
        P^.DATA := DATA;
        P^.LLINK := NIL;
        P^.RLINK := NIL;
        IF OLDP = NIL THEN ROOT := P ELSE
         IF SIGN THEN OLDP^.LLINK := P
          ELSE OLDP^.RLINK := P;
        NEWNAM := TRUE;
    END;
END (* FUNCTION NEWNAM *);

PROCEDURE SYMTABLE;
(* SYMTABLE LIST DE SYMBOLTABLE, ALFABETISCH GESORTEERD. *)
VAR SYMDUN : INTEGER;
PROCEDURE L1SYM(P : TREE);
(* LIST EEN SYMBOOL EN DE BIJBEHORENDE BOOM *)
BEGIN
    IF P^.RLINK <> NIL THEN L1SYM(P^.RLINK);
    WRITE(' ',P^.NAME,P^.DATA^.DEFLIN : 5,' ');
    PRINTHEX(OUTPUT,P^.DATA^.WAARDE,4);
    WRITE(OUTPUT,'  ');
    SYMDUN := SYMDUN + 1;
    IF SYMDUN > 4 THEN BEGIN
         SYMDUN := 1;
         WRITELN;
    END;
    IF P^.LLINK <> NIL THEN L1SYM(P^.LLINK);
END (* L1SYM *);

BEGIN (* OF SYMTABLE *)
    SYMDUN := 1;
    FOR SYMDUN := 1 TO 4 DO
        WRITE(' NAME    DEF VALUE ');
    WRITELN; WRITELN;
    SYMDUN := 1;
    IF ROOT <> NIL THEN L1SYM(ROOT);
   WRITELN; WRITELN;
END (* SYMTABLE *);
