.\" Deltac deltau
.\" 
.\" Permission to use, copy, and distribute this software and its
.\" documentation for any purpose and without fee is hereby granted,
.\" provided that the above copyright notice appear in all copies and that
.\" both that copyright notice and this permission notice appear in
.\" supporting documentation.
.\" 
.\" THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
.\" WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
.\" MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
.\" 
.TH DELTAC L "7 June 1990"
.SH NAME
deltac, deltau \- compress and expand using delta modulation
.SH SYNOPSIS
.B deltac
.IR no options
.LP
.B deltau
.IR no options
.SH DESCRIPTION
.B Deltac
compresses eight bit data from standard input to the standard output
using delta modulation.  Each byte is stored as four bits if the absolute
value of its difference from a running value is less than 8.
This technique has proven to be more effective than \fIcompress(1)\fP
or \fIpack(1)\fP for 8 bit grey level graphics images.  It could also
work on 24 bit colour images if each plane is stored separately.  For
any other data the size will probably increase.
.LP
.B Deltau
reads data compressed produced by
.B deltac
from the standard input and outputs the uncompressed data on
standard output.
.SH DIAGNOSTICS
Both programs will terminate with an error if they fail on writing
on standard output.
.SH AUTHOR
Diomidis Spinellis <dds@cc.ic.ac.uk>
.SH "SEE ALSO"
.BR compress (1)
.BR pack (1)
