#include <sys/types.h>
#include <sys/file.h>
#ifdef BSD
#include <sgtty.h>
#endif
#include <stdio.h>

extern char	*alo_getline();

char *
alo_getpass(prompt)

char	*prompt;

{
  struct sgttyb	t_old;
  FILE		*tf;
  int		tf0;
  FILE		*of = stderr;
  int		ef;
  char		*r;
  
  if ((tf0 = open("/dev/tty",O_RDWR,0)) != -1) {
    if (!(tf = fdopen(tf0,"r"))) {
      close(tf0);
      return 0;
    }
  } else {
    tf = 0;
  }
  if (!tf)
    tf = stdin;
  fputs(prompt,of);
  fflush(of);
#ifdef BSD
  ioctl(fileno(tf),TIOCGETP,&t_old);
  ef = t_old.sg_flags & ECHO;
  t_old.sg_flags &= ~ECHO;
  ioctl(fileno(tf),TIOCSETP,&t_old);
#endif
  r = alo_getline(tf);
#ifdef BSD
  if (r)
    fputs("\n",of);
  ioctl(fileno(tf),TIOCGETP,&t_old);
  t_old.sg_flags &= ~ECHO;
  t_old.sg_flags |= ef;
  ioctl(fileno(tf),TIOCSETP,&t_old);
#endif
  if (tf != stdin)
    fclose(tf);
  return r;
}
