case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
# $Header: Makefile.SH,v 2.0 88/06/28 23:12:03 lwall Locked $
#
# $Log:	Makefile.SH,v $
# Revision 2.0  88/06/28  23:12:03  lwall
# Baseline.
# 

bin = $bin
mansrc = $mansrc
manext = $manext
CFLAGS = -O
LDFLAGS = $iandd

!GROK!THIS!
cat >>Makefile <<'!NO!SUBS!'

CC = cc
public = makedist makeSH
private = 
manpages = makedist.man
util = Makefile

c =

obj =

lintflags = -phbvxac

addedbyconf = Makefile makedist

# grrr
SHELL = /bin/sh

.c.o:
	$(CC) -c $(CFLAGS) $*.c

all: $(public) $(private) $(util)
	touch all

makedist: makedist.SH
	sh makedist.SH

# won't work with csh
install: $(public)
	export PATH || exit 1
	- if test `pwd` != $(bin); then cp $(public) $(bin); fi
	cd $(bin); chmod +x $(public)
	- if test `pwd` != $(mansrc); then \
for page in $(manpages); do \
cp $$page $(mansrc)/`basename $$page .man`.$(manext); \
done; \
fi

clean:
	rm -f *.o

realclean:
	rm -f kitlists *.o core $(addedbyconf)

# The following lint has practically everything turned on.  Unfortunately,
# you have to wade through a lot of mumbo jumbo that can't be suppressed.
# If the source file has a /*NOSTRICT*/ somewhere, ignore the lint message
# for that spot.

lint:
	lint $(lintflags) $(defs) $(c) > kitlists.fuzz

!NO!SUBS!
$eunicefix Makefile
