.rn '' }`
''' $Header: metaconfig.man,v 2.0 88/06/28 23:18:51 lwall Locked $
''' 
''' $Log:	metaconfig.man,v $
''' Revision 2.0  88/06/28  23:18:51  lwall
''' Baseline.
''' 
''' 
.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
'''
'''     Set up \*(-- to give an unbreakable dash;
'''     string Tr holds user defined translation string.
'''     Bell System Logo is used as a dummy character.
'''
.ie n \{\
.tr \(*W-\*(Tr
.ds -- \(*W-
.if (\n(.H=4u)&(1m=24u) .ds -- \(*W\h'-12u'\(*W\h'-12u'-\" diablo 10 pitch
.if (\n(.H=4u)&(1m=20u) .ds -- \(*W\h'-12u'\(*W\h'-8u'-\" diablo 12 pitch
.ds L" ""
.ds R" ""
.ds L' '
.ds R' '
'br\}
.el\{\
.ds -- \(em\|
.tr \*(Tr
.ds L" ``
.ds R" ''
.ds L' `
.ds R' '
'br\}
.de Sh
.br
.ne 5
.PP
\fB\\$1\fR
.PP
..
.de Sp
.if t .sp .5v
.if n .sp
..
.de Ip
.br
.ie \\n.$>=3 .ne \\$3
.el .ne 3
.IP "\\$1" \\$2
..
.TH METACONFIG 1 LOCAL
.SH NAME
metaconfig - a Configure script generator
.SH SYNOPSIS
.B metaconfig
[options] 
.SH DESCRIPTION
.I Metaconfig
is a program that writes Configure scripts.
If you don't know what a Configure script is, you probably aren't
interested in
.IR metaconfig .
.PP
.I Metaconfig
operates from set of
.I units
which define everything that metaconfig knows about portability.
Each unit is self-contained, and does not have to be registered anywhere
other than by inclusion in either the public U directory or your private
U directory.
If the dist package (of which metaconfig is a part) is installed in LIB,
then the public U directory is LIB/dist/mcon/U.
Your private U directory, if you have one,
is in the top level directory of your package.
Before you can run metaconfig you must do a several things:
.Ip 1) 4 4
Create a .package file in the package's top level directory by running packinit.
This program will ask you about your package and remember what you tell
it so that all the dist programs can be smart.
.Ip 2) 4 4
Consult the Glossary (in LIB/dist/mcon) and write your shell scripts and
C programs in terms of the symbols that metaconfig knows how to define.
You don't need to tell metaconfig which symbols you used, since metaconfig
will figure that out for you.
.Ip 3) 4 4
Generate any .SH scripts needed to write Makefiles or shell scripts that
will depend on values defined by Configure.
There is a program called makeSH that will help you do this.
.Ip 4) 4 4
Create a MANIFEST.new file in your top level directory that lists all the
files in your package.
The filename should be the first field on each line.
After some whitespace you can add a comment which will end up in MANIFEST.
.Ip 5) 4 4
Copy any .U files that you want to modify to your private U directory.
Any .U files in your private U directory will be used in preference to
the one in the public U directory.
For example, one way to force inclusion of any unit is to copy the End.U
file to your .U directory and add the name of the unit you want as
a dependency on the end of the ?MAKE: line.
Certain units can ONLY be forced in this way, namely those of the form
Warn_*.U and Chk_*.U.
You can also customize certain default Configure variables by copying
Myinit.U to your package's private U directory and setting the variables in
that unit.
.PP
Now you are ready to run metaconfig.
.PP
If you are testing a new unit, and your source files haven't changed,
you may use the
.B \-w
switch to suppress the scan of your programs.
In this case, metaconfig uses the Wanted file from the previous run
of metaconfig.
.PP
The
.B \-v
switch makes metaconfig a little more verbose.
The
.B \-V
switch makes metaconfig a LOT more verbose.
.PP
In order to create new units, do the following:
.Ip 1) 4 4
Copy a similar unit to a new .U file.
The name you choose should be the name of a variable generated by the unit.
It should be 12 or less characters to prevent filename chopping.
Actually, it should probably be 10 or less so that those who want to use RCS
can have a .U,v on the end without chopping.
Metaconfig uses the case of the first letter to determine if any variable is
actually produced by this unit, so don't Capitalize your unit
name if it is supposed to produce a shell variable.
.Ip 2) 4 4
Edit the new .U file to do what you want.
The first ?MAKE: line indicates the dependencies; before the final list
colon all the variables this unit defines, and after the final colon
all the variables (or other units) on which this unit depends.
It is very important that these lists be accurate.
IMPORTANT: The first symbol after ?MAKE: *must* be the name of the file
(without the .U).
.Ip 3) 4 4
To the extent possible, parameterize your unit based on shell
variable defined on ?INIT: lines.
This will move the variable definitions up to the Init.U unit,
where they can be overridden by definitions in Myinit.U, which is
included after Init.U.
.Ip 4) 4 4
Add the definition of any C symbols desired as ?H: lines.
A line beginning with ?H:?%1: in the .U file will be added to the eventual
config.h file if and only if metaconfig decides that the first symbol
on the ?MAKE: line is needed.
The %1 stands for that first symbol, which happens to be the name of
the file too (without .U).
Always put a comment on each ?H: line in case one of the variable
substitutions earlier on the line starts a comment without finishing it.
Any shell variable starting with d_ may do this, so beware.
.Ip 5) 4 4
Add glossary definitions as ?S: lines for shell variables and ?C:
lines for C preprocessor variables.
See a current unit for examples.
It is VERY important to start each entry with a left justified symbol
name, and end each entry with with a ?C:. or ?S:. line.  The algorithm
that translates C preprocessor symbol entries for the Glossary into
comments for config.h depends on this.
.Ip 6) 4 4
Make sure the order of all your ? lines is right.  The correct order is:
.nf

	?RCS: and ?X: lines		-- basically just comments
	?MAKE: lines			-- metaconfig dependencies
	?C: and ?S: lines		-- Glossary definitions
	?H: lines			-- config.h definitions

	?INIT: lines can go anywhere.

.fi
.Ip 7) 4 4
Put the unit into the public or private U directory as appropriate.
.Ip 8) 4 4
Rerun metaconfig.
.Ip 9) 4 4
Send unit to lwall@jpl-devvax.jpl.nasa.gov (Larry Wall) for inclusion
in the master copy, if you think it's of general interest.
.PP
In order to add a new program to be located:
.Ip 1) 4 4
Edit Loc.U, and add the name of the program both to the ?MAKE: line
(between the two colons) and to either loclist or trylist (depending
on whether the program is mandatory or not).
.Ip 2) 4 4
Rerun metaconfig.
.Ip 3) 4 4
Send Loc.U to me for inclusion in the master copy, if you think it's
of general interest.
.PP
Notes for writing .U files:
.Ip * 4 4
Always use "rm -f" because there are systems where rm is interactive by
default.
.Ip * 4 4
Always use echo " " (with a space) because of Eunice systems.
.Ip * 4 4
Use only programs that came with V7, so that you know everyone has them.
.Ip * 4 4
Use $contains when you want to grep conditionally, since not all
greps return a reasonable status.
Be sure to redirect the output to /dev/null.
.Ip * 4 4
Use "if test" rather than "if [...]" since not every sh knows the
latter construct.
.Ip * 4 4
Use the myread script for inputs so that they can do shell escapes
and default evaluation.  The general form is
.nf

	case "$grimble" in
	'') dflt=452;;
	*) dflt="$grimble";;
	esac
	rp="How many grimbles do you have? [$dflt]"
	echo $n "$rp $c"
	. myread
	grimble="$ans"
.fi
.Ip * 4 4
Always try to determine whether a feature is present in the most
specific way--don't say "if bsd" when you can grep libc.  There
are many hybrid systems out there, and each feature should stand
or fall by itself.
.Ip * 4 4
Always try to determine whether a feature is present in the most
general way, so that other packages can use your unit.
.Ip * 4 4
When in doubt, set a default and ask.  Don't assume anything.
.Ip * 4 4
If you think the user is wrong, allow for the fact that he may be right.
For instance, he could be running Configure on a different system than
he is going to use the final product on.
.PP
Metaconfig reserves the following names in your directory, and if you use such
a name it may get clobbered or have other unforeseen effects:
.nf

	.MT/*
	Configure
	Wanted
	UU/*

.fi
Additionally, Configure may clobber these names in the directory it is run in:
.nf

	UU/*
	config.sh
	config.h
.fi
.SH AUTHOR
Larry Wall <lwall@jpl-devvax.jpl.nasa.gov>
.SH ENVIRONMENT
No environment variables are used by
.IR metaconfig .
.SH FILES
LIB/dist/mcon/U/*.U
.br
LIB/dist/mcon/Glossary
.br
    where LIB is something like /usr/lib or /usr/local/lib.
.SH SEE ALSO
pat(1)
.br
makeSH(1)
.br
makedist(1)
.SH DIAGNOSTICS
.SH BUGS
Units are sometimes included unnecessarily if one of its symbols is
accidentally mentioned, e.g. in a comment.
Better too many units than too few, however.
.rn }` ''
