case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
# $Header: Makefile.SH,v 2.0 88/06/28 23:19:00 lwall Locked $
#
# $Log:	Makefile.SH,v $
# Revision 2.0  88/06/28  23:19:00  lwall
# Baseline.
# 

bin = $bin
mansrc = $mansrc
manext = $manext

!GROK!THIS!
cat >>Makefile <<'!NO!SUBS!'

public = pat patcil patbase patdiff patmake patpost patsend patftp \
	patindex
private = 
manpages = pat.man
util = Makefile

c = 

obj = 

addedbyconf = pat patmake patpost patsend

# grrr
SHELL = /bin/sh

all: $(public) $(private) $(util)
	touch all
pat: pat.SH ../pl/package.pl
	sh pat.SH

patbase: patbase.SH ../pl/package.pl ../pl/rcsargs.pl ../pl/comment.pl
	sh patbase.SH

patcil: patcil.SH ../pl/package.pl ../pl/rcsargs.pl ../pl/comment.pl
	sh patcil.SH

patdiff: patdiff.SH ../pl/package.pl ../pl/rcsargs.pl
	sh patdiff.SH

patmake: patmake.SH ../pl/package.pl
	sh patmake.SH

patpost: patpost.SH ../pl/package.pl ../pl/rangeargs.pl
	sh patpost.SH

patsend: patsend.SH ../pl/package.pl ../pl/rangeargs.pl
	sh patsend.SH

patftp: patftp.SH ../pl/package.pl ../pl/rangeargs.pl
	sh patftp.SH

Makefile: Makefile.SH
	sh Makefile.SH

# won't work with csh
install: $(public)
	export PATH || exit 1
	- if test `pwd` != $(bin); then cp $(public) $(bin); fi
	cd $(bin); chmod +x $(public)
	- if test `pwd` != $(mansrc); then \
for page in $(manpages); do \
cp $$page $(mansrc)/`basename $$page .man`.$(manext); \
done; \
fi

clean:

realclean:
	rm -f core $(addedbyconf)

!NO!SUBS!
$eunicefix Makefile
