case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting patbase (with variable substitutions)"
cat >patbase <<!GROK!THIS!
#!/usr/bin/perl
        eval "exec /usr/bin/perl -S \$0 \$*"
                if \$running_under_some_shell;

# $Header: patbase.SH,v 2.0 88/06/28 23:19:25 lwall Locked $
#
# $Log:	patbase.SH,v $
# Revision 2.0  88/06/28  23:19:25  lwall
# Baseline.
# 
# 

!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
cat >>patbase <<'!NO!SUBS!'

die "pat [files]\n" unless $#ARGV >= 0;

do readpackage();

$RCSEXT = ',v' unless $RCSEXT;

if ($ARGV[0] eq '-a') {
    open(MANI,"MANIFEST.new") || die "No MANIFEST.new found.\n";
    @ARGV = ();
    while (<MANI>) {
        chop;
	($_) = split(' ');
        push(@ARGV,$_);
    }
    close MANI;
}

foreach $file (@ARGV) {
    $files = do rcsargs($file);
    @files = split(' ',$files);
    $revs=0;
    $rlog = `rlog -r$baserev -r$revbranch $files 2>&1`;
    ($revs) = ($rlog =~ /selected revisions: (\d+)/);
    if (!$revs) {
	print "patbase: $file has never been checked in--checking in...\n";
	$comment = rcscomment($file);
	system 'rcs', '-i', "-c$comment", @files if $comment;
	(system 'ci', "-l$baserev", @files) ||
	  (system 'rcs', "-Nlastpat:$baserev", @files);
    }
    elsif ($revs == 1) {
	print "Last revision for $file is $baserev.\n";
	system 'rcs', "-Nlastpat:$baserev", @files;
    }
    else {
	($lastrev) = ($rlog =~ /revision $revbranch\.(\d+)/);
	print "Last revision for $file is $revbranch.$lastrev.\n";
	system 'rcs', "-Nlastpat:$revbranch.$lastrev", @files;
    }
}
unlink ".rlog$$";

!NO!SUBS!
cat ../pl/package.pl >>patbase
cat ../pl/rcsargs.pl >>patbase
cat ../pl/comment.pl >>patbase
chmod +x patbase
$eunicefix patbase
