case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting patdiff (with variable substitutions)"
cat >patdiff <<!GROK!THIS!
#!/usr/bin/perl
        eval "exec /usr/bin/perl -S \$0 \$*"
                if \$running_under_some_shell;

# $Header: patdiff.SH,v 2.0 88/06/28 23:19:39 lwall Locked $
#
# $Log:	patdiff.SH,v $
# Revision 2.0  88/06/28  23:19:39  lwall
# Baseline.
# 
# 

!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
cat >>patdiff <<'!NO!SUBS!'

$RCSEXT = ',v' unless $RCSEXT;

die "patdiff [files]\n" unless $#ARGV >= 0;

do readpackage();

system 'mkdir', 'bugs' unless -d 'bugs';

if (-f 'patchlevel.h') {
    open(PL,"patchlevel.h") || die "Can't open patchlevel.h\n";
    while (<PL>) {
        $bnum = $1 if /^#define\s+PATCHLEVEL\s+(\d+)/;
    }
    die "Malformed patchlevel.h file.\n" if $bnum eq '';
    ++$bnum;
}
else {
    $bnum=1;
}

$update = 1;
while ($ARGV[0] =~ /^-/) {
    $_ = shift;
    last if /--/;
    if ($_ eq '-n') {
        $update = 0;
    }
    elsif ($_ eq '-a') {
        $all++;
    }
    else {
        die "Unrecognized switch: $_\n";
    }
}

if ($all) {
    open(MANI,"MANIFEST.new") || die "No MANIFEST.new found.\n";
    @ARGV = ();
    while (<MANI>) {
        chop;
	($_) = split(' ');
        push(@ARGV,$_);
    }
    close MANI;
}

foreach $file (@ARGV) {
    if (! -f $file) {
	print "$file not found.\n";
    }
    else {
	$files = do rcsargs($file);
	@files = split(' ',$files);
	$new='';
	$revs=0;
	$rlog = `rlog -rlastpat- $files 2>&1`;
	($lastpat) = ($rlog =~ /lastpat: ([\d.]+)/);
	($revs) = ($rlog =~ /selected revisions: (\d+)/);
	if (!$revs) {
	    print "No cil has been done on $file.\n" ;;
	}
	elsif ($revs == 1) {
	    ($base) = ($rlog =~ /.*\nrevision\s+(\S+)/);
	    ($a,$b,$c,$d) = split(/\./,$base);
	    if ($d ne '') {
		if ($update) {
		    print "No changes in $file since last patch.  (Did you cil it?)\n";
		}
		else {
		    $new='foo';
		}
	    }
	    else {
		$revs=0;
		$rlog = `rlog -r$revbranch- $files 2>&1`;
		($revs) = ($rlog =~ /selected revisions: (\d+)/);
		if (!$revs) {
		    print "No changes in $file since base version.  (Did you cil it?)\n";
		}
		else {
		    ($new) = ($rlog =~ /\nrevision\s*(\d+\.\d+\.\d+\.\d+)/);
		}
	    }
	}
	else {
	    ($new) = ($rlog =~ /\nrevision\s*(\d+\.\d+\.\d+\.\d+)/);
	}
	if ($new ne '') {
	    ($fname = $file) =~ s|.*/||;
	    open(PATCH,">>bugs/$fname.$bnum") || die "Can't make patch";
	    print PATCH "\nIndex: $file\n";
	    open(CO,"co -p -rlastpat $files 2>/dev/null |");
	    while (<CO>) {
		if (/\$Header/) {
		    print PATCH "Prereq: $lastpat\n";
		    last;
		}
	    }
	    close CO;
	    if ($update) {
		if ($mydiff eq '') {
		    open(DIFF,"rcsdiff -c -rlastpat -r$new $files |") ||
			die "Can't run rcsdiff";
		    while (<DIFF>) {
			if ($. == 1) {s|\*\*\* \S+	|*** $file.old	|;}
			if ($. == 2) {s|--- \S+	|--- $file	|;}
			print PATCH;
		    }
		    close DIFF;
		    system 'rcs', "-Nlastpat:$new", @files;
		}
		else {
		    system "co -p -rlastpat $files >/tmp/pdo$$";
		    system "co -p -r$new $files >/tmp/pdn$$";
		    open(DIFF, "$mydiff /tmp/pdo$$ /tmp/pdn$$ |") ||
			die "Can't run $mydiff";
		    while (<DIFF>) {
			if ($. == 1) {s|\*\*\* \S+	|*** $file.old	|;}
			if ($. == 2) {s|--- \S+	|--- $file	|;}
			print PATCH;
		    }
		    close DIFF;
		    system 'rcs', "-Nlastpat:$new", @files;
		    unlink "/tmp/pdn$$", "/tmp/pdo$$";
		}
	    }
	    else {
		if ($mydiff eq '') {
		    open(DIFF,"rcsdiff -c -rlastpat $files |") ||
			die "Can't run rcsdiff";
		    while (<DIFF>) {
			if ($. == 1) {s|\*\*\* \S+	|*** $file.old	|;}
			if ($. == 2) {s|--- \S+	|--- $file	|;}
			print PATCH;
		    }
		    close DIFF;
		}
		else {
		    system "co -p -rlastpat $files >/tmp/pdo$$";
		    system "cp $file /tmp/pdn$$";
		    open(DIFF, "$mydiff /tmp/pdo$$ /tmp/pdn$$ |") ||
			die "Can't run $mydiff";
		    while (<DIFF>) {
			if ($. == 1) {s|\*\*\* \S+	|*** $file.old	|;}
			if ($. == 2) {s|--- \S+	|--- $file	|;}
			print PATCH;
		    }
		    close DIFF;
		    unlink "/tmp/pdn$$", "/tmp/pdo$$";
		}
	    }
	}
    }
}
unlink ".rlog$$";

!NO!SUBS!
cat ../pl/package.pl >>patdiff
cat ../pl/rcsargs.pl >>patdiff
chmod +x patdiff
$eunicefix patdiff
