case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting patftp (with variable substitutions)"
cat >patftp <<!GROK!THIS!
#!/usr/bin/perl
        eval "exec /usr/bin/perl -S \$0 \$*"
                if \$running_under_some_shell;

# $Header: patftp.SH,v 2.0 88/06/28 23:19:57 lwall Locked $
#
# $Log:	patftp.SH,v $
# Revision 2.0  88/06/28  23:19:57  lwall
# Baseline.
# 

\$orgname='$orgname';
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
cat >>patftp <<'!NO!SUBS!'

chop($orgname = `cat $orgname`) if $orgname =~ m|^/|;

chdir '..' if -f '../.package';

do readpackage();

if ($#ARGV < 0) {
    open(PL,"patchlevel.h") || die "Can't open patchlevel.h\n";
    while (<PL>) {
        $argv = $1 if /^#define\s+PATCHLEVEL\s+(\d+)/;
    }
    close PL;
    die "Malformed patchlevel.h file.\n" if $argv eq '';
    @ARGV = $argv;
}
else {
    for (@ARGV) {
	s/^patch//;
    }
    $argv = do rangeargs(@ARGV);
    @ARGV = split(' ',$argv);
}

if ($#ARGV < 0) {
    die "No patches specified.\n";
}
elsif ($#ARGV) {
    print "Copying $package $baserev patches $argv to $ftpdir...\n";
}
else {
    print "Copying $package $baserev patch $argv to $ftpdir...\n";
}

chdir 'bugs' || die "Can't cd to bugs\n";

until ($#ARGV < 0) {
    $patnum = shift;
    `cp patch$patnum $ftpdir`;
}

!NO!SUBS!
cat ../pl/package.pl >>patftp
cat ../pl/rangeargs.pl >>patftp
chmod +x patftp
$eunicefix patftp
