case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting patpost (with variable substitutions)"
cat >patpost <<!GROK!THIS!
#!/usr/bin/perl
	eval "exec /usr/bin/perl -S \$0 \$*"
		if \$running_under_some_shell;

# $Header: patpost.SH,v 2.0 88/06/28 23:19:50 lwall Locked $
#
# $Log:	patpost.SH,v $
# Revision 2.0  88/06/28  23:19:50  lwall
# Baseline.
# 

\$inews='${inews-/usr/lib/news/inews}';
\$orgname='$orgname';
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
cat >>patpost <<'!NO!SUBS!'
if ($inews eq 'inews') {
    $inews = '/usr/lib/news/inews' if -f '/usr/lib/news/inews';
}

chdir '..' if -f '../.package';

do readpackage();

chop($orgname = `cat $orgname`) if $orgname =~ m|^/|;

if ($ARGV[0] eq '-r') {
    shift; $repost = ' (REPOST)';
}

while ($_ = shift) {
    if (/^(patch)?[1-9][\d\-]*$/) {
	s/^patch//;
	push(@argv,$_);
    }
    else {
	push(@newsgroups,$_);
    }
}
$newsgroups = join(',',@newsgroups) unless $#newsgroups < 0;
die "patpost newsgroups [patches]\n" unless $newsgroups;

@ARGV = @argv;
open(PL,"patchlevel.h") || die "Can't open patchlevel.h\n";
while (<PL>) {
    $maxnum = $1 if /^#define\s+PATCHLEVEL\s+(\d+)/;
}
close PL;
die "Malformed patchlevel.h file.\n" if $maxnum eq '';

if ($#ARGV < 0) {
    $argv = $maxnum;
    @ARGV = $argv;
}
else {
    $argv = do rangeargs(@ARGV);
    @ARGV = split(' ',$argv);
}

$argv =~ s/ $//;

if ($#ARGV < 0) {
    die "No patches specified.\n";
}
elsif ($#ARGV) {
    print "Posting $package $baserev patches $argv to $newsgroups...\n";
}
else {
    print "Posting $package $baserev patch $argv to $newsgroups...\n";
}

chdir 'bugs' || die "Can't cd to bugs\n";

fork && exit;

until ($#ARGV < 0) {
    $patnum = shift;
    open(XHEAD,">.xhead$$") || die "Can't create temp file.\n";
    print XHEAD
"Newsgroups: $newsgroups
Subject: $package $baserev patch #$patnum$repost
Summary: This is an official patch for $package $baserev.  Please apply it.
Expires: 
References: 
Sender: 
Distribution: 
Organization: $orgname
Keywords: 

";
    open(PATCH,"patch$patnum") || die "Can't open patch$_\n";
    while (<PATCH>) {
	print XHEAD;
    }
    close XHEAD;
    system "$inews -h <.xhead$$";
}
unlink ".xhead$$";

!NO!SUBS!
cat ../pl/package.pl >>patpost
cat ../pl/rangeargs.pl >>patpost
chmod +x patpost
$eunicefix patpost
