case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting patsend (with variable substitutions)"
cat >patsend <<!GROK!THIS!
#!/usr/bin/perl
        eval "exec /usr/bin/perl -S \$0 \$*"
                if \$running_under_some_shell;

# $Header: patsend.SH,v 2.0 88/06/28 23:19:54 lwall Locked $
#
# $Log:	patsend.SH,v $
# Revision 2.0  88/06/28  23:19:54  lwall
# Baseline.
# 

\$orgname='$orgname';
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
cat >>patsend <<'!NO!SUBS!'

chop($orgname = `cat $orgname`) if $orgname =~ m|^/|;

chdir '..' if -f '../.package';

do readpackage();

while ($_ = shift) {
    if (/^(patch)?[1-9][\d,-]*$/) {
	s/^patch//;
	push(@argv,$_);
    }
    else {
	push(@dest,$_);
    }
}
$dest = join(' ',@dest);
die "patsend dest [patches]\n" unless $dest;

@ARGV = @argv;

open(PL,"patchlevel.h") || die "Can't open patchlevel.h\n";
while (<PL>) {
    $maxnum = $1 if /^#define\s+PATCHLEVEL\s+(\d+)/;
}
close PL;
die "Malformed patchlevel.h file.\n" if $maxnum eq '';

if ($#ARGV < 0) {
    $argv = $maxnum;
    @ARGV = $argv;
}
else {
    $argv = do rangeargs(@ARGV);
    @ARGV = split(' ',$argv);
}

$argv =~ s/ $//;

if ($#ARGV < 0) {
    die "No patches specified.\n";
}
elsif ($#ARGV) {
    print "Sending $package $baserev patches $argv to $dest...\n";
}
else {
    print "Sending $package $baserev patch $argv to $dest...\n";
}

chdir 'bugs' || die "Can't cd to bugs\n";

fork && exit;

until ($#ARGV < 0) {
    $patnum = shift;
    open(XHEAD,">.xhead$$") || die "Can't create temp file.\n";
    print XHEAD
"Subject: $package $baserev patch #$patnum
Organization: $orgname

[The latest patch for $package version $baserev is #$maxnum.]

";
    open(PATCH,"patch$patnum") || die "Can't open patch$_\n";
    while (<PATCH>) {
        print XHEAD;
    }
    close XHEAD;
    system "/bin/mail $dest <.xhead$$";
}
unlink ".xhead$$";

!NO!SUBS!
cat ../pl/package.pl >>patsend
cat ../pl/rangeargs.pl >>patsend
chmod +x patsend
$eunicefix patsend
