/* CHK=0x48C0 */
/*+-------------------------------------------------------------------------
	bamboozle.c - ecu/ecuungetty protection scheme
	wht%n4hgf@gatech.edu
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:23-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:03-15-1990-01:45-wht@n4hgf-suggest some variations on the theme */
/*:10-28-1989-16:26-wht-provide for no crypt */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:07-03-1989-01:50-wht-creation */

char *crypt(char *,char *);


/*+-------------------------------------------------------------------------
	bamboozle(pid) - build encrypted string based on 'pid'

If crypt not used, do something pretty basic  (probably enough)
If you are paranoid, don't use _ANY_ of these algorithms exactly
--------------------------------------------------------------------------*/
char *
bamboozle(pid)
int pid;
{
#if defined(CRYPT)
char pidstr[16];
char *cptr;

	sprintf(pidstr,"z%08d",pid);
	pidstr[0] = 'G';	/* fool strings searchers */
	cptr = crypt(pidstr,"ba");
	return(cptr);
#else				/* probably enough */
static char pidstr[16];
	sprintf(pidstr,"b%09da",(int)(((long)pid * 4) / 5));
	return(pidstr);
#endif

#ifdef VARIANT_1	/* very paranoid */
char pidstr[16];
char *cptr;
	sprintf(pidstr,"z%08d",pid);
	pidstr[0] = 0xFF;	/* fool strings searchers */
	cptr = crypt(pidstr,pidstr);
	return(cptr);
#endif
#ifdef VARIANT_2	/* not paranoid at all */
char pidstr[16];
	sprintf(pidstr,"z%08d",pid - 2);
#endif
#ifdef VARIANT_3	/* invite trouble :-) */
	return("I_am_easy");
#endif

}	/* end of bamboozle */


/* vi: set tabstop=4 shiftwidth=4: */
/* end of bamboozle.c */
