






				      ECU

			    (Extended Call Utility)






			Personal Communications	Package
			       for XENIX System	V












                   Warren H. Tucker, III <wht%n4hgf@gatech.edu>






			     Technical Description
			    Revision 1.22 (ecu 2.80)
				     5/7/90





















    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       1



    1.	Introduction


    ECU	(Extended Call Utility)	is a  personal	communications	program	 for
    users  of  SCO  UNIX  V.3.2/386  and XENIX V on 80286 and 80386 systems.
    This preliminary document describes	ECU functionality and implementation
    from a technical point of view.

    ECU	provides the classic terminal  communications  facility	 of  passing
    keyboard  data  to a serial	line and incoming data to the computer video
    display.  In addition, a  dialing  directory,  a  function	key  mapping
    feature, and session logging are available.

    A very flexible procedure (script)	language  is  also  incorporated  to
    automate  many  communications  tasks.   Using  shell  scripts  and	 ECU
    procedures,	it is possible	to  use	 ECU  in  an  entirely	"unattended"
    fashion for	batch-style communications sessions.

    ECU	supports numerous file	transfer  protocols:  as  of  this  writing,
    XMODEM,   XMODEM/CRC,   XMODEM-1K,	 YMODEM/CRC   Batch,  ZMODEM/CRC-16,
    ZMODEM/CRC-32, Kermit and SEAlink are supported.

    This document is preliminary and is	NOT well written.   It	attempts  to
    get	 across	 to  the  inquiring  mind  how	ECU  works.   In  places, an
    understanding of the  UNIX	programming  model,  UNIX,  XENIX  and	UUCP
    constructs	and asynchrononous communications techniques is	assumed.  In
    other places, the document goes into tedious detail	about  the  simplest
    of concepts.


























    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       2



    2.	Basic Organization


    ECU	forks to run as	two separate processes,	a transmitter (XMTR)  and  a
    receiver (RCVR).  The two processes	communicate via	signals	and a System
    V shared memory segment.  XMTR controls RCVR  and  terminates  it  under
    certain  circumstances,  called  here  auxiliary  operations.   After an
    auxiliary operation	completes, XMTR	forks again to recreate	RCVR.


    2.1	 Transmitter Process (XMTR)


    XMTR accepts user input from the computer keyboard;	input is  recognized
    as	belonging to one of two	types: 1) transmit data	and 2) ECU commands.
    Keyboard input is passed to	the serial line	driver until an	ECU  command
    is	detected.  Commands are	prefixed with a	HOME key which causes ECU to
    accept keyboard data up to the next	ENTER key as command text.  After  a
    command  has  been	processed,  keyed data is again	routed to the serial
    line.


    2.1.1  Keyboard Interface

    The	keyboard driver	is set into the	raw mode.  XMTR	reads characters one
    at	a time from the	driver.	 Normally, characters read from	the keyboard
    are	passed directly	to the serial line driver.  The	ASCII ESC ("escape")
    character is handled as a special case.  When a function key is pressed,
    the	keyboard driver	presents to XMTR an ESC	character, followed  by	 two
    more   characters  describing  which  function  key	 has  been  pressed.
    Pressing the ESC key also causes XMTR to see an ESC	character, but	with
    no subsequent function key "suffix".

    When an ESC	character is read, XMTR	delays transmission of the character
    to the line	for a short period to determine	whether	the ESC	key has	been
    pressed or a function key has been pressed.	 If no "suffix"	is detected,
    the	 ESC  is  passed to the	line, having suffered an insignificant delay
    given human	typing speeds.

    If a function key  "suffix"	 is  detected,	the  function  key  type  is
    decoded.   The  HOME  key  indicates  an ECU command follows.  Any other
    function key is passed to the function key	mapping	 feature  (described
    later).


    2.1.2  ECU Command Assembly

    After HOME has been	pressed, XMTR presents a reverse video prompt on the
    display,  indicating  its  readiness to accept a command.  During input,
    the	command	may be edited using the	same  control  keys  specified	with
    stty(C).   Command	input  is  aborted  by pressing	ESC.  When a command



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       3



    string has been assembled, it is passed to the command processor,  which
    breaks the command arguments into a	token array similar to the argc/argv
    array.  When the command handler returns, XMTR  returns  to	 its  normal
    mode of copying keyboard data to the serial	line.

    Further information	on XMTR	command	line  processing  may  be  found  in
    later sections titled Line Editing and Interactive Command History.


    2.1.3  Function Key	Mapping

    Function keys other	than HOME are available	to  be	mapped	to  transmit
    short  keystroke  sequences	 on a connection by connection basis.  Under
    control of the dialing command ("Dial" described below)  or	the function
    key	control	command	("FK"),	predefined function key	maps may be loaded.

    Function keys which	may be mapped are F1 through F12, PgUp,	 PgDn,	End,
    Ins, Del, and the cursor control keys.

    The	unshifted keypad '5' key is permanently	mapped to produce  a  screen
    snapshot when it is	pressed	and XMTR is reading from the keyboard.


    2.1.4  Auxiliary Operation Control

    Certain commands cause ECU	to  perform  what  is  called  an  auxiliary
    operation,	requiring  temporary  termination of the RCVR process.	Such
    operations are not as useful with cu(C), because cu	does  NOT  kill	 its
    receiver  process  at  any	time.	As  a result, it impossible to run a
    modern file	transfer protocol since	the cu receiver	process	eats some of
    the	characters sent	by the remote protocol program.

    There are  two  types  of  auxiliary  operations:  1)  internal  command
    execution  and 2) external program execution.  Certain internal commands
    require tight control over the serial  line.   For	instance,  the	dial
    command  requires transmitting modem command strings and receiving modem
    response codes.  Such procedures are best accomplished by single-process
    control  of	 the line.  External program execution is of two kinds,	file
    transfer invocation	and local shell/command	execution.

    The	RCVR process is	terminated in any of these cases either	to avoid the
    RCVR swallowing characters intended	for other targets (the modem handler
    in XMTR or the file	transfer protocol) or to avoid	having	remote	data
    interspersed with the output of local programs.










    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       4



    2.2	 Receiver Process (RCVR)


    The	receiver process reads the incoming serial data	stream and passes it
    to the user	terminal driver	through	a filter which scans for events	such
    as the occurrence of ASCII BEL (bell)  characters  or  terminal  control
    sequences.	 RCVR  also  handles  the  session  logging  and ANSI filter
    functions.


    2.2.1  ANSI	Filter

    Since the term "ANSI" is used to describe many variations  on  the	ANSI
    X3.64 recommendations for terminal control (read "IBM pseudo-ANSI"), the
    ECU	receiver process has an	"ANSI filter" which  attempts  to  translate
    incompatible  (read	 "MSDOS")  ANSI-like  control sequences	to sequences
    acceptable to the XENIX display driver.  This includes support  for	 the
    "save cursor" and "restore cursor" sequences.


    2.2.2  Session Logging

    When directed by the user, the RCVR	process	logs incoming serial data to
    a  file  named  on	the  log  command line.	 The default operation is to
    filter unprintable characters (other than TAB and NL) from the log,	 but
    raw	 logging  is available with a command option.  In a like manner, the
    default is for appending to	an existing file, but a	command	 option	 may
    specify scratching any previous contents.

    Log	files receive header lines each	time the file is opened, stating the
    logical system name, the telephone number and the date/time.























    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       5



    3.	Features



    3.1	 Line Editing


    When you are entering a line of text for an	ecu command or in a field on
    a  screen,	you  may  edit	it  in a number	of ways	at any time prior to
    pressing Enter.  Cursor Left moves the cursofr  left  by  one  character
    position,  nondestructively.   Cursor  Right moves to the right.  Insert
    toggles insert mode.  Backspace (your erase	key as specified to stty  in
    commands,  the actual backspace key	in screens) deletes the	character to
    the	left of	the cursor.  Your line kill key	(as specified  to  stty)  in
    command  mode or the ^U character in screen	mode erases the	entire line.
    Esc	in command mode	cancels	the command.  Esc  in  screen  mode  usually
    cancels the	screen or subfunction in a screen.  ^L or ^R in	command	mode
    shows the current state of Insert mode and redisplays the edited string.


    3.2	 Interactive Command History


    After pressing the Home key, pressing it again invokes  the	 interactive
    command  history  function.	  After	 the second Home key is	pressed, the
    last interactive command is	redisplayed. Line editing may  be  performed
    on the command as described	in the previous	section.

    Additionally, using	the Cursor Up key  accesses  less  recent  commands.
    The	 Cursor	 Down  key  accesses  more  recent commands.  Pressing Enter
    causes the command to be executed.	Preesing Esc abort command entry.


    3.3	 Dialing Directory


    ECU	provides an on-line editable dialing directory.	 Remote	systems	 are
    defined as records using alphanumeric identifiers as keys.	Other record
    fields  include  telephone	number,	 baud  rate,  parity   and   textual
    description.


    3.4	 Online	Command	Dictionary


    The	ECU help command presents a display of	interactive  commands.	 The
    user  is  then  prompted to	enter a	command	name for further, Unix-style
    "usage" information.






    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       6



    3.5	 Multiscreen Event Alarm


    By using the BN (bell notify) interactive command, an audible  alert  is
    sent  to all multiscreens when an ASCII BEL	(bell) is received or when a
    file transfer completes.  An additional option causes an alert when	 ANY
    data  is  received	from  the  line.  This makes it	simple to do work on
    other  multiscreen	consoles  and  be  alerted  when  attention  to	 the
    communications session is required.

    For	instance, the Berkeley 4.x Unix	utility	"talk" rings the  bell	when
    another user wishes	an interactive chat mode.  BSD "biff" rings the	bell
    when incoming mail is received.  Scripts or	commands at remote sites can
    be configured to ring the bell as in:

	 make foo bar; bell; make more_stuff; bell;

    to call attention to the ECU user when  work  is  being  done  on  other
    multiscreen	consoles.


    3.6	 Function Key Mapping


    All	function keys with the exception of the	Home, BkTab (shift TAB), and
    keypad  unshifted 5	key can	be programmed to emit selected strings.	 For
    instance, when communicating with a	Stratus	computer, doing	your best to
    emulate a VT100, a function	key map	might be constructed as	follows:

     F1	 F1	F2  F2	       Home ecu	cmd	PgUp  dispform
     F3	 F3	F4  F4	       End  enter	PgDn  cancel
     F5	 F5	F6  F6	       Ins  local shell	CUR5  Screen dump
     F7	 status	F8  no status  BkTab restore receiver display
     F9		F10 redisp     CUR^ ^		CUR>  >
     F11	F12	       CUR< <		CURv  v


    Function key mapping is placed in ~/.ecu/keys.  The	Stratus	example:
















    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       7



    stratus
	    F1:F1:esc O	q
	    F2:F2:esc O	r
	    F3:F3:esc O	s
	    F4:F4:esc O	t
	    F5:F5:esc O	u
	    F6:F6:esc O	v
	    F7:F7:esc O	w
	    F8:status:dc4
	    F9:no status:nl
	    F10:redisp:esc O y
	    F11:redisp:syn
	    PGDN:cancel:esc O Q
	    END:enter:esc O M
	    PGUP:dispform:esc O	R
	    CUU:^:dle
	    CUD:v:so
	    CUL:<:stx
	    CUR:>:ack


    If you have	installed the mapkey  file  (as	 described  in	the  release
    directory  in  mapkeys/README),  then  ALT-a  through  ALT-z  causes the
    "silent" execution of procedures 'alt_a.ep'	for  ALT-a,  'alt_b.ep'	 for
    ALT-b,  etc.  The models subdirectory contains an example alt_h.ep which
    will home the cursor when ALT-h is pressed.	 This  facility	 allows	 the
    execution of 26 procedures without ECU itself changing the video display
    at all.  Any changes to the	display	(short	of  procedure  errors)	will
    result  solely  from  the  action  of  the	invoked	 procedure.   If the
    procedure matching the ALT-[a-z] key pressed cannot	be found,  the	bell
    is rung.


    3.7	 Built-in Modem	Dialer


    The	built-in ECU dialer supports modems which  use	the  Hayes-style  AT
    command  set or most variants thereof.  It is used when HoneyDanBer	UUCP
    is not installed or	when there is no entry in the  /usr/lib/uucp/Devices
    file  for  the  selected  outgoing line.  (For more	information, see the
    later section titled "HoneyDanBer UUCP Interface".)

    The	built-in dialer	uses  files  in	 the  /usr/lib/ecu  directory  which
    contains   modem   initialization	information.   Modem  initialization
    filenames are made from concatenating the  tty  name  with	".mi".	 For
    instance, tty1a's initialization file is named "tty1a.mi".

    Commands for initializing the modem	and for	dialing	may be specified  in
    a  very  flexible manner.  Separate	init and dial strings for each legal
    baud rate, a single	pair of	strings	for all	baud rates or a	 combination
    may	be specified.



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       8



		 Sample	Modem Initialization Files

    #+-----------------------------------------------------------
    #  tty1a.mi	- Microcom AX/9624c
    #------------------------------------------------------------
    init_>2400:ATS11=47X4S0=0S7=30Q1X1N3   # baud rates	> 2400
    init_default:ATS11=47X4S0=0S7=30Q0X0N0 # other baud	rates
    dial_default:ATDT


    #+-----------------------------------------------------------
    #  tty2d.mi	- USR Courier 2400
    #------------------------------------------------------------
    init_default:ATS11=47 X4 S0=0 S7=32
    dial_default:ATDT


    3.8	 File Transfer


    ECU	supports numerous file	transfer  protocols:  as  of  this  writing,
    XMODEM,   XMODEM/CRC,   XMODEM-1K,	 YMODEM/CRC   Batch,  ZMODEM/CRC-16,
    ZMODEM/CRC-32, and Kermit are supported.  Although a seamless  interface
    (there's  some  yuppie  programmer	newspeak)  is  provided	to the user,
    transfer is	facilitated by executing external programs.

    XMODEM, YMODEM and ZMODEM transfers	(thanks	to  modified  public  domain
    programs  by  Chuck	Forsberg) present dynamic status displays similar to
    the	following:

	.-[ ecusz 2.37 ]-- /tmp	-----------------------------------.
	|  ZMODEM/CRC32	 Data xfer rate	~=    896 chars/sec	   |
	|  File	  1 of	 1: ckermit-5a-130			   |
	|  File	position:     34053 length:    34053  -rw-r--r--   |
	|  Sending 34053 bytes	total time ~=  0:40		   |
	|  tx: hdr ZFIN	 0	       rx: hdr ZFIN  0		   |
	|  Comm	I/O: rx	     175  tx	34393 bytes		   |
	|  Baud	rate:  9600 BINARY blklen:  1024 comm mode: NORMAL |
	|  Time:	 started: 17:31:50  this file: 17:31:51	   |
	|  17:32:29	 elapsed: 00:00:39	       00:00:38	   |
	|  Errors: this	file:	0 total:    0 files skipped:   0   |
	|  Total file bytes transferred: 34053			   |
	|  End of file						   |
	|  Remote: CRC32 y  duplex y  continuous stream	y	   |
	`- Connected to	ki4xo -	procedure put_ck5a ----------------'









    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				       9



    3.9	 Procedures (Scripts)


    A powerful,	language-style procedure language is incorporated into	ECU.
    The	lnaguage is described in later sections.


    3.10  Initial (Startup) Procedure


    An initial procedure may be	be specified to	ECU either to initialize  an
    interactive	 session  or  to  execute  an entirely unattended or "batch"
    communication session.



    3.11  Home Directory Files


    ECU	control	files reside in	the .ecu subdirectory of  each	user's	home
    directory.	For example, in	home directory /usr/wht:

	 /usr/wht/.ecu/dir     CD interactive command history file
	 /usr/wht/.ecu/keys    function	key mapping
	 /usr/wht/.ecu/log     connect,	file transfer history
	 /usr/wht/.ecu/phone   dialing directory
	 /usr/wht/.ecu/colors  colors used by ECU


    The	.ecu directory also contains ECU procedure files (having  the  '.ep'
    extension).


    3.12  Lock Files


    ECU	maintains lock files  in  /usr/spool/uucp  in  accordance  with	 the
    HoneyDanBer	  UUCP	conventions  (ASCII  pids  as  10-character  strings
    followed by	a newline).  Lock files	are created for	both device names of
    a  line.   For  example, both LCK..tty1A and LCK..tty1a are	created	when
    /dev/tty1a OR /dev/tty1A is	selected.   See	 the  later  section  titled
    "HoneyDanBer UUCP Interface".


    3.13  Dial-In/Dial-Out Line	Support


    ECU	works with the SCO getty to support dialing out	on  a  line  enabled
    for	login.	After use of the line is complete, ECU signals the system to
    restore incoming call status to the	line.  See the later section  titled
    "HoneyDanBer UUCP Interface".



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      10



    3.14  Tools


    Commands are provided for conversion of hexadecimal	or  decimal  numbers
    to	and  from  ASCII  equivalents.	For example, 26(10) == 0x1a == ^Z ==
    SUB.  For details, refer to	the description	of the XA and AX interactive
    commands.


    3.15  Shared Memory	'Friend' Interface


    ECU	maintains a copy of the	received screen	image (80 x 43 maximum)	 and
    other   information	 in  its  shared  memory  segment.   Normally,	this
    information	is used	 only  by  the	transmitter  and  receiver  process.
    However,   ECU supports the	concept	of a friend process which may access
    the	shared memory segment, perform arbitrary auxiliary operations,	read
    from  and  write  to  the  attached	 communications	line and communicate
    resulting information or status to an  ECU	procedure  via	a  1024-byte
    "friend" data area in the shared memory segment.

    The	procedure language  supports  the  friend  process  concept  through
    commands and functions which allow

       + passing the ECU shared	 memory	 segment  id  (shmid)  to  a  called
	 program,

       + reading a single character or	string	of  characters	from  screen
	 memory,

       + reading cursor	position information and

       + reading and writing of	 characters,  short  or	 long  integers	 and
	 strings in the	1024-byte "friend" shared memory data area.

    This facility allows batch and interactive applications to be  developed
    with  C programs which would be tedious or impractical to implement	with
    procedure language alone.

    For	more information, refer	to the shared memory header  file  ecushm.h,
    the	  ecufriend   subdirectory  of	the  software  release	and  to	 the
    description	of the %shmid, %cury and %curx procedure functions  and	 the
    getf and putf procedure commands.











    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      11



    4.	Starting the Program



    4.1	 Simple	Startup	- Initial Setup	Menu


    ECU	may be started in a number of  ways  through  use  of  command	line
    switches, but the easiest is to enter

	 ecu

    by itself.	In this	case, the screen is cleared and	the folowing  screen
    will be presented.




      .--[ ecu 1.96 Copyright 1986,1989, W. Tucker ]-----------------.
      |								     |
      |	 Name/phone number to call: ___________________		     |
      |								     |
      |								     |
      |	 tty: /dev/tty1a					     |
      |								     |
      |	 duplex: F  baud: 2400	 parity:N  (data bits 8)	     |
      |	 Add NL	to transmitted CR: N				     |
      |	 Add NL	to received CR:	   N				     |
      |								     |
      |								     |
      |	  TAB:next ^B:prev END:proceed ^D:phone	dir  ESC:quit ecu    |
      `- logical phone directory entry,	phone number or	empty -------'





    4.1.1  Name/Phone Number Field

    If a dialing directory has been configured,	a literal phone	number	need
    not	 be entered.  However, on your first invocation,  you'll very likely
    have no directory.	Therefore, you have three options:












    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      12



	 1.  Enter a literal telephone number, (e.g. 18005551212).
	     Hyphens and open and close	parentheses may	also
	     be	entered.

	 2.  Press ENTER to skip the 'Name/phone' field	and enter
	     ^D	to enter the telephone directory to enter your
	     first directory entry.

	 3.  Press END to enter	interactive mode and use the Dial
	     interactive command to dial a literal telephone num-
	     ber or to enter the dialing directory.



    4.1.2  Other Fields

    The	'tty' field may	be used	to select an outgoing line  other  than	 the
    default /dev/tty1a.	 Note:	only the last two characters of	the tty	name
    need be entered.  The remainder  of	 the  tty  name	 is  assumed  to  be
    '/dev/tty'.

    The	'duplex' field may be used to select a duplex value other  than	 the
    default 'F'	(full).

    The	'baud' field may be used to select a baud rate value other than	 the
    default 2400.

    The	'parity' field may be used to select a parity value other  than	 the
    default 'N'	(none).


    The	'Add NL	to transmitted CR' and 'Add NL to received  CR'	 fields	 are
    usually left defaulted to 'N' (no).	 If you	will be	communicating with a
    terminal (with a human), you will usually need  to	set  both  of  these
    fields to 'Y' as well as to	select 'H'alf duplex.


    4.1.3  Special Characters

    Special keyboard characters	while filling in the startup screen are:














    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      13



	  TAB	 move to next field ...	if nothing typed in
		 the field, do not disturb contents

	  ^B	 back up to previous field

	  END	 proceed with session, dialing remote if
		 logical directory entry name or literal
		 telephone number enetered

	  ^D	 enter phone directory

	  ESC	 quit ecu without any communications



    4.2	 Command Line Arguments	and Switches


    ECU	can be started in a number of ways:


	 ecu [-lxx] [-b<baud>] [-h] [-e|-o] [-t] <tel-number>
	 ecu [-lxx] [-b<baud>] [-h] [-e|-o] [-t]
	 ecu [-t] <logical>
	 ecu [-lxx] [-b<baud>] [-h] [-e|-o] [-d] -p <proc> [<arg> ...]



    4.2.1  -l

    When ECU starts up,	it normally chooses a line as described	later in the
    section  titled "Choosing a	Dialout	Line".	Specifying the -l switch can
    suggest that the program choose a specific line.  The  argument  to	 the
    switch is the last two charcters of	the ttyname; e.g., "-l1a".

    On a system	with HoneyDanBerr UUCP,	to access a device  which  does	 not
    appear  in	the  Devices file, it may be necessary to explicitly specify
    the	device with -l.


    4.2.2  -f
    Normally, ECU starts up in the full	duplex	mode.	If  half  duplex  is
    desired, the -f switch is used.


    4.2.3  -e, -o

    Normally, ECU starts up with 8 data	bits and no parity.  If	even  parity
    is	desired,  the -e switch	is specified.  If odd parity is	desired, the
    -o switch is specified.




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      14



    These switches


    4.2.4  -p <procname>

    The	 -p  switch  causes  ECU  to  execute	the   procedure	  <procname>
    ("<procname>.ep")  immediately.   Such a procedure is termed the initial
    procedure.	All non-switch arguments  after	 <procname>  are  passed  as
    arguments  to the initial procedure	(see the descriptions of the integer
    function %argc and the string function %argv).


    4.2.5  -d

    The	-d switch instructs ECU	to "die" (terminate with  error	 status)  if
    any	 specified initial procedure fails.  This switch ensures a batch ECU
    execution will hang	up any connection and terminate	if a procedure error
    occurs.

    Absence of the -d switch causes ecu	(upon any completion of	the  initial
    procedure)	to  enter the 1) interactive mode if a line was	successfully
    attached by	the procedure or 2) the	setup menu if not line was attached.


    4.2.6  -t

    The	-t switch instructs  ECU  to  map  incoming  and  outgoing  carriage
    returns  to	 carriage  return/line	feed  pairs.  This is helpful if the
    remote connection will be to a terminal with a human operator.   Use  of
    the	-h switch is probably also necessary.


    4.3	 Environment Variables


    Prior to starting ECU, it is useful, but not necessary, to establish two
    environment	variables, ECUPROMPT and ECUHELP.


    4.3.1  ECUPROMPT

    The	ECUPROMPT environment variable determines the prompt printed by	 ECU
    when  the  interactive  command key	("HOME") is pressed.  When you first
    run	ECU, try setting it to your name, e. g.,

	 setenv	ECUPROMPT Ralph	   if you use csh

	 ECUPROMPT=Ralph	   if you use sh, ksh, etc.
	 export	ECUPROMPT

    Then, when you see how it  used,  you  may	wish  to  establish  a	more



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      15



    permanent choice in	your .login or .profile.


    4.3.2  ECUHELP

    Ordinarily,	ECU  looks  for	 interactive  command  help  information  in
    "/usr/lib/ecu/ecuhelp.data".   The ECUHELP environment may be set to the
    complete pathname of the ecu help file if an alternate  file  is  to  be
    used.

    The	help file is explained later in	the section titled  "Online  Command
    Dictionary".










































    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      16



    5.	Interactive Mode Commands


    The	following is a partial list of commands	available in the interactive
    (non-procedure)  mode.   It	 is  not  necessary  to	 to enter the entire
    command in most cases.  The	 portion  of  each  command  which  must  be
    entered is capitalized in the following section headers.

    Refer to the  sections  titled  Interactive	 Command  History  and	Line
    Editing for	more information.


    5.1	 AX : ascii char to hex/oct/dec

    usage: ax [<param>]


    <param> may	be a single ASCII character,  a	 standard  ASCII  identifier
    (such  as ETX), or a two-character control character identifier (such as
    ^C,	typed as a caret followed by a C).

    If no argument is supplied,	a table	of  control  characters	 is  printed
    containing	decimal,  octal,  hex,	ASCII  identifiers and two-character
    control character identifier.



    5.2	 BAud :	set/display line baud rate

    usage: baud	[<baud-rate>]


    <baud-rate>, if specified, must be taken from the values 110, 300,	600,
    1200,  2400,  4800,	 9600,	19200 and 38400.  On some systems, 19200 and
    38400 may not be supported.	 If baud rate 110 is selected, 2  stop	bits
    are	 automatically	specified;  other  baud	 rates	set  1 stop bit.  If
    <baud-rate>	is not supplied, the current baud rate is displayed.

    The	setting	may be automatically changed  as  the  result  of  a  'dial'
    command.  See also the dial	and parity command descriptions.



    5.3	 BN : all console event	alarm

    usage: bn [	0 | 1 |	2 ]


    "bell notify": If no  argument  is	supplied,  the	current	 setting  is
    displayed.	 Specifying  0	disables  the  facility; 1 causes an audible
    alarm to be	sounded	on all of the XENIX virtual consoles upon receipt of



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      17



    a  bell  (0x07)  character	from  the remote system; 2 causes an audible
    alarm to be	sent to	all consoles upon receipt of ANY characters from the
    remote system.  A non-zero value also causes an audible alarm to be	sent
    to all console upon	the successful	completion  of	a  'redial'  command
    which  must	 retry	more than one redial attempt or	upon completion	of a
    file transfer operation.

    Different alarms are sent depending	upon the the type of  event  causing
    the	alarms.

    BN is set to 1 when	ECU begins executing.


    5.4	 BReak : send break to remote

    usage: break


    This command sends a break signal to the remote system.



    5.5	 CD : change current directory

    usage: cd [<dir-path>]


    This command allows	you to change  the  working  directory	of  the	 ECU
    process.   If  <dir-path> is supplied, the previous	working	directory is
    displayed, and <dir-path> is made the new working directory.  A  history
    of	previous  directory  changes is	maintained.  Entering the cd command
    shows the numbered history list and	allows you to select a new directory
    by	entering  the  number.	Other commands allow deletion of directories
    from the list or saving the	list to	file  ~/.ecu/phone.   This  file  is
    automatically  read	 at  ECU  startup,  providing  a  convenient list of
    directories	available for quick selection.



    5.6	 DA : decimal to ascii char

    usage: da [<decimal-val>]


    <decimal-val> is a decimal value between 0 and 0377; the  parity  (sign)
    bit	is stripped and	the equivalent ASCII character value is	displayed.

    If no argument is supplied,	a table	of  control  characters	 is  printed
    containing	decimal,  octal,  hex,	ASCII  identifiers and two-character
    control character identifier.




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      18



    5.7	 Dial :	dial remote destination

    usage: dial	[<dial-param>]


    <dial-param> may take one of two forms, a telephone	number to dial or  a
    logical  name  which  can  be found	in the user phone directory (in	file
    ~/.ecu/phone).

    If a telephone number is supplied, the phone number	is dialed; you	must
    first  have	 set  the  desired  baud  rate and parity using	the baud and
    parity commands.

    If a logical name is entered, the phone directory is  searched;  if	 the
    entry  is  found,  the  baud rate and parity is automatically set.	If a
    procedure file can be found	in the current directory or the	 users	home
    .ECU  subdirectory	whose  name  matches  the  logical  name,  then	 the
    procedure is executed with the argument '!INTERACTIVE'.


    If <dial-param> is not supplied, then a screen-oriented self-documenting
    directory  manager is executed; you	may scan the the directory to select
    a number to	dial, as well as add, remove and edit entries.	Upon dialing
    from the menu, if a	procedure file can be found in the current directory
    or the users home .ECU subdirectory	whose name matches the logical name,
    then the procedure is executed with	the argument '!MENU'.



    5.8	 DO : perform procedure

    usage: do <procname> [<arg>	... ]


    Perform ECU	procedure.  Ecu	searches for <procname>.ep  in	the  current
    directory.	 If the	file is	not found, the program looks for the file in
    the	~/.ECU directory.  One or  more	 arguments  may	 be  passed  to	 the
    procedure.	Arguments aare made available in the called procedure by use
    of the %argc integer function and %argv string function.

    Unlike arguments to	the  do	 procedure  command,  arguments	 to  the  do
    interactive	 command  are not quoted and may not contain embedded spaces
    or tabs.











    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      19



    5.9	 DUplex	: set/display duplex

    usage: duplex [ Full | Half	]


    This command specifies whether or not ECU is to locally echo  characters
    typed  by  you  at	the  keyboard.	 The overwhelming majority of remote
    systems provide the	echo function, in which	case  full  duplex  must  be
    used.   For	the rare occasions when	the remote system does not echo	your
    keyboard input, setting half duplex	will allow you to see what  you	 are
    typing.

    When communicating with another terminal in	a  "teletype  conversation",
    setting  half  duplex  is generally	required.  In such cases, use of the
    nl,	nlin and nlout commands	may also be required.

    The	default	setting	for duplex is full.



    5.10  EXit : drop carrier, exit program

    usage: exit


    This command terminates ECU	promptly.   If	your  modem  does  not	drop
    carrier  upon  loss	 of  Data  Terminal  Ready  (DTR),  the	command	will
    terminate ECU, but may leave the communications line off  hook.   It  is
    strongly  recommended that you configure your modem	to hang	up the phone
    line when DTR drops.  A shorthand version of this command exists: '.' is
    equivalent to exit.



    5.11  FI : send text file to line

    usage: fi [<filename>]


    "file insert": This	command	causes file characters to be  inserted	into
    the	 transmit  data	 stream	 as  though  they  had	been  entered at the
    keyboard.  No error	 correction  is	 provided,  although  XON/XOFF	flow
    control is obeyed.

    If <filename> is not entered on the	 command  line,	 a  prompt  for	 the
    filename  is made.	Once the filename has been entered and file has	been
    opened, you	are asked whether the file should  be  transmitted  at	full
    speed,  by	"echo  pacing"	or by a	single line at a time.	You may	also
    append an 'f', 'e' or 's' argument to the command line.

    If your remote can tolerate	it, full speed transmission is the  fastest.



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      20



    Some  systems  are	not  capable  of  receiving  large  amount  of	data
    ("streaming	data") without pauses.	Even with "full" speed transmission,
    some  "pacing"  (inter-character delay) is introduced to ease loading on
    the	remote system.	Pressing the interrupt key (DEL) stops a full  speed
    transmission.

    By specifying echo pacing, it is possible to increase the likelihood  of
    proper  receipt.  Echo pacing reads	the return data	stream to attempt to
    keep from overloading the remote.	Pressing  the  interrupt  key  (DEL)
    stops an echo paced	transmission.

    As a last resort, if echo pacing is	not working for	you, (i.e., you	 are
    using  the command in an environment where the remote does not echo	your
    characters), single	line at	a  time	 transmission  is  available.	With
    "single"  line  transmission,  you	must press the space key to initiate
    sending each line.	Pressing the 'ESC' or 's' key stops the	transfer.


    5.12  FKey : function key definition

    usage: fkey	[<keyset_name>]


    This command allows	the mapping of function	keys F1-F12, PgUp, PgDn, End
    and	 Ins  and the cursor up, down, left and	right keys to emit a desired
    sequence of	characters when	a function key	is  pressed.   <keyset_name>
    specifies which key	set in ~/.ecu/keys is to be selected. Sample entry:

	 hayes
	     F1:escape:+ + +
	     F2:autoans:A T S 0	= 1 cr
	     F3:dial:A T D T
	 bbs
	     F1:cancel:^K
	     F2:yes:y cr


    If a keyset_name matches a logical dial directory  name,  it  is  loaded
    when the number is dialed.

    The	characters in the mapped string	may be any  printable  character  or
    one	of the following:












    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      21



	 map ->	character	map -> character
	 ---	-----------	---    ------------
	 nul	0 000 00 ^@  |	dle    16 020 10 ^P
	 soh	1 001 01 ^A  |	dc1    17 021 11 ^Q
	 stx	2 002 02 ^B  |	dc2    18 022 12 ^R
	 etx	3 003 03 ^C  |	dc3    19 023 13 ^S
	 eot	4 004 04 ^D  |	dc4    20 024 14 ^T
	 enq	5 005 05 ^E  |	nak    21 025 15 ^U
	 ack	6 006 06 ^F  |	syn    22 026 16 ^V
	 bel	7 007 07 ^G  |	etb    23 027 17 ^W
	 bs	8 010 08 ^H  |	can    24 030 18 ^X
	 ht	9 011 09 ^I  |	em     25 031 19 ^Y
	 nl    10 012 0a ^J  |	sub    26 032 1a ^Z
	 vt    11 013 0b ^K  |	esc    27 033 1b ^[
	 ff    12 014 0c ^L  |	fs     28 034 1c ^(
	 cr    13 015 0d ^M  |	gs     29 035 1d ^]
	 so    14 016 0e ^N  |	rs     30 036 1e ^^
	 si    15 017 0f ^O  |	us     31 037 1f ^_



    5.13  HAngup : hang	up modem

    usage: hangup


    This  causes  DTR  to  be  momentarily  interrupted,   terminating	 any
    outstanding	 connection.   Your DCE	(modem)	must be	able to	drop carrier
    upon loss of DTR.


    5.14  HElp : invoke	help

    usage: help	[<cmd-name>]


    Issuing this command with  no  argument  displays  a  list	of  commands
    followed by	a request for a	command	for further information.


    5.15  LLp :	set session log	to /dev/lp

    usage: llp


    This command is a shorthand	version	of 'log	/dev/lp'.  /dev/lp must	 not
    be under the control of a print spooler.







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      22



    5.16  LOFf : turn off session logging

    usage: loff


    This command is shorthand for 'log off'.  If session logging is  active,
    it is turned off.


    5.17  LOG :	session	logging	control

    usage: log [-s] [-r] [ | off | filename ]
	-s "scratch" previous file contents; otherwise append
	-r "raw" logging; otherwise non-printable characters
	    other than tab and newline are omitted from	the log


    This command controls session  logging;  issuing  the  command  with  no
    argument  causes  the  status  of  session logging to be displayed.	 The
    special argument 'off' causes active logging to  be	 terminated.   Other
    argument values cause logging to start using the argument as a filename.
    Issuing a log command with a filename when	logging	 is  already  active
    causes  the	 previous  file	 to be closed and the new file to be opened.
    Switches are meaningful only when used in conjunction with a filename to
    start logging.



    5.18  NL : display CR/LF mapping

    usage: nl


    Display the	current	setting	of CR/LF  mapping.   For  more	information,
    refer to the nlin and nlout	command	descriptions.



    5.19  NLIn : set receive CR/LF mapping

    usage: nlin	[<y-n>]


    This command controls whether or not a newline (NL/LF) character is	sent
    to	the  screen  upon  receipt of a	carriage return	(CR) from the remote
    system.  Most remote computers supply a NL after CR.  When communicating
    with  another  terminal  in	a "teletype conversation", this	is generally
    not	the case (see also the duplex command).

    Issuing the	command	without	<y-n>  causes  the  current  setting  to  be
    displayed.	 The  format  of  <y-n>	 is  flexible:	'y'  or	 '1' enables



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      23



    appending NL to CR,	'n' or '0' causes the feature to be disabled.



    5.20  NLOut	: set transmit CR/LF mapping

    usage: nlout [<y-n>]


    This command controls whether or not a newline (NL/LF) character is	sent
    to the remote system upon transmission of a	carriage return	(CR) entered
    by	the  keyboard.	 Most  remote  computers  do  not  require   (indeed
    "dislike") a NL after CR.  When communicating with another terminal	in a
    "teletype conversation", this is generally not the case  (see  also	 the
    duplex command).

    Issuing the	command	without	<y-n>  causes  the  current  setting  to  be
    displayed.	 The  format  of  <y-n>	 is  flexible:	'y'  or	 '1' enables
    appending NL to CR,	'n' or '0' causes the feature to be disabled.



    5.21  OA : octal to	ascii char

    usage: oa [<octal-val>]


    <octal-val>	is a octal value between 0 and 0377; the parity	 (sign)	 bit
    is stripped	and the	equivalent ASCII character value is displayed.

    If no argument is supplied,	a table	of  control  characters	 is  printed
    containing	decimal,  octal,  hex,	ASCII  identifiers and two-character
    control character identifier.



    5.22  PARity : set/display line parity

    usage: parity [ None | Even	| Odd ]


    This command controls  the	parity	of  characters	transmitted  by	 the
    keyboard.	Issuing	 the  command  with no argument	displays the current
    setting.  When the argument	is supplied, only  the	first  character  is
    required.  Even or odd parity implies seven	data bits; no parity implies
    eight data bits.  Parity of	incoming characters is not checked.

    The	setting	may be automatically changed as	the result of an interactive
    or procedure dial command.	See the	baud and dial command descriptions.





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      24



    5.23  PId :	display	process	ids

    usage: pid


    This command displays the process id of the	ECU transmitter	process, the
    ECU	receiver process and the process ids of	ECU's parent and group.


    5.24  PLog : procedure logging

    usage: plog	[ <filename> | off]


    This command enables or disbles procedure logging.


    5.25  PTrace : control procedure trace

    usage: ptrace [ 0 |	1 | on | off]


    This command controls whether  or  not  procedure  execution  is  to  be
    traced.  Trace  output  is written to the screen and varys in its nature
    depending upon the command being traced.  Specifically, any	change to  a
    string  or integer variable	is noted.  If tracing is enabled, the output
    will also be written to the	procedure log file (see	the interactive	 and
    procedure commands).  Issuing the command with no argument shows current
    status.


    5.26  PWd :	print working directory

    usage: pwd


    This command prints	the current working directory of the ECU process.



    5.27  REDial : redial last number

    usage: redial [<retry-count> [<pause-interval>]]


    This command redials a number previously dialed with the 'dial' command.
    Modem  status is tested and	multiple retries may be	made.  <retry-count>
    specifies how many retries are to be made.	 <pause-interval>  specifies
    how	 many  seconds	the  program pauses after a failure to connect.	 You
    must specify <retry-count> in order	to  specify  <pause-interval>.	 The
    default value for <retry-count> is 10, for <pause-interval>	is 60.



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      25



    You	should know that in some jurisdictions,	it is ILLEGAL  to  dial	 the
    same  telephone number more	than a specified number	of times during	some
    interval of	time.  In any case, a <pause-interval> less than 15  seconds
    is silently	changed	to 15 seconds.


    5.28  REV :	ECU revision/make date

    usage: rev


    This command displays ECU's	revision, the transmitter  process  id'	 and
    the	date and time ECU was made.


    5.29  RK : receive via C-Kermit

    usage: rk


    This command searches the PATH list	for 'ckermit'  (Columbia  University
    C-Kermit) and invokes it to	receive	files.

    The	file ~/.kermrc must be set up to  have	any  desired  initialization
    paraeters	you  desire.   Refer  to  C-Kermit  documentation  for	more
    information.



    5.30  RS : receive via SEAlink

    usage: rs


    This command invokes a SEAlink receive protocol.


    5.31  RTScts : control RTS/CTS flow	control

    usage: bn [	0 | 1 |	y | n ]


    This command controls the  RTS/CTS	flow  control  feature	of  the	 SCO
    UNIX/XENIX line driver.  If	no argument is supplied, the current setting
    is displayed.  Specifying 0	or n disables the facility; 1  or  y  causes
    RTS/CTS flow control to be enabled.








    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      26



    5.32  RX : receive via XMODEM/CRC

    usage: rx


    This command invokes ecurz to receive files	from the remote	system using
    XMODEM/CRC.

    After entering the command,	you are	prompted as to whether or  not	file
    CR/LF   characters	are  to	 be  converted	to  newlines.	If  you	 are
    transferring  text	files  from  a	system	which  contain	CR/LF	line
    terminators, you must answer yes to	this question.	You should answer no
    when transferring binary files, such as executables, .arc files and	 the
    like.   File  transfer  progress  is  presented on a visual	display.  To
    abort the transfer,	press your interrupt key (usually DEL  unless  reset
    with stty(C)).



    5.33  RY : receive via YMODEM Batch

    usage: ry


    This command invokes ecurz to receive files	from the remote	system using
    YMODEM batch with CRC-16 error correction.	The YMODEM is "true YMODEM",
    not	XMODEM-1k.  File transfer progress is presented	on a visual display.
    To	abort  the  transfer,  press  your interrupt key (usually DEL unless
    reset with stty(C)).



    5.34  RZ : receive via ZMODEM/CRC32

    usage: rz


    This command invokes ecurz to receive files	from the remote	system using
    ZMODEM/CRC32.   File transfer progress is presented	on a visual display.
    To abort the transfer, press your  interrupt  key  (usually	 DEL  unless
    reset with stty(C)).



    5.35  SDNAME : select screen dump file name

    usage: sdname [<filename>]


    When the "cursor 5"	key is pressed,	the screen contents are	dumped to  a
    file.   By	default,  this	file  is  named	 '~/.ecu/screen.dump'.	This



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      27



    command either displays or changes the current screen  dump	 file  name,
    depending upon whether or not a argument is	supplied.

    The	actions	of this	command	have no	 effect	 on  the  operation  of	 the
    procedure command.


    5.36  SK : send via	C-Kermit

    usage: sk [<file-list>]


    This command searches the PATH list	for 'ckermit'  (Columbia  University
    C-Kermit)  and invokes it to send files.  The file ~/.kermrc must be set
    up to have any desired initialization paraeters you	desire.

    After entering the command,	you are	prompted as to whether or  not	file
    newline   characters   are	to  be	converted  to  CR/LF.	If  you	 are
    transferring  text	files  to  a  system  which  requires	CR/LF	line
    terminators, you must answer yes to	this question.	You should answer no
    when transferring binary files, such as executables, .arc files and	 the
    like.   You	 are  prompted	to  enter a list of files to send, which may
    contain one	or more	wildcard specifications.

    The	file ~/.kermrc must be set up to  have	any  desired  initialization
    arguments	you  desire.   Refer  to  C-Kermit  documentation  for	more
    information.



    5.37  SS : send via	SEAlink

    usage: ss [<file-list>]


    This command invokes a SEAlink file	transmission protocol.


     .--[ Send SEAlink ]-------- dir: /u1/src/ecu ------------------.
     |								    |
     |	File(s)	to send:					    |
     |	___________________________________________________________ |
     |								    |
     |	  TAB:next  ^B:prev  END:perform transfer  ESC:abort	    |
     `-- enter file(s) to send -------------------------------------'









    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      28



    5.38  STat : connection status

    usage: stat


    This command displays statistics about ECU usage.  Example display:

    Date/time: 06-14-1988 11:40:35 (UTC	15:40)
    Total chars	transmitted: 178
    Total chars	received:    3681

    Date/time: 06-14-1988 14:41:24 (UTC	18:41)
    Connected to CompuHost (555-1234) at 14:40:57
    Parameters:	2400-N-1 Connect time: 00:01:27
    Total chars	transmitted: 234 (since	CONNECT	142)
    Total chars	received:    2278 (since CONNECT 1478)



    5.39  SX : send via	XMODEM/CRC

    usage: sx [<file-name>]


    This command invokes ecusz to send a file to  the  remote  system  using
    XMODEM/CRC.

    After entering the command,	you are	prompted as to whether or  not	file
    CR/LF   characters	are  to	 be  converted	to  newlines.	If  you	 are
    transferring  text	files  from  a	system	which  contain	CR/LF	line
    terminators, you must answer yes to	this question.	You should answer no
    when transferring binary files, such as executables, .arc files and	 the
    like.

    You	are prompted to	enter a	filename to send.  File	transfer progress is
    presented  on  a  visual  display.	 To  abort  the	transfer, press	your
    interrupt key (usually DEL unless reset with stty(C)).

     .--[ Send XMODEM/CRC ]----- dir: /u1/src/ecu -----------.
     |							     |
     |	File to	send:					     |
     |	____________________________________________________ |
     |							     |
     |	Binary:	Y (no NL-CR/LF translation)		     |
     |							     |
     |	 TAB:next  ^B:prev  END:perform	transfer  ESC:abort  |
     `-- enter file(s) to send ------------------------------'







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      29



    5.40  SY : send via	YMODEM Batch

    usage: sy [<file-list>]


    This command invokes ecusz to send file(s) to the  remote  system  using
    YMODEM/CRC.

    You	are prompted to	enter filename(s) to send, which may consist of	 one
    or more wildcard specifications.  File transfer progress is	presented on
    a visual display.  To abort	 the  transfer,	 press	your  interrupt	 key
    (usually DEL unless	reset with stty(C)).

     .--[ Send YMODEM/CRC ]----- dir: /u1/src/ecu -----------.
     |							     |
     |	File to	send:					     |
     |	____________________________________________________ |
     |							     |
     |	Binary:	Y (no NL-CR/LF translation)		     |
     |							     |
     |	 TAB:next  ^B:prev  END:perform	transfer  ESC:abort  |
     `-- enter file(s) to send ------------------------------'



    5.41  SZ : send via	ZMODEM/CRC32

    usage: sz [<file-list>]


    This command invokes ecusz to send file(s) to the  remote  system  using
    ZMODEM/CRC32.

    You	are prompted to	enter filename(s) to send, which may consist of	 one
    or more wildcard specifications.  File transfer progress is	presented on
    a visual display.  To abort	 the  transfer,	 press	your  interrupt	 key
    (usually DEL unless	reset with stty(C)).

    Note: if you specify sending only newer files and  the  remote  receiver
    does  not  support	the  feature,  it  may skip (reject) all your files.
    Retry the transfer specifying 'N' to 'Transfer only	newer files'.













    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      30



    |								     |
    |  File(s) to send:						     |
    |  ckermit-5a-130						     |
    |								     |
    |  Binary: Y (no NL-CR/LF translation)			     |
    |  Overwrite destination files: Y				     |
    |  Send full pathames:  N					     |
    |  Transfer	only newer files: N				     |
    |								     |
    |	  TAB:next  ^B:prev  END:perform transfer  ESC:abort	     |
    `--	enter file(s) to send ---------------------------------------'
    `--	Y: no conversion, N: NLs converted to CR/LF -----------------'
    `--	Y: overwrite, N: protect destination files ------------------'
    `--	Y: full	pathnames, N: strip directory portion from names ----'
    `--	Y: send	only if	source newer than destination, N send all ---'



    5.42  TIme : time of day

    usage: time


    This command displays the local date and time as  well  as	the  current
    UTC.


    5.43  TTy :	console	tty name

    usage: tty


    This command displays the current console tty name.



    5.44  XA : hex to ascii char

    usage: xa [<hex-val>]


    <hex-val> is a hexadecimal value between 0 and FF; the parity (sign) bit
    is stripped	and the	equivalent ASCII character value is displayed.

    If no argument is supplied,	a table	of  control  characters	 is  printed
    containing	decimal,  octal,  hex,	ASCII  identifiers and two-character
    control character identifier.







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      31



    5.45  ! : execute shell

    usage: !
	   !<command>


    The	'!' command is a shell escape.	The environment	 variable  SHELL  is
    read  to  determine	 what shell program to execute (e.g., /bin/sh, etc).
    If '!' is entered by itself, an interactive	shell is started;  press  ^D
    to	exit  back  to ECU.  If	<command> is supplied, it is executed by the
    shell with an immediate return to ECU.











































    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      32



    6.	Procedure Language


    Sample procedures are shown	in the companion document 'samplproc.man'.



    6.1	 Arguments


    There are five types of arguments to procedure commands:

	 Switch
	 Alphabetic Token
	 Integer
	 String
	 Relational Operators

    This section describes the syntax and construction of each type in turn.
    There  are separate	groups of valid	of relational operators	for integers
    and	strings; thus, they are	described under	the appropriate	sections.


    6.1.1  Switches

    Switch arguments begin with	a hyphen (minus, '-').	The switch  argument
    must  be the first argument	after the command.  Only one switch argument
    is allowed on the command line.  If	switches '-a', '-b'  and  '-c',	 are
    available and '-a' and '-b'	are desired, '-ab' or '-ba' is entered.


    6.1.2  Alphabetic Tokens

    Alphabetic tokens, for lack	of a  better  term,  are  non-integer,	non-
    quoted terms used as arguments for certain commands, such as:

	 plog off

    Such argument types	are fairly simple to understand	and  use;  they	 are
    described here for completeness.


    6.1.3  Integers

    Integer values are 32-bit quantities  ranging  between  -2147483647	 and
    2147483647.

    In one case, an integer  is	 used  to  store  a  32-bit  color  mask  as
    described by the color command and the %colors integer function.





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      33



    6.1.3.1  Constants

    Integer constants are numeric strings, optionally with an initial  minus
    sign, the absolue value of which must be less than 2147483648.


    6.1.3.2  Variables

    There are 50 numbered, permanent integer  variables	 referenced  by	 the
    terms  '$i0'  through  '$i49'.   When  ECU is started, the value of	each
    variable is	zero.  Variables retain	 their	value  until  changed,	even
    between  procedure	executions.   The  integer  variable  number  may be
    expressed as  an  expression  by  enclosing	 an  integer  expression  in
    brackets.  For instance:

	 $i[4+5]      refers to	$i9

	 $i2=5
	 $i[20+$i2]   refers to	$i25


    Integer variables may be created for use  as  "local"  variables  or  to
    promote code readability.  Refer to	the mkvar command.


    6.1.3.3  Functions

    ECU	has many built-in functions  which  return  the	 value	of  ecu-  or
    system-related  information.  A list of the	functions appears in a later
    section.


    6.1.3.4  Expressions

    In almost any place	an integer argument is allowed,	an expression may be
    supplied.	Expressions are	composed of two	or more	integer	constants or
    variables separated	by operators from the group:

	+     addition
	-     subtraction
	*     multiplication
	/     division
	|     OR
	@     MOD
	^     XOR
	&     AND

    Evaluation	of  expressions	 is  left-to-right.   Parentheses  are	 not
    allowed.





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      34



    6.1.3.5  Relational	Operators

    Integer relational operators are chosen from the following group:

	 =	 "is equal to"
	 ==	 "is equal to"
	 !=	 "is not equal to"
	 <>	 "is not equal to"
	 >	 "is greater than"
	 <	 "is greater than"
	 >=	 "is greater than or equal to"
	 <=	 "is less than or equal	to"



    6.1.4  Strings

    Strings are	classic	concatenations of zero or more eight-bit characters.
    In general,	the maximum size of a string used by ECU is 256	characters.


    6.1.4.1  Constants

    String constants are formed	by placing alphanumeric	 characters  between
    single quote characters (apostrophes).  The	backslash ('\')	character is
    used to "escape" certains characters:

	'\'    one backslash
	'0   newline
	''   tab
	'''   apostrophe



    6.1.4.2  Variables

    There are 50 numbered, permanent  string  variables	 referenced  by	 the
    terms  '$s0'  through  '$s49',  each  possessing a maximum length of 256
    characters When ECU	is started, the	value of each variable is null (zero
    length).   Variables  retain  their	 value	until  changed,	even between
    procedure executions.  The string variable number may be expressed as an
    expression by enclosing an string expression in brackets.  For instance:

	 $s[4+5]      refers to	$s9

	 $s2=5
	 $s[20+$s2]   refers to	$s25


    String variables may be created for	 use  as  "local"  variables  or  to
    promote code readability.  Refer to	the mkvar command.



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      35



    6.1.4.3  Functions

    ECU	has many built-in functions  which  return  the	 value	of  ecu-  or
    system-related  information.  A list of the	functions appears in a later
    section.


    6.1.4.4  Expressions

    String expressions are formed by the concatenation of string  constants,
    variables and function return values using the '+' operator:

    Example:
       'The quick brown	fox jumped over	the '+$s0'+' dog at '+%time



    6.1.4.5  Relational	Operators

    String relational operators	are chosen from	the following group:

	 =	 "is equal to"
	 ==	 "is equal to"
	 !=	 "is not equal to"
	 <>	 "is not equal to"




    6.2	 Commands



    6.2.1  baud

    usage: baud	<baud-int>

    This command sets the baud rate for	 the  attached	line.	The  integer
    argument  <baud-int>  must	be  one	 of 110, 300, 600, 1200, 2400, 4800,
    9600, 19200	and 38400.

    Example:
	baud 9600
	set $i0=2400; baud $i0



    6.2.2  break

    usage: break




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      36



    This command is used inside	a whilei or  whiles  compound  statement  to
    exit the loop.

    Example:

	whilei 1=1 #forever unless break command executed
	{
	    echo -n 'Answer yes	or no: '
	    set	$s0=%cgets # get answer
	    ifi	%instr($s0,'y')	== 0 set $i0 = 1; break
	    ifi	%instr($s0,'n')	== 0 set $i0 = 0; break
	    # got neither 'y' nor 'n' ... keep trying
	}
	# now $i0 = 1 if yes, 0	if no


    NOTE: further examples of break usage may be found in  the	example	 for
    the	else command.


    6.2.3  cd

    usage: cd <directory-path>

    This command  changes  ECU's  current  working  directory.	 The  string
    argument   <directory-path>	  may	contain	  any	directory   pathname
    specification legal	to  be	submitted  to  the  shell  csh.	  Wild	card
    characters	may  be	 used,	provided  the  expansion  produces  only one
    pathname.


    Example:

	cd '~user/bin'
	cd %envvar('HOME')+'/bin'



    6.2.4  clrx

    usage: clrx

    This  command  clears   the	 attached  line's  transmitter	XOFF  state.
    Issuing  the  command  is  the  equivalent	to receiving an	XON from the
    remote system.


    6.2.5  cls

    usage: cls




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      37



    This command clears	the screen.


    6.2.6  color


    usage: color <normal-foreground> [<normal-background>]
    usage: color -r <reverse-foreground> [<reverse-background>]


    This command changes the current normal or reverse	video  colors  in  a
    manner  similar to the setcolor(C) command.	 It has	no effect on systems
    using a  monochrome	 monitor.   If	the  second  (background)  color  is
    omitted, it	is assumed to be black.

    The	command	also forces normal video mode.	Refer  to  the	vidnorm	 and
    vidrev commands.  Refer also to the	vidcolor command.


    Color names
       blue	 magenta      brown	 black
       lt_blue	 lt_magenta   yellow	 gray
       cyan	 white	      green	 red
       lt_cyan	 hi_white     lt_green	 lt_red

    Example:

	color lt_green	# normal video light green on black
	color -r red white # reverse video red on white



    6.2.7  continue

    usage: continue

    This command is used inside	a whilei or  whiles  compound  statement  to
    skip the remainder of any commands in the loop and continue	execution at
    the	first command in the loop.















    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      38



    Example:

	send ''	# send ENTER to	get prompt
	whilei 1=1 # forever unless break command executed
	{
	    lookfor -e 'login: ' # look	for login prompt
	    ifi	$i0 == 0	 # if we dont get prompt ...
	    {
		send ''		 # send	ENTER again
		continue	 # and look for	login prompt
	    }
	    send $s_name	 # send	username
	    lookfor -e 'Password:'
	    send $s_password
	    get	-e 0 50		 # wait	10 seconds for response

	    # if incorrect not found in	response, ...
	    if %instr($s0,'incorrect') < 0 # ... must have won
		break

	    # garbled line?: system will send another 'login: '
	}



    NOTE: further examples of continue usage may be found in the example for
    the	else command.


    6.2.8  cursor

    usage: cursor <row>	[<col>]

    This command places	the cursor at a	 specified  position  on  the  video
    screen.  The top left of the scrren	is row 0, column 0.  If	<col> is not
    specified, it is assumed 0 (left margin).

    Example:

	cls
	$i0 = 5
	whilei $i5 < 12
	{
	    cursor $i5
	    echo 'This is line '+%itos($i5,2d)+' of the	display'
	}








    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      39



    6.2.9  delline

    usage: delline

    This command deletes the current line from the video display.


    6.2.10  dial

    usage: dial	<remote>

    This command causes	an outgoing call to be placed.	The string  argument
    <remote>  can  take	 one  of two forms: a numeric telephone	number or an
    alphanumeric "logical" number or system name.

    A numeric phone number ('1(800)555-1212' or	'2345678') must	begin with a
    digit and must consist entirely of digits, parentheses or hyphens.	If a
    telephone number is	supplied, the phone number is dialed; you must first
    have  set the desired baud rate and	parity using the 'baud'	and 'parity'
    commands.

    If a logical name is  entered,  the	 phone	directory  (managed  by	 the
    interactive	 dial  command)	is searched; if	the entry is found, the	baud
    rate and parity is automatically set from values in	the directory entry;
    then, the number in	the directory entry is dialed.

    When the dial command returns, integer variable $i0	is set to  a  status
    code and string variable $s0 has a text message (the modem verbal result
    code if the	ecu dialer is used, a representation of	 the  return  status
    code if a uucp dialer is used [see below]).

    Dial Command $i0 Status Codes

	0  successful connect
	1  failed to connect (call progress)
	2  dial	interrupted by signal
	3  modem error (non responsive or commands rejected)

















    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      40



    Dial Command $s0 Status Messages (uucp dialer)

	CONNECT	####	       #### = baud rate
	BUSY		       only some modems
	NO ANSWER	       only some modems
	NO CARRIER	       most generic "fail to connect"
	NO DIAL	TONE	       only some modems
	!Connect bad baud rate modem reported different	rate
	!Interrupted	       call interrupted	by signal
	!Invalid arguments     ecu error
	!Invalid phone number  too long	or bad characters
	!Ioctl error	       should not be reported here
	!Line in use	       should not be reported here
	!Line open error       should not be reported here
	!Modem Error	       modem did not respond

    Note: if the ecu dialer is used, the actual	modem result code
    is returned	in $s0 or one of the following two strings:

	!Interrupted	       call interrupted	by signal
	!Modem Error	       modem did not respond



    6.2.11  do

    usage: do <procname> [<arg>	...]

    This command executes a procedure whose name appears  as  the  command's
    first (string) argument.  One or more arguments (up	to 19) may be passed
    to the called procedure; an	argument may consist  of  any  valid  string
    expression,	provided, that,	when expanded,	the argument does not exceed
    256	characters in length.

    The	called procedure may read  its	arguments  using  the  %argv  string
    function.	%argv(0)  is  the  name	 of  the procedure.  The quantity of
    arguments may be obtained using the	%argc integer function.


    Example:

	do 'proc' %rname %date+' '+%time %argv(0)

    Note: in this example, the called procedure	is passed the name
    of the calling procedure as	the last argument.



    6.2.12  duplex





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      41



    usage: duplex full | half
	   duplex 'full' | 'half'


    This command specifies whether or not ecu is to locally echo  characters
    typed  by  you  at	the  keyboard.	 The overwhelming majority of remote
    systems provide the	echo function, in which	case  full  duplex  must  be
    used.   For	the rare occasions when	the remote system does not echo	your
    keyboard input, setting half duplex	will allow you to see what  you	 are
    typing.

    When communicating with another terminal in	a  "teletype  conversation",
    setting  half  duplex  is generally	required.  In such cases, use of the
    interactive	nl, nlin and nlout commands may	also be	required.

    Example:

	duplex full
	$s0 = 'full'; duplex $s0




    6.2.13  echo

    usage: echo	[-n] <string>

    This command prints	the contents of	the string argument <string> on	 the
    screen.   If  the -n switch	is not present,	a newline follows the output
    of <string>.

    Example:

	echo 'Procedure	'+%argv(0)+' executing at '+%time
	echo -n	'Enter your first name:	'; $s0 = %cgets



    6.2.14  eeol

    usage: eeol

    This command erases	the video display to the end of	the line.


    6.2.15  else


    This statement may follow an ifi or	ifs command to specify one  or	more
    statements	to  be	executed  if the if-type command condition is false.
    Else commands may be chained  together  in	the  traditional  structured



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      42



    usage: else	<statement>

	   else
	       <statement>

	   else
	   {
		any kind and number of statements
	   }

	   else	<if> <statement>

	   else	<if>
	   {
		any kind and number of statements
	   }


    language manner.

    For	the purposes of	describing this	command, <statement> is	 any  single
    or compound	statement NOT containing a whilei or whiles command.  If you
    wish to have a while-type command executed as part of an else condition,
    the	while must occur within	braces ("{}").

    <if> is an ifi or ifs command followed by  an  <if-condition>  (see	 the
    description	of the ifi or ifs commands below).



























    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      43



    Example:

    #+------------------------------------------------------
    # finger.ep	- procedure to send 'finger' to	remote
    # BSD Unix system; print resulting lines in	different
    # colors: uucp logins green, root red, others cyan
    #-------------------------------------------------------

	mkvar $icolor; $icolor = %colors
	mkvar $itimeout
	$itimeout = 50	   # timeout for first line 5 secs
	send 'ps -aux'	   # send command, but do not echo
	lookfor	'0 40	 # swallow command
	whilei 1==1	   # forever, or until break
	{
	    lgets 0 $itimeout 1	'0 #get	a line
	    ifi	$i0 = 0	break #if no chaacters read
	    $itimeout =	10 #wait 1 sec for later lines

	    ifi	%instr($s0,'% ') >= 0 #	if csh prompt seen
		break		      #	exit while loop
	    else ifi %instr($s0,'Login') >= 0
		color gray
	    else ifi %instr($s0,'root')	>= 0
		color red
	    else ifi %instr($s0,'uucp')	>= 0
		color green
	    else color cyan
	    echo $s0
	}
	icolor $icolor #restore	entry colors
	send ''	       #force a	new prompt from	remote




    6.2.16  exit

    usage: exit	[<status>]

    This command causes	an abrupt  termination	of  the	 ecu  program.	 Any
    existing  connection with a	remote system is terminated immediately.  If
    no integer argument	<status> is found, ecu exits  with  a  program	exit
    status of 0.  If <status> is found and the value is	zero, then ecu exits
    with a program exit	status of 0.  If <status> non-zero,its value must be
    in the range of 1 to 31, and ecu exits with	a program exit status of 192
    plus <status>.  This feature allows	batch executions  of  ecu  by  shell
    script and ECU procedure to	detect ECU execution status.






    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      44



    6.2.17  expresp

    usage: expresp [-v[v...]] <exp-resp-str> [<timeout_msecs>]

    This command emulates the uuchat function as described in  the  SCO	 HDB
    UUCP documentation and in the /usr/lib/uucp/Dialers	file.

    -v causes the expect-respond conversation between  ECU  and	 the  remote
    system  to	be  displayed  on  the screen.	This switch is automatically
    enabled if procdedure tracing is enabled.

    multiple v's (e.g.,	-vv, -vvv) up to 3 'v's	produce	more  verbose  debug
    output.  -vv  causes  each	base  level  expect and	respond	string to be
    displayed. -vvv causes a hexadecimal dump of  each	 interpreted  expect
    string to be displayed.

    <exp-resp-str> is as defined in /usr/lib/ecu/Dialers.

       Meaning of some of the escape characters:
	- pause	(approximately 1/4-1/2 second delay)

	- delay	(2 seconds)
       D - phone number/token
       T - phone number	with Dialcodes and character translation
       N - null	byte
       K - insert a BREAK
       E - turn	on echo	checking (for slow devices)
       \--carriagefreturnchecking
	   - send new-line
	n - send octal number
       Speed - Hayes-specific speed-adaptive connect handler


    <timeout_msecs>  specifies	an  optional  timeout  in  milliseconds	 for
    waiting  on	 expect	 strings;   it	defaults  to 10,000 milliseconds (10
    seconds).  The resolution for timeouts is limited to the basic tick	time
    of	your  system  (HZ,  10	msec for UNIX/386, 20 msec for XENIX/386 and
    XENIX/286).	 The timeout for 'Speed' expects is fixed at 90	seconds.


    6.2.18  fchmod

    usage: fchmod <mode> <file>

    This command sets the mode of <file> to  <mode>.   The  <mode>  argument
    takes one of two forms, a nine-character mode string (e.g.,	'rwxr-xr-x')
    or an integer value	(0755).	 The <file>  argument  is  either  a  string
    value  forming  a filename or an integer file number representing a	file
    opened with	the fopen command.

    The	command	sets $i0 = 0 if	successful,  else  to  the  errno  from	 the



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      45



    associated	system	call  (refer  to  the %errstr string function and/or
    /usr/include/sys/errno.h).


    Example:

	fopen 1	'/tmp/123'; fchmod 'rwxrwxrwx' 1
	fchmod 'rwxrwxrwx' '/tmp/123'
	fopen 1	'/tmp/123'; fchmod 0777	1
	$i0 = 0777; fchmod $i0 '/tmp/123'

    All	of the above example result in the same	result.



    6.2.19  fclose

    usage: fclose <file>

    This command closes	<file>.	 The <file>  argument  is  an  integer	file
    number representing	a file opened with the fopen command.

    The	command	is ignored if <file> is	not open.  No  integer	variable  is
    modified by	fclose.


    Example:

	fclose 1



    6.2.20  fdel

    usage: fdel	<file>

    This command removes a file.

    The	command	sets $i0 = 0 if	successful,  else  to  the  errno  from	 the
    associated	system	call  (refer  to  the %errstr string function and/or
    /usr/include/sys/errno.h).


    Example:

	fdel '/tmp/123'








    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      46



    6.2.21  fgetc

    usage: fgetc <file>	<destination>

    This command reads a character from	<file>.	 The <file> argument  is  an
    integer file number	representing a file opened with	the fopen command.

    The	argument <destination> is either a string  variable  or	 an  integer
    variable.	If  the	 file  has  reached end	of file: an integer variable
    receives -1;  a  string  variable  is  returned  null.   Otherwise,	 the
    character's	 numeric value (0-255) is placed in an integer variable	or a
    string variable is returned	with a length of one with the file character
    as its only	character.


    Example:

	fgetc 1	$s0
	fgetc 1	$i_input



    6.2.22  fgets

    usage: fgets <file>	<strvar>

    This command reads a character from	<file>.	 The <file> argument  is  an
    integer file number	representing a file opened with	the fopen command.

    The	argument <strvar> is a string variable.	 If the	file has reached end
    of file, <strvar> is returned null and integer variable $i0	is set to 1.
    Otherwise, the <strvar> receives input from	the file minus the  trailing
    newline and	$i0 is returned	zero.


    Example:

	fgets 1	$s0



    6.2.23  fkey

    usage: fkey	<str>

    This command selects a function  key  definition  from  the	 ~/.ecu/keys
    file.







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      47



    6.2.24  flush

    usage: flush

    This command causes	any characters received	by the system from the line,
    but	not yet	read by	the procedure to be "forgotten"	or flushed.


    6.2.25  fopen
    usage: fopen [-switches] <filenum> <filename>

    This command opens a file named by the string  argument  <filename>	 and
    associates	it with	the user-chosen	file number <filenum> (which must be
    an integer value between 0 and 4, inclusive).

    The	argument switches govern how a file is opened  and  must  be  chosen
    from this list:

	-r	   The file is opened read-only; if it does  not  exist,  an
		   error occurs.

	-r+	   The file is opened for reading and writing;	if  it	does
		   not exist, an error occurs.

	-w	   The file is opened for writing (any previous	contents  of
		   the file are	lost); if it does not exist, it	is created.

	-w+	   The file is opened for reading and writing (any  previous
		   contents  of	the file are lost); if it does not exist, it
		   is created.

	-a	   The file is opened for appending (writes to the file	 are
		   added  to  the  previous  file  contents); if it does not
		   exist, it is	created.  All writes  are  appended  to	 the
		   file	(the fseek command has no effect).

    The	switches parameter may be omitted; in such cases, the file is opened
    as	though	'-r'  had  been	 supplied.  However, if	procedure tracing is
    enabled (see the description of the	interactive  and  procedure  command
    ptrace), a warning message will be issued.

    The	command	sets $i0 = 0 if	successful,  else  to  the  errno  from	 the
    associated	system	call  (refer  to  the %errstr string function and/or
    /usr/include/sys/errno.h).

    Example:

	fopen 0	-r '/etc/passwd'
	fopen 1	-w+ '/tmp/123'
	fopen 2	-a 'tranact.log'




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      48



    6.2.26  fputc

    usage: fputc <file>	<char>

    This command writes	character <char> into <file>.  The  <file>  argument
    is	an  integer  file  number  representing	a file opened with the fopen
    command.  Argument <char> is a integer value of which  the	lower  eight
    bits are used or a string value of which the first character is used.

    If a write error occurs, procedure execution is terminated.

    Example:

	$s0='abc'; fputc 1 $s0	      writes 'a'
	$i0=0x30 ; fputc 1 $i0	      writes '0'



    6.2.27  fputs

    usage: fputs [-n] <file> <str>

    This command writes	the string <str> into <file>.  The  <file>  argument
    is	an  integer  file  number  representing	a file opened with the fopen
    command.

    If the switch '-n' is omitted, a newline is	appended after <str> in	 the
    file; if present, no newline is written.

    If a write error occurs, procedure execution is terminated.

    Example:

	$s0='abc'; fputc 1 $s0	      writes 'a'



    6.2.28  fseek

    usage: fseek <file>	<position>

    This command sets  the  file  position  of	<file>	to  <position.	 The
    corresponding  integer  function  %ftell  may  be  used to determine the
    current file position.

    Note: if <file> is open for	append ('-a'), then the	fseek  command	will
    have no effect.







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      49



    6.2.29  getf


    usage: getf	-x <int-var-spec> <offset>

    where: -x ==
       -b byte
       -w word (little-endian)
       -W word (big-endian)
       -l 32-bits (little-endian)
       -L 32-bits (big-endian)



    6.2.30  goto

    usage: goto	<label>

    This command transfers control of procedure	to a  statement	 other	than
    the	one immediately	following.  The	<label>	argument may be	literal	text
    or may be a	string,	allowing a "computed goto" feature.

    Example:

	goto GET_NEXT
	goto 'GET_NEXT'
	goto 'GET'+'_NEXT'
	$s0 = 'GET_NEXT'; goto $s0
	$s0 = 'NEXT'; goto 'GET_'+$s0

    Note: all the above	examples cause transfer	to the label GET_NEXT.


    6.2.31  gotob

    usage: gotob <label>

    This command serves	the same function as the  goto	command	 except	 the
    programmer is signifying that the label is behind the current statement,
    resulting in slightly faster execution.  (The label	is not	REQUIRED  to
    be	at  any	 specific  location  in	 the procedure relative	to the gotob
    statement.)


    6.2.32  hangup

    usage: hangup

    This command causes	Data Terminal Ready (DTR) to be	dropped	momentarily,
    causing  (hopefully)  the  termination  of	any  current connection	to a
    remote system. This	command	is  only  effective  if	 the  attached	Data



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      50



    Communications  Equipment  is  configured to terminate its connection on
    loss of DTR.

    If no line is attached, the	command	is ignored (a warning  is  generated
    if procedure tracing is enabled).


    6.2.33  hexdump

    usage: hexdump [-s]	<str>
	   hexdump -t[s] <str1>	<str>


    <str> buf to dump <str1> title (if -t) -s short (terse) dump

    This command prints	a hexadecimal dump of <str> on the  screen  (and  to
    the	procedure log file, if logging enabled with the	ptrace command).

    The	switch '-t' signifies that <str1> is a title to	be printed

    Example:

	$s0='The quick brown fox jumped	over the lazy dog's back'
	hexdump	-t 'Example hex	dump' $s0
    ---------------------------- Example hex dump ----------------------------
    0000  54 68	65 20 71 75 69 63 6B 20	62 72 6F 77 6E 20 | The	quick brown  |
    0010  66 6F	78 20 6A 75 6D 70 65 64	20 6F 76 65 72 20 | fox	jumped over  |
    0020  74 68	65 20 6C 61 7A 79 20 64	6F 67 27 73 20 62 | the	lazy dog's b |
    0030  61 63	6B					  | ack		     |

	hexdump	%left($s0,9)
    0000  54 68	65 20 71 75 69 63 6B			  | The	quick	     |

	hexdump	-ts 'Example hex dump' %left($s0,9)
    Example hex	dump
    0000  54 68	65 20 71 75 69 63 6B | The quick |

	hexdump	-s %left($s0,9)
    0000  54 68	65 20 71 75 69 63 6B | The quick |



    6.2.34  home

    usage: home

    This command homes the video cursor.







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      51



    6.2.35  icolor

    usage: %icolor <int-colors>

    This command sets the  normal  and	reverse	 foreground  and  background
    colors according to	<int-colors>, an integer value in the format as	that
    returned by	the %colors integer function.

    This command is provided primarily to be able to save the  color  state,
    modify it temporarily and then restore it.

    Example:

	mkvar $icolor_save; $icolor_save = %colors
	color red; echo	'Connection seems to be	dead'
	icolor $icolor_save # restore previous colors



    6.2.36  ifi

    usage: ifi <int> <rel-op> <int> <statement>
	   ifi <int> <rel-op> <int>
	       <statement>
	   ifi <int> <rel-op> <int>
	   {
	       any kind	or number of statements
	   }


    This command selectively executes one or more statements based on a	test
    of	two integer quantities.	 See the description of	the break, continue,
    and	else commmands for examples of how the command is used.


    6.2.37  ifs

    usage: ifs <str> <rel-op> <str> <statement>
	   ifs <int> <rel-op> <int>
	       <statement>
	   ifs <int> <rel-op> <int>
	   {
	       any kind	or number of statements
	   }


    This command selectively executes one or more statements based on a	test
    of	two  string values.  See the description of the	break, continue, and
    else commmands and many other  examples  throughout	 the  document,	 for
    examples of	how the	command	is used.




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      52



    6.2.38  lbreak

    usage: lbreak

    This command transmits a break to the remote system.


    6.2.39  lgets


    usage: lgets [-er] <strvar>	<t1-int> <t2-int> [<stop-str>]

    -e echo received characters	to screen
    -r raw read	(retain	carriage returns)


    This command reads a  string  from	the  attached  communications  line.
    <t1-int>  is  the  number of tenths	of seconds before timing out waiting
    for	the first character to be  received.   <t2-int>	 is  the  number  of
    tenths  of seconds before timing out on later characters.  <stop-str> is
    an optional	argument, which	 if  received,	immediately  terminates	 the
    read.  Integer variable $i0	is set to the count of characters received.

    If the specified string variable is	filled with  characters	 before	 the
    <stop-str>	has  been  encountered	or before a timeout occurs, then the
    command returns with $i0 set to the	maximum	size of	the variable.  Refer
    to	the section on string variables	above and the section describing the
    mkvar command below	for information	on the size of string variables.


    6.2.40  insline

    usage: insline

    This command inserts a line	onto the video screen at the current line.


    6.2.41  logevent

    usage: logevent <str>


    This command writes	a log item to ~/.ecu/log.











    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      53



    Example:

	$s0='/tmp/alm.log'
	log 'appending alarm info to '+$s0

    writes:
    10-02-1989-17:39-01261-PROC	appending alarm	info to	/tmp/alm.log

    6.2.42  lookfor

    lookfor [-e] [quiet	| <str>] [<timeout-int>]

    -e echo to screen while "looking"

    This command is used to read from the attached commuications line  until
    one	of two user-specified conditions occurs.

    The	'quiet'	option waits becomes quiet  for	 the  number  of  tenths  of
    seconds specified  by <timeout-int>.

    The	other option reads the line until <str>	is read	 from  the  line  or
    until  <timeout-int>  tenths  of  seconds  elapses.	  With	this option,
    integer variable $i0 is set	to 1 if	<str> is found	within	the  timeout
    period or 0	if not.


    Examples:

	lookfor	-e quiet 20   wait for quiet line for 2	secs
	lookfor	'word:'	50    wait for 'word:' for up to 5 secs

    6.2.43  mkvar

    usage: mkvar [$]i<name>
	   mkvar [$]s<name>(<size>)


    This command creates one or	more named integer or string variables.	 The
    variable  type  is	determines  by	the first character of the variable,
    which must be 'i' or 's'.	The  size  of  a  string  variable  must  be
    specified  via the <size> argument.	 An optional '$' may be	supplies for
    neatness, but may be omitted if desired.

    The	maximum	value for <size> is 5120.  Note	that most commands  are	 not
    capable  of	 handling  variables  longer  in  current  length  than	256.
    Procedures employing created string	variables longer than 256 characters
    should be tested carefully with string lengths that	exceed 256.

    The	scope of created variables is for the duration of the  execution  of
    the	creating procedure.  Procedures	called by the creating procedure (by
    'do') can reference	created	variables.  When created, integer  variables



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      54



    are	 set  to  zero	and  string variables are set to zero length.  These
    features differ from numbered variables which  retain  their  scope	 and
    values  at	all  times, even when procedure	execution terminates and ECU
    returns to interactive mode.

    The	<name> space for integer and string variables are separate.   It  is
    possible to	have an	integer	variable named '$ixyz' and a string variable
    named '$sxyz'.  <name> may contain any alphabetic or  numeric  character
    or	the  underscore	 ('_')	character, but must begin with a non-numeric
    character.	'$s_xyz' and '$sxyz' or	legal, but '$s3xyz' is not (would be
    interpreted	as '$s3' followed by the illegal command sequence 'xyz').

    Variables may be created by	the same name more than	 once.	 The  latest
    mkvar  execution  specifies	 the  variable	referenced.   Thus  if proc1
    declares '$ixx' and	calls proc2  which  also  declares  '$ixx',  proc2's
    variable  is distinct from proc1's and disappears when proc2 terminates,
    thus making	proc1's	available to it	again, containing the same value  as
    it had at the time proc2 was called.


    Examples:

	mkvar i_count
	mkvar $i_count
	mkvar s20(20),s80(80),i_timeout,$i_colors



    6.2.44  nap
    usage: nap <int>

    This command suspends procedure execution for <int>	tenths of seconds.


    Examples:

	nap 30
	nap $i0*$i2

    6.2.45  parity

    usage: parity [even	| odd |	none]
	   parity <str>


    This command sets the parity for the attached communications  line.	  If
    <str>  is  supplied,  the  first  character	 must  be  'e',	 'o' or	'n'.
    Uppercase equivalents are also accepted.






    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      55



    Examples:

	parity even
	parity 'e'
	parity 'Even now as we speak'



    6.2.46  pclose
    usage: pclose <filenum>

    This command should	be issued when a command started by the	 interactive
    popen commandf completes.


    6.2.47  plog

    usage: plog
	   plog	<str>
	   plog	off


    This command controls logging to a file  of	 the  screen  output  during
    procedure  execution.  With	no argument, the command displays the status
    of logging.	 <str> specifies  a  log  file	pathname,  while  the  'off'
    argument turns logging off.

    If procedure execution terminates due to an	error, procedure logging  is
    turned  off.   However, if procedure execution terminates normally while
    logging is active, erratic and  unpredictable  portions  of	 interactive
    mode screen	output will continue to	be logged to the current log file.

    The	interactive mode command plog may also be used to control  procedure
    logging.

    Example:

	mkvar s_logname(128)
	$s_logname = %dir+'logname'
	plog $s_logname
	echo 'Test'
	plog off;cd 'somewhere_else';plog $s_logname
	echo 'Test'



    6.2.48  popen
    usage: popen [-switches] <filenum> <command>

    This command executes a shell command defined  by  the  string  argument
    <command>  and  associates it with the user-chosen file number <filenum>



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      56



    (which must	be an integer value between 0 and 4, inclusive).

    The	argument switches govern whether the command  is  to  receive  input
    from ecu or	output to ecu and must be chosen from this list:

	-r	   The command will output to ecu.

	-w	   The command will receive input from ecu.

    The	switches parameter may be omitted; in such cases, the file is opened
    as	though	'-r'  had  been	 supplied.  However, if	procedure tracing is
    enabled (see the description of the	interactive  and  procedure  command
    ptrace), a warning message will be issued.

    The	command	sets $i0 = 0 if	successful,  else  to  the  errno  from	 the
    associated	system	call  (refer  to  the %errstr string function and/or
    /usr/include/sys/errno.h).

    Example:

	popen 0	-r 'ls -l *.log'
	popen 1	-w 'cat	| sort > /tmp/sorted'




    6.2.49  prompt
    usage: prompt <str>

    This command allows	selection of an	alternate prompt to the	 interactive
    mode  HOME command trigger.	 Refer to the section titled "ECUPROMPT" for
    more information on	the interactive	mode prompt.

    Note: the interactive and  procedure  hangup  commands  both  cause	 the
    default prompt to be reestablished.


    Example:

	 prompt	%rname+' >'    use remote name in prompt



    6.2.50  ptrace

    usage: ptrace [ <str> | off	]


    This command controls procedure  execution	tracing.   Trace  output  is
    written to the screen and varys in its nature depending upon the command
    being traced.  Specifically, any change to a string	or integer  variable



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      57



    is noted.  If tracing is enabled, the output will also be written to any
    active procedure log  file	(see  the  plog	 interactive  and  procedure
    commands).


    6.2.51  putf

    Not	yet implemented.


    6.2.52  return
    usage: return [<int>]

    This command causes	the  currently	executing  procedure  to  terminate,
    returning  either to a calling procedure or	to the interactive mode.  If
    <int> is supplied, if  it  nonzero,	 then  all  procedure  execution  is
    terminated	and  the  integer status is printed on the screen along	with
    the	name of	the executing procedure.


    6.2.53  rk
    usage: rk [-a]

    This command invokes the Kermit file receive protocol.  If	switch	'-a'
    is	omitted,  the  received	 files	are  stored  as	 received; otherwise
    carriage return/linefeed pairs are converted to  newlines.	 The  remote
    sender must	have been started prior	the the	execution of this command.


    6.2.54  rname
    usage: rname <str>

    Normally, the %rname string	function returns  the  same  string  as	 the
    logical  dialing directory entry.  This command allows the default value
    to be overridden with a user-selected value	(63-character maximum).

    This feature is useful in  situations  where  one  system  is  initially
    dialed,  but  a connection is made to yet another system from the dialed
    system via networking.


    6.2.55  rs
    usage: rs

    This command invokes the SEAlink file receive  protocol.   There  is  no
    provision  in  the	SEAlink	protocol to convert carriage return/linefeed
    pairs to newlines, so the received files are stored	 as  received.	 The
    remote  sender  must  have	been started prior the the execution of	this
    command.





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      58



    6.2.56  rx
    usage: rx [-a] <str>

    This command invokes the XMODEM file receive protocol  to  receive	file
    <str>.   If	 switch	 '-a'  is  omitted,  the  received file	is stored as
    received; otherwise	carriage  return/linefeed  pairs  are  converted  to
    newlines.	The  remote  sender  must  have	 been  started prior the the
    execution of this command.


    6.2.57  ry
    usage: ry

    This command invokes the YMODEM Batch (not to be confused  with  XMODEM-
    1K)	 protocol  to receive files from a remote system.  The remote sender
    must have been started prior the the execution of this command.


    6.2.58  rz
    usage: rz

    This command invokes the ZMODEM protocol to	receive	files from a  remote
    system.   The  remote  sender  must	 have  been  started  prior  the the
    execution of this command.


    6.2.59  scrdump
    usage: scrdump [<str>]

    This command causes	the current screen contents to be stored in a  file.
    If	<str>  is  supplied,  it  is  used  as	a pathname.  If	<str> is not
    supplied, "~/.ecu/screen.dump".  The actions of the	 interactive  sdname
    command have no effect on the execution of this command.


    6.2.60  send
    usage: send	[-n] <str>

    This command sends <str> to	the communications line.  If the '-n' switch
    is	omitted, a carriage return (0x0D) is transmitted after <str>.  If '-
    n' is supplied, no carriage	return is transmitted.


    Examples:

	send 'ps -au'
	send -n	%chr(0x02)+"START'+%chr(0x03)







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      59



    6.2.61  set

    usage: set [$]i<name>=<int-expression>[, ...]
	   set [$]s<name>=<str-expression>[, ...]


    This command sets an integer or string variable to an  expression.	 The
    'set'  verb	 may  be  omitted  provided  the  otherwise  optional '$' is
    supplied.  There are many examples of how the set statement	is performed
    throughout	this document.	The examples here are to further clarify the
    statement's	syntax.

    If the  '=<expression>'  is	 omitted,  the	value  of  the	variable  is
    displayed  (useful	when  debugging).    If	procedure tracing is enabled
    with the ptrace command, all variables referenced by  the  set  command,
    whether a value is assigned	or not,	are displayed.


    Examples:

	set i0=0
	set $s0='brown',s1='The	quick '+$s0+' fox'
	set $S0		     with no '=', displays contents
	set i0,$i1,s0='abc',s1
	$s0 = 'abc'	     legal
	set s0='abc'	     legal
	s0 = 'abc'	     illegal

    6.2.62  sk
    usage: sk [-a] <str>

    This command invokes the Kermit file transfer protocol to  send  one  or
    more  files.   If  switch  '-a'  is	 supplied, newlines are	converted to
    carriage return/linefeed pairs.  If	'-a' is	 omitted,  the	file(s)	 are
    transmitted	without	modification.

    Integer variable $i0 receives the exit status from the transfer.   Note:
    procedure  execution  is  NOT terminated by	a SIGINT to the	spawned	file
    transfer process.  It is the responsibility	of the procedure to  process
    the	exit status returned in	$i0.  If $i0 is	set to -1, the file transfer
    program did	not begin.


    6.2.63  ss
    usage: ss <str>

    This command invokes the SEAlink file transfer protocol to send  one  or
    more  files.   There  is no	provision in the SEAlink protocol to convert
    newlines to	carriage return/linefeed pairs.	 so the	received  files	 are
    stored as received.




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      60



    Integer variable $i0 receives the exit status from the transfer.   Note:
    procedure  execution  is  NOT terminated by	a SIGINT to the	spawned	file
    transfer process.  It is the responsibility	of the procedure to  process
    the	exit status returned in	$i0.  If $i0 is	set to -1, the file transfer
    program did	not begin.


    6.2.64  sx
    usage: sx [-ak[l]] [<label-str>] <filename-str>

    This command invokes the XMODEM or XMODEM-1K file transfer	protocol  to
    send  a  file.  If '-k' is supplied, XMODEM-1K is used, else XMODEM.  If
    switch  '-a'  is  supplied,	  newlines   are   converted   to   carriage
    return/linefeed  pairs.  If	'-a' is	omitted, the file(s) are transmitted
    without modification.  If '-l' is supplied,	then <label-str> specifies a
    string to display on the bottom of the file	transfer screen.  If '-l' is
    omitted, then <label_str> must also	be omitted.

    Integer variable $i0 receives the exit status from the transfer.   Note:
    procedure  execution  is  NOT terminated by	a SIGINT to the	spawned	file
    transfer process.  It is the responsibility	of the procedure to  process
    the	exit status returned in	$i0.  If $i0 is	set to -1, the file transfer
    program did	not begin.


    Examples:

	sx -al 'sending	log file' '/tmp/log.file'
	sx -



    6.2.65  sy
    usage: sy [-a[l]] [<label-str>] <filelist-str>

    This command invokes the YMODEM Batch (not to be confused  with  XMODEM-
    1K)	file transfer protocol to send one or more files.

    If	switch	'-a'  is  supplied,  newlines  are  converted  to   carriage
    return/linefeed  pairs.  If	'-a' is	omitted, the file(s) are transmitted
    without modification.  If '-l' is supplied,	then <label-str> specifies a
    string to display on the bottom of the file	transfer screen.  If '-l' is
    omitted, then <label_str> must also	be omitted.

    Integer variable $i0 receives the exit status from the transfer.   Note:
    procedure  execution  is  NOT terminated by	a SIGINT to the	spawned	file
    transfer process.  It is the responsibility	of the procedure to  process
    the	exit status returned in	$i0.  If $i0 is	set to -1, the file transfer
    program did	not begin.





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      61



    6.2.66  system
    usage: system [-l] <cmdstr>

    If switch '-l', is supplied, the attached  communications  line  becomes
    the	stdin and stdout for the command.

    Integer variable $i0 is set	to the spawned process'	exit status  if	 the
    process  exits "normally", or 0x100	if the process is killed, dumps	core
    or interrupted.

    Note:  procedure execution is NOT terminated by a SIGINT to	the  spawned
    process.   It is the responsibility	of the procedure to process the	exit
    status returned in $i0.  If	$i0 is set to -1, the file transfer  program
    did	not begin.


    6.2.67  sz
    usage: sz [-anf[l]]	[<label-str>] <filelist-str>

    This command invokes the ZMODEM (CRC-32 capable) file transfer  protocol
    to send one	or more	files.

    Switch '-n'	causes the receiver to accept  files  with  do	not  already
    exist  at  the  remote  system or which have older times of	 last access
    that at the	sending	system.

    Switch '-f'	  causes  the  full  pathname  of  each	 file  to  be  sent;
    otherwise, the simple filename is transmitted.

    If	switch	'-a'  is  supplied,  newlines  are  converted  to   carriage
    return/linefeed  pairs.  If	'-a' is	omitted, the file(s) are transmitted
    without modification.

    If '-l' is supplied, then <label-str> specifies a string to	 display  on
    the	 bottom	 of  the  file	transfer  screen.   If '-l' is omitted,	then
    <label_str>	must also be omitted.

    Integer variable $i0 receives the exit status from the transfer.   Note:
    procedure  execution  is  NOT terminated by	a SIGINT to the	spawned	file
    transfer process.  It is the responsibility	of the procedure to  process
    the	exit status returned in	$i0.  If $i0 is	set to -1, the file transfer
    program did	not begin.


    6.2.68  vidcolor
    usage: vidcolor <type> <fcolor> [<bcolor>]

    This command allows	control	over the internal color	choices	 ecu  makes.
    <type> must	be one of the following:





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      62



	 normal	  - normal video color
	 reverse  - reverse video color
	 notify	  - color used for low key notifications such as
		    "[interactive mode]" and "[procedure finished]"
	 success  - color used for modem CONNECT messages and other
		    "success" notifications
	 alert	  - color used to alert	user for warning or caution
		    purposes
	 error	  - color used to display error	status or messages


    <fcolor> and <bcolor> are color names as described in the description of
    the	 color	command.  <fcolor>  choses  the	foreground color and must be
    supplied.  <bcolor>	choses the background color and	is optional; if	 not
    supplied, the background color is black.

    Note: The vidcolor normal and reverse options are analogs of  the  color
    and	color -r command.


    Examples:  (showing	ecu default internal color list)

	vidcolor normal	lt_green
	vidcolor reverse red white
	vidcolor notify	gray
	vidcolor success lt_green
	vidcolor alert yellow
	vidcolor error red



    6.2.69  vidnorm
    usage: vidnorm

    This command causes	later screen output to	appear	in  the	 normal,  as
    opposed  to	 reverse  video	mode.  The color command forces	normal video
    mode.


    6.2.70  vidrev
    usage: vidrev

    This command causes	later screen output to appear  in  the	reverse,  as
    opposed  to	 normal	 video	mode.  The color command forces	normal video
    mode.


    6.2.71  whilei






    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      63



    usage: whilei <int>	<rel-op> <int> <statement>
	   whilei <int>	<rel-op> <int>
	       <statement>
	   whilei <int>	<rel-op> <int>
	   {
	       any kind	or number of statements
	   }


    This command executes a loop one or	more statements	based on a  test  of
    two	integer	quantities.  See the description of the	break, else, whilei,
    and	whiles commmands for examples of how the command is used.


    6.2.72  whiles

    usage: whiles <str>	<rel-op> <str> <statement>
	   whiles <int>	<rel-op> <int>
	       <statement>
	   whiles <int>	<rel-op> <int>
	   {
	       any kind	or number of statements
	   }


    This command executes a loop of one	or more	statements based on  a	test
    of	two  string values.  See the description of the	break, continue, and
    else commmands and many other  examples  throughout	 the  document,	 for
    examples of	how the	command	is used.



    6.3	 Integer Functions



    6.3.1  %argc

    This function returns the number of	 arguments  passes  to	the  current
    procedure.




    6.3.2  %baud

    This function returns the baud rate	of the communications line.   If  no
    line  is  currently	attached, the baud rate	returned is the	value of the
    last line attached.	 If no line has	been  attached	during	the  current
    session, the default baud rate is returned.




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      64



    6.3.3  %colors

    This function  returns  the	 state	of  the	 normal	 and  reverse  video
    foreground and background colors in	the 32-bit value:

	 00000000001111111111222222222233
	 01234567890123456789012345678901
	 0000|--|0000|--|0000|--|0000|--|
	      fg      bk      fg      bk
	       reverse		normal


    The	color values are obtained from the following lists:

	Alphabetic Order
	black	     0
	blue	     1
	brown	     6
	cyan	     3
	gray	     8
	green	     2
	hi_white    15
	lt_blue	     9
	lt_cyan	    11
	lt_green    10
	lt_magenta  13
	lt_red	    12
	magenta	     5
	red	     4
	white	     7
	yellow	    14























    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      65



	Numeric	Order
	black	     0
	blue	     1
	green	     2
	cyan	     3
	red	     4
	magenta	     5
	brown	     6
	white	     7
	gray	     8
	lt_blue	     9
	lt_green    10
	lt_cyan	    11
	lt_red	    12
	lt_magenta  13
	yellow	    14
	hi_white    15



    6.3.4  %conn

    This function returns the  communications  line  file  descriptor  if  a
    connection	 is  in	 progress,  else  0.   NOTE:   if  carrier  is	lost
    abnormally,	%conn will return non-zero incorrectly.


    6.3.5  %curx

    This function returns the display cursor column position last set by the
    remote system.  This value does not	reflect	the actual hardware cursor.


    6.3.6  %cury

    This function returns the display cursor row position last	set  by	 the
    remote system.  This value does not	reflect	the actual hardware cursor.


    6.3.7  %csec

    This function returns the number of	seconds	ECU has	been connected to  a
    remote system.  If ECU is not connected, zero is returned.


    6.3.8  %ctoi

    usage: %ctoi(str0)

    This function returns the integer value of the first character in string
    str0.  If str0 is non-empty, the return value will be between 0 and	255,



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      66



    inclusive.	if str0	is empty, then -1 is returned.


    6.3.9  %fatime

    usage: %fatime(int0)
	   %fatime(str0)


    This function returns the time of last access of the file referenced  by
    the	argument.  If the argument is an integer, the file referenced is the
    file opened	by that	number with the	fopen command.	If the argument	is a
    string, it is the literal filename.

    If int0 does not refer to an open file, the	procedure terminates with an
    error.  If the file	specified by str0 does not exist, -1 is	returned.

    The	return value is	the number of seconds since January 1, 1970 at	0000
    UTC.   The	%edate	string	function  may be used to convert the integer
    value to a string representation of	the date and time expressed relative
    to the current time	zone.


    6.3.10  %fmode

    usage: %fmode(int0)
	   %fmode(str0)


    This function returns the file mode	value ("rwxrwx---" ==  077)  of	 the
    file  referenced  by  the  argument.  If the argument is an	integer, the
    file referenced is the  file  opened  by  that  number  with  the  fopen
    command.  If the argument is a string, it is the literal filename.

    If int0 does not refer to an open file, the	procedure terminates with an
    error.  If the file	specified by str0 does not exist, -1 is	returned.


    6.3.11  %fmtime

    usage: %fmtime(int0)
	   %fmtime(str0)


    This function returns the time of last modified of the  file  referenced
    by	the argument.  If the argument is an integer, the file referenced is
    the	file opened by that number with	the fopen command.  If the  argument
    is a string, it is the literal filename.

    If int0 does not refer to an open file, the	procedure terminates with an
    error.  If the file	specified by str0 does not exist, -1 is	returned.



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      67



    The	return value is	the number of seconds since January 1, 1970 at	0000
    UTC.   The	%edate	string	function  may be used to convert the integer
    value to a string representation of	the date and time expressed relative
    to the current time	zone.


    6.3.12  %fmode

    usage: %fmode(int0)
	   %fmode(str0)


    This function returns the size of the file referenced by  the  argument.
    If the argument is an integer, the file referenced is the file opened by
    that number	with the fopen command.	 If the	argument is a string, it  is
    the	literal	filename.

    If int0 does not refer to an open file, the	procedure terminates with an
    error.  If the file	specified by str0 does not exist, -1 is	returned.


    6.3.13  %ftell

    usage: ftell(int0)

    This function returns the current file position of the the	file  opened
    by int0 with the fopen command.

    If int0 does not refer to an open file, the	procedure terminates with an
    error.


    6.3.14  %instr

    usage: %instr(str0,str1)

    This function returns the leftmost column  position	 withing  str0	that
    str1  is found (zero relative).  If	str1 cannot be found in	string str0,
    -1 is returned.  However, if str1 is null and str0 is not, zero will  be
    returned (i.e., the	null string matches at the left).

    The	comparison is made without regard to case.












    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      68



	 Examples:

		     00000000001111111
		     01234567890123456
	 Assume	$s0='abcdefghijklmnabc'
		$s1='abc'
		$s2='gHi'
		$s3='cat'

		%instr($s0,$s1)	       returns 0
		%instr($s0,$s2)	       returns 6
		%instr($s0,$s3)	       returns -1
		%instr($s0,'bcd')      returns 2
		%instr($s0,'bad')      returns -1



    6.3.15  %ischr

    usage: %ischr(int0)
	   %ischr(str0)


    This function returns 1 if the file	referenced  by	the  argument  is  a
    character special file, else 0.  If	the argument is	an integer, the	file
    referenced is the file opened by that number with the fopen	command.  If
    the	argument is a string, it is the	literal	filename.

    If int0 does not refer to an open file, the	procedure terminates with an
    error.  If the file	specified by str0 does not exist, -1 is	returned.

    Examples:


	 %ischr('/dev/tty')    returns 1
	 %ischr('/usr/bin')    returns 0
	 %ischr('/xenix')      returns 0



    6.3.16  %isdir

    usage: %isdir(int0)
	   %isdir(str0)


    This function returns 1 if the file	referenced  by	the  argument  is  a
    directory  file,  else  0.	 If  the  argument  is	an integer, the	file
    referenced is the file opened by that number with the fopen	command.  If
    the	argument is a string, it is the	literal	filename.




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      69



    If int0 does not refer to an open file, the	procedure terminates with an
    error.  If the file	specified by str0 does not exist, -1 is	returned.

    Examples:


	 %isdir('/dev/tty')    returns 0
	 %isdir('/usr/bin')    returns 1
	 %isdir('/xenix')      returns 0



    6.3.17  %isreg

    usage: %isreg(int0)
	   %isreg(str0)


    This function returns 1 if the file	referenced  by	the  argument  is  a
    regular  file,  else  0.   If  the	argument  is  an  integer,  the	file
    referenced is the file opened by that number with the fopen	command.  If
    the	argument is a string, it is the	literal	filename.

    If int0 does not refer to an open file, the	procedure terminates with an
    error.  If the file	specified by str0 does not exist, -1 is	returned.

    Examples:


	 %isreg('/dev/tty')    returns 0
	 %isreg('/usr/bin')    returns 0
	 %isreg('/xenix')      returns 1



    6.3.18  %len

    usage: %len(str0)

    This function returns the length of	str0.

	 Example:

	 set str0='abcdef',i0=%len(str0),i1=%len('1234')
	 str00 = 'abcdef'
	 int00 = 6
	 int01 = 4







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      70



    6.3.19  %lgetc

    Returns a character	read from the line.


    6.3.20  %pid

    This function returns the process id (pid) of ECU.


    6.3.21  %match

    usage: %match(str0,str1)

    This function  searches  string  str0  for	a  match  with	the  regular
    expression in str1 (for information	on regular expressions,	refer to the
    ed(C) manual pages).  The function returns the index into str0 where the
    match  is found or -1 if no	match can be found.  The matching process is
    case sensitive.

    The	variable $i0 receives the length of the	matching string	in str0	if a
    match is found.  For this reason, it is not	advisable that $i0 otherwise
    be involved	in the operation.  Specifically	to be avoided is:

	 set $i0=%instr(...)

    Examples:

		00000000001111111
		01234567890123456
    Assume $s0='abcdefghijklmnabc'
	   $s1='abc'
	   $s2='n.*'

	   %match($s0,$s1)	  returns 0   $i0=3
	   %match($s0,$s2)	  returns 16  $i0=4
	   %match($s0,$s3)	  returns -1  $i0 unchanged
	   %match($s0,'de..h')	  returns 3   $i0=5
	   %match($s0,'de..H')	  returns -1  $i0 unchanged



    6.3.22  %mhack

    usage: %mhack

    This  function  ("Millisecond  time	 HACK")	 returns   the	 number	  of
    milliseconds  since	 ecu  was  started.  It	isn't a	very useful value by
    itself, but	differences between the	values returned	by two calls to	 the
    function  may  be  used  to	determine the time between two events to the
    maximum accuracy the operating system can deliver.



    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      71



    Examples:
	$i10 = %mhack
	send 'test'
	lookfor	-e 0x0A	100
	ifi $i0	== 0 echo 'no response in 10 seconds'
	else echo 'response time '+%itos(%mhack	- $i10)+' msec'



    6.3.23  %rchr

    This function returns the number of	characters received by ECU since the
    program starrted.


    6.3.24  %rchrc

    This function returns the number of	characters received  by	 ECU  during
    the	current	connection.


    6.3.25  %shmid

    This function returns the integer  shared  memory  segment	id  for	 the
    current  ECU  process.   It	 may  be  used	to pass	the id to a "friend"
    process so that it may access the shared memory  segment  (described  in
    header  file  ecushm.h).   For more	details, refer to an earlier section
    entitled "Shared Memory 'Friend' Interface."


    Example:

	 system	'ecufriend '+%itos(%shmid)



    6.3.26  %stoi

    usage: %stoi(str0)

    This function converts the contents	of str0	to an  integer	and  returns
    the	value.


    6.3.27  %xchr

    This function returns the number of	characters transmitted by ECU  since
    the	program	starrted.






    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      72



    6.3.28  %xchrc

    This function returns the number of	characters transmitted by ECU during
    the	current	connection.




    6.4	 String	Functions



    6.4.1  %argv

    usage: %argv(int0)

    This function returns the string value of  an  argument  passed  to	 the
    procedure  by the 'do' command.  Argument 0	is the name of the procedure
    itself.  The integer function %argc	may be used to determine the  number
    of	arguments  passed  to  the procedure.  Specifying an argument number
    greater than the number of arguments passed	returns	a  null	 string	 (if
    procedure tracing is enabled with the 'ptrace' comand, a warning will be
    displayed in this case).

	 Example:
	     invocation	from shell:
	     ecu -p test Quick Brown Fox

	     invocation	from interactive command line:
	     do	test Quick Brown Fox

	     invocation	from procedure:
	     do	'test' 'Quick' 'Brown' 'Fox'

	     results in:
	     %argv(0) =	'test'
	     %argv(1) =	'Quick'
	     %argv(2) =	'Brown'
	     %argv(3) =	'Fox'
	     %argv(4) =	''


    NOTE: the interactive dial command,	the dialing directory menu  and	 the
    initial  setup  menu  all  can  automatically  execute a procedure which
    matches a dialed logical telephone number.	There two  arguments  passed
    to	these  procedures,  %argv(0)  being  the  procedure  name as always.
    %argv(1) is	set according to the following table:







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      73



	  invoker	       %argv(1)
	 -------------------  -------------
	 initial setup menu   !INITIAL
	 interactive dial     !INTERACTIVE
	 dialing menu	      !MENU

    Thus it is possible	for the	invoked	procedure to determine that  it	 has
    been  automatically	 executed  by  testing	%argv(1)  for an exclamation
    point, or possibly the entire argument.


    6.4.2  %cgetc

    usage: %cgetc

    This  function reads one character from the	console	keyboard and returns
    it.	 The character is not echoed.


    6.4.3  %cgets

    usage: %cgets

    This function reads	a string from the console keyboard and	returns	 it.
    Each  character is echoed as it is typed and the user's normal erase and
    kill character is available	to edit	the  input  before  terminating	 the
    read with ENTER.


    6.4.4  %chr

    usage: %chr(int0)

    This function returns the character	value whose ASCII value	is  supplied
    in int0.


    Example:

	set $s0	= %chr(4)  places a ^D (EOT) character into $s0



    6.4.5  %date

    usage: %date

    This function returns the current date in the form 'mm-dd-yyyy'  in	 the
    local time zone (daylight time if it applies).





    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      74



    6.4.6  %datez

    usage: %datez

    This function returns the current date in the form 'mm-dd-yyyy'  in	 the
    UTC	(Z) time zone.


    6.4.7  %day

    usage: %day

    This function returns the current day of the week as a  three  character
    abbreviation:  'Sun',  'Mon',  'Tue',  'Wed', 'Thu', 'Fri',	'Sat' in the
    local time zone (daylight time if it applies).


    6.4.8  %dayz

    usage: %dayz

    This function returns the current day of the week as a  three  character
    abbreviation: 'Sun', 'Mon',	'Tue', 'Wed', 'Thu', 'Fri', 'Sat' in the UTC
    (Z)	time zone.


    6.4.9  %dir

    usage: %dir

    This  function  returns  the  full	pathname  of  the  current   working
    directory.


    6.4.10  %edate

    usage: %edate(int0)

    The	value in int0 is expected to be	a number of seconds since January 1,
    1970  00:00	 UTC (Universal	Coordinated Time) as returned by the integer
    functions %fatime and %fmtime.  This function converts the value into  a
    string  representing  the  equivalent local	time in	the form 'mm-dd-yyyy
    hh:mm:ss'.











    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      75



    Example:

    set	$i0=%fmtime('/xenix')
    $i00 = 601178971 (0x23d5435b,04365241533)

    set	$s0=%edate($i0)
    $s00 = '01-18-1989 21:09:31'



    6.4.11  %envvar

    usage: %envvar()

    This function returns the string value of an environment variable.


    Example:

	set $s0=%envvar('HOME')	might set $s0 '/usr/user'

    Typical Environment	Variables:

	HOME	      pathname of home directory
	EDITOR	      user's preferred editor
	PATH	      program execution	searchlist
	TERM	      terminal type
	SHELL	      user's preferred shell
	MAIL	      user's mail box file
	ECUPROMPT     ECU interactive command prompt
		      at beginning of execution



    6.4.12  %errstr

    usage: %errstr(int0)

    This function returns the system error message, given int0 as  an  errno
    as returned	by a file-related command.  fopen.


    Example:

	echo %errstr(1)
	Not owner








    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      76



    6.4.13  %etime

    usage: %etime(int0)

    This function returns a string representation of  elapsed  time  in	 the
    format 'hh:mm:ss' for the integer parameter	int0, a	number of seconds.


    Example:

	echo %etime(62)
	00:01:02



    6.4.14  %fmodestr

    usage: %fmodestr(int0)

    This function returns a string representation of the familiar file	mode
    string given the file mode integer int0.


    Example:

	echo %fmodestr(0100755)
	-rwxr-xr-x

	echo %fmodestr(%fmode('/usr/lib'))
	drwxr-xr-x



    6.4.15  %itos

    usage: %itos(int0[,format])

    This function converts integer int0	to a string, optionally	 controlling
    the	format of the conversion.

    If the format parameter is missing,	 the  conversion  is  to  a  minimum
    number of decimal characters necessary to hold the result.

    If the format parameter is present,	it must	of  consist  of	 a  non-null
    string made	of one or both optional	parts:









    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      77



	decimal	number of digits to be part of result string
	(a leading zero	indicates leading zeroes are to
	appear in the string; no leading zero pads with
	leading	spaces

	a lower	case letter from the following list:
	    d -	decimal	conversion
	    x -	hexadecimal conversion
	    o -	octal conversion

    Example:

	%itos(33)	    '33'
	%itos(33,d)	    '33'
	%itos(33,x)	    '21'
	%itos(33,5d)	    '	33'
	%itos(33,010d)	    '0000000033'
	%itos(33,10d)	    '	     33'
	%itos(33,x)	    '21'
	%itos(33,04x)	    '0021'
	%itos(33,4x)	    '  21'
	%itos(33,o)	    '41'
	%itos(33,4o)	    '	 41'



    6.4.16  %left

    usage: %left(str0,int0)

    This function returns the leftmost int0  characters	 of  str0.   If	 the
    length of the string is less than int0, the	entire str0 is returned.

    Example:

	if $s0 == 'abcdefg'
	%left($s0,3) returns 'abc'



    6.4.17  %line

    usage: %line

    This function returns the name of the attached  communications  line  in
    the	 form  "/dev/ttyxx".  If no line is currently attached,	the function
    returns null.







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      78



    6.4.18  %logname

    usage: %logname

    This function returns the login name of the	user executing	ECU.   Note:
    the	 name  returned	 is  the  name	supplied  to a login prompt, not any
    current su(C) username that	may be in effect.


    6.4.19  %mid

    usage: %mid(str0,int0[,int1])

    This function returns the middle portion of	a string str0 beginning	with
    the	 character at position int0 and	for a length of	int1 characters.  If
    int0 is greater than or equal to the length	of stro, a  null  string  is
    returned.	If  the	 optional  argument  int1 is not supplied, or if the
    length of the string is less than int1, the	entire str0 is returned.

    Example:

	if $s0 == '0123456789abc'
	%mid($s0,3,4)  returns '3456'
	%mid($s0,3)    returns '3456789abc'
	%mid($s0,10,2) returns 'ab'
	%mid($s0,10,5) returns 'abc'



    6.4.20  %month

    usage: %month

    This  function  returns  the  current  month  as   a   three   character
    abbreviation:  'Jan',  'Feb',  'Mar', 'Apr', 'May',	'Jun', 'Jul', 'Aug',
    'Sep', 'Oct', 'Nov', 'Dec'.


    6.4.21  %rdesc

    usage: %rdesc

    This function returns the description portion of the  dialing  directory
    entry  for the currently connected remote.	If no connection exists, the
    function returns null.


    6.4.22  %right

    usage: %right(str0,int0)




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      79



    This function returns the rightmost	int0 characters	 of  str0.   If	 the
    length of the string is less than int0, the	entire str0 is returned.

    Example:

	if $s0 == 'abcdefg'
	%right($s0,3) returns 'efg'



    6.4.23  %rname

    usage: %rname

    This function returns the logical name portion of the dialing  directory
    entry  for	the  currently	connected  remote.  If the remote was dialed
    directly, as in dial 5551212, the returned value is	 the  phone  number.
    If no connection exists, the function returns null.

    The	value returned by this command may be overridden by use	of the rname
    procedure command.


    6.4.24  %rtelno
    usage: %rtelno

    This function returns  the	telephone  number  portion  of	the  dialing
    directory  entry  for  the currently connected remote.  If no connection
    exists, the	function returns null.


    6.4.25  %time

    usage: %time

    This function returns the current time in the form 'hh:mm' in the  local
    time zone (daylight	time if	it applies).


    6.4.26  %times

    usage: %times

    This function returns the current time in the  form	 'hh:mm:ss'  in	 the
    local time zone (daylight time if it applies).


    6.4.27  %timez

    usage: %timez




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      80



    This function returns the current time in the form 'hh:mm'	in  the	 UTC
    (Z)	time zone.


    6.4.28  %timezs

    usage: %timezs

    This function returns the current time in the form 'hh:mm:ss' in the UTC
    (Z)	time zone.


    6.4.29  %tty

    usage: %tty

    This function returns the console tty name in the form "/dev/ttynn".




    6.5	 HoneyDanBer UUCP Interface



    6.5.1  UUCP	Control	Files


    6.5.1.1  /usr/lib/uucp/Devices

    ECU	reads this file	to determine what  tty	devices	 are  available	 for
    outgoing  calls.   The fifth field of each entry must contain either the
    full pathname of a modem dialer program (with leading slash) or the	name
    of	an entry in the	/usr/lib/uucp/Dialers file.  Sysfiles support is not
    yet	provided.  The Devices file  must  be  named  /usr/lib/uucp/Devices.
    For	 more  information, see	"UUCP Dialers" and "Choosing a Dialout Line"
    below.


    6.5.1.2  /usr/lib/uucp/Dialers

    Dialers entries may	be specified in	the Devices entry. Sysfiles  support
    is	  not	 yet   provided.    The	  Dialers   file   must	  be   named
    /usr/lib/uucp/Dialers.


    6.5.1.3  /usr/lib/uucp/Sysfiles

    Sysfiles support is	not yet	provided.  The	Devices	 and  Dialers  files
    must have their default names.




    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      81



    6.5.1.4  /usr/lib/uucp/Systems

    No use is made of the Systems file	at  this  time.	  ECU  provides	 the
    equivalent function	with its dialing directory.


    6.5.2  Choosing a Dialout Line

    When using the interactive	dial  command,	or  when  dialing  from	 the
    initial  menu,  if	a logical or system name is specified, the directory
    entry is fetched and examined.  If the tty field specifies a value other
    than  "Any",  the  specific	 line requested	is opened, if available, and
    dialing commences. If the specified	line  is  not  available,  the	dial
    attemptfails.

    If "Any" is	found in the dialing directory	entry,	then  ECU  finds  an
    avaialable	line which matches the baud rate specified in the entry.  It
    does so by reading the Dialers file.

    If a line matching the  necessary  baud  rate  is  found  (by  searching
    /etc/utmp)	to be a	line enabled for login,	but which is currently idle,
    the	getty interface, described below, is used to acquire  the  line	 for
    outgoing use.


    6.5.3  Getty Interface

    When an idle dialin	(enabled) line is chosen for dialout, ECU makes	 use
    of	/usr/lib/ecu/ecuungetty	 to  signal  the line's	getty to release the
    line (via SIGUSR1).	 Ecuungetty is again employed to signal	the getty to
    reacquire	the  line  when	 outgoing  communication  is  complete	(via
    SIGUSR2).

    Ecuungetty is a privileged program,	which must be owned by root and	have
    the	 setuid-on-execute  bit	 set.	A  encrypted  id is passed by ecu to
    ecuungetty to validate requests and	to prevent abuse  of  ecuungetty  by
    hackers, malcontents and other twentieth-century phenomena.


    6.5.4  UUCP	Dialer Programs

    If the Devices file	can be found in	/usr/lib/uucp, and a valid entry for
    the	 attached  line	 can  be  found,  ECU will use the Dialers script or
    dialer program specified in	the Devices entry.

    Sample enhanced modem dialer program sources may be	found  in  the	uucp
    subdirectory of the	distribution.







    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      82



    7.	Technical Notes


    ECU	is written in Microsoft/SCO XENIX System V C.  Full use	is  made  of
    function  prototyping  for ECU functions and external library functions.
    The	source consists	of 32,000 lines	of source files	(731000	 bytes)	 and
    2500  lines	 of  header files (73000 bytes).  The output of	"size" for a
    -M3	version	(actaul	information may	be obsolete):


	 text	  data	  bss	  dec	   hex
	 140940	+ 34068	+ 61852	= 236860 = 0x39d3c










































    Public Domain by wht@n4hgf		  5/7/90







    ECU	Technical Description				      83



    8.	Revision Numbers

    ECU	revision numbers are defined as	follows:

	 pppp#.##-#86x
	  ^  ^ ^  ^  ^
	  |  | |  |  `----- 's'	if XENIX select(S) in use, 'n' if not
	  |  | |  `-------- '2'	for 286, '3' for 386
	  |  | `----------- patch level
	  |  `------------- major revision
	  `---------------- package ('unet' for	this release)











































    Public Domain by wht@n4hgf		  5/7/90











				    CONTENTS


    1.	Introduction........................................   2

    2.	Basic Organization..................................   3
	2.1   Transmitter Process (XMTR)....................   3
	      2.1.1   Keyboard Interface....................   3
	      2.1.2   ECU Command Assembly..................   3
	      2.1.3   Function Key Mapping..................   4
	      2.1.4   Auxiliary	Operation Control...........   4
	2.2   Receiver Process (RCVR).......................   5
	      2.2.1   ANSI Filter...........................   5
	      2.2.2   Session Logging.......................   5

    3.	Features............................................   6
	3.1   Line Editing..................................   6
	3.2   Interactive Command History...................   6
	3.3   Dialing Directory.............................   6
	3.4   Online Command Dictionary.....................   6
	3.5   Multiscreen Event	Alarm.......................   7
	3.6   Function Key Mapping..........................   7
	3.7   Built-in Modem Dialer.........................   8
	3.8   File Transfer.................................   9
	3.9   Procedures (Scripts)..........................  10
	3.10  Initial (Startup)	Procedure...................  10
	3.11  Home Directory Files..........................  10
	3.12  Lock Files....................................  10
	3.13  Dial-In/Dial-Out Line Support.................  10
	3.14  Tools.........................................  11
	3.15  Shared Memory 'Friend' Interface..............  11

    4.	Starting the Program................................  12
	4.1   Simple Startup - Initial Setup Menu...........  12
	      4.1.1   Name/Phone Number	Field...............  12
	      4.1.2   Other Fields..........................  13
	      4.1.3   Special Characters....................  13
	4.2   Command Line Arguments and Switches...........  14
	      4.2.1   -l....................................  14
	      4.2.2   -f....................................  14
	      4.2.3   -e, -o................................  14
	      4.2.4   -p <procname>.........................  15
	      4.2.5   -d....................................  15
	      4.2.6   -t....................................  15
	4.3   Environment Variables.........................  15
	      4.3.1   ECUPROMPT.............................  15
	      4.3.2   ECUHELP...............................  16

    5.	Interactive Mode Commands...........................  17
	5.1   AX : ascii char to hex/oct/dec................  17
	5.2   BAud : set/display line baud rate.............  17



			       - i -











	5.3   BN : all console event alarm..................  17
	5.4   BReak : send break to remote..................  18
	5.5   CD : change current directory.................  18
	5.6   DA : decimal to ascii char....................  18
	5.7   Dial : dial remote destination................  19
	5.8   DO : perform procedure........................  19
	5.9   DUplex : set/display duplex...................  20
	5.10  EXit : drop carrier, exit	program.............  20
	5.11  FI : send	text file to line...................  20
	5.12  FKey : function key definition................  21
	5.13  HAngup : hang up modem........................  22
	5.14  HElp : invoke help............................  22
	5.15  LLp : set	session	log to /dev/lp..............  22
	5.16  LOFf : turn off session logging...............  23
	5.17  LOG : session logging control.................  23
	5.18  NL : display CR/LF mapping....................  23
	5.19  NLIn : set receive CR/LF mapping..............  23
	5.20  NLOut : set transmit CR/LF mapping............  24
	5.21  OA : octal to ascii char......................  24
	5.22  PARity : set/display line	parity..............  24
	5.23  PId : display process ids.....................  25
	5.24  PLog : procedure logging......................  25
	5.25  PTrace : control procedure trace..............  25
	5.26  PWd : print working directory.................  25
	5.27  REDial : redial last number...................  25
	5.28  REV : ECU	revision/make date..................  26
	5.29  RK : receive via C-Kermit.....................  26
	5.30  RS : receive via SEAlink......................  26
	5.31  RTScts : control RTS/CTS flow control.........  26
	5.32  RX : receive via XMODEM/CRC...................  27
	5.33  RY : receive via YMODEM Batch.................  27
	5.34  RZ : receive via ZMODEM/CRC32.................  27
	5.35  SDNAME : select screen dump file name.........  27
	5.36  SK : send	via C-Kermit........................  28
	5.37  SS : send	via SEAlink.........................  28
	5.38  STat : connection	status......................  29
	5.39  SX : send	via XMODEM/CRC......................  29
	5.40  SY : send	via YMODEM Batch....................  30
	5.41  SZ : send	via ZMODEM/CRC32....................  30
	5.42  TIme : time of day............................  31
	5.43  TTy : console tty	name........................  31
	5.44  XA : hex to ascii	char........................  31
	5.45  !	: execute shell.............................  32

    6.	Procedure Language..................................  33
	6.1   Arguments.....................................  33
	      6.1.1   Switches..............................  33
	      6.1.2   Alphabetic Tokens.....................  33
	      6.1.3   Integers..............................  33
		      6.1.3.1  Constants  34
		      6.1.3.2  Variables  34



			       - ii -











		      6.1.3.3  Functions  34
		      6.1.3.4  Expressions  34
		      6.1.3.5  Relational Operators  35
	      6.1.4   Strings...............................  35
		      6.1.4.1  Constants  35
		      6.1.4.2  Variables  35
		      6.1.4.3  Functions  36
		      6.1.4.4  Expressions  36
		      6.1.4.5  Relational Operators  36
	6.2   Commands......................................  36
	      6.2.1   baud..................................  36
	      6.2.2   break.................................  36
	      6.2.3   cd....................................  37
	      6.2.4   clrx..................................  37
	      6.2.5   cls...................................  37
	      6.2.6   color.................................  38
	      6.2.7   continue..............................  38
	      6.2.8   cursor................................  39
	      6.2.9   delline...............................  40
	      6.2.10  dial..................................  40
	      6.2.11  do....................................  41
	      6.2.12  duplex................................  41
	      6.2.13  echo..................................  42
	      6.2.14  eeol..................................  42
	      6.2.15  else..................................  42
	      6.2.16  exit..................................  44
	      6.2.17  expresp...............................  45
	      6.2.18  fchmod................................  45
	      6.2.19  fclose................................  46
	      6.2.20  fdel..................................  46
	      6.2.21  fgetc.................................  47
	      6.2.22  fgets.................................  47
	      6.2.23  fkey..................................  47
	      6.2.24  flush.................................  48
	      6.2.25  fopen.................................  48
	      6.2.26  fputc.................................  49
	      6.2.27  fputs.................................  49
	      6.2.28  fseek.................................  49
	      6.2.29  getf..................................  50
	      6.2.30  goto..................................  50
	      6.2.31  gotob.................................  50
	      6.2.32  hangup................................  50
	      6.2.33  hexdump...............................  51
	      6.2.34  home..................................  51
	      6.2.35  icolor................................  52
	      6.2.36  ifi...................................  52
	      6.2.37  ifs...................................  52
	      6.2.38  lbreak................................  53
	      6.2.39  lgets.................................  53
	      6.2.40  insline...............................  53
	      6.2.41  logevent..............................  53



			      -	iii -











	      6.2.42  lookfor...............................  54
	      6.2.43  mkvar.................................  54
	      6.2.44  nap...................................  55
	      6.2.45  parity................................  55
	      6.2.46  pclose................................  56
	      6.2.47  plog..................................  56
	      6.2.48  popen.................................  56
	      6.2.49  prompt................................  57
	      6.2.50  ptrace................................  57
	      6.2.51  putf..................................  58
	      6.2.52  return................................  58
	      6.2.53  rk....................................  58
	      6.2.54  rname.................................  58
	      6.2.55  rs....................................  58
	      6.2.56  rx....................................  59
	      6.2.57  ry....................................  59
	      6.2.58  rz....................................  59
	      6.2.59  scrdump...............................  59
	      6.2.60  send..................................  59
	      6.2.61  set...................................  60
	      6.2.62  sk....................................  60
	      6.2.63  ss....................................  60
	      6.2.64  sx....................................  61
	      6.2.65  sy....................................  61
	      6.2.66  system................................  62
	      6.2.67  sz....................................  62
	      6.2.68  vidcolor..............................  62
	      6.2.69  vidnorm...............................  63
	      6.2.70  vidrev................................  63
	      6.2.71  whilei................................  63
	      6.2.72  whiles................................  64
	6.3   Integer Functions.............................  64
	      6.3.1   %argc.................................  64
	      6.3.2   %baud.................................  64
	      6.3.3   %colors...............................  65
	      6.3.4   %conn.................................  66
	      6.3.5   %curx.................................  66
	      6.3.6   %cury.................................  66
	      6.3.7   %csec.................................  66
	      6.3.8   %ctoi.................................  66
	      6.3.9   %fatime...............................  67
	      6.3.10  %fmode................................  67
	      6.3.11  %fmtime...............................  67
	      6.3.12  %fmode................................  68
	      6.3.13  %ftell................................  68
	      6.3.14  %instr................................  68
	      6.3.15  %ischr................................  69
	      6.3.16  %isdir................................  69
	      6.3.17  %isreg................................  70
	      6.3.18  %len..................................  70
	      6.3.19  %lgetc................................  71



			       - iv -











	      6.3.20  %pid..................................  71
	      6.3.21  %match................................  71
	      6.3.22  %mhack................................  71
	      6.3.23  %rchr.................................  72
	      6.3.24  %rchrc................................  72
	      6.3.25  %shmid................................  72
	      6.3.26  %stoi.................................  72
	      6.3.27  %xchr.................................  72
	      6.3.28  %xchrc................................  73
	6.4   String Functions..............................  73
	      6.4.1   %argv.................................  73
	      6.4.2   %cgetc................................  74
	      6.4.3   %cgets................................  74
	      6.4.4   %chr..................................  74
	      6.4.5   %date.................................  74
	      6.4.6   %datez................................  75
	      6.4.7   %day..................................  75
	      6.4.8   %dayz.................................  75
	      6.4.9   %dir..................................  75
	      6.4.10  %edate................................  75
	      6.4.11  %envvar...............................  76
	      6.4.12  %errstr...............................  76
	      6.4.13  %etime................................  77
	      6.4.14  %fmodestr.............................  77
	      6.4.15  %itos.................................  77
	      6.4.16  %left.................................  78
	      6.4.17  %line.................................  78
	      6.4.18  %logname..............................  79
	      6.4.19  %mid..................................  79
	      6.4.20  %month................................  79
	      6.4.21  %rdesc................................  79
	      6.4.22  %right................................  79
	      6.4.23  %rname................................  80
	      6.4.24  %rtelno...............................  80
	      6.4.25  %time.................................  80
	      6.4.26  %times................................  80
	      6.4.27  %timez................................  80
	      6.4.28  %timezs...............................  81
	      6.4.29  %tty..................................  81
	6.5   HoneyDanBer UUCP Interface....................  81
	      6.5.1   UUCP Control Files....................  81
		      6.5.1.1  /usr/lib/uucp/Devices  81
		      6.5.1.2  /usr/lib/uucp/Dialers  81
		      6.5.1.3  /usr/lib/uucp/Sysfiles  81
		      6.5.1.4  /usr/lib/uucp/Systems  82
	      6.5.2   Choosing a Dialout Line...............  82
	      6.5.3   Getty Interface.......................  82
	      6.5.4   UUCP Dialer Programs..................  82

    7.	Technical Notes.....................................  83




			       - v -











    8.	Revision Numbers....................................  84





















































			       - vi -




