/* CHK=0x4253 */
/*+-----------------------------------------------------------------------
	ecu.c
	wht%n4hgf@gatech.edu

  Defined functions:
	main(argc,argv,envp)
	xmtr()

------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:23-wht@n4hgf---- 2.80 --- */
/*:04-19-1990-03:07-wht@n4hgf-GCC run found unused vars -- rm them */
/*:03-27-1990-15:18-wht@n4hgf-overhaul for/wait/SIGCLD handling */
/*:03-26-1990-15:11-wht@n4hgf-better diag when line choice fails with HDB */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:03-16-1990-04:30-wht@n4hgf-make ftime call for starting_timeb */
/*:02-20-1990-03:50-wht-per doc, do not assume timeval unmodified by select */
/*:10-14-1989-21:10-wht-allow user to change ecu color choices */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:52-wht-flush edits --- ecu 1.95 */

#define DECLARE_LINEVARS_PUBLIC
#include "ecu.h"
#include "esd.h"
#include "proc.h"
#include "ecukey.h"
#include "ecuxkey.h"
#include "ecuhangup.h"

char *getenv();

extern char *makedate;			/* temporary make date */
extern char *numeric_revision;	/* ecunumrev.c */
extern char *revision_modifier; /* ecunumrev.c */
extern ESD *icmd_prompt;
extern char kbdeof;			/* current input EOF */
extern char kbdeol2;		/* current secondary input EOL */
extern char kbdeol;			/* current input EOL */
extern char kbderase;		/* current input ERASE */
extern char kbdintr;		/* current input INTR */
extern char kbdkill;		/* current input KILL */
extern char kbdquit;		/* current input QUIT */
extern ulong colors_current;
extern int there_is_hdb_on_this_machine;
extern char lopen_err_str[];

char *optarg;
char curr_dir[258];		/* current working directory of process */
char hello_str[80];		/* msg printed upon BOJ */
char errmsg[128];
char modem_ctl_fname[128];
char initial_procedure[128] = "";
int usage_quit =0;
int init_proc_argc = 0;
char *init_proc_argv[MAX_PARGV];
int quiet = 0;			/* don't shut up is default */
int rcvr_pid = -1;		/* pid for rcvr process (-1 == no proc active) */
	/* ... -2 == special flag for modem control/timed-read procedures */
int xmtr_pid = 0;
int quit_on_init_proc_fail = 0;
struct timeb starting_timeb;

/*-----------------------*/
int nice_value = 3;		/* go for hi priority */
ushort geteuid();
ushort getuid();
ushort euid;
ushort uid;
/*-----------------------*/

/*+-----------------------------------------------------------------------
	xmtr() --  copy stdin to comm line

  THE INITIAL PROCESS EXECUTES THIS PROCESS UNTIL PROGRAM TERMINATION

  TTY input lines beginning with % have special significance
  (see ecuicmd.c)
------------------------------------------------------------------------*/
int
xmtr()
{
uchar xmtr_char;
uchar nlchar = NL;
void xmtr_SIGINT_handler();

	ttymode(1);
	xmtr_signals();
	while(1)
	{
/* bug somewhere ... may be SIGINT too rapidly causing SIG_IGN ????? */
		signal(SIGINT,xmtr_SIGINT_handler);	/* so make sure */
		xmtr_char = ttygetc(1);

		if(xmtr_char & 0x80)
		{
			kbd_escape(xmtr_char);
			continue;
		}

		lputc(xmtr_char);
		if(shm->Lfull_duplex == 0)		/* echo character if asked */
			write(TTYERR,&xmtr_char,1);

		if(xmtr_char == CR)
		{
			if(shm->Ladd_nl_outgoing)
				lputc('\n');
			if(shm->Lfull_duplex == 0)
				write(TTYERR,&nlchar,1);
		}
	}		/* end of while we can read a character */
	return(HANGUP_XMTR_LOGIC_ERROR);	/* should not have gotten here */

}	/* end of xmtr */

/*+-------------------------------------------------------------------------
	main(argc,argv,envp)

  main() program forks to create rcvr process; then main()
  becomes the xmtr process
------------------------------------------------------------------------*/
main(argc,argv,envp)
int argc;
char **argv;
char **envp;
{
char *cptr;
int iargv;
int swchar;
int itmp;
ulong colors_save;
char *get_ttyname();

	setbuf(stderr,NULL);
	ttyinit();				/* init console tty mode handler */
	clear_screen();
	xmtr_pid = getpid();
	ftime(&starting_timeb);	/* get startup time */

/* get this off quick, cause we'll be busy for a little while on 286 */
	sprintf(hello_str,"ecu %s%s by wht@n4hgf (pid %d)",
		numeric_revision,revision_modifier,xmtr_pid);
	ff(se,"%s\n",hello_str);

/* if we are root (as we should be on 286 versions), nice to very bad
   and set uid to real uid */

	uid = getuid();
	euid = geteuid();
	if((euid == 0) || (uid == 0))	/* if root running or prog text ... */
	{								/* ... sets to root, then grab gusto */
	int old_nice = nice(0) + 20;
		nice(-old_nice + nice_value);
		if(uid != euid)					/* but if user not really root ... */
		{
			if(setuid(uid))			/* ... take away the privilege */
			{
				ff(se,"\r\n");
				perror("setuid");
				ff(se,"\r\n");
				exit(-1);
			}
		}
	}

	shm_init();				/* open shared segment */

	keyset_init();			/* intialize keyset */

	make_ecu_subdir();		/* needs to be very early before lots of init */

	xmtr_signals();			/* catch xmtr signals */

	get_curr_dir(curr_dir,sizeof(curr_dir));
	cd_array_init();		/* read %cd directory list */

	hdb_init();

	var_init();				/* initialize procedure variables */
	poutput_init();			/* initialize procedure output */

	icmd_prompt = make_esd(64);
	set_default_escape_prompt();
	ttymode(1);				/* put user console in `raw' mode */

/* init line variables */
	shm->Lline[0] = 0;				/* no line chosen yet */
	shm->Liofd = -1;				/* no line open now */
	shm->Lbaud = DEFAULT_BAUD_RATE;	/* see ecu.h */
	shm->Lparity = 0;				/* no parity selected ... default NONE */
	shm->Ltelno[0] = 0;				/* no telephone number for remote yet */
	shm->Llogical[0] = 0;			/* no logical name for remote yet */
	shm->Lrname[0] = 0;				/* no logical name for remote yet */
	shm->Ldescr[0] = 0;				/* no description for remote yet */
	shm->Lmodem_off_hook = 0;		/* assume modem on hook */
	shm->Ladd_nl_incoming = 0;		/* dont add nl to incoming cr */
	shm->Ladd_nl_outgoing = 0;		/* dont add nl to outgoing cr */
	shm->Lfull_duplex = 1;			/* assume full duplex */
	shm->Lmodem_already_init = 0;	/* modem has not been initialized */
	shm->xmtr_pid = getpid();
	shm->xmtr_ppid = getppid();
	shm->xmtr_pgrp = getpgrp(0);
	strcpy(shm->tty_name,get_ttyname());
	shm->shm_revision = SHM_REV;

	for(iargv = 1; iargv < argc; iargv++)
	{
		if(*argv[iargv] != '-')
			continue;
		swchar = *(argv[iargv] + 1);
		optarg = "";
		if((swchar == 'c') || (swchar == 'l') || (swchar == 'b') ||
			(swchar == 'p'))
		{
			if(*(argv[iargv] + 2) == 0)
			{
				if(iargv < argc - 1)
				{
					++iargv;
					optarg = argv[iargv];
				}
			}
			else		/* we have a switch setting */
				optarg = argv[iargv] + 2;
			switch( swchar )
			{
				case 'b':
					if(((*optarg == 0) || (*optarg == '-')))
					{
						ff(se,"-b must have a baud rate argument\r\n");
						usage();
						/*NOTREACHED*/
					}
					if(valid_baud_rate(shm->Lbaud = atoi(optarg)) < 0)
					{
						ff(se,"invalid baud rate\r\n");
						usage();
					}
					break;
				case 'c':
					if(((*optarg == 0) || (*optarg == '-')))
					{
						ff(se,"-c must have a modem control filename\r\n");
						usage();
						/*NOTREACHED*/
					}
					strcpy(modem_ctl_fname,optarg);
					break;
				case 'l':
					if(((*optarg == 0) || (*optarg == '-')))
					{
						ff(se,"-l must have a valid suffix for '/dev/tty'\r\n");
						usage();
						/*NOTREACHED*/
					}
					shm->Lline[0] = 0;
					if(strncmp(optarg,"/dev/tty",8))
						strcpy(shm->Lline,"/dev/tty");
					strcat(shm->Lline,optarg);
					break;
				case 'p':
					if(((*optarg == 0) || (*optarg == '-')))
					{
						ff(se,"-p must have a initial procedure name\r\n");
						usage();
						/*NOTREACHED*/
					}
					strcpy(initial_procedure,optarg);
					break;
				default:
					ff(se,"logic error in optarg procssing\r\n");
					exit(99);
					break;
			}	/* end of swchar with optional string */
			continue;
		}	/* end of if keyword switch (requiring additonal string) */

		/* simple switches */
		cptr = argv[iargv] + 1;
		while(swchar = *cptr++)
		{
			switch(swchar)
			{
				case 'h': shm->Lfull_duplex = 0; break;
				case 'f': shm->Lfull_duplex = 1; break;
				case 'd': quit_on_init_proc_fail = 1;
				case 't': shm->Ladd_nl_incoming = 1;
				          shm->Ladd_nl_outgoing = 1; break;
				case 'e': shm->Lparity = 'e'; break;
				case 'o': shm->Lparity = 'o'; break;
				case '?': usage();
				          /*NOTREACHED*/
				default:
					ff(se,"unrecognized switch -'%c' (ignored)\r\n",swchar);
					usage_quit = 1;
					break;
			}
		}	/* end of while simple switches may be after one '-' */
	}		/* end of argv loop */

	if(usage_quit)
		usage();

/* check out line */
	if(!shm->Lline[0])
	{
		if(!there_is_hdb_on_this_machine)
			strcpy(shm->Lline,"/dev/tty1a");
		else
		{
			choose_line(shm->Lbaud);
			if(!shm->Lline[0])
			{
				ff(se,"\r\n");
				ff(se,"\r\n");
				stand_out();
				ff(se,"[no available Devices line at %u baud]",shm->Lbaud);
				stand_end();
				ff(se,"\r\n");
				strcpy(shm->Lline,"/dev/tty1a");
			}
		}
	}

	cptr = (char *)0;
	if(initial_procedure[0])
	{
		init_proc_argv[0] = initial_procedure;
		init_proc_argc = 1;
		for(iargv = 1; iargv < argc; iargv++)
		{
			if(*argv[iargv] != '-')
			{
				if(init_proc_argc == MAX_PARGV)
				{
					ff(se,"too many arguments to initial procedure\r\n");
					hangup(1);
				}
				init_proc_argv[init_proc_argc++] = argv[iargv];
			}
		}

/* wierd bug fixed by this ... I know not why */
		windows_start();
		windows_end2();
		fflush(so);

		ttymode(2);
		if(do_proc(init_proc_argc,init_proc_argv))
		{
			if(quit_on_init_proc_fail)
				hangup(HANGUP_INIT_PROC_ERROR);
		}
		proc_file_reset();
		colors_save = colors_current;
		setcolor(colors_notify);
		fputs("[procedure finished]",se);
		setcolor(colors_save);
		ff(se,"\r\n");
		if(shm->Liofd < 0)
		{
			ff(se,"\r\n");
			ff(se,"\r\n");
			stand_out();
			ff(se, "[no line attached by initial procedure]");
			stand_end();
			ff(se,"\r\n");
			if(quit_on_init_proc_fail)
				hangup(HANGUP_INIT_PROC_ERROR);
			stand_out();
			ff(se, "[press ESC to exit or SPACE for setup menu]");
			stand_end();
			itmp = ttygetc(0);
			ff(se,"\r\n");
			if(itmp == ESC)
				hangup(1);
			ttymode(1);	
			setup_screen((char *)0);
		}
		else
		{

			ttymode(1);
			start_rcvr_process(0);
		}
	}
	else		/* no initial procedure */
	{
		cptr = (char *)0;
		for(iargv = 1; iargv < argc; iargv++)
		{
			if((*argv[iargv] != '-') || (strcmp(argv[iargv],"-") == 0))
			{
				cptr = argv[iargv];
				break;
			}
		}
		ttymode(1);	
		setup_screen(cptr);
	}

	hangup(xmtr());			/* enter xmtr operation */
	/*NOTREACHED*/
}	/* end of main */

/* end of ecu.c */

/* vi: set tabstop=4 shiftwidth=4: */
