/* CHK=0xE5D6 */
/*+-----------------------------------------------------------------------
	ecu.h -- TuckerWare Extended Calling Unit
	wht%n4hgf@gatech.edu
------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:03-16-1990-04:28-wht@n4hgf-add sys/timeb.h */
/*:03-12-1990-04:35-wht@n4hgf-get rid of obsolete LINEVARS */
/*:01-03-1990-16:19-wht-indulge deviant "progressive" __STDC__ m/c/realloc */
/*:11-23-1989-03:11-wht-conditional compile for M_XENIX or M_UNIX */
/*:10-14-1989-21:08-wht-add setcolor variables */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#if defined(__STDC__)	/* sigh ... malloc and such types */
#define VTYPE void
#else
#define VTYPE char
#endif

#if defined(M_UNIX)
#undef M_XENIX		/* we don't want this defined in UNIX world */
#undef NO_SELECT	/* UNIX select(S) works */
#endif

#if defined(M_I286) && !defined(NO_SELECT)
#define NO_SELECT	/* the last 286 XENIX I saw (2.2.1) had no select */
#endif

#if !defined(STDIO_H_INCLUDED)
#include <stdio.h>
#endif
#include <signal.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/errno.h>
#include <sys/timeb.h>

#if defined(M_XENIX) || defined(M_UNIX)
#include <memory.h>
#include <sys/stat.h>
#include <string.h>
#include <fcntl.h>
#if !defined(OMIT_TERMIO_REFERENCES)
#include <sys/ioctl.h>
#include <termio.h>
#endif
#endif

#if defined(pyr)
#include <sys/stat.h>
#include <sys/file.h>
#if !defined(OMIT_TERMIO_REFERENCES)
#include <sys/termio.h>
#endif
#include <strings.h>
#define strchr index
#define strrchr rindex
#define memcpy(to,from,length) bcopy(from,to,length)
#endif

#include "ecuhangup.h"
#include "ecushm.h"

/* already in ecushm.h */
/* #if !defined(ushort) */
/* #define ushort unsigned short */
/* #endif */
/* #if !defined(uchar) */
/* #define uchar unsigned char */
/* #endif */
/* #if !defined(uint) */
/* #define uint unsigned int */
/* #endif */
/* #if !defined(ulong) */
/* #define ulong unsigned long */
/* #endif */

#define MALLOC_3X
#if defined(MALLOC_3X)
#include <malloc.h>
#endif

/* for better source line utilization, frequent use of 'fprintf' and 'stderr'
   warrants the following */
#define pf	printf
#define	ff	fprintf
#define se	stderr
#define so	stdout

#define DEFAULT_BAUD_RATE	2400
#define TTYIN	0
#define TTYOUT  1				/* ditto tty output */
#define TTYERR  2				/* ditty tty output error channel */

/* xbell codes */
#if defined(M_XENIX) || defined(M_UNIX)
#define  XBELL_DONE 		1		/* octaves or morse 'd' */
#define  XBELL_ATTENTION	2		/* morse .-.-.- ATTENTION */
#define  XBELL_C			3		/* morse -.-. C */
#define  XBELL_3T			4		/* --- really 'o' */
#endif

/* lopen() and related routines error codes */
#define LOPEN_INVALID			-1		/* for invalid tty name */
#define LOPEN_UNKPID			-2		/* unknown pid using line */
#define LOPEN_LCKERR			-3		/* lock file open error */
#define LOPEN_NODEV				-4		/* device does not exist */
#define LOPEN_OPNFAIL			-5		/* could not open line */
#define LOPEN_ALREADY			-6		/* line already open */
#define LOPEN_ENABLED			-7		/* line enabled for login */
#define LOPEN_ENABLED_IN_USE	-8		/* line in use by incoming login */
#define LOPEN_DIALOUT_IN_USE	-9		/* line in use by another dial out */

#if defined(DECLARE_LINEVARS_PUBLIC)

char LLCKname[128];			/* lock file name */
struct termio Ltermio;		/* attributes for the line to remote */
uchar Lmodem_sreg[20];		/* allow for more later */
#else
#if !defined(OMIT_TERMIO_REFERENCES)
extern char LLCKname[];
extern struct termio Ltermio;
#endif
extern uchar Lmodem_sreg[];
#endif
/* setcolor variables - see setcolor() */
extern ulong colors_current;
extern ulong colors_normal;
extern ulong colors_success;
extern ulong colors_alert;
extern ulong colors_error;
extern ulong colors_notify;

typedef struct lrwt /* param to lgets_timeout in eculine.c */
{
	ulong to1;		/* timeout for 1st character (granularity 20) */
	ulong to2;		/* timeout for each next char (granularity 20) */
	int raw_flag;	/* !=0, rtn full buffer, ==0, rtn filtered hayes result */
	char *buffer;	/* buffer to fill */
	int bufsize;	/* size of buffer */
	int count;		/* from proc, count rcvd */
	char *delim;	/* ending string for lgets_timeout_or_delim */
	int echo;		/* echo incdoming chars to screen */
}	LRWT;

#include "stdio_lint.h"
#include "lint_args.h"
/* vi: set tabstop=4 shiftwidth=4: */
