/* CHK=0xBB62 */
/*+-------------------------------------------------------------------------
	ecucmd.h -- command definitions
	wht%n4hgf@gatech.edu
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:04-05-1990-14:29-wht@n4hgf-sort/renumber CT tokens */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:03-18-1990-15:33-wht@n4hgf-add popen and pclose */
/*:03-12-1990-04:44-wht@n4hgf-add rname */
/*:12-21-1989-21:49-wht-add 'rtscts' */
/*:11-20-1989-16:05-wht-add 'getf' and 'putf' */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

/* interactive command tokens */

#define CTax             1
#define CTbaud           2
#define CTbn             3
#define CTbreak          4
#define CTcd             5
#define CTclrx           6
#define CTda             7
#define CTdial           8
#define CTdo             9
#define CTduplex        10
#define CTexit          11
#define CTfi            12
#define CTfkey          13
#define CTgetf          14
#define CThangup        15
#define CThelp          16
#define CTllp           17
#define CTloff          18
#define CTlog           19
#define CTmdump         20
#define CTnl            21
#define CTnlin          22
#define CTnlout         23
#define CToa            24
#define CTparity        25
#define CTpcmd          26
#define CTpid           27
#define CTplog          28
#define CTptrace        29
#define CTputf          30
#define CTpwd           31
#define CTredial        32
#define CTrev           33
#define CTrk            34
#define CTrs            35
#define CTrtscts        36
#define CTrx            37
#define CTry            38
#define CTrz            39
#define CTsdname        40
#define CTsgr           41
#define CTshell         42
#define CTsk            43
#define CTss            44
#define CTstat          45
#define CTsx            46
#define CTsy            47
#define CTsz            48
#define CTte            49
#define CTtime          50
#define CTts            51
#define CTtty           52
#define CTxa            53
#define CTxlog          54

#define TOKEN_QUAN	128		/* for help package */

typedef int (*PFI)();

#if defined(HELPGEN)
#define Z {;}
#else
#define Z ;
#endif

int cmd_baud() Z
int cmd_break() Z
int cmd_cd() Z
int cmd_clrx() Z
int cmd_cls() Z
int cmd_color() Z
int cmd_continue() Z
int cmd_cursor() Z
int cmd_delline() Z
int cmd_dial() Z
int cmd_do() Z
int cmd_duplex() Z
int cmd_echo() Z
int cmd_eeol() Z
int cmd_else() Z
int cmd_exit() Z
int cmd_expresp() Z
int cmd_getf() Z
int cmd_fchmod() Z
int cmd_fclose() Z
int cmd_fgetc() Z
int cmd_fgets() Z
int cmd_fkey() Z
int cmd_flush() Z
int cmd_fopen() Z
int cmd_fputc() Z
int cmd_fputs() Z
int cmd_fread() Z
int cmd_fseek() Z
int cmd_fdel() Z
int cmd_fwrite() Z
int cmd_goto() Z
int cmd_gotob() Z
int cmd_hangup() Z
int cmd_hexdump() Z
int cmd_home() Z
int cmd_icolor() Z
int cmd_insline() Z
int cmd_ifi() Z
int cmd_ifs() Z
int cmd_lbreak() Z
int cmd_lgets() Z
int cmd_logevent() Z
int cmd_lookfor() Z
/* int cmd_mkdir() Z */
int cmd_mkvar() Z
int cmd_nap() Z
int cmd_parity() Z
int cmd_pclose() Z
int cmd_plog() Z
int cmd_popen() Z
int cmd_prompt() Z
int cmd_ptrace() Z
int cmd_putf() Z
int cmd_return() Z
int cmd_rk() Z
int cmd_rname() Z
int cmd_rs() Z
int cmd_rx() Z
int cmd_ry() Z
int cmd_rz() Z
int cmd_scrdump() Z
int cmd_send() Z
int cmd_set() Z
int cmd_sk() Z
int cmd_ss() Z
int cmd_sx() Z
int cmd_sy() Z
int cmd_system() Z
int cmd_sz() Z
int cmd_vidcolor() Z
int cmd_vidnorm() Z
int cmd_vidrev() Z
int cmd_whilei() Z
int cmd_whiles() Z

typedef struct p_cmd
{ 
	char *cmd;		/* command string */
	int min;		/* min chars required for match */
	int token;		/* command number */
	char *descr;	/* command description */
	PFI proc;		/* do cmd handler */
}	P_CMD;

#if !defined(DECLARE_P_CMD)
#if defined(NEED_P_CMD)
extern P_CMD icmd_cmds[];
#endif
#else
P_CMD icmd_cmds[] =
{
	{ "ax",		2,CTax,		"ascii char to hex/oct/dec",	0 },
	{ "baud",	2,CTbaud,	"set/display line baud rate",	cmd_baud },
	{ "bn",		2,CTbn,		"all console event alarm",		0 },
	{ "break",	2,CTbreak,	"send break to remote",			cmd_break },
	{ "cd",		2,CTcd,		"change current directory",		cmd_cd },
	{ "clrx",	2,CTclrx,	"simulate XON from remote",		cmd_clrx },
	{ "cls",	0,0,		"",								cmd_cls },
	{ "color",	0,0,		"",								cmd_color },
	{ "continue",0,0,		"",								cmd_continue },
	{ "cursor",	0,0,		"",								cmd_cursor },
	{ "da",		2,CTda,		"decimal to ascii char",		0 },
	{ "dial",	1,CTdial,	"dial remote destination",		cmd_dial },
	{ "delline",0,0,		"",								cmd_delline },
	{ "do",		2,CTdo,		"perform procedure",			cmd_do },
	{ "duplex",	2,CTduplex,	"set/display duplex",			cmd_duplex },
	{ "echo",	0,0,		"",								cmd_echo },
	{ "eeol",	0,0,		"",								cmd_eeol },
	{ "else",	0,0,		"",								cmd_else },
	{ "esc",	2,CTte,		"set command escape",			0 },
	{ "exit",	2,CTexit,	"drop carrier, exit program",	cmd_exit },
	{ "expresp",0,0,		"",								cmd_expresp },
	{ "fchmod",	0,0,		"",								cmd_fchmod },
	{ "fclose",	0,0,		"",								cmd_fclose },
	{ "fdel",	0,0,		"",								cmd_fdel },
	{ "fgetc",	0,0,		"",								cmd_fgetc },
	{ "fgets",	0,0,		"",								cmd_fgets },
	{ "fi",		2,CTfi,		"send text file to line",		0 },
	{ "fkey",	2,CTfkey,	"function key definition",		cmd_fkey },
	{ "flush",	0,0,		"",								cmd_flush },
	{ "fopen",	0,0,		"",								cmd_fopen },
	{ "fputc",	0,0,		"",								cmd_fputc },
	{ "fputs",	0,0,		"",								cmd_fputs },
	{ "fread",	0,0,		"",								cmd_fread },
	{ "fseek",	0,0,		"",								cmd_fseek },
	{ "fwrite",	0,0,		"",								cmd_fwrite },
	{ "getf",	0,0,		"",								cmd_getf },
	{ "goto",	0,0,		"",								cmd_goto },
	{ "gotob",	0,0,		"",								cmd_gotob },
	{ "hangup",	2,CThangup,	"hang up modem",				cmd_hangup },
	{ "help",	2,CThelp,	"invoke help",					0 },
	{ "hexdump",0,0,		"",								cmd_hexdump },
	{ "home",	0,0,		"",								cmd_home },
	{ "icolor",	0,0,		"",								cmd_icolor },
	{ "ifi",	0,0,		"",								cmd_ifi },
	{ "ifs",	0,0,		"",								cmd_ifs },
	{ "insline",0,0,		"",								cmd_insline },
	{ "lbreak",	0,0,		"",								cmd_lbreak },
	{ "llp",	2,CTllp,	"set session log to /dev/lp",	0 },
	{ "lgets",	0,0,		"",								cmd_lgets },
	{ "loff",	3,CTloff,	"turn off session logging",		0 },
	{ "log",	3,CTlog,	"session logging control",		0 },
	{ "logevent",0,0,		"",								cmd_logevent },
	{ "lookfor",0,0,		"",								cmd_lookfor },
	{ "mdump",	5,CTmdump,	"",								0 },
/*	{ "mkdir",	3,CTmkdir,	"mkdir <dirname>",				cmd_mkdir }, */
	{ "mkvar",	0,0,		"",								cmd_mkvar },
	{ "nap",	0,0,		"",								cmd_nap },
	{ "nl",		2,CTnl,		"display CR/LF mapping",		0 },
	{ "nlin",	3,CTnlin,	"set receive CR/LF mapping",	0 },
	{ "nlout",	3,CTnlout,	"set transmit CR/LF mapping",	0 },
	{ "oa",		2,CToa,		"octal to ascii char",			0 },
	{ "parity",	3,CTparity,	"set/display line parity",		cmd_parity },
	{ "pclose",	0,0,		"",								cmd_pclose },
	{ "pcmd",	2,CTpcmd,	"execute a procedure command",	0 },
	{ "pid",	2,CTpid,	"display process ids",			0 },
	{ "plog",	2,CTplog,	"control procedure logging",	cmd_plog },
	{ "popen",	0,0,		"",								cmd_popen },
	{ "prompt",	0,0,		"",								cmd_prompt },
	{ "ptrace",	2,CTptrace,	"control procedure trace",		cmd_ptrace },
	{ "putf",	0,0,		"",								cmd_putf },
	{ "pwd",	2,CTpwd,	"print working directory",		0 },
	{ "redial",	3,CTredial,	"redial last number",			0 },
	{ "return",	0,0,		"",								cmd_return },
	{ "rev",	3,CTrev,	"ecu revision/make date",		0 },
	{ "rk",		2,CTrk,		"receive via C-Kermit",			cmd_rk },
	{ "rname",	2,0,		"",								cmd_rname },
	{ "rs",		2,CTrs,		"receive via SEAlink",			cmd_rs },
	{ "rtscts",	3,CTrtscts,	"control RTS/CTS flow control",	0 },
	{ "rx",		2,CTrx,		"receive via XMODEM/CRC",		cmd_rx },
	{ "ry",		2,CTry,		"receive via YMODEM Batch",		cmd_ry },
	{ "rz",		2,CTrz,		"receive via ZMODEM/CRC32",		cmd_rz },
	{ "scrdump",0,0,		"",								cmd_scrdump },
	{ "sdname",	3,CTsdname,	"select screen dump name",		0 },
	{ "send",	0,0,		"",								cmd_send },
	{ "set",	0,0,		"",								cmd_set },
	{ "sgr",	2,CTsgr,	"",								0 },
	{ "sk",		2,CTsk,		"send via C-Kermit",			cmd_sk },
	{ "ss",		2,CTss,		"send via SEAlink",				cmd_ss },
	{ "stat",	2,CTstat,	"connection status",			0 },
	{ "sx",		2,CTsx,		"send via XMODEM/CRC",			cmd_sx },
	{ "sy",		2,CTsy,		"send via YMODEM Batch",		cmd_sy },
	{ "system",	0,CTsy,		"",								cmd_system },
	{ "sz",		2,CTsz,		"send via ZMODEM/CRC32",		cmd_sz },
	{ "time",	2,CTtime,	"time of day",					0 },
	{ "ts",		2,CTts,		"termio display",				0 },
	{ "tty",	2,CTtty,	"console tty name",				0 },
	{ "vidcolor",0,0,		"",								cmd_vidcolor },
	{ "vidnorm",0,0,		"",								cmd_vidnorm },
	{ "vidrev",	0,0,		"",								cmd_vidrev },
	{ "whilei",	0,0,		"",								cmd_whilei },
	{ "whiles",	0,0,		"",								cmd_whiles },
	{ "xa",		2,CTxa,		"hex to ascii char",			0 },
	{ "xlog",	2,CTxlog,	"",								0 },
	{ "!",		1,CTshell,	"execute shell",				0 },
	{ "",		0,-1,"",	0 },		/* list ends with token value of -1 */
};
#endif

/* end of ecucmd.h */
/* vi: set tabstop=4 shiftwidth=4: */
