/* CHK=0x4F27 */
#define SHM_REV	0x0CDEF0005L	/* high 16-bits unique, low=revision */
/*+-------------------------------------------------------------------------
	ecushm.h -- ecu XENIX shared data segment
	wht%n4hgf@gatech.edu
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:03-12-1990-04:22-wht@n4hgf-add Lrname */
/*:11-17-1989-15:12-wht-add friend space */
/*:11-05-1989-16:48-wht-rename ansi_y to cursor_y, ansi_x to cursor_x */
/*:11-05-1989-16:08-wht-keep screen in shared memory */
/*:11-04-1989-07:00-wht-keep ansi cursor position in shm */
/*:11-04-1989-06:55-wht-externalize shm addr */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#if defined(M_I386)
#define FAR
#else
#define FAR far
#endif

/* for header users which do not include ecu.h */
#if !defined(ushort)
#define ushort unsigned short
#endif
#if !defined(uchar)
#define uchar unsigned char
#endif
#if !defined(uint)
#define uint unsigned int
#endif
#if !defined(ulong)
#define ulong unsigned long
#endif

#define SHM_STRLEN	256
typedef struct ecu_sds
{
	uchar screen[43][80];
	ulong shm_revision;
	int xcmd;			/* signal from xmtr to rcvr SIGUSR2 */
	int xi1;
	int xi2;
	int xi3;
	char xs1[SHM_STRLEN];
	int rcmd;			/* signal from rcvr to xmtr SIGUSR2 */
	int ri1;
	int ri2;
	char rs1[SHM_STRLEN];
	ulong rcvd_chars;		/* rcvr char count */
	ulong rcvd_chars_this_connect;	/* count since last connect */
	ulong xmit_chars;		/* xmit char count */
	ulong xmit_chars_this_connect;	/* count since last connect */
	int cursor_y;			/* program-maintained receive cursor */
	int cursor_x;			/* program-maintained receive cursor */
	int Ladd_nl_incoming;	/* when in ksr mode, add nl to cr on receive */
	int Ladd_nl_outgoing;	/* when in ksr mode, add nl to cr on xmit */
	int Lfull_duplex;		/* if non-zero, full duplex else half */
	int Liofd;				/* file descriptor for line */
	int Lmodem_already_init;/* true if modem already initialized */
	int Lmodem_off_hook;	/* we try to keep accurate */
	int Lparity;			/* 0==NONE, 'e' == even, 'o' == odd */
	uint Lbaud;				/* baud rate */
	char Ldescr[64];		/* description of remote */
	char Lline[64];			/* /dev/ttyname for outgoing line */
	char Llogical[64];		/* logical name of remote (from dial dir) */
	char Lrname[64];		/* logical name of remote (settable) */
	long Loff_hook_time;	/* time() at connect */
	char Ltelno[20];		/* telephone number for remote or null */
	int xmtr_pid;			/* transmitter process pid */
	int xmtr_ppid;			/* transmitter process' parent's pid */
	int xmtr_pgrp;			/* transmitter process group */
	char tty_name[64];
	ulong friend_space[128];/* space for friend programs */
} ECU_SDS;

extern ECU_SDS FAR *shm;		/* shared segment pointer */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of ecushm.h */
