/* CHK=0xD1F3 */
/*+-----------------------------------------------------------------------
	ecuusage.c
	wht%n4hgf@gatech.edu

  Defined functions:
	general_usage(uptr)
	log_cmd_usage()
	usage()

------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#include <stdio.h>
#include "ecuhangup.h"
#define ff fprintf
#define se stderr

extern char *makedate;			/* temporary make date */
extern char *numeric_revision;	/* ecunumrev.c */
extern char *revision_modifier; /* ecunumrev.c */

char *usage_text[] = 
{
"usage: ecu [-l /dev/tty<ttynum>] [-b <baud_rate>] [-e] [-o]\r\n",
"           [-c <filename>] [-h] [-k] [-t] [-v[vv...]]\r\n",
"           [-p <initial_proc> | <phone_number>]\r\n",
"Default: 2400,N,8 (use -e for even parity, -o for odd 7 data bits)\r\n",
"-c <filename> use this file rather than ~/.ecumodem\r\n",
"-h half duplex ... default is full duplex\r\n",
"-v verbosity ... the more 'v's the more verbosity.\r\n",
"\r\n",
"For a list of built in commands, type HOME?<ENTER> once program started\r\n",
"\r\n",
"For access to line with no dialing try: ecu - [-eosv]\r\n",
"However, program default line may be busy or not exist\r\n",
	(char *)0		/* terminated with null pointer */
};

char *log_cmd_usage_text[] = 
{
"Usage: log [-s] [-r] <filename>\r\n",
"       log off   turn logging off\r\n",
" -s scratch any previous contents of <filename>, else append\r\n",
" -r raw log, else drop 0x00-0x08,0x11-0x1F,0x7F-0xFF\r\n",
	(char *)0		/* terminated with null pointer */
};

/*+-----------------------------------------------------------------------
	general_usage(uptr)
------------------------------------------------------------------------*/
void
general_usage(uptr)
register char **uptr;
{
	while(*uptr != (char *)0)
		fputs(*(uptr++),se);
}	/* end of usage */

/*+-----------------------------------------------------------------------
	usage()
------------------------------------------------------------------------*/
void
usage()
{
	ff(se,"ecu %s%s made: %s\r\n",
		numeric_revision,revision_modifier,makedate);
	general_usage(usage_text);
	hangup(HANGUP_USAGE);
	/*NOTREACHED*/
}

/*+-------------------------------------------------------------------------
	log_cmd_usage()
--------------------------------------------------------------------------*/
void
log_cmd_usage()
{
	general_usage(log_cmd_usage_text);
}	/* end of log_cmd_usage */

/* vi: set tabstop=4 shiftwidth=4: */
