/* CHK=0xAF92 */
/*+-------------------------------------------------------------------------
	ecuxfer.c
	wht%n4hgf@gatech.edu

   000000000011111111112222222222333333333344444444445555555555666666666actually
   012345678901234567890123456789012345678901234567890123456789012345678wider
00:.--[ Send ZMODEM/CRC32 ]--------------------------------------------.
01:|                                                                   |
02:|  File? to send:                                                   |
03:|  ................................................................ |
04:|                                                                   |
05:|  Binary: Y (no CR/LF translation)                                 |
06:|  Overwrite destination files: Y                                   |
07:|  Send full pathnames: N                                           |
08:|  Transfer only newer files: N (if receiver supports)              |
09:|                                                                   |
-1:| TAB:next  ^B:prev  END:perform transfer  ESC:abort                |
-0:`-------------------------------------------------------------------'

  Defined functions:
	file_xfer_done_bell()
	file_xfer_start()
	receive_files_from_remote(argc,argv)
	report_send_status()
	send_files_to_remote(argc,argv)
	xfer_title_fragment()
	xfrw_bot_msg(msg)
	xfrw_display_cmd_line()
	xfrw_get_single(nondelim_list)
	xfrws_display_allvars()
	xfrws_display_binary()
	xfrws_display_literals()
	xfrws_display_name()
	xfrws_display_xfernew()

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:04-19-1990-03:07-wht@n4hgf-GCC run found unused vars -- rm them */
/*:03-27-1990-15:18-wht@n4hgf-overhaul for/wait/SIGCLD handling */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:11-24-1989-14:41-wht-UNIX tcap-curses blinks with high bits set on addch */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-27-1989-22:42-wht-brackets around standout status report */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#include <curses.h>

#define STDIO_H_INCLUDED
#define OMIT_TERMIO_REFERENCES
#include "ecu.h"
#include "ecukey.h"
#include "ecuxkey.h"
#include "ecuerror.h"
#include "pc_scr.h"

#define END		XFend

/* -- protocol xfer types -- */
#define ECUSZ_X			1
#define ECUSZ_Y			2
#define ECUSZ_Z			3
#define ECUSEA			4
#define CKERMIT			5
#define ECURZ_X			7
#define ECURZ_Y			8
#define ECURZ_Z			9

/* --------------------- send window ----------------------------------- */
/*      SNDW_LINES			calculated (xfrw_lines) */
#define SNDW_COLS			79
#define SNDW_TLY			2
/*      SNDW_TLX			calculated (xfrw_tlx) */

#define SNDW_FILE_LY		2
#define SNDW_FILE_LX		3
#define SNDW_FILE_Y			3
#define SNDW_FILE_X			3
#define SNDW_FILE_LEN		(SNDW_COLS - SNDW_FILE_X - 2)

#define SNDW_BIN_Y			5
#define SNDW_BIN_LX			3
#define SNDW_BIN_X			11
#define SNDW_BIN_LX2		13

#define SNDW_OVERW_Y		6
#define SNDW_OVERW_LX		3
#define SNDW_OVERW_X		32

#define SNDW_SNDFUL_Y		7
#define SNDW_SNDFUL_LX		3
#define SNDW_SNDFUL_X		24

#define SNDW_XFRNEW_Y		8
#define SNDW_XFRNEW_LX		3
#define SNDW_XFRNEW_X		30

extern char curr_dir[];		/* current working directory */
extern int protocol_log_packets;
extern int last_child_wait_status;

long file_xfer_start_time;	/* time() value at beginning of file xfer */
char xfertype = -1;		/* file xfer type */
WINDOW *xfrw;
char xfrw_cols;
char xfrw_lines;
char xfrw_tlx;

char p_binary;		/* xfer options -- not all apply to all protocols */
char p_sendfull;
char p_overwrite;
char p_xfernew;
char p_filelist[80];

/*+-------------------------------------------------------------------------
	file_xfer_start()
--------------------------------------------------------------------------*/
void
file_xfer_start()
{
long time();
	file_xfer_start_time = time((long *)0);
}	/* end of file_xfer_start */

/*+-------------------------------------------------------------------------
	file_xfer_done_bell()
--------------------------------------------------------------------------*/
void
file_xfer_done_bell()
{
long time();
long xfer_time = time((long *)0) - file_xfer_start_time;
int xbell_count = 0;
extern int want_bell_notify;

	sleep(1);
	xbell_count = 1;
	if(xfer_time >= 3600L)			/* >= one hour */
		xbell_count = 3;
	else if(xfer_time >= 1800L)		/* >= 1/2 hour */
		xbell_count = 2;

	if(want_bell_notify)
		bell_notify(XBELL_ATTENTION);

	xbell(XBELL_DONE,xbell_count);
}	/* end of file_xfer_done_bell */

/*+-------------------------------------------------------------------------
	xfrw_bot_msg(msg)
--------------------------------------------------------------------------*/
void
xfrw_bot_msg(msg)
char *msg;
{
register itmp;
register itmp2;
static last_msglen = 0;
char msg2[80];

	wmove(xfrw,xfrw_lines - 1,3);

	if((itmp = strlen(msg)) == 0)
	{
		itmp2 = last_msglen + 2;
		for(itmp = 0; itmp < itmp2; itmp++)
			waddch(xfrw,(unsigned)sHR);
		last_msglen = 0;
	}
	else
	{
		waddch(xfrw,' ');
		if(itmp > xfrw_cols - 3 - 2)
		{
			strncpy(msg2,msg,xfrw_cols - 3 - 2);
			msg2[xfrw_cols - 3 - 2 + 1] = 0;
			waddstr(xfrw,msg2);
			itmp = strlen(msg2);
		}
		else
		{
			waddstr(xfrw,msg);
			itmp = strlen(msg);
		}
		waddch(xfrw,' ');
		if((itmp2 = last_msglen - itmp) > 0)
		{
			while(itmp2--)
				waddch(xfrw,(unsigned)sHR);
		}
		last_msglen = itmp;		/* remember last message length */
	}
	wrefresh(xfrw);
}	/* end of xfrw_bot_msg */

/*+-------------------------------------------------------------------------
	xfrw_get_single(nondelim_list)
assumes cursor is already positioned
--------------------------------------------------------------------------*/
int
xfrw_get_single(nondelim_list)
register char *nondelim_list;
{
register uint itmp;
static char xfrw_nondelim_list[] =
{
	CR,NL,CTL_B,TAB,ESC,CTL_L,CTL_R,END
};

	itmp = winget_single(xfrw,nondelim_list,xfrw_nondelim_list);
	if( (itmp & 0xFF) == 0x0D)
		itmp = NL | 0x1000;
	return(itmp);
}	/* end of xfrw_get_single */

/*+-------------------------------------------------------------------------
	xfer_title_fragment(xfertype)
--------------------------------------------------------------------------*/
char *
xfer_title_fragment()
{
register char *cptr = "UNKNOWN";

	switch(xfertype)
	{
		case ECURZ_X:
		case ECUSZ_X: cptr = "XMODEM/CRC"; break;
		case ECURZ_Y:
		case ECUSZ_Y: cptr = "YMODEM/CRC"; break;
		case ECURZ_Z:
		case ECUSZ_Z: cptr = "ZMODEM/CRC32"; break;
		case ECUSEA:  cptr = "SEAlink"; break;
		case CKERMIT: cptr = "KERMIT/CRC" ;break;
	}
	return(cptr);
}	/* end of xfer_title_fragment */

/*+-------------------------------------------------------------------------
	xfrw_display_cmd_line()
--------------------------------------------------------------------------*/
void
xfrw_display_cmd_line()
{
register itmp;
char *cmd_string = "TAB:next  ^B:prev  END:perform transfer  ESC:abort"; 
register left_spaces = ((xfrw_cols - 2) - strlen(cmd_string)) / 2;
int x;
int y;

	wmove(xfrw,xfrw_lines - 2,1);
	wstandout(xfrw);
	for(itmp = 0; itmp < left_spaces; itmp++)
		waddch(xfrw,' ');
	waddstr(xfrw,cmd_string);
	getyx(xfrw,y,x);
	while(++x < xfrw_cols)
		waddch(xfrw,' '); 
	wstandend(xfrw);

}	/* end of xfrw_display_cmd_line */

/*+-------------------------------------------------------------------------
	xfrws_display_literals()
--------------------------------------------------------------------------*/
void
xfrws_display_literals()
{
	wmove(xfrw,SNDW_FILE_LY,SNDW_FILE_LX);
	if(xfertype == ECUSZ_X)
		waddstr(xfrw,"File");
	else
		waddstr(xfrw,"File(s)");
	waddstr(xfrw," to send:");

	switch(xfertype)
	{
		case ECUSZ_Z:
			wmove(xfrw,SNDW_XFRNEW_Y,SNDW_XFRNEW_LX);
			waddstr(xfrw,"Transfer only newer files:");
			wmove(xfrw,SNDW_SNDFUL_Y,SNDW_SNDFUL_LX);
			waddstr(xfrw,"Send full pathames:");
		case CKERMIT:
			wmove(xfrw,SNDW_OVERW_Y,SNDW_OVERW_LX);
			waddstr(xfrw,"Overwrite destination files:");
		case ECUSZ_Y:
		case ECUSZ_X:
			wmove(xfrw,SNDW_BIN_Y,SNDW_BIN_LX);
			waddstr(xfrw,"Binary:");
	}
}	/* end of xfrws_display_literals */

/*+-------------------------------------------------------------------------
	xfrws_display_name()
--------------------------------------------------------------------------*/
void
xfrws_display_name()
{
	clear_area(xfrw,SNDW_FILE_Y,SNDW_FILE_X,SNDW_FILE_LEN);
	waddstr(xfrw,p_filelist);

}	/* end of xfrws_display_name */

/*+-------------------------------------------------------------------------
	xfrws_display_binary()
--------------------------------------------------------------------------*/
void
xfrws_display_binary()
{
	wmove(xfrw,SNDW_BIN_Y,SNDW_BIN_X);
	waddch(xfrw,(p_binary) ? 'Y' : 'N');
	if(p_binary)
		waddstr(xfrw," (no NL-CR/LF translation)     ");
	else
		waddstr(xfrw," (NL-CR/LF translation enabled)");

}	/* end of xfrws_display_binary */

/*+-------------------------------------------------------------------------
	xfrws_display_xfernew()
--------------------------------------------------------------------------*/
void
xfrws_display_xfernew()
{
	wmove(xfrw,SNDW_XFRNEW_Y,SNDW_XFRNEW_X);
	waddch(xfrw,(p_xfernew) ? 'Y' : 'N');
	if(p_xfernew)
		waddstr(xfrw," (if receiver supports)");
	else
		waddstr(xfrw,"                       ");
}	/* end of xfrws_display_xfernew */

/*+-------------------------------------------------------------------------
	xfrws_display_allvars()
--------------------------------------------------------------------------*/
void
xfrws_display_allvars()
{
	xfrws_display_name();
	switch(xfertype)
	{
		case ECUSZ_Z:
			xfrws_display_xfernew();
			wmove(xfrw,SNDW_SNDFUL_Y,SNDW_SNDFUL_X);
			waddch(xfrw,(p_sendfull) ? 'Y' : 'N');
		case CKERMIT:
			wmove(xfrw,SNDW_OVERW_Y,SNDW_OVERW_X);
			waddch(xfrw,(p_overwrite) ? 'Y' : 'N');
		case ECUSZ_Y:
		case ECUSZ_X:
			xfrws_display_binary();
	}
}	/* end of xfrws_display_allvars */

/*+-------------------------------------------------------------------------
	report_send_status() - report file transmission result
returns proc-type erc
for "ecu knowledgeable" protocols only
--------------------------------------------------------------------------*/
report_send_status()
{
int erc = 0;
unsigned int utmp;
ulong colors_at_entry = colors_current;
char *signal_name_text();

	utmp = last_child_wait_status;
	if((utmp & 0xFF) == 0)	/* exit() called */
	{
		utmp >>= 8;
		if(utmp == 0)
		{
			setcolor(colors_notify);
			pputs("[transfer successful]");
			erc = 0;
		}
		else if(utmp == 255)
		{
			setcolor(colors_error);
			pputs("[ecu error: transfer program usage error]");
			erc = eFATAL_ALREADY;
		}
		else if(utmp == 254)
		{
			setcolor(colors_error);
			pputs(
			"[protocol failure: bad line conditions or remote not ready]");
			erc = eFATAL_ALREADY;
		}
		else if(utmp == 253)
		{
			setcolor(colors_alert);
			pputs("[no requested files exist]");
			erc = eFATAL_ALREADY;
		}
		else if(utmp < 128)
		{
			setcolor(colors_alert);
			if(utmp == 127)
				pputs("[127 or more files skipped]");
			else
				pprintf("[%u files rejected]",utmp);
			erc = 0;
		}
		else
		{
			setcolor(colors_alert);
			pprintf("[transfer aborted by %s]",
				signal_name_text(utmp & 0x7F));
			erc = eProcAttn_Interrupt;
		}
	}
	else
	{
		curbotleft();
		setcolor(colors_error);
		pprintf("[transfer killed by %s]",
			signal_name_text(utmp & 0x7F));
		erc = eProcAttn_Interrupt;
	}

	setcolor(colors_at_entry);
	pputs("\n");
	return(erc);

}	/* end of report_send_status */

/*+-----------------------------------------------------------------------
	send_files_to_remote(argc,argv)
------------------------------------------------------------------------*/
void
send_files_to_remote(argc,argv)
int argc;
char **argv;
{
register itmp;
register input_state = 0;
register input_state_mod;
unsigned int utmp;
int input_done;
int used_argv = 0;
char execcmd[256];
char s80[80];
uchar delim;	/* important to be unsigned to avoid sign extension */
WINDOW *window_create();
char bottom_label[64];

	p_binary = 1;		/* assume p_binary xfer */
	p_sendfull = 0;		/* assume no full pathnames */
	p_overwrite = 1;	/* assume overwrite */
	p_xfernew = 0;		/* assume send only newer */
	p_filelist[0] = 0;	/* no filenames yet */

	switch(to_lower(*(argv[0] + 1)))
	{
		case 'x': xfertype = ECUSZ_X; break;
		case 'y': xfertype = ECUSZ_Y; break;
		case 'z': xfertype = ECUSZ_Z; break;
		case 'k': xfertype = CKERMIT; break;
		case 's': xfertype = ECUSEA; break;
		default: ff(se,"send command invalid\n");
			return;
	}

	kill_rcvr_process(SIGUSR1);	/* SIGUSR1 gives chance to close log file */

/* define and open window */
	input_state_mod = 0;
	xfrw_tlx = (COLS - SNDW_COLS) / 2;
	xfrw_cols = SNDW_COLS;
	switch(xfertype)
	{
		case ECUSEA:
			input_state_mod = 1;
			xfrw_lines = 7;
			break;
		case ECUSZ_X:
			input_state_mod = 2;
			xfrw_lines = 9;
			break;
		case ECUSZ_Z:
			input_state_mod = 5;
		case CKERMIT:
			if(!input_state_mod)
				input_state_mod = 3;
		case ECUSZ_Y:
			if(!input_state_mod)
				input_state_mod = 2;
			xfrw_lines = input_state_mod + 7;
			break;
		default:
			hangup(9999);
	}

	windows_start();
	sprintf(execcmd,"Send %s",xfer_title_fragment());
	xfrw = window_create(execcmd,-3,SNDW_TLY,(int)xfrw_tlx,
			(int)xfrw_lines,(int)xfrw_cols);
	xfrw_display_cmd_line();
	xfrws_display_literals();
	xfrws_display_allvars();
	wmove(xfrw,0,27);
	waddstr(xfrw," dir: ");
	if(strlen(curr_dir) > (xfrw_cols - 32))
	{
	char s80[80];
		strncpy(s80,curr_dir,xfrw_cols - 32);
		s80[xfrw_cols - 32] = 0;
		waddstr(xfrw,s80);
	}
	else
		waddstr(xfrw,curr_dir);
	waddch(xfrw,' ');

REENTER_INPUT_LOOP:
	input_done = 0;
	while(!input_done)
	{
		switch(input_state)
		{
			case 0:		/* filename(s) */
				xfrw_bot_msg("enter file(s) to send");
CASE_0_AGAIN:
				if(used_argv || (argc == 1))
				{
					itmp = wingets(xfrw,SNDW_FILE_Y,SNDW_FILE_X,s80,
						SNDW_FILE_LEN + 1,&delim,(p_filelist[0] != 0));
				}
				else
				{
					used_argv = 1;
					s80[0] = 0;
					utmp = 0;
					for(itmp = 1; itmp < argc; itmp++)
					{
						if((strlen(s80) + strlen(argv[itmp]) + 1) > sizeof(s80))
						{
							xfrw_bot_msg("arguments too long ... reenter list");
							ring_bell();
							goto CASE_0_AGAIN;
						}
						strcat(s80,argv[itmp]);
						if(itmp != (argc - 1))
							strcat(s80," ");
					}
					delim = CR;
				}
				if(delim == ESC)
					break;
				if(strlen(s80))
				{
					strcpy(p_filelist,s80);
					xfrws_display_name();
					if(find_shell_chars(p_filelist))
					{
					char *expcmd;

						if(expand_cmd_with_wildlist(p_filelist,&expcmd))
						{
							xfrw_bot_msg(expcmd);
							ring_bell();
							goto CASE_0_AGAIN;
						}
						expcmd[SNDW_FILE_LEN - 1] = 0;
						clear_area(xfrw,SNDW_FILE_Y,SNDW_FILE_X,SNDW_FILE_LEN);
						waddstr(xfrw,expcmd);
						free(expcmd);
					}
				}
				break;
			case 1:		/* binary */
				xfrw_bot_msg("Y: no conversion, N: NLs converted to CR/LF");
				wmove(xfrw,SNDW_BIN_Y,SNDW_BIN_X);
				wrefresh(xfrw);
				delim = NL;
				switch(itmp = xfrw_get_single("ny"))
				{
					case 0:
					case 1:
						p_binary = itmp;
						xfrws_display_binary();
						break;
					default:
						delim = itmp & 0xFF;
						break;
				}
				break;

			case 2:		/* overwrite */
				xfrw_bot_msg("Y: overwrite, N: protect destination files");
				wmove(xfrw,SNDW_OVERW_Y,SNDW_OVERW_X);
				wrefresh(xfrw);
				delim = NL;
				switch(itmp = xfrw_get_single("ny"))
				{
					case 0:
					case 1:
						p_overwrite = itmp;
						break;
					default:
						delim = itmp & 0xFF;
						break;
				}
				break;

			case 3:		/* send full pathnames */
				xfrw_bot_msg(
					"Y: full pathnames, N: strip directory portion from names");
				wmove(xfrw,SNDW_SNDFUL_Y,SNDW_SNDFUL_X);
				wrefresh(xfrw);
				delim = NL;
				switch(itmp = xfrw_get_single("ny"))
				{
					case 0:
					case 1:
						p_sendfull = itmp;
						break;
					default:
						delim = itmp & 0xFF;
						break;
				}
				break;

			case 4:		/* resume interrupted transfer */

				xfrw_bot_msg(
				"Y: send only if source newer than destination, N send all");
				wmove(xfrw,SNDW_XFRNEW_Y,SNDW_XFRNEW_X);
				wrefresh(xfrw);
				delim = NL;
				switch(itmp = xfrw_get_single("ny"))
				{
					case 0:
					case 1:
						p_xfernew = itmp;
						xfrws_display_xfernew();
						break;
					default:
						delim = itmp & 0xFF;
						break;
				}
				break;

		}

		switch(delim)
		{
			case CTL_B:
				input_state = (input_state) ? input_state - 1 
				                            : input_state_mod - 1;
				break;

			case TAB:
			case NL:
				input_state++;
				input_state %= input_state_mod;
				break;

			case CTL_L:
			case CTL_R:
				clear_screen();
				touchwin(stdscr);
				wrefresh(stdscr);
				touchwin(xfrw);
				wrefresh(xfrw);
				break;

			case ESC:
				xfrw_bot_msg("transfer abandoned");
				input_done = 1;
				break;

			case END:
				input_done = 1;
				break;
		}
	}

	if(delim == END)
	{
		if(!p_filelist[0])
		{
			ring_bell();
			xfrw_bot_msg("No filenames entered!  Press <ENTER>");
			(void)ttygetc(1);
			input_state = 0;
			goto REENTER_INPUT_LOOP;
		}
		xfrw_bot_msg("starting file transfer");
	}

	windows_end(xfrw);
	curmove(SNDW_TLY + xfrw_lines + 1,0);

	if(delim == ESC)
	{
		start_rcvr_process(1);
		return;
	}

	sprintf(bottom_label,"-C \"'Connected to %s'\" ",
		(shm->Llogical[0]) ? shm->Llogical : "?");

/* we are going to do a transfer! */
	switch(xfertype)
	{
		case ECUSZ_X:
			sprintf(execcmd,"ecusz -X -. %d ",shm->Liofd);
			strcat(execcmd,bottom_label);
			if(protocol_log_packets)
				strcpy(&execcmd[strlen(execcmd) ],"-, ");
			if(p_binary)
				strcat(execcmd,"-b ");
			else
				strcat(execcmd,"-a ");
			strcat(execcmd,p_filelist);
			break;
		case ECUSZ_Y:
			sprintf(execcmd,"ecusz -Y -. %d -k ",shm->Liofd);
			strcat(execcmd,bottom_label);
			if(protocol_log_packets)
				strcpy(&execcmd[strlen(execcmd) ],"-, ");
			if(p_binary)
				strcat(execcmd,"-b ");
			else
				strcat(execcmd,"-a ");
			strcat(execcmd,p_filelist);
			break;

		case ECUSZ_Z:
			sprintf(execcmd,"ecusz -Z -. %d ",shm->Liofd);
			strcat(execcmd,bottom_label);
			if(protocol_log_packets)
				strcat(execcmd,"-, ");
			if(p_overwrite)
				strcat(execcmd,"-y ");
			else
				strcat(execcmd,"-p ");
			if(p_binary)
				strcat(execcmd,"-b ");
			else
				strcat(execcmd,"-a ");
			if(p_xfernew)
				strcat(execcmd,"-n ");	/* overrides -y/-p choice earlier */
			if(p_sendfull)
				strcat(execcmd,"-f ");
			strcat(execcmd,p_filelist);
			break;

		case ECUSEA:
			sprintf(execcmd,"ecusea -. %d -/ %s -s ",shm->Liofd,curr_dir);
			if(protocol_log_packets)
				strcat(execcmd,"-, ");
			strcat(execcmd,p_filelist);
			break;

		case CKERMIT:
			sprintf(execcmd,"ckermit -l %d -b %u -p %c%s%s -s %s",
					shm->Liofd,
					shm->Lbaud,
					(shm->Lparity) ? shm->Lparity : 'n',
					(p_binary) ? " -i" : "",
					(p_overwrite) ? "" : " -w",
					p_filelist);
			break;

	}

	file_xfer_start();

	if(find_shell_chars(execcmd))
	{
	char *expcmd;

		if(expand_cmd_with_wildlist(execcmd,&expcmd))
		{
			ff(se,"No files match\r\n");
			return;
		}
		if(exec_cmd(expcmd))
		{
			ff(se,"Could not execute command\r\n");
			start_rcvr_process(1);
			free(expcmd);
			return;
		}
		free(expcmd);
	}
	else
	{
		if(exec_cmd(execcmd))
		{
			ff(se,"Could not execute command\r\n");
			start_rcvr_process(1);
			return;
		}
	}

	lreset_ksr();

	switch(xfertype)
	{
		case ECUSEA:
		case ECUSZ_X:
		case ECUSZ_Y:
		case ECUSZ_Z:
			xfertype = 1;		/* was ecusz */
			break;
		default:
			xfertype = 0;
			break;
	}

	if(xfertype)	/* ecu knowledgable */
		report_send_status();
	else
	{
		stand_out();
		ff(se," transfer status %04x ",last_child_wait_status);
		stand_end();
		ff(se,"\r\n");
	}

	ff(se,"\r\n");

	file_xfer_done_bell();
	start_rcvr_process(1);
}	/* end of send_files_to_remote */

/*+-------------------------------------------------------------------------
	receive_files_from_remote(argc,argv)
--------------------------------------------------------------------------*/
void
receive_files_from_remote(argc,argv)
int argc;
char **argv;
{
register itmp;
char execcmd[256];
int xfertype;
char bottom_label[64];

	sprintf(bottom_label,"-C 'Connected to %s' ",
		(shm->Llogical[0]) ? shm->Llogical : "?");

	switch(to_lower(*(argv[0] + 1)))
	{
		case 'k': xfertype = CKERMIT; break;
		case 's': xfertype = ECUSEA; break;
		case 'x': xfertype = ECURZ_X; break;
		case 'y': xfertype = ECURZ_Y; break;
		case 'z': xfertype = ECURZ_Z; break;
		default: ff(se,"receive command invalid\n");
			return;
	}

	if(xfertype == ECURZ_X)
	{
	char p[128];
		kill_rcvr_process(SIGUSR1);
		sprintf(execcmd,"ecurz -X -. %d -c ",shm->Liofd);
		strcat(execcmd,bottom_label);
		if(protocol_log_packets)
			strcpy(&execcmd[strlen(execcmd) ],"-, ");

		/* get xmodem ascii or binary */
		ff(se,"    Translate CR/LF to NL (ASCII)? ");
		switch(itmp = to_lower(ttygetc(0)))
		{
			case 'y': strcat(execcmd,"-a "); break;
			case 'n': strcat(execcmd,"-b "); break;
			default:
				ff(se,"transfer abandoned\r\n");
				start_rcvr_process(1);
				return;
		}
		ff(se,"%s\r\n",(itmp == 'y') ? "yes" : "no");
		ff(se,"File name to receive via XMODEM/CRC:  ");
		ttygets(p,sizeof(p),1);
		if( (p[0] != ESC) && strlen(p) )
		{
			strcat(execcmd,p);
			file_xfer_start();
			exec_cmd(execcmd);
		}
		else
			ff(se,"transfer abandoned\r\n");
	}
	else if(xfertype == ECURZ_Y)
	{
		ff(se,"\r\n");
		kill_rcvr_process(SIGUSR1);
		sprintf(execcmd,"ecurz -Y -. %d -y ",shm->Liofd);
		strcat(execcmd,bottom_label);
		if(protocol_log_packets)
			strcpy(&execcmd[strlen(execcmd) ],"-, ");
		file_xfer_start();
		exec_cmd(execcmd);
	}
	else if(xfertype == ECURZ_Z)
	{
		ff(se,"\r\n");
		kill_rcvr_process(SIGUSR1);
		sprintf(execcmd,"ecurz -Z -. %d ",shm->Liofd);
		strcat(execcmd,bottom_label);
		if(protocol_log_packets)
			sprintf(&execcmd[strlen(execcmd) ],"-, ");
		file_xfer_start();
		exec_cmd(execcmd);
	}
	else if(xfertype == CKERMIT)
	{
		kill_rcvr_process(SIGUSR1);
		sprintf(execcmd,"ckermit -r -e 512 -l %d -b %d -p %c",
			shm->Liofd,shm->Lbaud,(shm->Lparity) ? shm->Lparity : 'n');
		ff(se,"    Translate CR/LF to NL (ASCII)? ");
		switch(itmp = to_lower(ttygetc(0)))
		{
			case 'y': strcat(execcmd," -i"); break;
			case 'n': break;
			default:
				ff(se,"transfer abandoned\r\n");
				start_rcvr_process(1);
				return;
		}
		ff(se,"%s\r\n",(itmp == 'a') ? "yes" : "no");
		file_xfer_start();
		exec_cmd(execcmd);
	}
	else if(xfertype == ECUSEA)
	{
		kill_rcvr_process(SIGUSR1);
		sprintf(execcmd,"ecusea -r -. %d -/ %s",shm->Liofd,curr_dir);
		if(protocol_log_packets)
			strcat(execcmd," -,");
		file_xfer_start();
		exec_cmd(execcmd);
	}
	lreset_ksr();
	file_xfer_done_bell();
	nap(20L);
	start_rcvr_process(1);
}	/* end of receive_files_from_remote */
/* end of ecuxfer.c */
/* vi: set tabstop=4 shiftwidth=4: */
