/* CHK=0x9BA1 */
/*+-------------------------------------------------------------------------
	pprintf.c
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

/* based on Portable vsprintf  by Robert A. Larson <blarson@skat.usc.edu> */

/* Copyright 1989 Robert A. Larson.
 * Distribution in any form is allowed as long as the author
 * retains credit, changes are noted by their author and the
 * copyright message remains intact.  This program comes as-is
 * with no warentee of fitness for any purpouse.
 *
 * Thanks to Doug Gwen, Chris Torek, and others who helped clarify
 * the ansi printf specs.
 *
 * Please send any bug fixes and improvments to blarson@skat.usc.edu .
 * The use of goto is NOT a bug.
 */

#if !defined(BUILDING_LINT_ARGS)

#include <stdio.h>
#include <varargs.h>

#if defined(M_I386)
#define LONGINT
#endif

/* This must be a typedef not a #define! */
#define NOVOID
#ifdef NOVOID
typedef char *pointer;
#else
typedef void *pointer;
#endif

typedef int *intp;

/*+-------------------------------------------------------------------------
	pprintf(format,va_alist)
--------------------------------------------------------------------------*/
void
pprintf(format,va_alist)
register char *format;
va_dcl
{
va_list args;
register char c;
register char *tp;
char tempfmt[64];
#ifndef LONGINT
int longflag;
#endif
char accum_string[256];
register char *dp = accum_string;

	va_start(args);

	tempfmt[0] = '%';
	while(c = *format++)
	{
		if(c=='%')
		{
			tp = &tempfmt[1];
#ifndef LONGINT
			longflag = 0;
#endif
continue_format:
			switch(c = *format++)
			{
			case 's':
				*tp++ = c;
				*tp = '\0';
				dp += sprintf(dp,tempfmt,va_arg(args,char *));
				break;
			case 'u':
			case 'x':
			case 'o':
			case 'X':
#ifdef UNSIGNEDSPECIAL
				*tp++ = c;
				*tp = '\0';
#ifndef LONGINT
				if(longflag)
					dp += sprintf(dp,tempfmt,va_arg(args,unsigned long));
				else
#endif
					dp += sprintf(dp,tempfmt,va_arg(args,unsigned));
				break;
#endif
			case 'd':
			case 'c':
			case 'i':
				*tp++ = c;
				*tp = '\0';
#ifndef LONGINT
				if(longflag)
					dp += sprintf(dp,tempfmt,va_arg(args,long));
				else
#endif
					dp += sprintf(dp,tempfmt,va_arg(args,int));
				break;
			case 'f':
			case 'e':
			case 'E':
			case 'g':
			case 'G':
				*tp++ = c;
				*tp = '\0';
				dp += sprintf(dp,tempfmt,va_arg(args,double));
				break;
			case 'p':
#if defined(M_I386)
				dp += sprintf(dp,"0x%08lx",va_arg(args,pointer));
#else
#if defined(M_I286)
				tp = va_arg(args,pointer);
#if defined(M_SDATA)
				dp += sprintf(dp,"0x%04x",tp);
#else
				dp += sprintf(dp,"%04x:%04x",(int)tp,(int)((long)tp >> 16));
#endif /* M_SDATA */
#else
>>>>>>>>>>>> model problem
#endif /* M_I286 */
#endif /* M_I386 */
				break;
			case '-':
			case '+':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case '.':
			case ' ':
			case '#':
			case 'h':
				*tp++ = c;
				goto continue_format;
			case 'l':
#ifndef LONGINT
				longflag = 1;
				*tp++ = c;
#endif
				goto continue_format;
			case '*':
				tp += sprintf(tp,"%d",va_arg(args,int));
				goto continue_format;
			case '%':
			default:
				*dp++ = c;
				break;
			}
		}
		else *dp++ = c;
	}
	*dp = '\0';
	va_end(args);
	pputs(accum_string);
}	/* end of pprintf */
#endif /* !defined(BUILDING_LINT_ARGS) */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of pprintf.c */
