#include "xt.h"

XtTranslations Get_Translations (t) Object t; {
    register char *s;
    XtTranslations ret;

    Make_C_String (t, s);
    if ((ret = XtParseTranslationTable (s)) == 0)
	Primitive_Error ("bad translation table: ~s", t);
    return ret;
}

static Object P_Augment_Translations (w, t) Object w, t; {
    Check_Widget (w);
    XtAugmentTranslations (WIDGET(w)->widget, Get_Translations (t));
    return Void;
}
    
static Object P_Override_Translations (w, t) Object w, t; {
    Check_Widget (w);
    XtOverrideTranslations (WIDGET(w)->widget, Get_Translations (t));
    return Void;
}

static Object P_Uninstall_Translations (w) Object w; {
    Check_Widget (w);
    XtUninstallTranslations (WIDGET(w)->widget);
    return Void;
}

init_xt_translation () {
    Define_Primitive (P_Augment_Translations,   "augment-translations",
	2, 2, EVAL);
    Define_Primitive (P_Override_Translations,  "override-translations",
	2, 2, EVAL);
    Define_Primitive (P_Uninstall_Translations, "uninstall-translations", 
	1, 1, EVAL);
}
