/* flink -- f77 call mapper -- from Bourne's C xref, p. 204 */
/* Written by Bill Silvert, August 1988 */
%k 100
%a 1000
%o 1000
%n 200
%e 200
%p 1000
%{
#undef ECHO
static char SCCSID[] = "@(#)flink.l	Ver. 1.17, 88/08/17 10:11:33";
char *progname, *filename="-";
#define	FWORD	8
#define	ESIZE	10
#define	SKIP	0
#define	PROG	1
#define	SUBR	2
#define	FUNC	3
#define	BLKD	4
#define	ENTR	5
#define	CALL	9
int status = SKIP;	/* flags to define level of name */
char *routine[] = {	"",
			"PROGRAM",
			"SUBROUTINE",
			"FUNCTION",
			"BLOCK DATA",
			"ENTRY",
			"",
			"",
			"",
			"CALL"
		  };
#define OPTTBL	0
#define OPTCAL	1
#define OPTDEP	2
#define OPTENT	3
#define OPTFIL	4
#define OPTBLK	5
#define OPTUNU	6
#define OPTUNS	7
#define OPTSUB	8
int option = OPTTBL;
char *select = NULL;		/* name selected as option */
int verbose=1;
int entered=0, linked=0;	/* initialization flags */
char unit[FWORD];
typedef struct element	{	char name[FWORD];
				char *file;
				int level;
				int hit;
				int class;
				struct element *next;
			}	ELEMENT;

typedef struct matrix	{	ELEMENT *i;
				ELEMENT *j;
				struct matrix *next;
			}	MATRIX;

/* arrays for data and pointers -- first element of each array is useless */
ELEMENT entry[ESIZE], *lentry=entry+ESIZE-1, *current, *rec;
ELEMENT *newrecord(), *altrecord(), *addrecord();
MATRIX link[ESIZE], *llink=link+ESIZE-1, *index=link;
int type[10];	/* how many subprograms of each type? */

main(argc,argv)
int argc;
char *argv[];
{
	extern int optind;
	extern char *optarg;
	int count, ocount;

	progname = argv[0];
	strcpy(entry->name, "------");	/* safety defaults */
	entry->next = NULL;
	link->next = NULL;
	for(count=0; count<10; count++)
		type[count] = 0;
	while((count = getopt(argc, argv, "bcdefqstuvxC:D:F:h")) != EOF)
		switch(count) {
		case 'b': option = OPTBLK;	break;
		case 'C': select = optarg;
		case 'c': option = OPTCAL;	break;
		case 'D': select = optarg;
		case 'd': option = OPTDEP;	break;
		case 'e': option = OPTENT;	break;
		case 'F': select = optarg;
		case 'f': option = OPTFIL;	break;
		case 'q': verbose=0;		break;
		case 's': option = OPTSUB;	break;
		case 't': option = OPTTBL;	break;
		case 'u': option = OPTUNU;	break;
		case 'x': option = OPTUNS;	break;
		case 'v': verbose=2;		break;
		case 'h':
		default:
			fprintf(stderr,
				"%s [-bcdefqtuvx] [-CDF name] file ...\n",
					progname);
			fprintf(stderr,
				"\tb\tBLOCK DATA\n\tc\tCALLs\n\td\tDependencies (reverse of CALLs)\n\te\tENTRY points\n\tf\tFiles in which subprograms occur\n\tq\tQuiet mode\n\tt\tTabular output (default)\n\tu\tUnused subroutines\n\tv\tVerbose mode\n\tx\tunsatisfied eXternals\n\tC name\tCALLs from <name>\n\tD name\tDependencies on <name> (what CALLs it)\n\tF name\tFile in which <name> occurs\n");
			exit(1);
		}
	if(optind >= argc) {
		strcpy(unit, "------");
		yylex();
		if(current && verbose)
			fprintf(stderr,
				"Missing END statement at end of %s %s\n",
					routine[current->class], current->name);
	}
	else {
		for(; optind < argc; optind++) {
			if(freopen(argv[optind],"r",stdin)==NULL) {
				fprintf(stderr,"%s: %s: cannot open\n",
						progname, argv[optind]);
			}
			else {
				filename=argv[optind];
				yylineno=1;
				strcpy(unit, "------");
				yylex();
				if(current && verbose) {
					fprintf(stderr,
			"Missing END statement at end of %s %s in file %s\n",
						routine[current->class],
						current->name,
						filename);
					current = NULL;
				}
			}
		}
	}
	/* Now find all of the dependencies */
	switch(type[PROG]) {
	case 0:			/* no main PROGRAM defined */
		status = 1;		/* flag */
		count = 0;		/* test for blank input */
		for(rec = entry; rec->class != SUBR; rec = rec->next) {
			if(! rec->next) {	/* oops -- made it to end */
				if(! count)
					error_("No program units in input");
				/* at this stage, display what we have */
				status = 0;
				break;
			}
			else
				count++;	/* keep track of input */
		}
		if(status)
		    rec->level = 1;	/* process first subroutine */
		else
		    if(verbose)
			fprintf(stderr, "No PROGRAM or SUBROUTINE in input\n");
		break;
	case 1:			/* usual case */
		break;
	default: if(verbose)
		fprintf(stderr, "There are %d PROGRAM units\n\n", type[PROG]);
	}
	count = type[PROG] + type[FUNC];
	status = 1;	/* change the use of status to a counter */
	do {
		ocount = count;
		if(verbose>1)
			printf("Level %d, count=%d\n", status-1, count);
		status++;
		for(index = link;;index=index->next) {
			if(index->i->level && !index->j->level) {
				index->j->hit = status;
			}
			if(! index->next) break;
		}
		for(rec=entry;;rec=rec->next) {
			if(rec->hit && ! rec->level) {
				rec->level = rec->hit;
				count++;
			}
			if(! rec->next) break;
		}
	} while(count > ocount);
	if(! entered)
		error_("No subprograms encountered");
	/* now generate output */
	switch(option) {
	case OPTTBL:
			tabulate();
			break;
	case OPTCAL:
			if(! linked) error_("No linkages found");
			calls();
			break;
	case OPTDEP:
			if(! linked) error_("No linkages found");
			depends();
			break;
	case OPTENT:
			if(! linked) error_("No linkages found");
			enters();
			break;
	case OPTFIL:
			file();
			break;
	case OPTBLK:
			blocks();
			break;
	case OPTUNU:
			unused();
			break;
	case OPTUNS:
			external();
			break;
	case OPTSUB:
	default:
			errord("Option %d not implemented", option);
	}
	exit(0);
}

tabulate()
{
	printf("\nSubroutines called:\nName\tLevel\tFile\n");
	for(rec=entry;;rec=rec->next) {
		int recl;
		recl = rec->class;
		if(rec->file && rec->level && recl != ENTR && recl != FUNC)
		    printf("%s\t%d\t%s\n", rec->name, rec->level-1,rec->file);
		if(! rec->next) break;
	}
	if(type[FUNC]) {
		printf("\nFunctions:\nName\tFile\n");
		for(rec=entry;;rec=rec->next) {
			if(rec->file && rec->class == FUNC) {
				printf("%s\t%s\n", rec->name, rec->file);
				rec->level++;	/* don't list as unused */
			}
			if(! rec->next) break;
		}
	}
	if(type[ENTR]) {
		printf("\nAlternate entry points:\nName\tFile\n");
		for(rec=entry;;rec=rec->next) {
			if(rec->file && rec->class == ENTR) {
				printf("%s\t%s\n", rec->name, rec->file);
				rec->level++;	/* don't list as unused */
			}
			if(! rec->next) break;
		}
	}
	if(type[BLKD]) {
		printf("\nBLOCK DATA subprograms:\nName\tFile\n");
		blocks();
	}
	printf("\nUnused subprograms:\nName\tFile\n");
	if(! unused())
		printf("(none)\n");
	printf("\nUnsatisfied externals:\nName\tLevel\n");
	if(! external())
		printf("(none)\n");
	/* CALLS to subroutines called by unused subprograms are ignored */
}

blocks()
{
	for(rec=entry;;rec=rec->next) {
		if(rec->file && rec->class == BLKD) {
			printf("%s\t%s\n", rec->name, rec->file);
			rec->level++;	/* don't list as unused */
		}
		if(! rec->next) break;
	}
}

unused()
{
	int k = 0;
	for(rec=entry;;rec=rec->next) {
		if(rec->file && ! rec->level) {
			printf("%s\t%s\n", rec->name, rec->file);
			k++;
		}
		if(! rec->next) break;
	}
	return k;
}

external()
{
	int k = 0;
	for(rec=entry;;rec=rec->next) {
		if(rec->level && ! rec->file) {
			printf("%s\t%d\n", rec->name, rec->level-1);
			k++;
		}
		if(! rec->next) break;
	}
	return k;
}

calls()
{
	if(verbose>1)
		printf("Name\tSubroutine called\n");
	for(index = link;;index=index->next) {
		if(index->i->class != ENTR)
			if(!select || !strcmp(index->i->name, select))
				printf("%s\t%s\n", index->i->name,
						index->j->name);
		if(! index->next) break;
	}
}

depends()
{
	if(verbose>1)
		printf("Name\tCalling subroutine\n");
	for(index = link;;index=index->next) {
		if(index->i->class != ENTR)
			if(!select || !strcmp(index->j->name, select))
				printf("%s\t%s\n", index->j->name,
						index->i->name);
		if(! index->next) break;
	}
}

enters()
{
	if(verbose>1)
		printf("Name\tAlternate ENTRY\n");
	for(index = link;;index=index->next) {
		if(index->i->class == ENTR)
			/* if(!select || !strcmp(index->j->name, select)) */
				printf("%s\t%s\n", index->j->name,
						index->i->name);
		if(! index->next) break;
	}
}

file()
{
	if(verbose>1)
		printf("Name\tFile\n");
	for(rec=entry;;rec=rec->next) {
		if(rec->file) {
			if(!select || !strcmp(rec->name, select))
				printf("%s\t%s\n", rec->name, rec->file);
		}
		if(! rec->next) break;
	}
}

ELEMENT *newrecord(recname)	/* encounter a new program unit */
char *recname;
{
	if(current&& verbose)
		fprintf(stderr, "%s %s starts before %s %s ends\n",
			routine[status], recname,
			routine[current->class], current->name);
	return altrecord(recname);
}

ELEMENT *altrecord(recname)	/* identify program unit or entry point */
char *recname;
{
	ELEMENT *newrec;
	newrec = addrecord(recname);
	if(newrec->file)
		errors("Duplicate declaration of %s", recname);
	newrec->file = filename;
	newrec->class = status;
	return newrec;
}

ELEMENT *addrecord(recname)	/* find or create matching entry */
char *recname;
{
	ELEMENT *add;
	if(entered) {
		ELEMENT *next;
		for(add=entry;;add=add->next) {
			if(! strcmp(recname, add->name))
				return add;
			if(! add->next)	/* end of list? */
				break;
		}
		if(add < lentry)
			   next = add + 1;
		else {
			    next = (ELEMENT *)
				calloc(ESIZE,sizeof(ELEMENT));
			    lentry += ESIZE;
		}
		add->next = next;
		add = next;
	}
	else {
		entered = 1;
		add = entry;
	}
	strcpy(add->name, recname);
	add->file = NULL;
	add->level = 0;
	add->hit = 0;
	add->class = 0;
	add->next = NULL;
	return add;
}

connect(i, j)
ELEMENT *i, *j;
{
	if(linked) {
		MATRIX *next;
		if(index < llink)
			next = index + 1;
		else {
			next = (MATRIX *) calloc(ESIZE, sizeof(MATRIX));
			llink += ESIZE;
		}
		index->next = next;
		index = next;
	}
	else {
		linked = 1;
		index = link;
	}
	index->i = i;
	index->j = j;
	index->next = NULL;
}
%}
%%
^[C*].*\n			;	/* skip comments */
^[ \t]*PROGRAM			status=PROG;
^[ \t]*SUBROUTINE		status=SUBR;
FUNCTION			status=FUNC;
^[ \t]*ENTRY			status=ENTR;
^[ \t]*BLOCK[ \t]*DATA		status=BLKD;
^[ \t]*END[ \t]*\n		{ strcpy(unit, "------"); current = NULL; }
CALL				status=CALL;
^[ \t]*EXTERNAL			;
[0-9.]*[ED][-+0-9]*		;	/* skip floating point numbers */
[A-Z][A-Z0-9]* { switch(status) {
		case PROG:	/* program definition */
			strcpy(unit, yytext);
			current = newrecord(unit);
			current->level = 1;
			break;
		case SUBR:	/* subroutine */
		case BLKD:	/* block data */
			strcpy(unit, yytext);
			current = newrecord(unit);
			break;
		case FUNC:	/* function */
			strcpy(unit, yytext);
			current = newrecord(unit);
			current->level = 1;	/* assume function is used */
			break;
		case ENTR:	/* entry point */
			strcpy(unit, yytext);
			connect(altrecord(unit), current);
			break;
		case CALL:	/* call */
			if(current)
				connect(current, addrecord(yytext));
			else
				errors("CALL %s with no current subprogram",
					yytext);
			break;
		default:
			break;
		} ++type[status]; status = SKIP; }
.	;
\n	status=SKIP;
