case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
echo "Extracting hdrs/sysdefs.h (with variable substitutions)"
sed <<!GROK!THIS! >sysdefs.h -e 's!^#undef!/\*#undef!'
/* $Id: sysdefs.SH,v 4.1.1.1 90/06/09 22:28:42 syd Exp $ */
/*******************************************************************************
 *  The Elm Mail System  -  $Revision: 4.1.1.1 $   $State: Exp $
 *
 * 			Copyright (c) 1986, 1987 Dave Taylor
 * 			Copyright (c) 1988, 1989, 1990 USENET Community Trust
 *******************************************************************************
 * Bug reports, patches, comments, suggestions should be sent to:
 *
 *	Syd Weinstein, Elm Coordinator
 *	elm@DSI.COM			dsinc!elm
 *
 *******************************************************************************
 * $Log:	sysdefs.SH,v $
 * Revision 4.1.1.1  90/06/09  22:28:42  syd
 * Allow use of submit with mmdf instead of sendmail stub
 * From: martin <martin@hppcmart.grenoble.hp.com>
 * 
 * Revision 4.1  90/04/28  22:42:14  syd
 * checkin of Elm 2.3 as of Release PL0
 * 
 *
 ******************************************************************************/

/**  System level, configurable, defines for the ELM mail system.  **/


#define FIND_DELTA	10		/* byte region where the binary search
					   on the path alias file is fruitless 
                                           (can't be within this boundary)    */

#define MAX_IN_WEEDLIST 150	/* max headers to weed out               */

#define MAX_HOPS	35	/* max hops in return addr to E)veryone  */

#define DEFAULT_BATCH_SUBJECT  "$defbatsub"

#define DEFAULT_DOMAIN  "$mydomain"  /* if mydomain file is missing */

/** If you want to implement 'site hiding' in the mail, then you'll need to
    uncomment the following lines and set them to reasonable values.  See 
    the configuration guide for more details....(actually these are undoc-
    umented because they're fairly dangerous to use.  Just ignore 'em and
    perhaps one day you'll find out what they do, ok?)
**/

/****************************************************************************

#define   SITE_HIDING
#define   HIDDEN_SITE_NAME	"fake-machine-name"
#define   HIDDEN_SITE_USERS	"/usr/mail/lists/hidden_site_users"

****************************************************************************/

#define system_text_file        "$lib/aliases.text"
#define system_hash_file        "$lib/aliases.hash"
#define system_data_file        "$lib/aliases.data"

#define ALIAS_TEXT		".elm/aliases.text"
#define ALIAS_HASH		".elm/aliases.hash"
#define ALIAS_DATA		".elm/aliases.data"

#define pathfile		"$pathalias"
#define domains			"$domains"
#define hostdomfile             "$lib/domain"

/** where to put the output of the elm -d command... (in home dir) **/
#define DEBUGFILE	"ELM:debug.info"
#define OLDEBUG		"ELM:debug.last"

#define	default_temp   	"$tmpdir/"
#define temp_file	"snd."
#define temp_form_file	"form."
#define temp_mbox	"mbox."
#define temp_print      "print."
#define temp_edit	"elm-edit"
#define temp_uuname	"uuname."
#define readmsg_file	".elm/readmsg"

#define emacs_editor	"$emacs"

#define default_editor	"$defeditor"
#define mailhome	"$maildir/"

#define default_shell	"$prefshell"
#define default_pager	"$pager"
#define default_printout	"$cat %s | $linepr"

#define sendmail	"$sendmail"
#define smflags		"-oi -oem"	/* ignore dots and mail back errors */
#define smflagsv      	"-oi -oem -v"   /* Verbose voyuer mode */
#define submitmail     	"$submit"
#define submitflags     "-mlrnxto,cc*"
#define mailer		"$mailer"

#define mailx		"$mailx"

#define helphome	"$lib"
#define helpfile	"elm-help"

#define ELMRC_INFO	"$lib/elmrc-info"

#define elmrcfile	".elm/elmrc"
#define old_elmrcfile	".elm/elmrc.old"
#define mailheaders	".elm/elmheaders"
#define dead_letter	"Cancelled.mail"

#define unedited_mail	"emergency.mbox"

#define newalias	"newalias 1>&2 > /dev/null"
#define readmsg		"readmsg"

#define remove_cmd	"$rm -f"	/* how to remove a file */
#define cat		"$cat"		/* how to display files */
#define sed_cmd		"$sed"		/* how to access sed */
#define move_cmd	"$mv"		/* how to access sed */
#define uuname		"$uuname"	/* how to get a uuname  */

#define MSG_SEPERATOR	"\001\001\001\001\n"	/* mmdf message seperator */
!GROK!THIS!
