echo "Extracting joinr (with variable substitutions)"
: This section of the file will have variable substitutions done on it.
: Move anything that needs config subs from !NO!SUBS! section to !GROK!THIS!.
: Protect any dollar signs and backticks that you do not want interpreted
: by putting a backslash in front.  You may delete these comments.
$spitshell >joinr <<!GROK!THIS!
$startsh
#
# joinr - Extract and glue together mailsplit transmissions 
# @(#)joinr.SH    2.7    90/03/28       M F Wyle, T. Numata, H. Yamanaka
#
# \$Id: joinr.SH,v 1.9 90/03/19 22:38:39 yamanaka Rel $
#
# Modify awk script and strip dirnames of commands for compatibility
# between BSD and System V.
#		90/01/25       H.Yamanaka (with T.Numata's advices)
#
# Modify tar extraction mechanism in mailsplit to work on System V
# machines.
#		90/02/01	H.Yamanaka (with T.Numata's advices)

############################################################################
# These commands and paths should be configured for your machine/site

PATH="/bin:/usr/bin:/usr/local/bin:/usr/ucb:/usr/local:/usr/lbin:/etc:\\
/usr/new:/usr/new/bin:/usr/nbin:/usr/ucb/bin:/usr/old"
BA=$basename     # chop off leading path *
CAT=$cat         # Concatenate And prinT *
TA=$tar          # Archive command *
# options to send to archive command to extract data
if test -f /vmunix ; then
   TAO="xvf"  # If BSD;
elif test -f /unix ; then
   TAO="xfo"  # If System V;
else
   TAO="xf" ; # I don't know.
fi
RM="$rm -f"      # Remove command
SED=$sed         # Stream editor *
MV=$mv           # Rename command *
AWK=$awk         # get regular expression *
HEAD=$head       # Get initial part of file (for a non-UCB sys use cat) *
PWD=$pwd         # Print working directory *
touch=$touch     # the touch command
uncompress=$uncompress
uudecode=$uudecode
UUOPT=$UUOPT
CE=$CE           # compress'd file name extension

TD=$TD            # temp directory
T1=$TD/x_\$\$_    # temp file for pieces
T2=$TD/g_\$\$     # temp file for garbage
T3=$TD/f_\$\$     # temp file for archive
T4=$TD/p_\$\$     # file containing the extract awk script

!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
$spitshell >>joinr <<'!NO!SUBS!'
##############################################################################
# You might want to change these, but it's not likely.

ME=`$BA $0`        # This program's name
VE="2.7 90/03/28"  # Version of this program

##############################################################################
# Hacker city

echo " "
echo "$ME version $VE  (C) 1988, 1989, 1990   M F Wyle" 1>&2
echo " "

echo "...initializing, preparing to extract..."
if test ! -t 0; then
  echo "...found data on standard in; ignoring command line..."
else
  echo "...standard input empty, looking for files on command line..."
  case $# in
    0) case $ME in
	 joinr) echo " "
		echo "Usage:   $ME [ < ] file(s)"
		echo "Example: $ME < p1of2 p2of2"
		echo " "
		exit 1 ;;
	*) $CAT $0 |/bin/sh $0
	   exit 0 ;;
       esac ;;
  esac
  echo "...found $# file(s) on command line, feeding them to $ME"
  case $ME in
    joinr) $CAT $* | $0 ;;
    *)     $CAT $0 $* | /bin/sh $0 ;;
  esac
  exit 0
fi

case $ME in
  sh) echo " "
      echo "Usage:   $ME file(s)"
      echo "Example: $ME p1of2 p2of2"
      echo " "
      exit 1 ;;
esac

$RM $T1* $T2 $T3* $T4*  # get rid of old files
$CAT  <<'EOA' > $T4         # create awk extract script
AWK '
BEGIN { inhex = 0; nparts=0 }
/^---/ {
  if ($2 == "start" && $3 == "of" && $5 == "part" && $7 == "of") {
    nparts= $8
    fd=proc_files[$6 - 1]
    if (fd == 0) fd= $6
    if (fd < 10) file = "T1" fd
    else if (fd < 100) file = "T1" "_" fd
    else file = "T1" "__" fd
    if (proc_files[$6] > 0) {
       file = "T2"
    } else {
       proc_files[$6] = fd
    }
    inhex = 1
    getline
  }
  else if ($2 == "end" && $3 == "of" && $5 == "part" && $7 == "of") 
    inhex = 0
}
{ if (inhex) print $0 > file }
END { nerrors=0
      for (i=1; i <= nparts; i++)
	if (proc_files[i] == 0) {
	  print "*** part " i " is missing. ***" 
	  nerrors++
	}
      if (nerrors > 0) print "abort" > "T3"
}'
EOA

# Make awk script use process-specific filenames
$SED -e "s;AWK;$AWK;" -e "s;T1;$T1;" -e "s;T2;$T2;" \
   -e "s;T3;$T3;" < $T4 > $T4"p"
$RM $T4
$MV $T4"p" $T4
# Invoke the awk script on std in:
echo ...extracting data...
. $T4
if test -s $T3 ; then
  echo "...aborted extraction..."
  $RM $T1* $T2 $T3 $T4
  exit 1
fi
$CAT $T1* > $T3                # gather pieces
echo ...finished extraction, starting uudecode...
header=`$HEAD $T3 | $AWK '/[bB]egin/{print $1 " " $3}'`
set $header
fname=$2
case $1 in
  xbtoa5) uudecode=btoa
	  UUOPT='-a' ;;
  begin) uudecode=uudecode
	 UUOPT=
	 ;;
esac
OurDir=`$PWD`
cd $TD
$touch $T3
chmod  777 $T3
$uudecode $UUOPT $T3
$RM  $T3
chmod  777 $fname
IFS=.
set $fname
IFS=' '
case $2 in
  C) uncompress=uncompact
     CE=C ;;
  z) uncompress=unpack
     CE=z ;;
  Z) uncompress=uncompress
     CE=Z ;;
  tar) uncompress=:
       $MV $fname $1 ;;
  *) $MV $fname $1.$CE ;;
esac
fname=$1

echo ...finished uudecode, starting uncompress...
$uncompress $fname.$CE 1>/dev/null 2>&1
$MV $fname $OurDir
cd $OurDir
echo ...finished uncompress, starting tar extraction...
$RM $T1*                      # tar returns no exit status!! Grrr.
$TA $TAO $fname 2>$T1         # check exit status of tar
if test -s $T1 ; then
echo "... >>> Sigh <<<  $TA seems to be having problems:"
$CAT $T1
echo "...saving $TA archive in $fname."
else
if test ! -f /vmunix ; then   # for System V (by yamanaka@iias.fujitsu.co.jp)
  $TA tfv $fname
fi
echo "...That's all folks!"
$RM $fname
fi
$RM  $T1* $T2* $T3* $T4*
exit 0
!NO!SUBS!
chmod 755 joinr
$eunicefix joinr
