### this is the default makefile for Unix: default.mk

SUFFIXES = .o .c .f .e .r .y .l .s .sh .h
.SUFFIXES: $(SUFFIXES)

#	ASM section
AS       = as
ASFLAGS  =
.s:
	$(AS) $(ASFLAGS) $<
.s.o:
	$(AS) $(ASFLAGS) -o $@ $<

#	C section
CC       = cc
CFLAGS   = -O
.c.o:
	$(CC) $(CFLAGS) -c $<

.c.i:
	$(CC) $(CFLAGS) -P $<

.c:
	$(CC) $(CFLAGS) $(LDFLAGS) $< -o $@

#	Lex section
LEX      = lex
LFLAGS   =
.l.c:
	$(LEX) $(LFLAGS) $<
	$(MV) lex.yy.c $@

.l.o:
	$(LEX) $(LFLAGS) $<
	$(CC) $(CFLAGS) -c lex.yy.c
	$(RM) lex.yy.c
	$(MV) lex.yy.o $@

#	YACC section
YACC     = yacc
YFLAGS   =
.y.c:
	$(YACC) $(YFLAGS) $<
	$(MV) y.tab.c $@

.y.h:
	$(YACC) $(YFLAGS) -d $<
	$(RM) y.tab.c
	$(MV) y.tab.h $@

.y.o:
	$(YACC) $(YFLAGS) $<
	$(CC) $(CFLAGS) -c y.tab.c
	$(RM) y.tab.c
	$(MV) y.tab.o $@

.sh:
	cp $< $@

#	BSD Unix Misc section
A        = .a
AR       = ar
ARFLAGS  =
BIN      = /bin
CDEBUG   = -g
CP       = cp
E        =
EDITOR   = /usr/bin/vi
GFLAGS   =
GET      = get
LDFLAGS  =
LD       = ld
LIBDIR   =
MAKE     = make
MKDEPEND = makedepend
MODEL    =
MV       = mv
O        = .o
RANLIB   = ranlib
RM       = rm -f
SHELL    = /bin/csh

#	DOS Misc section
#A        = .lib
#AR       = lib
#ARFLAGS  =
#BIN      = C:\bin
#CDEBUG   = /Od /Zi
#CP       = cp
#E        = .exe
#EDITOR   = $(BIN)\vi
#GFLAGS   =
#GET      = echo cannot get
#LDFLAGS  = /link /noe /noi $(LIBS)
#LD       = $(CC) $(CFLAGS)
#LIBDIR   = c:\msc5.1\lib
#MAKE     = make
#MKDEPEND = mkdepend
#MODEL    = S
#MV       = mv
#O        = .o
#RANLIB   = echo cannot ranlib 
#RM       = rm -f
#SHELL    = command /c
