case $CONFIG in
    '') . ./config.sh ;;
esac
echo "Extracting Makefile {with variable substitutions}"
cat >Makefile <<!GROK!THIS!
# $Header: /usera/rsk/news/nntp/rrn/RCS/Makefile.SH,v 4.24 88/05/23 17:51:56 rsk Exp $
#
# 

CC = $cc
BINDEST = $rnbin
LIBDEST = $rnlib
ETCDEST = /usr/local/etc
DEFS = -DDOXREFS
CFLAGS = $iandd -O ${DEFS}
LDFLAGS = $iandd
NDIRC = $ndirc
NDIRO = $ndiro
MODE = 751
SHMODE = 755
TXTMODE = 644
OWNER = binary
GROUP = system
NNTPSRC = $NNTPSRC

libs = $ndirlib $termlib $jobslib
!GROK!THIS!
cat >>Makefile <<'!NO!SUBS!'

COMMANDS = rrn

HDR =	addng.h art.h artio.h artsrch.h backpage.h bits.h cheat.h common.h \
	final.h head.h help.h init.h intrp.h kfile.h last.h ndir.h ng.h \
	ngdata.h ngsrch.h ngstuff.h only.h rcln.h rcstuff.h respond.h rn.h \
	search.h sw.h term.h util.h artstate.h INTERN.h EXTERN.h config.h

SRC =	addng.c art.c artio.c artsrch.c backpage.c bits.c cheat.c final.c \
	head.c help.c init.c intrp.c kfile.c last.c ${NDIRC} ng.c ngdata.c \
	ngsrch.c ngstuff.c only.c rcln.c rcstuff.c respond.c rn.c search.c \
	sw.c term.c util.c

OBJ =	addng.o art.o artio.o artsrch.o backpage.o bits.o cheat.o final.o \
	head.o help.o init.o intrp.o kfile.o last.o ${NDIRO} ng.o ngdata.o \
	ngsrch.o ngstuff.o only.o rcln.o rcstuff.o respond.o rn.o search.o \
	sw.o term.o util.o

CONFIG = bsd eunice loc pdp11 usg v7 myread grimble all 

all:	${COMMANDS}

rrn:	${OBJ} clientlib.o
	${CC} ${LDFLAGS} ${OBJ} clientlib.o ${libs} -o rrn

${HDR} ${SRC}:
	co $@

clientlib.o:
	$(CC) $(CFLAGS) -c $(NNTPSRC)/common/clientlib.c

lint:	${HDR} ${SRC}
	lint -phbvxac ${DEFS} ${SRC}

tags:
	ctags ${HDR} ${SRC}

clean:
	-rm -f Makefile.bak a.out core errs lint.errs ${CONFIG} ${COMMANDS} *.o

spotless:	clean
	rcsclean Makefile ${HDR} ${SRC}

print:	Makefile ${HDR} ${SRC}
	lpr -J"rrn source" Makefile ${HDR} ${SRC}

install:	all
	-install -c -m ${MODE} -o ${OWNER} -g ${GROUP} -s rrn ${BINDEST}

depend:	${HDR} ${SRC}
	maketd -a ${DEFS} ${INCLUDE} ${SRC}

# DO NOT DELETE THIS LINE - make depend DEPENDS ON IT
I=/usr/include
S=/usr/include/sys

addng.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h addng.c addng.h common.h config.h intrp.h last.h ngdata.h \
	only.h rcstuff.h rn.h search.h util.h

art.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h art.c art.h artio.h artstate.h backpage.h bits.h cheat.h \
	common.h config.h final.h head.h help.h intrp.h ng.h ngstuff.h \
	rcstuff.h rn.h search.h sw.h term.h util.h

artio.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artio.c artio.h common.h config.h

artsrch.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artio.h artsrch.c artsrch.h bits.h cheat.h common.h config.h \
	final.h head.h intrp.h kfile.h ng.h search.h term.h util.h

backpage.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h \
	$I/stdio.h $S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h \
	EXTERN.h INTERN.h backpage.c backpage.h common.h config.h final.h \
	intrp.h

bits.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artio.h bits.c bits.h cheat.h common.h config.h final.h \
	head.h intrp.h kfile.h ng.h ngdata.h rcln.h rcstuff.h rn.h util.h

cheat.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artio.h artsrch.h bits.h cheat.c cheat.h common.h config.h \
	head.h intrp.h ng.h search.h term.h

final.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h bits.h common.h config.h final.c final.h init.h last.h ng.h \
	rcstuff.h term.h util.h

head.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artio.h bits.h common.h config.h head.c head.h util.h

help.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h help.c help.h rn.h term.h

init.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h addng.h art.h artio.h artsrch.h backpage.h bits.h cheat.h \
	common.h config.h final.h head.h help.h init.c init.h intrp.h kfile.h \
	last.h ng.h ngdata.h ngsrch.h ngstuff.h only.h rcln.h rcstuff.h \
	respond.h rn.h search.h sw.h term.h util.h

intrp.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artio.h artsrch.h bits.h common.h config.h final.h head.h \
	intrp.c intrp.h ng.h rcstuff.h respond.h rn.h search.h term.h util.h

kfile.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artsrch.h bits.h common.h config.h intrp.h kfile.c kfile.h \
	ng.h ngstuff.h rcstuff.h rn.h search.h term.h util.h

last.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h intrp.h last.c last.h rn.h util.h

ng.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h art.h artio.h artsrch.h artstate.h backpage.h bits.h cheat.h \
	common.h config.h final.h head.h help.h intrp.h kfile.h last.h ng.c \
	ng.h ngdata.h ngstuff.h rcln.h rcstuff.h respond.h rn.h search.h \
	term.h util.h

ngdata.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/dir.h $S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h \
	EXTERN.h INTERN.h common.h config.h final.h intrp.h ndir.h ngdata.c \
	ngdata.h rcln.h rcstuff.h rn.h

ngsrch.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h final.h ngsrch.c ngsrch.h rcln.h rcstuff.h \
	rn.h search.h term.h util.h

ngstuff.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h bits.h cheat.h common.h config.h final.h head.h intrp.h ng.h \
	ngstuff.c ngstuff.h sw.h term.h util.h

only.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h final.h ngsrch.h only.c only.h search.h \
	util.h

rcln.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h ngdata.h rcln.c rcln.h rcstuff.h util.h

rcstuff.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h final.h intrp.h ngdata.h only.h rcln.h \
	rcstuff.c rcstuff.h rn.h search.h term.h util.h

respond.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h artio.h common.h config.h final.h head.h intrp.h ng.h \
	respond.c respond.h rn.h term.h util.h

rn.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h addng.h common.h config.h final.h help.h init.h intrp.h \
	last.h ng.h ngdata.h ngsrch.h only.h rcln.h rcstuff.h rn.c rn.h \
	search.h sw.h term.h util.h

search.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h search.c search.h util.h

sw.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h common.h config.h head.h intrp.h ng.h only.h search.h sw.c \
	sw.h term.h util.h

term.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h EXTERN.h \
	INTERN.h cheat.h common.h config.h final.h help.h intrp.h term.c \
	term.h util.h

util.o: $I/ctype.h $I/errno.h $I/fcntl.h $I/sgtty.h $I/signal.h $I/stdio.h \
	$S/dir.h $S/ioctl.h $S/stat.h $S/ttychars.h $S/ttydev.h $S/types.h \
	EXTERN.h INTERN.h common.h config.h final.h ndir.h util.c util.h

# *** Do not add anything here - It will go away. ***
!NO!SUBS!
$eunicefix Makefile
