*** rn/ng.c	Sun Mar 15 19:54:26 1987
--- rrn/ng.c	Mon May 25 22:41:53 1987
***************
*** 48,53
  #include "rcln.h"
  #include "last.h"
  #include "search.h"
  #include "INTERN.h"
  #include "ng.h"
  #include "artstate.h"			/* somebody has to do it */

--- 48,54 -----
  #include "rcln.h"
  #include "last.h"
  #include "search.h"
+ #include "server.h"
  #include "INTERN.h"
  #include "ng.h"
  #include "artstate.h"			/* somebody has to do it */
***************
*** 110,115
  do_newsgroup(start_command)
  char *start_command;			/* command to fake up first */
  {
      char oldmode = mode;
      register long i;			/* scratch */
      int skipstate;			/* how many unavailable articles */

--- 111,121 -----
  do_newsgroup(start_command)
  char *start_command;			/* command to fake up first */
  {
+ #ifdef SERVER
+     char ser_line[256];
+     char artname[32];
+     static long our_pid;
+ #endif SERVER
      char oldmode = mode;
      register long i;			/* scratch */
      int skipstate;			/* how many unavailable articles */
***************
*** 117,122
      
      char *whatnext = "%sWhat next? [%s]";
  
  #ifdef ARTSEARCH
      srchahead = (scanon && ((ART_NUM)toread[ng]) >= scanon ? -1 : 0);
  					/* did they say -S? */

--- 123,133 -----
      
      char *whatnext = "%sWhat next? [%s]";
  
+ #ifdef SERVER
+     if (our_pid == 0)           /* Agreed, this is gross */
+         our_pid = getpid();
+ #endif SERVER
+ 
  #ifdef ARTSEARCH
      srchahead = (scanon && ((ART_NUM)toread[ng]) >= scanon ? -1 : 0);
  					/* did they say -S? */
***************
*** 125,130
      mode = 'a';
      recent_art = curr_art = 0;
      exit_code = NG_NORM;
      if (eaccess(ngdir,5)) {		/* directory read protected? */
  	if (eaccess(ngdir,0)) {
  #ifdef VERBOSE

--- 136,156 -----
      mode = 'a';
      recent_art = curr_art = 0;
      exit_code = NG_NORM;
+ 
+ #ifdef SERVER
+     sprintf(ser_line, "GROUP %s", ngname);
+     put_server(ser_line);
+     if (get_server(ser_line, sizeof(ser_line)) < 0) {
+ 	fprintf(stderr, "rrn: Unexpected close of server socket.\n");
+ 	finalize(1);
+     }
+     if (*ser_line != CHAR_OK) {
+ 	if (atoi(ser_line) != ERR_NOGROUP)
+ 		fprintf(stderr, "rrn: server response to GROUP %s:\n%s\n",
+ 			ngname, ser_line);
+ 	return (-1);
+     }
+ #else not SERVER
      if (eaccess(ngdir,5)) {		/* directory read protected? */
  	if (eaccess(ngdir,0)) {
  #ifdef VERBOSE
***************
*** 165,170
  	mode = oldmode;
  	return -1;
      }
  
  #ifdef CACHESUBJ
      subj_list = Null(char **);		/* no subject list till needed */

--- 191,197 -----
  	mode = oldmode;
  	return -1;
      }
+ #endif SERVER
  
  #ifdef CACHESUBJ
      subj_list = Null(char **);		/* no subject list till needed */
***************
*** 293,298
  	else if
  	  (!reread && !was_read(art)
  	    && artopen(art) == Nullfp) {	/* never read it, & cannot find it? */
  	    if (errno != ENOENT) {	/* has it not been deleted? */
  #ifdef VERBOSE
  		IF(verbose)

--- 320,326 -----
  	else if
  	  (!reread && !was_read(art)
  	    && artopen(art) == Nullfp) {	/* never read it, & cannot find it? */
+ #ifndef SERVER
  	    if (errno != ENOENT) {	/* has it not been deleted? */
  #ifdef VERBOSE
  		IF(verbose)
***************
*** 306,311
  		skipstate = 0;
  		sleep(2);
  	    }
  	    switch(skipstate++) {
  	    case 0:
  		clear();

--- 334,340 -----
  		skipstate = 0;
  		sleep(2);
  	    }
+ #endif
  	    switch(skipstate++) {
  	    case 0:
  		clear();
***************
*** 329,334
  	    default:
  		putchar('.');
  		fflush(stdout);
  #define READDIR
  #ifdef READDIR
  		{			/* fast skip patch */

--- 358,364 -----
  	    default:
  		putchar('.');
  		fflush(stdout);
+ #ifndef SERVER
  #define READDIR
  #ifdef READDIR
  		{			/* fast skip patch */
***************
*** 341,346
  		    art = newart - 1;
  		}
  #endif
  		break;
  	    }
  	    oneless(art);		/* mark deleted as read */

--- 371,396 -----
  		    art = newart - 1;
  		}
  #endif
+ #else
+ 		{
+ 			char	ser_line[256];
+ 			ART_NUM	newart;
+ 
+ 			put_server("NEXT");
+ 			if (get_server(ser_line, sizeof (ser_line)) < 0) {
+ 				fprintf(stderr,
+ 			"rrn: unexpected close of server socket.\n");
+ 				finalize(1);
+ 			}
+ 			if (ser_line[0] != CHAR_OK)
+ 				newart = lastart + 1;
+ 			else
+ 				newart = atoi(ser_line+4);
+ 		        for (i=art; i<newart; i++)
+ 				oneless(i);
+ 		        art = newart - 1;
+ 		}
+ #endif SERVER
  		break;
  	    }
  	    oneless(art);		/* mark deleted as read */
***************
*** 450,455
      if (artfp != Nullfp) {		/* article still open? */
  	fclose(artfp);			/* close it */
  	artfp = Nullfp;			/* and tell the world */
  	openart = 0;
      }
      putchar('\n') FLUSH;

--- 500,509 -----
      if (artfp != Nullfp) {		/* article still open? */
  	fclose(artfp);			/* close it */
  	artfp = Nullfp;			/* and tell the world */
+ #ifdef SERVER
+         sprintf(artname, "/tmp/rrn%ld.%ld", (long) openart, our_pid);
+         UNLINK(artname);
+ #endif SERVER
  	openart = 0;
      }
      putchar('\n') FLUSH;
