*** rn/rcstuff.c	Sun Mar 15 19:54:20 1987
--- rrn/rcstuff.c	Fri May 29 09:33:43 1987
***************
*** 31,36
  #include "intrp.h"
  #include "only.h"
  #include "rcln.h"
  #include "INTERN.h"
  #include "rcstuff.h"
  

--- 31,37 -----
  #include "intrp.h"
  #include "only.h"
  #include "rcln.h"
+ #include "server.h"
  #include "INTERN.h"
  #include "rcstuff.h"
  
***************
*** 53,58
      register bool foundany = FALSE;
      char *some_buf;
      long length;
  
  #ifdef HASHNG
      for (i=0; i<HASHSIZ; i++)

--- 54,62 -----
      register bool foundany = FALSE;
      char *some_buf;
      long length;
+ #ifdef SERVER
+     char *cp;
+ #endif SERVER
  
  #ifdef HASHNG
      for (i=0; i<HASHSIZ; i++)
***************
*** 61,66
  
      /* make filenames */
  
      rcname = savestr(filexp(RCNAME));
      rctname = savestr(filexp(RCTNAME));
      rcbname = savestr(filexp(RCBNAME));

--- 65,79 -----
  
      /* make filenames */
  
+ #ifdef SERVER
+ 
+     if (cp = getenv("NEWSRC"))
+ 	rcname = savestr(filexp(cp));
+     else
+ 	rcname = savestr(filexp(RCNAME));
+ 
+ #else not SERVER
+ 
      rcname = savestr(filexp(RCNAME));
  
  #endif SERVER
***************
*** 62,67
      /* make filenames */
  
      rcname = savestr(filexp(RCNAME));
      rctname = savestr(filexp(RCTNAME));
      rcbname = savestr(filexp(RCBNAME));
      softname = savestr(filexp(SOFTNAME));

--- 75,83 -----
  #else not SERVER
  
      rcname = savestr(filexp(RCNAME));
+ 
+ #endif SERVER
+ 
      rctname = savestr(filexp(RCTNAME));
      rcbname = savestr(filexp(RCBNAME));
      softname = savestr(filexp(SOFTNAME));
***************
*** 224,229
  /* returns TRUE if found or added, FALSE if not. */
  /* assumes that we are chdir'ed to SPOOL */
  
  bool
  get_ng(what,do_reloc)
  char *what;

--- 240,249 -----
  /* returns TRUE if found or added, FALSE if not. */
  /* assumes that we are chdir'ed to SPOOL */
  
+ #ifdef SERVER
+ static int addnewbydefault = 0;
+ #endif SERVER
+ 
  bool
  get_ng(what,do_reloc)
  char *what;
***************
*** 231,236
  {
      char *ntoforget;
      char promptbuf[128];
  
  #ifdef VERBOSE
      IF(verbose)

--- 251,259 -----
  {
      char *ntoforget;
      char promptbuf[128];
+ #ifdef SERVER
+     char ser_line[256];
+ #endif SERVER
  
  #ifdef VERBOSE
      IF(verbose)
***************
*** 248,253
      set_ngname(what);
      ng = find_ng(ngname);
      if (ng == nextrcline) {		/* not in .newsrc? */
  	if ((softptr[ng] = findact(buf,ngname,strlen(ngname),0L)) < 0 ) {
  	    dingaling();
  #ifdef VERBOSE

--- 271,291 -----
      set_ngname(what);
      ng = find_ng(ngname);
      if (ng == nextrcline) {		/* not in .newsrc? */
+ 
+ #ifdef SERVER
+ 	sprintf(ser_line, "GROUP %s", ngname);
+ 	put_server(ser_line);
+ 	if (get_server(ser_line, sizeof(ser_line)) < 0) {
+ 	    fprintf(stderr, "rrn: Unexpected close of server socket.\n");
+ 	    finalize(1);
+ 	}
+ 	if (*ser_line != CHAR_OK) {
+ 	    if (atoi(ser_line) != ERR_NOGROUP) {
+ 		fprintf(stderr, "Server response to GROUP %s:\n%s\n",
+ 		    ngname, ser_line);
+ 	    }
+ #else not SERVER
+ 
  	if ((softptr[ng] = findact(buf,ngname,strlen(ngname),0L)) < 0 ) {
  
  #endif SERVER
***************
*** 249,254
      ng = find_ng(ngname);
      if (ng == nextrcline) {		/* not in .newsrc? */
  	if ((softptr[ng] = findact(buf,ngname,strlen(ngname),0L)) < 0 ) {
  	    dingaling();
  #ifdef VERBOSE
  	    IF(verbose)

--- 287,295 -----
  #else not SERVER
  
  	if ((softptr[ng] = findact(buf,ngname,strlen(ngname),0L)) < 0 ) {
+ 
+ #endif SERVER
+ 
  	    dingaling();
  #ifdef VERBOSE
  	    IF(verbose)
***************
*** 261,266
  	    sleep(2);
  	    return FALSE;
  	}
  #ifdef VERBOSE
  	IF(verbose)
  	    sprintf(promptbuf,"\nNewsgroup %s not in .newsrc--add? [yn] ",ngname);

--- 302,314 -----
  	    sleep(2);
  	    return FALSE;
  	}
+ #ifdef SERVER
+ 	if (addnewbydefault) {
+ 		printf("(Adding %s to end of your .newsrc)\n", ngname);
+ 	        ng = add_newsgroup(ngname);
+ 	        do_reloc = FALSE;
+ 	} else {
+ #endif SERVER
  #ifdef VERBOSE
  	IF(verbose)
  	    sprintf(promptbuf,"\nNewsgroup %s not in .newsrc--add? [yn] ",ngname);
***************
*** 296,301
  	    ng = add_newsgroup(ngname);
  	    do_reloc = FALSE;
  	}
  	else {
  	    fputs(hforhelp,stdout) FLUSH;
  	    settle_down();

--- 344,359 -----
  	    ng = add_newsgroup(ngname);
  	    do_reloc = FALSE;
  	}
+ #ifdef SERVER
+ 	else if (*buf == 'Y') {
+ 	    fputs(
+ 	"(I'll add all new newsgroups to the end of your .newsrc.)\n", stdout);
+ 	    addnewbydefault = 1;
+ 	    printf("(Adding %s to end of your .newsrc)\n", ngname);
+ 	    ng = add_newsgroup(ngname);
+ 	    do_reloc = FALSE;
+ 	}
+ #endif SERVER
  	else {
  	    fputs(hforhelp,stdout) FLUSH;
  	    settle_down();
***************
*** 301,306
  	    settle_down();
  	    goto reask_add;
  	}
      }
      else if (rcchar[ng] == NEGCHAR) {	/* unsubscribed? */
  #ifdef VERBOSE

--- 359,367 -----
  	    settle_down();
  	    goto reask_add;
  	}
+ #ifdef SERVER
+       }
+ #endif SERVER
      }
      else if (rcchar[ng] == NEGCHAR) {	/* unsubscribed? */
  #ifdef VERBOSE
***************
*** 453,458
      if (newng < 0) {
        reask_reloc:
  	unflush_output();		/* disable any ^O in effect */
  #ifdef VERBOSE
  	IF(verbose)
  	    printf("\nPut newsgroup where? [%s] ", dflt);

--- 514,525 -----
      if (newng < 0) {
        reask_reloc:
  	unflush_output();		/* disable any ^O in effect */
+ #ifdef SERVER
+ 	if (addnewbydefault) {
+ 	    buf[0] = '$';
+ 	    buf[1] = '\0';
+ 	} else {
+ #endif SERVER
  #ifdef VERBOSE
  	IF(verbose)
  	    printf("\nPut newsgroup where? [%s] ", dflt);
***************
*** 465,470
        reinp_reloc:
  	eat_typeahead();
  	getcmd(buf);
  	if (errno || *buf == '\f') {
  			    /* if return from stop signal */
  	    goto reask_reloc;	/* give them a prompt again */

--- 532,540 -----
        reinp_reloc:
  	eat_typeahead();
  	getcmd(buf);
+ #ifdef SERVER
+ 	}
+ #endif SERVER
  	if (errno || *buf == '\f') {
  			    /* if return from stop signal */
  	    goto reask_reloc;	/* give them a prompt again */
