/*++
/* NAME
/*	termcap.h 5
/* SUMMARY
/*	internal type declarations for termcap functions
/* PROJECT
/*	ms-dos/unix compatibility
/* PACKAGE
/*	termcap
/* SYNOPSIS
/*	#include "termcap.h"
/* DESCRIPTION
/*	termcap.h contains declarations for internal use of the MS-DOS 
/*	implementation of the termcap(3) functions, assuming the
/*	presence of the ANSI.SYS console driver.
/* .nf

 /* function types */

extern tgetent();
extern tgetnum();
extern tgetflag();
extern char *tgetstr();
extern char *tgoto();
extern tputs();

 /* static storage for pc console capabilities */

typedef struct {
    char *name;
    char *cap;
} Cap;

extern Cap _console[];
/* SEE ALSO
/*	termcap(3), Berkeley extensions to UNIX.
/* FILES
/*	ANSI.SYS, ibm pc console driver.
/* AUTHOR(S)
/*	W.Z. Venema
/*	Eindhoven University of Technology
/*	Department of Mathematics and Computer Science
/*	Den Dolech 2, P.O. Box 513, 5600 MB Eindhoven, The Netherlands
/* CREATION DATE
/*	Wed Jan  1 19:01:13 GMT+1:00 1986
/* LAST MODIFICATION
/*	90/01/22 13:57:02
/* VERSION/RELEASE
/*	2.1
/*--*/
