.tr _
.TH PEG 1 "mplex"
.SH NAME
.I "peg"
\- pegboard system
.SH SYNTAX
.RB peg
[\-u|i
.I user
]
[\-c 
.I text
] [-lnqtvx] [+N[m|h|d|w] [H[:[M]][p]] [[[Y]/M]/D] [day] [month mday]
.SH OPTIONS
.TP 12
.BR \-q
suppress heading when reporting, suppress printing of date when updating
.TP
.BR \-u user
print specific user's pegboard entry 
.TP
.BR \-i user
(interrogate) returns a value of 0 if the user is on the pegboard, 1 if not
.TP
.BR \-c text
may be used to add a comment that is printed with the pegboard
.TP
.BR \-t
Log off until tomorrow.
The file ".pegrc" in the invoking users home directory is consulted
to get the time of day the user starts work.
.TP
.BR \-v
Verify only, with this option the time and date arguments are parsed and
the target time is printed.
The pegboard is
.B not
updated nor is the invoker logged off.
.TP
.BR \-x
Remove the invoking users peg.
It is not desirable for this option to work when 
.I peg
is invoked from
certain ttys, specifically modems and some network ports.
This situation occurs when "peg -x" is put in the system
.I .profile,
(or equivalent) and a user dials in on a modem port.
A facility is provided to avoid this in the file
.I /etc/default/peg
( see
.BR FILES
heading below).
.TP
.BR \-n
don't log off after updating pegboard
.TP
.BR \-l
Prints long format
.SH DESCRIPTION
.I peg
maintains a list of users who have logged off the system (a 
.I pegboard
), and dates and times of when they intend return to the site.
The default action when no arguments are given is to print the
pegboard contents on standard output.
The -u option may be used to print the pegboard entry for a
specific user.
.P
Context of arguments is dependent on their format.
Arguments that contain a "/" character are taken to be a date,
and one or two "/"'s may be present.
In the case of one, "MM/DD" is taken as a month and a day.
"YY/MM/DD" is taken as year month and day.
.P
Arguments that contain a ":" are taken as a time, and only one
":" may be present.
"HH:MM" is taken as hour and minute.
A single argument is taken to be an hour in the current day.
Hours are in 24 hour format, unless the argument is suffixed with the
letter "p", in which case the time is assumed to be after 12 noon.
Finally, a full date and time specification may be given by
providing both arguments, in either order.
.P
Numeric arguments may be preceded by a "+", in this case
the argument is taken as a "relative" quantity of time.
There may be an optional modifier after relative arguments,
legal modifiers are "m", "h", "d" and "w".
.TP
.BR m
the offset is taken as a number of minutes from the current time
.TP
.BR h
the offset is taken as a number of hours from the current time (default)
.TP
.BR d
the offset is taken as a number of days from the current date
.TP
.BR w
the offset is taken as a number of weeks from the current date
.P
If a modifier is not given and the argument is in "+n" format,
"n" is assumed to be a number of hours from the current time
(the h modifier is redundant).
.P
Peg recognizes names of days and months as well.
Month names must be followed by a day, ie. Sept 12.
The next occurrence of a day or month/day combination specified is assumed.
So specifying Tue on a Wednesday results in Tuesday of next week being
the specified day.
Similarly, giving a month/day that has already gone by results in that day
in the next year being the specified date.
.P
Any (reasonable) number of arguments may be given.
The effect of multiple arguments is additive, so specifying more
than one absolute date or time will not likely yield expected results.
Mixing one absolute date with some number of relative type arguments
has the effect of adding the relative arguments to the absolute.
.P
After the pegboard is updated (and the -n, -x, -i or -v options
were not given),
all processes in the process group are sent the signal SIGKILL.
.P
.I "peg"
should be run with the "-x" option in the system
.I .profile
so that each time the a user logs onto the system their pegboard entry
is expunged.
.P
.SH EXAMPLES
.TP 20
.BR "peg 99/1/12 14:00"
Log off and peg invoking user to be back January 12, 1999, at 2:00 pm
.TP 20
.BR "peg 2:00p 99/1/12"
Same as above
.TP 20
.BR "peg 3/10"
Log off and peg invoking user to be back March 10 at the current time.
If March 10th has passed then March 10th next year is assumed.
.TP 20
.BR "peg +2"
Log off and peg invoking user to be back 2 hours from current time
.TP 20
.BR "peg 2:00p"
Log off and peg invoking user to be back at 2pm today
.TP 20
.BR "peg +45m"
Log off and peg invoking user to be back 45 minutes from the current time
.TP 20
.BR "peg -t +3d"
Log off and peg invoking user to be back 3 days from current date at the
time found in the ".pegrc" file in their home directory
.TP 20
.BR "peg -t"
Log off and and peg invoking user to be back on the next day and time that has
an entry in the ".pegrc" file.
Days that have no entry will be skipped over.
.TP 20
.BR "peg -t 14"
Log off and peg invoking user to be back 2:00 pm on the next day specified
in their
.I .pegrc
file.
.TP 20
.BR "peg -v +1 +1 +1"
print what time it will be in three hours
.P
.SH FILES
.TP
.BR /etc/default/peg
.TP
.BR /$HOME/.pegrc
These files may have default start times for users in the format:
.P
.nf
.sp
MON 8:00
.sp .5
TUE 8:00
.sp .5
   .
.sp .5
   .
.sp .5
   .
.sp .5
FRI 8:00
SAT -
.sp .5
SUN -
.fi
.P
In addition,
.I "/etc/default/peg"
should contain entries of these formats:
.P
.nf
PEGDIR /usr/spool
.fi
.P
This variable specifies the directory that peg uses for the pegboard.
Each machine associated with a common pegboard should have
an "/etc/default/peg" file, specifying a common directory in
the PEGDIR variable.
The pegbord file in the common directory must be readable and writable
by all users.
.P
.nf
.sp .5
NOUNPEG /dev/ttyxx
.fi
.P
.P
Used to specify tty's that override the action of the
.I "-x"
option.
If peg is invoked from a tty that is listed thusly in
.I "/etc/default/peg"
then the program exits without updating the pegboard.
Ports that are connected to modems should be listed in this manner.
.TP 24
.BR PEGDIR/pegboard.a*
holds a copy of the pegboard when update is in progress
.TP 24
.BR $HOME/.pegrc
default start time of day and days of week
.TP 24
.BR /etc/passwd
Usernames etc. are extracted from this file.
The users name is assumed to be in the "gecos" field of the passwd entry
.SH NOTES
The pegboard is maintained using
.I "user id"
numbers.
.P
Only the first 3 letters of day and month names are significant.
.P
If the real user id of the invoking user is 0 and the
.I "-u"
command line option
is given then the specified users pegboard entry is updated to the date
given.
If the invoking user id is 0 and both the
.I "-u"
and
.I "-x"
options are given then the user name specified as the
.I "-u"
argument is removed from the pegboard.
.P
Week and month names etc. in the command line and tokens and variable names
in the
.I ".pegrc"
and
.I "/etc/default/peg"
files are
.BR not
case sensitive.
.I Arguments
in the
.I /etc/default/peg
and
.I .pegrc
files
.BR are
case sensitive.
.P
Comments are restricted to 64 characters, and must be whitespace or printable.
They are truncated to 32 characters in the short form to avoid
messing up screens (assuming 80 column ttys).
The complete comment may be read by invoking with the "-l" option.
.P
If no PEGDIR variable is found in the
.I /etc/default/peg
file then the default directory used is
.I /usr/spool.

