.ig
$Header: 10.t,v 1.1 88/05/21 18:39:51 papowell Locked $
$log$
..
.NH 1
Troubleshooting
.PP
The diagnostic messages issued by the PLP software
are verbose to the point of being obnoxious.
Usually there is enough information available to determine the exact cause
of problems.
However,
there are times when a bit of explanations do help.
.PP
In order to get detailed diagnostic information from any of the
PLP software,
you can enable diagnostic messages using the
.B -Dn
option to set debugging to level
.IR n .
Level 0 disables diagnostics,
level 3 is chatty,
level 5 is pretty verbose,
and level 9 is absolutely everthing.
.NH 2
LPD
.PP
When lpd is started,
it will try and open a log file.
If it cannot,
it will log to /dev/null.
However,
important errors are logged using the
.IR syslog (8)
facility.
You can specify a log file using the
.B "-L filename"
option to lpd;
.B "-L -"
will cause it to log error messages to standard output.
.PP
Each spool queue has an associated log file as well,
as does each server for a spool queue.
Most of the PLP software will also use
.IR syslog (8)
for important messages,
or log them to
.L /dev/console
if syslog is not available.
.NH 2
LPR
.SH
lpr: \fIprinter\fP\|: unknown printer
.IP
The
.I printer
was not found in the
.I printcap
database.
Usually this is a typing mistake;
however,
it may indicate a missing or incorrect entry in the printcap file.
.SH
lpr: \fIprinter\fP\|: jobs queued, but cannot start server.
.IP
The connection to 
.I lpd
on the local machine failed. 
This usually means the lpd process started at
boot time has died or is hung.
Use the
.L "lpc lpd"
command to check that the
.I lpd
process is running.
If it appears to be absent or not responding,
you restart the lpd process using the following commands.
.DS
.L
.SM
% /usr/lib/lpd
.DE
.NH 2
LPQ
.SH
waiting for \fIprinter\fP to become ready (trying since ????)
.IP
The printer device could not be opened by the server. 
This can happen for a number of reasons,
the most common being that the printer is turned off-line.
This message can also be generated if the printer is out
of paper, the paper is jammed, etc.
The actual reason is dependent on the meaning
of error codes returned by system device driver. 
Not all printers supply sufficient information 
to distinguish when a printer is off-line or having
trouble (e.g. a printer connected through a serial line). 
Another possible cause of this message is
some other process, such as an output filter,
has an exclusive open on the device.  Your only recourse
here is to kill off the offending program(s) and
restart the printer with
.IR lpc .
.SH
connecting to <host> (trying since ????)
.IP
The server is trying to connect to the remote site and nothing has happened.
First indication that the network is dead,
or the host you are trying to reach is down.
If the remote host is up,
.I lpd
on the remote machine is probably dead or
hung and should be restarted.
.SH
warning: no server present
.IP
There are entries in the spool queue,
but no server exists.
This normally occurs only when the server has unexpectedly died.
The error log file for the spool queue should be checked for a
diagnostic from the deceased process.
Use the lpc restart command to start a server.
