 #
#**********************************************************************
# THERE MUST BE A SPACE in the first character of the first line.
#**********************************************************************
#
#			NOTICE STATEMENT
#
# This code was developed by IBM Corporation.  Copyright is disclaimed.
#
# IBM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS CODE.  IN NO EVENT
# WILL IBM BE LIABLE FOR ANY DAMAGES, LOST PROFITS, OR LOST SAVINGS.
#
#	"@(#) This code was developed by IBM Corporation. "
#	"@(#) Copyright is disclaimed. "
#
#**********************************************************************
#  Written by:  Barry Books
#**********************************************************************

# this awk script is a state machine that find structure definetions
# it outputs the structure name and each element in the structure
# in the form
#NAME ELEMENT_TYPE

#the order of expressions to find is important

BEGIN {
	STRUCT=0;
	OPEN = 0;
	SEMI = 1;
	TYPEDEF = 0;
}

#ignore a few keywords
/unsigned/	{
	next;
	}

/extern/	{
	next;
	}

/signed/	{
	next;
	}

#braces signal begining structure elements
/{/	{
		OPEN += 1;
		SEMI = 1;
		next;
	}

/}/	{
		OPEN -= 1;
		next;
	}

#semi colon signals end of statement
#now we can look for a struct
/;/	{
		SEMI = 1;
		next;
	}

# this matches anything
#typedefs look like structures so weed them out
# if struct == 1 just print the name of the structure
# if struct == 2 print the name and the element type
/^/	{
		if ( TYPEDEF == 1 )
		{
			if ( OPEN == 0 )
			{
				if ( SEMI == 1 )
					SEMI = 0;
					TYPEDEF = 0;
			}
			next;
		}
		if ( STRUCT == 1 )
		{
			printf("%s\n",$1);
			STRUCT = 2;
			NAME = $1;
			next;
		}
		if ( STRUCT == 2 )
		{
			if ( OPEN == 1 )
			{
				if ( SEMI == 1 )
				{
					printf("%s %s\n",NAME,$1);
					SEMI = 0;
				}
				
			}
			if ( OPEN == 0 )
			{
				STRUCT = 0;
			}
		}
	}

# set flags for keywords
/typedef/	{
	TYPEDEF=1;
	next;
	}

/struct/	{
	STRUCT=1;
	next;
	}


