


                      Report on POSIX Include File Conformance

          Overview
            This document reports objects in include files which do  not
            meet  the POSIX 1003.1 specification.  This is intended as a
            tool more than a conformance test and is distributed to  aid
            in  reaching a consensus on what should be and should not be
            included in a POSIX 1003.1 conforming include file.

          Requirements
            The standard specifies the contents of include files in  two
            ways  first  by  stating  items  which  must be included and
            second allowing for other items as long as they meet certain
            criteria.   No  other objects are allowed when _POSIX_SOURCE
            is defined ( 1003.1 2.82. ).  The following  is  a  list  of
            objects not specifically mentioned in the standard but still
            allowed.
                 1. All external identifiers that  begin  with  an
                      underscore  are reserved ( POSIX 1003.1 2.8.1
                      ).
                 2.  All  other  identifiers  that  begin  with  an
                      underscore  and either an uppercase letter or
                      another  underscore  are  reserved  (   POSIX
                      1003.1 2.8.1 ).
                 3. Namespaces reserved by the C Standard are  also
                      reserved ( POSIX 1003.1 2.8.1 ).
                 4. Types ending in _t are reserved ( POSIX  1003.1
                      2.6 ).
                 5. Implementations may add members to a structure or
                      union  (  POSIX 1003.1 2.8.2 ). These members
                      must have either standard C  types  or  types
                      ending in _t ( implied by 4 ).
                 6. Additional macro definitions, beginning with  E
                      and a digit or E and an upper-case letter may
                      also be specified  by  the  implementation  (
                      ANSI 4.1.3 ).
                 7. Additional signals and pointers to  undeclarable
                      functions,    with   definitions   beginning,
                      respectively, with letters SIG and an  upper-
                      case  letter  or  with SIG_ and an upper-case
                      letter  may  also   be   specified   by   the
                      implementation ( ANSI 4.7 ).
                 8. Headers may be included in any order  and  more
                      than once with no effect different from being
                      included only once,  except  for  assert.h  (
                      ANSI 4.1.1 ).

          Interpreting The Results
            The results from each include file are  divided  into  three
            categories:  defines, structures and typedefs. If an include
            file is missing it is marked missing and the tests for  that
            include file are skipped.

            Defines
            The defines section  contains  four  columns.   The  "extra"
            column  contains defines not allowed by the standard.  These
            items should  be  moved  outside   the  scope  _POSIX_SOURCE
            feature  test  macro.  The "other" column contains items not
            specifically mentioned for this particular include file  but
            allowed  by  the  standard.   The  "missing" column contains
            items required by the standard but not found in the  include
            files.   This  column is used as a debugging aid as the test
            suites can find these problems quite easily.  You should not
            find  items  in  this column that are in your include files.
            The  last  column  is  the  "macros"  column.   This  column
            contains a list of functions that are defined as macros.

            Structures
            The structure  section  contains  two  columns.   The  first
            column  contains  any  structures not specified by the POSIX
            1003.1 or the ANSI C standard.  The second  column  contains
            structure elements not allowed by the 1003.1 standard.

            Typedefs
            The typedef section is similar to the define  section.   The
            first  column  contains  typedefs  not allowed by the 1003.1
            standard.  The next column  contains  typedefs  required  in
            other  include  files and the final column contains typedefs
            that are missing.

