%%$Header: pps.pro,v 0.0 88/06/22 05:22:26 on Rel $

% General macros ( should be builtins :-)

/inch { 72 mul } def
/min { 2 copy gt { exch } if pop } def
/max { 2 copy lt { exch } if pop } def
/curx { currentpoint pop } def
/cury { currentpoint exch pop } def

% Show a string, right justified, and move to its beginning.
/rshow {	% string
	dup stringwidth pop neg		% string width, negative
	dup 0 rmoveto
	exch show
	0 rmoveto			% to beginning of string
} def

% Commands

/fname {	% string fname -
	/filename exch def
	/pageno 0 def
	/lineno 1 def
	1 f
} def

/fdate {	% string fdate -
	/date exch def
} def

/funct {	% string funct -
	gsave
	C titlesize scalefont setfont

	fbase
	dontstep ( ) stringwidth pop sub cury min
	moveto
	90 rotate
	rshow
	/dontstep curx ( ) stringwidth pop sub def	% Yech!

	grestore
} def

/t {	% ntabs t -
	{ 
		curx 1 add
		tabwidth div ceiling
		tabwidth mul
		dup rlimit gt {
			pop
			lcont marshow
			1 nl
		} {
			cury moveto
		} ifelse
	} repeat
} def

/nl {	% nlines nl -	(internal use)
	{
		cury dy add
		dup
		highth neg le {
			pop
			1 f
		} {
			0 exch
			moveto
		} ifelse
	} repeat
} def

% Show a string in margins, if there is enough room.
/marshow {	% string marshow -	(internal)
	cury dight add dontstep lt {
		gsave

		C setfont
		width cury moveto
		rshow
		/dontstep cury def

		grestore
	} if
} def

/n {	% nlines n -
	dup lineno add
	/lineno exch def

	nl
	% Bug: does not number blank lines!
	lineres 0 gt {
		lineno lineres mod 0 eq {
			lineno maxline cvs marshow
		} if
	} if
} def

/np {	% npages np -	(internal)
	totalpage 0 gt {
		showpage
	} if
	/totalpage totalpage 1 add def
	margin ury translate
	0 0 moveto
} def

/f {	% npages f -
	{
		np
		/pageno pageno 1 add def
		titleput
		pageno 1 gt {
			lineno maxline cvs marshow
		} if
	} repeat
} def
	
/s {	% string font s -
	setfont

	dup stringwidth pop
	curx add
	rlimit gt {
		lcont marshow
		1 nl
	} if
	show
} def

% This is a halfhearted attempt.
% The ultimate thing is a printf() like specification from argv[].
/titleput { % - titleput -
	0 dy 3 mul rmoveto	% space for title

	C setfont
	date show

	C titlesize scalefont setfont

	width cury moveto
	pageno maxpage cvs rshow

	curx (  ) stringwidth pop sub rlimit min
	cury moveto
	currentdict /header known {
		header
	} {
		filename
	} ifelse rshow

	/dontstep cury def
	0 cury dy 2 mul add moveto
} def

% Init macro - must be called after definitions are changed.

/ppsinit { % - ppsinit -
	gsave

	/dy	 1 inch lpi div neg def
	fonts {
		findfont dy neg progsize mul scalefont def
	} forall

	% Paper limits
	initclip clippath pathbbox
	/ury exch def
	/urx exch 5 sub def	% margin may be set wrong
	/lly exch def
	/llx exch def

	% Line numbers are right justified to width.
	% We force a newline when rlimit is exceeded by text.
	/highth ury lly sub dy add def
	/margin llx 1 inch add def
	/width urx margin sub def

	% UnderlinePosition or FontBBox may be missing...
	% Measure sizes of things we print in margins.
	C setfont
	/rlimit width maxline stringwidth pop sub def	% right limit

	newpath 0 0 moveto
	(670) true charpath flattenpath pathbbox
	/dight exch def					% digit ht
	pop pop pop

	C titlesize scalefont setfont
	newpath 0 0 moveto
	(qypfgj\(\),_) true charpath flattenpath pathbbox
	pop pop exch pop width add
	/fbase exch def					% function base

	I setfont
	/tabwidth (n) stringwidth pop tabstop mul def

	/totalpage 0 def

	grestore
} def

/ppsdone {
	showpage
} def

% Page style -- may be modified.

/tabstop 8 def  	% Charcters per tabstop
/lineres 10 def		% Line numbering resolution
/maxline (9999) def	% Maximum lines / file
/maxpage (999) def	% Maximum pages / file

/lpi 7 def		% Lines per inch
/progsize 70 72 div def	% Program point size / line spacing
/titlesize 1.2 def	% Title point size / program point size

% Default fonts -- need not be fixed pitch.
/fonts 4 dict def
fonts begin
	/C /NewCenturySchlbk-Roman def	% Comments
	/K /Courier-Bold def		% Keywords
	/S /Courier-Oblique def		% Strings
	/I /Courier def			% The rest
end

/lcont (\274) def	% Line continuation char (ellipsis)
%%EndProlog
