      program normal
C
C This program demonstrates a few more features.
C
      real x(61), y(61), xx(23),yy(23)
C
C Note that you have access to all the parameters used in
C plotting in your program if you declare a common block
C as shown right here. If you know how to cut and paste,
C this should be a snap because you can use the declaration
C in the routine PSPVALS.
C
      real xmin,xmax,ymin,ymax,xr,yr
      real pxoff,pyoff,xvoff,yvoff,xnoff,ynoff,toff
      real plwid,plht,blwid,tickl,tickw,orient,size
      real xnfsize,ynfsize,tfsize,xvfsize,yvfsize
      integer iuno,ptype,nxticks,nyticks
      logical boxit,clines,tickf,tickh,tickq,fill,sxvals,syvals
      character*80 rec,xname,yname,title,dashp,xnfont,ynfont,tfont,
     +xvfont,yvfont
      character vnames(0:42)*10, descs(0:42)*60
      common/plotcom/iuno,xr,yr,rec,vnames,descs,
     +xmin,xmax,ymin,ymax,pxoff,pyoff,xvoff,yvoff,xnoff,ynoff,toff,
     +plwid,plht,blwid,tickl,tickw,orient,size,
     +xnfsize,ynfsize,tfsize,xvfsize,yvfsize,
     +ptype,nxticks,nyticks,
     +boxit,clines,tickf,tickh,tickq,fill,sxvals,syvals,
     +xname,yname,title,dashp,xnfont,ynfont,tfont,xvfont,yvfont
      save /plotcom/
C
C First let us do the usual stuff.
C
      c = 1./sqrt(2.*3.141592654)
      do 10 i=-30,30
         x(i+31)= i/10.
10       y(i+31) =c*exp(-0.005*i*i)
      open(1,file='plot4.ps')
      call psini(1)
C
C We need to set a few parameters for the plot.
C We will bypass the usual method of opening files
C and set the values right here in this program.
C But first, we will set the default values so that
C we don't have too many parameters to mess with.
C
      call psdef()
C
C Now let us set the parameters. Our plot shall be 1.25 inches
C away from the left edge of the paper and 6.5 inches up from
C the bottom edge. The plotting box will be 2.5 x 2.5 sq inches.
C
C  pxoff: the x-offset of the plot (in).                     
      pxoff = 1.5
C  pyoff: the y-offset of the plot (in).                     
      pyoff = 6.5
C  plwid: Width of plot (in).                                
      plwid = 2.5
C  plht: Height of plot (in).                                
      plht  = 2.5
C
C We will name the two axes and give a title to the plot.
C
C  xname: Name for x-axis.                                   
      xname = 'ABCISSA'
C  yname: Name for y-axis.                                   
      yname = 'ORDINATE'
C  title: Title for plot.                                    
      title = 'Figure 1. The Normal Density Curve.'
C
C We also want to control the x and y value increments shown
C at the ticks.
C
C  xmin: the min. x value used in scaling the plot.          
      xmin = -3.0
C  xmax: the max. x value used in scaling the plot.          
      xmax = 3.0
C  ymin: the min. y value used in scaling the plot.          
      ymin =  0.0
C  ymax: the max. y value used in scaling the plot.          
      ymax = 0.5
C  nyticks: Number of ticks for y-axis.                      
      nyticks = 5
C
C Finally we want to prevent the routine PSPLOT from
C finding the minimum and maximum of the arrays x and y
C because it will overwrite our values. So we give PSPLOT
C a negative value for uno1.
C
      call psplot(x,y,61,-2,3)
C
C We'll shade some areas of the plot. First, extract the path 
C to be shaded.
C
      do 20 i=-10,10
        xx(i+12) = x(i+31)
20      yy(i+12) = y(i+31)
        xx(1) = xx(2)
        yy(1) = ymin
        xx(23) = xx(22)
        yy(23) = ymin
C
C Now shade it. Note the value .true. for telling PSFILLP
C that the x's and y's represent values in the the original
C units of x's and y's, i.e. these values should to be scaled
C appropriately before use. The grey value used for shading
C is 0.5 (0 = black, 1 = white).
C
      call psfillp(xx,yy,23,0.5,.true.)
C
C  Now for a few more plots on the page with
C  various changes.
C
      pxoff = 5.0
      pyoff = 6.5
      ymin =  0.0
      ymax = 1.0
      nxticks = 6
      title = 'Figure 2. The Normal Density Curve.'
      boxit = .true.
      call psplot(x,y,61,-2,3)
C
      pxoff = 1.5
      pyoff = 2.25
      ymin =  0.0
      ymax = 0.5
      title = 'Figure 3. The Normal Density Curve.'
      ptype = 3
      size = 2.0
      boxit = .false.
      tickh = .false.
      tickq = .false.
      call psplot(x,y,61,-2,3)
C
      pxoff = 5.0
      pyoff = 2.25
      ymin =  0.0
      ymax = 0.5
      xname = ' '
      yname = ' '
      sxvals = .false.
      syvals = .false.
      title = 'Figure 4. The Normal Density Curve.'
      ptype = 1
      size = 0.5
      clines = .false.
      tickf = .false.
      dashp = '[10] 5 '
      call psplot(x,y,61,-2,3)
      call pspage
      call psfini
      end
