.TH RU L Feb/89 local 
.UC
.SH NAME
ru \- compact lists of users on all "visible" systems
.SH SYNOPSIS
.B "ru [-acdmrsuw] [-D domain] [-h host ... | -l user ...]"
.SH DESCRIPTION
.I Ru
lists the login names of the users currently on all visible systems.
.SH Options
.IP -a
list all users, regardless of their login idle time (\fIrwho(1)\fP-inspired).
.IP -c
show a count for multiply-logged users.
.\"When combined with -s, include a count of hosts in each domain.
.IP -d
list hosts alphabetically, regardless of their sub-domains
.\"group hosts within their sub-domains
(forces -s option).
.IP -m
show multiple logins (overrides -c option).
.\"squeeze (ignore) multiple logins.
.IP -r
produce \fIrwho(1)\fP-style output (forces -s option).
.IP -s
list users host-by-host instead of domain-by-domain.
.\"list users domain-by-domain instead of host-by-host.
.IP -u
display uptimes (see \fIruptime(1)\fP) (forces -s option).
.IP -w
break lines before they wrap around the screen.
.\"allow lines to wrap around (ie. single line per heading).
.IP "-D domain"
list only users logged on hosts in the given domain.
.IP "-h host ..."
list only users logged on to the specified host(s).
.IP "-l user ..."
list only hosts with the given user(s) (forces -s option).
.PP
The -h and -l options are mutually exclusive since they
both use the remaining arguments as a search list.
Either option should be followed by at least one name.
.PP
Any system for which data can be found in the
.I rwhod(8c)
spooling directory is considered to be a "visible system".
.SH FILES
/usr/spool/rwho/whod.*
.SH SEE ALSO
users(1), rwho(1C), rwhod(8C), ruptime(1C)
.SH HISTORY
Originally created by splicing pieces of
.I rwho(1)
source into
.I users(1)
source.
Rewritten to try to clean up the hacked code
and to make it easier to add (or delete) options.
.PP
Bug fixes, enhancements and help provided by
 nispa@hutcs.hut.fi <Tapani Lindgren>,
 kusalik@damask.uucp,
 pkh%cs.nott.ac.uk@nss.cs.ucl.ac.uk <Kevin Hopkins>,
 lamy@ai.toronto.edu <Jean-Francois Lamy>,
 moraes@ai.toronto.edu <Mark Moraes>
.SH BUGS
With the -h option,
.I ru
doesn't care if a host's spool file hasn't
been updated within the last 5 minutes.
.sp
This might be considered a good example of option overload.
.SH CONTACT
pkern@utcsri.uucp or pkern@csri.toronto.edu
