.NH 1
SUGGESTED READING
.PP
This section suggests some alternate sources of information pertaining to
the security and administration of the
.SM UNIX
operating system.
.sp
.in .5i
.ti -.5i
.I "\s-1UNIX\s0 System Administration Handbook"
.ti -.5i
Evi Nemeth, Garth Snyder, Scott Seebass
.ti -.5i
Prentice Hall, 1989, $26.95
.LP
This is perhaps the best general-purpose book on
.SM UNIX
system administration currently on the market.
It covers Berkeley
.SM UNIX ,
.SM OS , Sun
and System V.
The 26 chapters and 17 appendices cover numerous topics,
including booting and shutting down the system,
the file system,
configuring the kernel,
adding a disk,
the line printer spooling system,
Berkeley networking,
.I sendmail ,
and
.I uucp .
Of particular interest are the chapters on running as the super-user,
backups,
and security.
.sp
.in .5i
.ti -.5i
.I "\s-1UNIX\s0 Operating System Security"
.ti -.5i
F. T. Grammp and R. H. Morris
.ti -.5i
\s-1AT&T\s0 Bell Laboratories Technical Journal
.ti -.5i
October 1984
.LP
This is an excellent discussion of some of the more common security
problems in
.SM UNIX
and how to avoid them,
written by two of Bell Labs' most prominent security experts.
.sp
.in .5i
.ti -.5i
.I "Password Security: A Case History"
.ti -.5i
Robert Morris and Ken Thompson
.ti -.5i
Communications of the \s-1ACM\s0
.ti -.5i
November 1979
.LP
An excellent discussion on the problem of password security,
and some interesting information on how easy it is to crack
passwords and why.
This document is usually reprinted in most vendors'
.SM UNIX
documentation.
.sp
.in .5i
.ti -.5i
.I "On the Security of \s-1UNIX\s0"
.ti -.5i
Dennis M. Ritchie
.ti -.5i
May 1975
.LP
A discussion on
.SM UNIX
security from one of the original creators of the system.
This document is usually reprinted in most vendors'
.SM UNIX
documentation.
.sp
.in .5i
.ti -.5i
.I "The Cuckoo's Egg"
.ti -.5i
Clifford Stoll
.ti -.5i
Doubleday, 1989, $19.95
.LP
An excellent story of Stoll's experiences tracking down the German crackers
who were breaking into his systems and selling the data they found to the
.SM KGB .
Written at a level that nontechnical users can easily understand.
.sp
.in .5i
.ti -.5i
.I "System and Network Administration"
.ti -.5i
Sun Microsystems
.ti -.5i
May, 1988
.LP
Part of the
.SM OS "" Sun
documentation,
this manual covers most aspects of Sun system administration,
including security issues.
A must for anyone operating a Sun system,
and a pretty good reference for other
.SM UNIX
systems as well.
.sp
.in .5i
.ti -.5i
.I "Security Problems in the \s-1TCP/IP\s0 Protocol Suite"
.ti -.5i
S. M. Bellovin
.ti -.5i
\s-1ACM\s0 Computer Communications Review
.ti -.5i
April, 1989
.LP
An interesting discussion of some of the security problems with the
protocols in use on the Internet and elsewhere.
Most of these problems are far beyond the capabilities of the average
cracker,
but it is still important to be aware of them.
This article is technical in nature,
and assumes familiarity with the protocols.
.sp
.in .5i
.ti -.5i
.I "A Weakness in the 4.2\s-1BSD\s0 \s-1UNIX\s0 \s-1TCP/IP\s0 Software"
.ti -.5i
Robert T. Morris
.ti -.5i
\s-1AT&T\s0 Bell Labs Computer Science Technical Report 117
.ti -.5i
February, 1985
.LP
An interesting article from the author of the Internet worm,
which describes
a method that allows remote hosts to ``spoof'' a host into believing they
are trusted.
Again,
this article is technical in nature,
and assumes familiarity with the protocols.
.sp
.in .5i
.ti -.5i
.I "Computer Viruses and Related Threats: A Management Guide"
.ti -.5i
John P. Wack and Lisa J. Carnahan
.ti -.5i
National Institute of Standards and Technology
.ti -.5i
Special Publication 500-166
.LP
This document provides a good introduction to viruses,
worms,
trojan horses,
and so on,
and explains how they work and how they are used to attack computer systems.
Written for the nontechnical user,
this is a good starting point for learning about these security problems.
This document can be ordered for $2.50 from the U. S. Government Printing
Office,
document number 003-003-02955-6.
.in 0
