.de Mc
.nr L1 \\n(LL*10/21
.if \\n(.$ .nr L1 \\$1n
.nr NQ \\n(LL/\\n(L1
.if \\n(NQ<1 .nr NQ 1
.if \\n(NQ>2 .if (\\n(LL%\\n(L1)=0 .nr NQ -1
.if !\\n(1T \{\
.	BG
.	if n .sp 4
.	if t .sp 2
.\}
.if !\\n(NX .nr NX 1
.if !\\n(NX=\\n(NQ \{\
.	RT
.	if \\n(NX>1 .bp
.	mk
.	nr NC 1
.	po \\n(POu
.\}
.if \\n(NQ>1 .hy 12
.nr NX \\n(NQ
.nr CW \\n(L1
.ll \\n(CWu
.nr FL \\n(CWu*11u/12u
.if \\n(NX>1 .nr GW (\\n(LL-(\\n(NX*\\n(CW))/(\\n(NX-1)
.nr RO \\n(CW+\\n(GW
.ns
..
.de C
.nr PQ \\n(.f
.if t .ft 9
.if "\\$1"" .if n .ul 1000
.if !"\\$1"" .if n .ul 1
.if t .if !"\\$1"" \&\\$1\f\\n(PQ\\$2
.if n .if \\n(.$=1 \&\\$1
.if n .if \\n(.$>1 \&\\$1\c
.if n .if \\n(.$>1 \&\\$2
..
.ND
.IZ
.nr PS 11
.ps \n(PS
.nr VS 13
.vs \n(VSp
.nr LL 7i
.ll 7i
.nr HM -0.1i
.nr PO -0.3i
.po \n(POu
.ds [. \f1[
.ds .] ]\fP
.ds Rf References
.mc
.hw con-fig-u-ra-tion
.ds CH
.ds CF
.ds Un \\s-1\\fHU\\s-2NI\\s+2B\\s-2ASE\\fR\\s+3
.ds Da \\s-2\\fHDAMOKLES\\fR\\s+2
.ds sh \\s-1\\fHshape\\fR\\s+1
.sp -0.5i
.ps 16
.vs 18
.nf
.ce 3
An Integrated Toolset for Engineering Software Configurations\(dd
.fi
.FS
\(dd in \fIProceedings of the ACM SIGSOFT/SIGPLAN Software Engineering
Symposium on Practical Software Development Environments\fR
.br
Boston MA, 28-30 November 1988
.br
ACM SIGSOFT SE Notes Vol.13-No.5 / ACM SIGPLAN Notices Vol.24-No.2, pp. 191-200
.FE
.vs \n(VSp
.ps \n(PS
.sp 0.3i
\fIAxel Mahler\fR and \fIAndreas Lampen\fR
.br
Technische Universit\*:at Berlin, West-Germany
.sp 25p
.Mc
.LP
\fBAbstract\fR
.nr PS 10
.ps \n(PS
.nr VS 12
.vs \n(VSp
.PP
Configuration management in toolkit oriented software development
environments (SDE), such as the
.UX
system, is a long standing nuisance. Mostly, one has to
face the choice between poorly or not at all integrated, independent
tools, or highly integrated, most specialized, and often language
dependent environments. The first choice offers very limited support
for a complex task that needs a broad informational basis. The second
choice often takes away the programmers' most cherished tools, forces
him to adopt some different work discipline, and thereby eventually
restricts his creativity. The toolset described in this paper integrates
a dedicated version control system and \*(sh, a significantly enhanced
Make [Feld79a] 
program, on the basis of a common object model. This object model 
comprises multiple versions of software objects as well as conventional
file system objects. Taking this approach made it possible to have
a sufficiently integrated toolsystem for engineering software configurations
while retaining the flexibility of the basic toolbox philosophy, permitting
the use of 'off-the-shelf' tools, e.g. editors or compilers.
.ps 12
.nr PS 11
.ps \n(PS
.nr VS 13
.vs \n(VSp
.NH 1 
Introduction
.PP
Configuration management is a management technique, designed
to control very large development and maintenance projects.
As military and government institutions played a principal role 
in the establishment of configuration management, the related
terminology is precisely defined in an ANSI standard [IEEE83a].
An in-depth discussion of the underlying concepts can be found in [Bers80a].
.PP
Triggered off by the surge of interest in programming environments (PE)
during the last few years, the term \fIsoftware configuration
management\fR (SCM) made its way from the management domain
towards
the software engineering and development domain. Today, there are a
number of PEs with built-in SCM support (e.g. DSEE, Adele,
ISTAR [Lebl84a,\|Estu86a,\|Dows86a]).
However, it is not clear whether SCM is more of a development or
management task.  In particular, we suspect that strongly
management-oriented approaches to SCM are likely to produce red tape,
tending to stand in the (programmer's) way, and consequently
discourage their systematic application.  On the other hand, strongly
de\%vel\%op\%ment-o\%ri\%en\%ted SCM tools often perform a brilliant job in
supporting the programmer, but produce little or no usable information
for project management. To avoid confusion of management-oriented
and development-oriented interpretation of SCM, we'd rather prefer
the term \fIsoftware configuration engineering\fR (SCE) to emphasize
the more technical aspects as version control, configuration identification,
and system building.
.PP
Our toolsystem for engineering of software configurations 
consists of
an \fIobject base\fR for attributed software objects,
a dedicated \fIversion control system\fR, and \*(sh, a significantly
enhanced Make program.  Enhancements include full access to the
object base, and support of \fIconfiguration rules\fR which
control the selection process for component objects during
identification, build or rebuild of system configurations. 
.PP
Since integration of version control was a major objective for our
system, we had to face the need for an object identification scheme
that goes beyond the usual way of specifying just name and type.
As a consequence, we began to design an object base for attributed
software objects [Lamp88a] 
that allows to attach any number of attributes to software objects,
and introduces a much more generalized scheme
for object identification.  The object base's name, \fIattributed 
filesystem\fR (AFS), mirrors the basic idea, to enhance the regular
.UX
filesystem by supporting more fileattributes than
just a name and the information stored in the inode.
The AFS comprises concepts for
version control, support of variants or status models for example. Furthermore,
it helps to abstract from the particular underlying data storage
system. For the AFS application writer it makes no difference whether it is an
ordinary filesystem or a dedicated database system like e.g. \*(Da [Ditt86a].
.NH 2
Related Systems
.PP
At first glance, the user-level appearance of the \*(sh toolkit resembles
a combination of Make and a version control system such as
SCCS [Roch75a]
or RCS [Tich85a].
Over the last years some unsatisfying attempts have been made to integrate 
Make with source code control systems [Nick83a,\|AUGM83a].
The CMS/MMS tool \*([.DECC84a,\|DECM84a\*(.]
under VAX/VMS
corresponds to \fIAugmented Make\fR and SCCS. CMS and SCCS not only 
provide a user command interface, but also give application programs
direct access to the version control facilities through a procedural
interface. However, despite availability of these interfaces, 
neither Make nor MMS are build on top of them and more complex
configuration management applications find a hard limit in this lack
of integration.
\*(sh's AFS interface can be seen as an extended and more generalized interface
to the version control system. \*(sh and the related version control
commands are entirely build on top of this interface.
.PP
Besides these toolbox oriented systems, there are some highly 
specialized configuration management tools that are usually part of 
a software engineering environment.
Because they are part of an overall tool concept that also includes
programming languages, the functionality of these tools is often 
more comprehensive in terms of consistency enforcement. Cedar's
System Modeller [Lamp83a]
and the Gandalf version control facility [Habe82a]
fall into this category.
An interesting approach to the determination of system configurations
based on sets of software objects and functions to model the relations
between them is presented in Jasmine [Marz86a].
.PP
Common to all of the systems mentioned above is that a system description 
document (\fIsystem model\fR) is employed to define components and
overall architecture of a software system.
In contrast to that, the Adele configuration manager \fIderives\fR a
configuration from a system description
in terms of \fIdesired characteristics\fR 
rather than some sort of component list. The description
is evaluated against a \fImodule dependency graph\fR and \fImanuals\fR
(module descriptions) stored in a database of programs.
The Odin System [Clem86a] 
in turn uses a (compiled) knowledge base, called \fIderivation graph\fR,
describing derivative relationships between \fIdocument types\fR,
and associated tools to perform necessary derivations 
in order to obtain a requested object.
Odin integrates remarkably well with the standard 
.UX
tool environment
and can be used to construct comprehensive special purpose environments
from existing tools [Wait88a].
.PP
Finally, DSEE
represents to the authors' knowledge the most
outstanding configuration management system so far. It is based on system
models, describing the version-independent structure of a software
system and \fIconfiguration threads\fR, describing the version
requirements that must be met by the elements of a configuration to be
identified. DSEE combines configuration management with sophisticated
project support facilities, enabling large programmer teams to cooperate
over a (local or wide area) computer network.
.PP
In the design of \*(sh, we tried to adopt a number of the best
concepts mentioned above. Namely Make, Adele and DSEE had a strong
influence on the design of the \*(sh toolkit.  Despite the integration
of the toolkit itself, care has been taken to smoothly fit the SCE
system into the standard
.UX
environment. The entry cost for new
users (in terms of initial learning effort) is very low. The system may be
used as just a friendly version control tool, an upward compatible 
replacement for Make, or an intelligent integration of both.
Utilization of the toolkit can be gradually extended up to a network
based project support environment, employing a number of programmer
teams working on large software development and maintenance projects.
.PP
The simple,
.UX-like
nature of the toolkit's basic user interface
offers a broad range of possibilities to create dedicated user
interfaces that provide an integrated, problem oriented view of the
SCE system.  Currently in the works are an implementation of a
specially tailored SCE shell on the basis of \*(Th [H\*u87a]
(a graphical user interface system), and an implementation of a SCE-tool for
the \fIX Window System\fR.
.PP
The rest of this paper describes the \*(sh program and AFS, the
object base on top of which \*(sh and the version control commands
are built. Also, a number of problems,
encountered while trying to introduce general support for the 
handling of \fIvariants\fR, and implementing AFS on top of \*(Da,
will be discussed.
.NH 1
The Shape Toolkit
.PP
The user interface of the SCE toolkit consists of a set of commands for 
version control, project interaction, and the shape program itself.
The appearance of the version control commands is not unlike to
RCS' user interface. There are funtions to save and restore
an object version (\fCsave/retrv\fR), to manipulate object histories
and attributes of object versions (\fCvadm [ -delete | -setattr | -chmod 
\fR(etc.) \fC]\fR), as well as a funtion to obtain information about 
the contents of the object base (\fCvl\fR, gives a \fCls(1)\fR-like 
view of the object base).
.PP
The toolkit supports a basic project organization scheme that
distinguishes private workspaces for individual developers, and a
central library that is shared by the project team. The project
library is administered by the system integrator. The toolkit provides
functions for project interaction, controlling concurrent development
(\fIobject locking\fR), and orderly submission of software objects.
\fCresrv\fR (developer) attempts to reserve the update privilege for a
document history, \fCsbmit\fR (developer) submits a work result to be
included into the next release of a system, \fCaccpt\fR (system
integrator) accepts a submitted document version and gives it an
official, publically accessible state, and \fCrject\fR (system
integrator) denies a submitted work result the official state and
sends a corresponding message to the submitting programmer.
.PP
Version control and project interaction are functionally supported 
by a built-in general version status model. The states \fCbusy\fR,
\fCsaved\fR, \fCproposed\fR, \fCpublished\fR, \fCaccessed\fR, and 
\fCfrozen\fR are not only intended to say something about the relative
quality of a particular object version, but also reflect whether an
object version is in a developer's private experimentation domain, or
in the project's official domain, where it is visible and accessible
to the entirety of a project team. A more detailed description of the
version control system can be found in [Mahl88a].
.PP
The first implementation of \*(sh resembles Make.  As
in Make, the configuration process is controlled by a system
description document.
Unlike Make, however, \*(sh operates on objects in an object base
rather than
.UX
filesystem objects.
When building a certain configuration,
\*(sh searches the object base for appropriate
versions of a system's component objects, installs them temporarily
as
.UX
filesystem objects (regular files), eventually invokes some of
.UX's
standard tools on them, and stores the resulting \fIderived objects\fR
in the object base.
Accordingly, the most significant improvement with respect to Make is
the introduction
of \fIselection rules\fR into the
description document, the \fIShapefile\fR. Selection rules control the 
selection process for component versions during identification, build or
rebuild of system configurations. 
.KS
.LP
The system description document used by \*(sh consists 
of four basic components:
.in +0.2i
.IP \(bu 0.2i
system description
.IP \(bu
selection rules
.IP \(bu
transformation rules, and
.IP \(bu
variant definitions.
.in -0.2i
.KE
.LP
While the syntax for the
system description part is the same as for Makefiles,
the remaining \*(sh-file sections have a slightly different 
syntax from Makefiles and must be preceded and ended by
special comment sequences (\fC\s-1#%\ RULE-SECTION, #%\ VARIANT-SECTION, 
#%\ END-RULE-SECTION\s+1\fR a.s.o.).
.NH 2
Selection of Component Objects
.PP
Configuration selection rules are used to \fIbind concrete object
instances\fR in the object base to \fIcomponent names\fR applied
in the Shapefile at build time.  A selection rule is a
named sequence of \fIalternatives\fR, separated by semicolons,
constituting a logical OR expression. Each alternative consists of a
sequence of \fIpredicates\fR, separated by commas, constituting a
logical AND expression.  A selection rule \fIsucceeds\fR if one of its
alternatives succeeds (i.e. leads to the unique identification of some
object instance).
.PP
A selection rule that \- when activated \- would cause the configuration
of an experimental system (\fI\(lqselect the newest version of all components
that I am working on; select the newest published version of all other 
components\(rq\fR) might look like:
.LP
.nf
\fC\s-1exprule:
	*.c, attr (author, andy), 
	   attr (state, busy);
	*.c, attrge (state, published), 
	   attrmax (version).\s+1\fR
.fi
.PP
Another example illustrates how known versions of particular modules
could be configured into otherwise experimental systems:
.LP
.nf
\fC\s-1special_rule:
	afs_def.h, attr (version, 8.22);
	afs_hparse.c, attr (version, 8.17);
	*.c, attr (author, andy), 
	   attr (state, busy);
	*.c, attrge (state, published), 
	   attrmax (version).\s+1\fR
.fi
.PP
In alternatives, the first predicate (e.g. \fC*.c\fR) is usually a
pattern against which the name attribute of a sought component
is matched.  The patterns used by \*(sh have the same structure as those
used by \fCed\fR.
The other predicates allow certain requirements to be expressed with respect
to the object attributes. \fIAttr\fR and \fIattrge\fR are
predefined predicates that require a specified attribute to be equal
or greater-than-or-equal (with respect to a defined or lexical
order) a given value. The similarly predefined predicate \fIattrmax\fR
requires objects to have a maximal value in the specified attribute.
In order to uniquely identify exactly one object instance by
evaluation of a selection rule, the alternatives must be sufficient to
single out one element from a possible set. Usually, the last predicate
of an alternative guarantees a unique selection. Predicates like
\fIattrmax (attribute_name), attr (state, busy), \fRor\fI attr
(version, 4.2)\fR are examples of such selections.
.PP
The basic procedure of \*(sh is similar to Make's: Names \- so-called
\fItargets\fR \- are produced. \*(sh checks whether the
target already exists and is \fIcurrent\fR, or tries to produce it
from its \fIdependents\fR. 
A target is considered current if neither the source objects nor the
derivation context have changed.
In order to check whether a given target
is current, both the target document itself, and all of its dependents,
must be configured. A name\(dg
.FS
\(dg Conceptually, name \fIand type\fR of a document are passed as implicit
parameters. In this discussion, \fIname\fR stands for the concatenation
\fIname.type\fR
.FE
that has to be configured is passed as implicit parameter to the
active selection rule. During rule evaluation, the name is
sequentially matched against the name pattern of the rule
alternatives. If a pattern matches a name, the attempt will be made to
complete the following predicate sequence.
.PP
After a name match, \*(sh queries the object base for all objects with 
the given name and thereby initializes
an internal \fIhit set\fR. The subsequent sequence
of predicates will be applied to the set of found AFS objects. An
alternative fails if one of the following conditions is true:
.in +0.2i
.IP \(bu 0.2i
the pattern does not match
.IP \(bu
a predicate of the alternative fails
.IP \(bu
upon completion of the alternative, the cardinality of the hit set is
not equal to one, i.e. no unique name resolution was possible.
.in -0.2i
.LP
The application of predicates to the hit set results in the removal of
all AFS objects from the hit set that do not conform to the specified
requirements. A predicate's evaluation fails if the cardinality
of the hit set becomes equal to zero.
After the target and all of it's dependents have been configured,
the transformation predicate is applied to the target and each of its
dependents.
.PP
Selection rules can be activated on a per production basis by simply
giving the name of the rule as the first dependent of a production.
Thus, it is possible to define targets for the configuration of e.g.
testsystems and releasable systems within the same \*(sh-file.
.LP
.nf
	\fC\s-1test: exp_rule prog
	release: rel_rule prog
	prog: x.o y.o z.o\s+1\fR
.fi
.PP
A selection rule remains active until it is superseded by activation
of another selection rule or until the target that caused the activation
is produced. If no selection rule is specified, the default rule, which
is the same as Make's (\(lq\fIselect the busy object in the current 
directory\fR\(rq), is active.
.PP
After having uniquely identified the system's components, they will
be temporarily installed as 
.UX
filesystem objects, and the necessary
transformation actions can be performed.
.PP
The search space for retrieve operations is defined by
the \fIcurrent project\fR which is an explicitly selected work context.
If \*(sh cannot find a document in the local search space,
it tries to connect to a \fIproject server\fR, whose address is
defined by the current project. The project server might reside locally
or somewhere in the network. It provides controlled access to the
project's database. Thus, if a particular document could not be tracked
down locally, it might still be somewhere in the project library.
.NH 2
Transformation Rules
.PP
\*(sh's transformation rules describe, which kind of \fIsource object\fR
is transformed into which kind of \fIderived object\fR, how this
transformation is performed, and which parameters are significant
for that transformation.
Transformation rules consist of a \fItransformation specification\fR,
and a \fItransformation script\fR. Transformation specifications
describe prerequisites and resulting objects of a transformation. The
transformation script is a template for a shell script that
will be passed to a shell process upon activation of a transformation.
The syntax for these rules is an extension of Make's default rule
specification formalism. \*(sh's rule by which the transformation
of a C source object into a '\fC\&.\&o\fR' (speak: dot-o) derived object
is defined looks like:
.LP
.nf
.C
\s-1%.o: %.c : +(CC) +(CFLAGS)
	$(CC) -c $(CFLAGS) %.c\s+1
.R
.fi
.LP
A request to produce a derived object \- let's say \fCxyzzy.o\fR \- would,
by evaluating the transformation rule, result in the compilation
of \fCxyzzy.c\fR with the compiler defined by 
the macro \fCCC\fR, with compile switches defined by \fCCFLAGS\fR.
The percent sign is consistently substituted by the name \(lqxyzzy\(rq
throughout the transformation rule. The notation \fI$(NAME)\fR substitutes
the value of the macro \fINAME\fR, while \fI+(NAME)\fR substitutes the
entire macro definition (i.e. \fINAME=value\fR).
.PP
When a transformation rule is evaluated, the name of the source object
is passed to the current selection rule and thereby bound to a
concrete source object version in the object base. After the
transformation script has been executed (successfully), \*(sh assumes
that the specified derived object has been produced, and stores the
filesystem object that represents the derived object (in the example
above \fCxyzzy.o\fR) in a special area in the object base, called the
\fIbinary pool\fR. When put into the binary pool, an attribute
describing the transformation that just took place, is attached to the
derived object. This \fIderivation attribute\fR contains the
identification of all source objects, as well as the definitions of
the specified macros that were used in the transformation script.
.PP
In Make, triggering of transformations is controlled by the built-in
predicate \fIis_newer (target, source)\fR. This predicate fails to
produce a target, if a source object is left unchanged, but something in the
production environment changed. A common example of this case in
.UX 
is the compilation of the same C source file with different precompiler
switches. On the other hand, transformations can be omitted, if the source
was a saved version and the derived object is still existent in the
binary pool. When requested to produce a target, \*(sh configures
the source objects (by evaluating the selection rule), constructs the
derivation attribute that \fIwould be\fR assigned to the derived object, and
checks if a derived object
that already has such an attribute is readily available from the binary 
pool. In this case no compilation would be necessary. If something in
the source context or the transformation context has changed (e.g.
the compile switches in \fCCFLAGS\fR), a new derived object instance 
would be created.
.NH 2
Variant Support
.PP
There is a common understanding of variants as \fIalternative\fR realizations
of the same concept. The typical example
for the genesis of variants is porting of software products to 
different architectures. The idea of variants sounds quite simple, but
to actually handle them can be an extremely difficult task.
.PP
Variant documents can be represented by a single source document that has
to be \fIpreprocessed\fR in order to access a particular variant.
Variant documents can also be \fIphysically separated\fR, i.e. each variant
is a document of its own. Variants of this kind may have different
names, or the same name but in different name spaces (e.g. directories).
Variants can be identified by supplying a set of options to the preprocessor
or appropriate names or pathnames. Both techniques have their particular
advantages and disadvantages. In the case of preprocessed variants,
one has to write source documents that contain lots of precompiler-
or macroprocessor-related code. When things grow complex, it is easy 
to make mistakes. Besides, source documents of this kind are hard to read
and understand. Consequently, they are less maintainable.
Also, the specification of a planned configuration may require a lot
of error-prone work. 
.PP
The other case, the physically separate administration of variants, is 
expensive in terms of disk space and organizational overhead.
Moreover, it is extremely problematic when changes (e.g. bug-fixes,
feature enhancements) are made in sections that are common to all
variants. One has to face the choice of 
.in +0.2i
.IP \(bu 0.2i
doing the work all over again
for all variants, 
.IP \(bu
trying to \fImerge\fR changes that have been made in
one variant (semi-) automatically into the others, or 
.IP \(bu
changing only one 
variant (the best selling) and abandoning the others.
.in -0.2i
.PP
The real problem is even more complex. We suspect that it is still an
unsolved problem of software engineering to produce \fIportable
software designs\fR in the sense of predicting and planning the possibility
that certain modules of a system sprout variant branches.  It is still
a fact that variants \fIhappen\fR. In order to port a system to some
new architecture (that might not have even existed at the time of the
system's design), almost any module might be struck by the necessity
of minor or major adjustments. As a consequence, both techniques of
variant administration may happen to be mixed. Also variants of
variants (sub- or multivariants) may come into existence.  A complex
system often has lots of variant options that are completely
independent (e.g. a compiler that produces French diagnostics and VAX
code for a
.UX
System V environment). Variant properties of different modules
might also be dependent or contradictory (e.g. certain memory
management algorithms may rely on virtual memory, which a specified
target architecture lacks).  Furthermore, it is easily possible that
the overall structure of a software system becomes variant.  All this
comes to a climax at a point where module variation is a mere
symptom of metamorphosis, in which a system variant evolves into a
completely different product. The question arises, how long variants
should be treated as such, and when they start a life of their own.
.PP
We don't claim
that \*(sh offers a \(lqquick fix\(rq for the variant problem.  For
tools like \*(sh, only flexibility, rather than conceptual or
methodological corsets can be an answer.
\*(sh offers a simple but flexible mechanism for the
handling of variants that supports both elementary administration
concepts and their combination. For the realization in a
.UX
filesystem environment, \*(sh allows \fIvariant names\fR to be defined
and to be associated with variant-flags, that may be passed to the
transforming tool, and a variant-path, that extends the search space
by directories, which could host an object variant. The following
example illustrates the use of variant definitions:
.LP
.nf
\fC\s-1#% VARIANT-SECTION
vclass system ::= (vaxbsd, munix)
vclass database ::= (damokles, unixfs)
vaxbsd: 
	vflags="-DUNIX -DBSD43 -DSTDCC \e
	   -DVAX -DPSDEBUG" 
	vpath="sys/vaxbsd"
unixfs:
	vflags="-DFS"
	vpath="data/unixfs"
.sp 2p
	(\ .\ .\ .\ )
.sp 2p
#% END-VARIANT-SECTION\s+1\fR
.fi
.PP
Variant names, as defined in the variant section, can be applied in
selection rules through the predefined (pseudo-)predicate \fIattrvar\fR.
They provide a unified concept for the administration of variants within
the version control system, with preprocessor technique, and with
physical separation. Configuration selection rules making use of
the variant attribute might look like:
.LP
.nf
\fC\s-1fsexp:
  *.[ch], attrvar (vaxbsd), \e
    attrvar (unixfs), attr (state, busy).
.fi
.LP
\*(sh uses the special macros \fIvflags\fR and \fIvpath\fR to hold 
preprocessor options and extensions to the default document search 
path. 
Locations specified by \fIvpath\fR are searched for 
documents prior to the default location. If a document with the specified
attributes is found in a \fIvpath-\fRdirectory, the default directory
will \fInot\fR be searched.
.PP
Initially, both macros have an empty value. When variants are selected
in an alternative of a selection rule, the associated macro values are 
\fIadded\fR to \fIvflags\fR and \fIvpath\fR. In our example, during 
evaluation of rule \fCfsexp\fR,
\fIvflags\fR would become:
.sp 5p
.nf
\fC\s-1vflags="-DUNIX -DBSD43 -DSTDCC \e
	-DVAX -DPSDEBUG -DFS"\s+1\fR
.fi
.sp 5p
and \fIvpath\fR  would be:
.sp 5p
.nf
\fC\s-1vpath="sys/vaxbsd:data/unixfs"\s+1\fR.
.fi
.sp 5p
Upon completion of each alternative both macros are reset.
.PP
The construct \fIvclass system ::= (vaxbsd, munix)\fR defines a
\fIvariant class\fR. Variant classes define mutually exclusive variant
names. Variant classes can usually be given meaningful names, because
they mostly correspond to certain properties, in which the particular
variants vary. A variant class \fIcputype\fR for instance, with
element names \fIIBM4381, VAX630, VAX7XX, m68k\fR a.s.o. might be
defined in order to prevent the selection of different cpu-specific
modules with mismatching cpu attributes. \*(sh will complain if such a
condition is detected.  So far, this is the only concept in \*(sh for ensuring
semantic consistency across variant system components.
In this area, more work needs to be done. For a more thorough discussion
of this matter, we refer to [Perr87a].
.NH 2
Configuration Identification and Reproducibility
.PP
\*(sh can, for the purpose of configuration identification, be asked
to produce a \fIconfiguration identification document\fR (CID) for a
configuration. CIDs have the form of a Shapefile that is \fIcompletely
bound\fR. All components of the configuration are precisely identified
by their version number, and eventually variant identification. The
CID also contains all necessary macro definitions.  It is a good idea
to place the tools that are used to create system configurations
under version control as well. If this has been done, the tool
versions are also included in the CID.  Another important information
recorded in the CID is the \fIproject domain\fR. It defines the name of
the project from which a configuration originates, and the next-higher
domain in which the projectname can be resolved (e.g.  a network\-,
host\-, or pathname). This is necessary in order to define the object
base against which a possible rebuild of the configuration shall be
done.
.PP
Recording of system configurations in CIDs is the prerequisite
for proper rebuilds of a complex system. The ability to rebuild 
a released configuration is in turn the prerequisite for proper
product maintenance.
The fact that \*(sh CIDs are themselves Shapefiles makes it very
easy to reproduce a recorded configuration, provided the original object 
base is available and intact.
.PP
However, complete reproducibility of system releases is a goal that is hard
to achieve. To rebuild old configurations as identically as possible
not only requires keeping all document versions that have ever been
part of a release, but also a straight history of all tools (e.g. compilers)
that have ever been used to produce releases. The cost for this might be
considerable administrative overhead, because every project
needs a current \fItool registry\fR, where all production tools 
are logged. The gain on the other hand is increased security for the
maintenance phase of long lived software products. The \*(sh toolkit
will offer support for tool registries but not require to keep them.
.NH 1
The Object Base
.PP
Most conventional filesystems, such as those of the
.UX
flavor, solely use a file's
(path-) name to establish access to its
contents. 
They usually offer no provision for the maintenance of object
histories. Version control systems like SCCS or RCS
had to be introduced as auxiliary tools to avoid the problem of
conflicting filenames and to store versions in an efficient manner.
Histories of related objects are typically maintained completely
independently, so there is no obvious way to figure out which versions
of which objects were meant for each other.  Integration of version control
with system
building tools like Make is very poor.
The choice, which component
versions go into a system configuration, is often limited to the
selection of either the \fInewest available\fR versions or
\fIstatically designated\fR, i.e. a priori known versions (composition
list).
.PP
For configuration identification it is more desirable to
\fIdescribe\fR a planned configuration in terms of
properties that its components must have in order to be eligible.
The \fIattributed filesystem\fR (AFS) provides an
extended view of software objects to application programs. This view comprises
the concept of \fIobject histories\fR, as well as the possibility to
tag any number of \fIuser-defined attributes\fR to object instances.
Interpretation and use of these
attributes is left to the application that uses them. 
.NH 2
The Attributed Filesystem
.PP
The term attributed filesystem is only used for historical
reasons. The AFS layer described in this section rather implements a
data storage system independent base of \fIattributed software objects\fR\(dg
.FS
\(dgWe adhere to the terminology proposed in [Tich88a].
.FE
(ASO), on top
of which all programs of the configuration engineering toolkit are
built. 
.PP
Each software object
is understood as a complex of \fIcontent
data\fR and a set of \fIassociated attributes\fR.  
Attributes
have the general form \fIname=value\fR, where \fIname\fR represents
the attribute name, and \fIvalue\fR a possibly empty attribute value.
There are some implicitly defined \fIstandard attributes\fR for
every object instance.  Some of the standard attributes (e.g.
name, size, owner, or protection attributes) are inherited from the
underlying data storage system;
others (e.g. revision number or state) are AFS specific.
.PP
AFS is realized as a callable interface to a \fIdata storage
system\fR and provides a general, attribute based method to identify
objects in the object base.  All attributes are considered equally
suited for object identification. For instance, it is possible to
retrieve all ASOs with an attribute \fIname=xyzzy\fR, or all
items that have the attributes \fIauthor=andy\fR and
\fIstate=published\fR.  Versions are treated as \(lqjust another
attribute\(rq. AFS provides applications \- such as \*(sh \- with
fully transparent, stream oriented access to all object instances.
.sp 5p
.KS
.sp 4c
.ce 
\f3Fig 3.1.\f1 "The AFS and its applications"
.KE
.sp 5p
.PP
With AFS, software objects are retrieved by specifying an \fIattribute
pattern\fR.  An AFS retrieval results in a \- possibly empty \- set of
\fIobject keys\fR, each of which representing a unique object instance
that matches the specified attribute pattern.
.PP
The current implementation of AFS uses two
kinds of special files to realize the described concept of ASOs,
\fIhistory files\fR and \fIbinary pools\fR.  Both file types are
archives and capable of holding a possibly large number of objects. 
History files store successive versions of
source objects, which are
in most cases of textual nature. To preserve diskspace,
only differences
between successive versions are kept (\fIdelta technique\fR).
The version control system employs 
a new delta technique [Obst87a],
yielding deltas that
are about 30 percent smaller than deltas generated by \fIdiff\fR
(the standard 
.UX
comparison tool for generating deltas).
.PP
Binary pools are designed to hold \fIderived\fR objects, i.e. objects
that are produced by processing (transforming, compiling) of source
objects. Since derived objects can be reproduced from a corresponding
source object, binary pools are administered in a cache fashion,
i.e. when space runs short, binaries are cleaned out on a \(lqleast
accessed\(rq basis. The concept of binary pools resembles
DSEE's \fIderived object pools\fR.
.PP
Similar to other version control systems, history files generally
accompany a regular file, the so called workfile. In the context of
\*(sh and AFS, we use the term \fIbusy object\fR, instead of
workfile.  Busy objects are regular files, thus making it
possible to use tools, such as the EMACS editor, which don't know
about the AFS.  Access to non busy objects however, can only be
established through the AFS interface, because usually they must
first be regenerated from the information stored in the corresponding history
file. When a saved version is opened, the I/O operations
will actually access a temporarily created file. All the action
happens \- of course \- behind the scenes, and an AFS application
accesses busy objects as well as all other versions transparently
through the same mechanism.
.PP
The attributes of all version instances of an object, including the
busy object, are stored in the history file. Attributes of derived
objects are stored in the binary pool file that hosts them.
.PP
Every regular file can be accessed through the AFS.  In this case, it
will be treated as a busy object without AFS specific or user-defined
attributes.  If such a file is checked into the version control system
for instance, a history file will be created, and the missing standard
attributes will be supplemented in a meaningful manner.
.NH 2
AFS on top of \*(Da
.PP
A second implementation of AFS on top of \*(Da, a dedicated software
engineering database (prototype) is currently under way.
\*(Da is based on an \fIextended entity relationship model\fR and designed 
to serve as universal data management system for a large set of tools
to be part of an integrated programming environment.
.PP
The fact that the various tools are supposed to store their data in a
tool specific structure (of entities and relationships) leads to
some serious problems. First, opening of an ASO containing application
specific \*(Da structures must yield an object specific key rather
than a
.UX
file pointer. Second, simple operations such as copying,
moving, or printing of object contents are representation dependent and
can't be performed by the AFS any more. In particular, there is no easy
way for AFS to compute \fIversion deltas\fR between \*(Da object structures
(how should this kind of delta look like ?).
.PP
Another very practical problem is extensibility. In the current state,
a \*(Da database has \fIone\fR schema that defines the internal
structure of the entire database.  Addition of a new tool with the
necessity of schema updates requires the generation of a new database
and the (troublesome) transfer of all data from the old database to
the new one.  Due to these problems and the current lack of of \*(Da
based tools, we decided to use the database only as replacement 
for archive\- and binary pool files.
Busy objects and temporary files (containing the data of
reconstructed older versions) are still stored in the
.UX
filesystem.
AFS applications have no direct access to the database.  Similar to
the filesystem implementation, the contents of an ASO has the form of
a byte array.  Until now, there is no substantial difference between this
implementation and the filesystem implementation \(em except that it
will be slower.
.PP
A solution to the described problems that will allow AFS applications
to take full advantage of \*(Da' structuring facilities while
supporting the dynamic extension of the SPU without the necessity to
change or even recompile any part of the environment, can be found by
taking a consequently object oriented approach.  The design of an
object oriented AFS to be basic part of an object oriented \fIenvironment
frame\fR is currently in its early stage. However, we expect substantial
results in this direction in the near future.
.NH 1
Conclusion
.PP
The described system for engineering of software configurations
integrates tools for version control, system building, and
project organization on top of a common object concept. Despite the
integration of the toolkit itself, care has been taken to smoothly fit
the SCE system into the standard
.UX
environment. The entry cost for
new users (in terms of initial learning effort) is very low. The
system may be used as just a friendly version control tool, an upward
compatible replacement for Make, or an intelligent integration of
both.  Utilization of the toolkit can be gradually extended up to a
network based project support environment, employing a number of
programmer teams working on large software development and maintenance
projects.
.PP
The simple, 
.UX-like
nature of the toolkit's basic user interface
offers a broad range of possibilities to create dedicated user interfaces
that provide an integrated, problem oriented view of the SCE system.
.PP
There are, however, a number of areas where much more work needs to
be done. Particularly, powerful formalisms to deal with the complexity
of variant control are still at large. The use of software engineering
datbases as underlying data storage system is still a problem. However,
the use of object oriented design principles for a new version of the 
system is expected to overcome these problems and to open up exciting
perspectives for a \(lqgeneric, integrated, open software engineering
toolkit environment\(rq.
.NH 1
Acknowledgement
.PP
This work is part of the \*(Un project. The project is supported by the
Bundesministerium f\*:ur Forschung und Technologie 
(Federal Ministry for Research and Technology) under grant ITS 8308.
.]<
.\"AUGMAKE-1983-1
.ds [F AUGM83a
.]-
.ds [A AUGMAKE
.ds [T An Augmented Version of Make
.ds [J System V/68 Support Tools Guide
.ds [I Motorola Microsystems Inc., Ord.No. M68KUNSTG/D1
.ds [P 21-40
.nr [P 1
.ds [D January 1983
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Bersoff.E.H.-1980-2
.ds [F Bers80a
.]-
.ds [A Edward H. Bersoff
.as [A ", Vilas D. Henderson
.as [A ", and Stanley G. Siegel
.ds [T Software Configuration Management
.ds [I Prentice Hall
.ds [C Englewood Cliffs, N.J.
.ds [D 1980
.nr [T 0
.nr [A 0
.nr [O 0
.][ 2 book
.\"Clemm.G.M.-1986-3
.ds [F Clem86a
.]-
.ds [A Geoffrey M. Clemm
.ds [T The Odin System: An Object Manager for Extensible Software Environments
.ds [J CU-CS-314-86
.ds [I The University of Colorado
.ds [C Boulder, Colorado
.ds [D February 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"DECCMS-1984-4
.ds [F DECC84a
.]-
.ds [A DECCMS
.ds [T VAX DEC/CMS 2.0 Reference Manual
.ds [J VAX DEC/CMS Reference Manual, Order No. AA-L372B-TE
.ds [I Digital Equipment Corporation
.ds [C Maynard, Massachusetts
.ds [D November 1984
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"DECMMS-1984-5
.ds [F DECM84a
.]-
.ds [A DECMMS
.ds [T VAX DEC/MMS 2.0 User's Guide
.ds [J VAX DEC/MMS User's Guide, Order No. AA-P119B-TE
.ds [I Digital Equipment Corporation
.ds [C Maynard, Massachusetts
.ds [D August 1984
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Dittrich.K-1986-6
.ds [F Ditt86a
.]-
.ds [A Klaus Dittrich
.as [A ", Willi Gotthard
.as [A ", and Peter C. Lockemann
.ds [T DAMOKLES. A Database System for Software Engineering Environments
.ds [J International Workshop on Advanced Programming Environments
.ds [P 351-371
.nr [P 1
.ds [I IFIP WG2.4
.ds [I Springer Verlag
.ds [C Trondheim, Norway
.ds [D June 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Dowson.M-1986-7
.ds [F Dows86a
.]-
.ds [A Mark Dowson
.ds [T ISTAR - An Integrated Project Support Environment
.ds [J Proceedings of the ACM SIGSOFT/SIGPLAN Software Engineering
.ds [J Symposium on Practical Software Development Environments
.ds [J SIGPLAN Notices
.ds [V 22, 1
.ds [P 16-27
.nr [P 1
.ds [I ACM
.ds [C Palo Alto, California
.ds [D December 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Estublier.J.-1986-8
.ds [F Estu86a
.]-
.ds [A J. Estublier
.as [A " and N. Belkhatir
.ds [T Experience with a Database of Programs
.ds [J Proceedings of the ACM SIGSOFT/SIGPLAN Software Engineering
.ds [J Symposium on Practical Software Development Environments
.ds [J SIGPLAN Notices
.ds [V 22, 1
.ds [P 84-91
.nr [P 1
.ds [I ACM
.ds [C Palo Alto, California
.ds [D December 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Feldman.S.I.-1979-9
.ds [F Feld79a
.]-
.ds [A Stuart I. Feldman
.ds [T MAKE - A Program for Maintaining Computer Programs
.ds [J Software - Practice and Experience
.ds [V 9,3
.ds [P 255-265
.nr [P 1
.ds [D March 1979
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Haberman.A.N-1982-10
.ds [F Habe82a
.]-
.ds [A A. Nico Haberman
.as [A " and Gail E. Kaiser
.ds [T An Environment for System Version Control
.ds [J Dig. Papers Spring Compcon
.ds [I IEEE
.ds [D November 1982
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"H\*ubner.W.-1987-11
.ds [F H\*u87a
.]-
.ds [A W. H\*ubner
.as [A ", G. Lux-M\*ulders
.as [A ", and M. Muth
.ds [T THESEUS \- Die Benutzungsoberfl\*ache der UNIBASE Softwareentwicklungsumgebung
.ds [J Beitr\*age zur Graphischen Datenverarbeitung
.ds [I Zentrum f\*ur Graphische Datenverarbeitung
.ds [I Springer Verlag
.ds [C Berlin
.ds [D 1987
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"IEEE-1983-12
.ds [F IEEE83a
.]-
.ds [A IEEE
.ds [T IEEE Standard Glossary for Software Engineering Terminology
.ds [I IEEE
.ds [C New York, N.Y.
.ds [D February 1983
.nr [T 0
.nr [A 0
.nr [O 0
.][ 2 book
.\"Lampen.A-1988-13
.ds [F Lamp88a
.]-
.ds [A Andreas Lampen
.as [A " and Axel Mahler
.ds [T An Object Base for Attributed Software Objects
.ds [J (to appear in) Proceedings of the Fall 1988 EUUG Conference
.ds [I European Unix systems User Group
.ds [C Lisbon, Portugal
.ds [D October 1988
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Lampson.B.-1983-14
.ds [F Lamp83a
.]-
.ds [A B. Lampson
.as [A " and E. Schmidt
.ds [T Organizing Software in a Distributed Environment
.ds [J Proc. of the SIGPLAN 83 Symposium on Programming Language Issues in Software Systems
.ds [V 18, 6
.ds [P 1-13
.nr [P 1
.ds [C San Francisco, California
.ds [D June 1983
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Leblang.D.B.-1984-15
.ds [F Lebl84a
.]-
.ds [A David B. Leblang
.as [A " and Robert P. Chase
.ds [T Computer-Aided Software Engineering in a Distributed Workstation Environment
.ds [J Proceedings of the ACM SIGSOFT/SIGPLAN Software Engineering
.ds [J Symposium on Practical Software Development Environments
.ds [J SIGPLAN Notices
.ds [V 19, 5
.ds [P 104-113
.nr [P 1
.ds [I ACM
.ds [C Pittsburgh, PA.
.ds [D April 1984
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Mahler.A-1988-16
.ds [F Mahl88a
.]-
.ds [A Axel Mahler
.as [A " and Andreas Lampen
.ds [T shape \- A Software Configuration Management Tool
.ds [J Proceedings of the International Workshop on Software Version and Configuration Control
.ds [I German Chapter of the ACM
.ds [I B.G. Teubner
.ds [P 228-243
.nr [P 1
.ds [C Grassau, West-Germany
.ds [D January 1988
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Marzullo.K-1986-17
.ds [F Marz86a
.]-
.ds [A Keith Marzullo
.as [A " and Douglas Wiebe
.ds [T Jasmine: A Software System Modelling Facility
.ds [J Proceedings of the ACM SIGSOFT/SIGPLAN Software Engineering
.ds [J Symposium on Practical Software Development Environments
.ds [J SIGPLAN Notices
.ds [V 22, 1
.ds [P 121-130
.nr [P 1
.ds [I ACM
.ds [C Palo Alto, California
.ds [D December 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Nicklin.P.J.-1983-18
.ds [F Nick83a
.]-
.ds [A Peter J. Nicklin
.ds [T The SPMS Software Project Management System
.ds [I UC Berkeley
.ds [C Berkeley, CA.
.ds [D August 1983
.nr [T 0
.nr [A 0
.nr [O 0
.][ 2 book
.\"Obst.W-1987-19
.ds [F Obst87a
.]-
.ds [A Wolfgang Obst
.ds [T Delta Technique and String-to-String Correction
.ds [J Proceedings of the 1st European Software Engineering Conference
.ds [J Lecture Notes in Computer Science
.ds [P 69-73
.nr [P 1
.ds [I Springer Verlag
.ds [C Berlin
.ds [D September 1987
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Perry.D.E.-1987-20
.ds [F Perr87a
.]-
.ds [A Dewayne E. Perry
.ds [T Version Control in the Inscape Environment
.ds [J Proceedings of the 9th International Conference on Software Engineering
.ds [I IEEE
.ds [P 142-149
.nr [P 1
.ds [C Monterey, California
.ds [D March 1987
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Rochkind.M.J.-1975-21
.ds [F Roch75a
.]-
.ds [A Marc J. Rochkind
.ds [T The Source Code Control System
.ds [J IEEE Transactions on Software Engineering
.ds [V SE-1
.ds [P 364-370
.nr [P 1
.ds [D 1975
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Tichy.W.F.-1985-22
.ds [F Tich85a
.]-
.ds [A Walter F. Tichy
.ds [T RCS - A System for Version Control
.ds [J Software - Practice and Experience
.ds [V 15,7
.ds [P 637-654
.nr [P 1
.ds [D July 1985
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Tichy.W.F.-1988-23
.ds [F Tich88a
.]-
.ds [A Walter F. Tichy
.ds [T Tools for Software Configuration Management
.ds [J Proceedings of the International Workshop on Software Version and Configuration Control
.ds [P 1-20
.nr [P 1
.ds [I B.G. Teubner
.ds [I German Chapter of the ACM
.ds [C Grassau, FRG
.ds [D January 1988
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Waite.W.M.-1988-24
.ds [F Wait88a
.]-
.ds [A William M. Waite
.as [A ", V. P. Heuring
.as [A ", and Uwe Kastens
.ds [T Configuration Control in Compiler Construction
.ds [J Proceedings of the International Workshop on Software Version and Configuration Control
.ds [I German Chapter of the ACM
.ds [I B.G. Teubner
.ds [P 228-243
.nr [P 1
.ds [C Grassau, West-Germany
.ds [D January 1988
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.]>
