.IZ
.sp -0.9di
.ND
.nr UX 1
\" --- cut here --- 
.AM
.ds Rf References
.ds Un \\s-1\\f(HBU\\s-2NI\\s+2B\\s-2ASE\\fR\\s+3
.ds Co \\s-2\\f(HBCOMA\\fR\\s+2
.ds Da \\s-2\\f(HBDAMOKLES\\fR\\s+2
.ds Th \\s-2\\f(HBTHESEUS\\fR\\s+2
.ds Mk Make
.ds sh \\s-1\\f(HBshape\\fR\\s+1
.ds Af AFS
.TL
An Object Base for Attributed Software Objects\(dg
.FS
\(dg in \fIProceedings of the EUUG Autumn '88 Conference\fR
.br
(Cascais, 3-7 October 1988), pp. 95-105, European UNIX Users Group, London 1988
.FE
.AU
Andreas Lampen, Axel Mahler
andy@coma.uucp, axel@coma.uucp
.AI
Technische Universit\*:at Berlin
Sekretariat FR 5-6
Franklinstr. 28/29
D-1000 Berlin 10
.AB
The
.UX
filesystem supports a fixed set of attributes for filesystem
objects, stored in inodes and directory entries.
The (path-)name attribute is the sole means to identify
and access a filesystem object.
This turns out to be a rather severe limitation for certain
complex applications such as large scale software development,
where software objects typically evolve in a considerable number of
versions.
.LP
An approach to improve the situation
is introduced by the \fIattribute filesystem\fR (\*(Af),
the system described in this paper.
The \*(Af combines the notion of immutable objects (versions)
with the possibility to attach any number of user-definable
attributes to any attributed software object (ASO).
\*(Af objects can be identified by specifying any set of
attribute value(s) as retrieve pattern.
The \fIname\fR of an \*(Af object is treated as \fIjust another attribute\fR.
The \*(Af is equipped with a proper retrieve interface that allows
non-unique identification of \fIsets of objects\fR and provides
operations on those sets.
.LP
The \*(Af is a significant extension to the
.UX
filesystem interface providing applications with a unified,
consistent view of attributed filesystem objects comprising
immutable versions and ordinary
.UX
files.
The concept of \fIpersistent objects\fR makes \*(Af a basis
for object oriented applications in an
.UX
environment. 
We used \*(Af as a basis for the implementation of the \*(sh toolkit,
a collection of programs supporting
software configuration management in multi-programmer software
development projects.
.LP
One important objective of \*(Af is to abstract from the actually
underlying data storage system. This paper will briefly discuss
two different implementations of \*(Af \- one on top of the
.UX
filesystem and the other based on \*(Da, a dedicated software
engineering database.
.AE
.NH 1
Introduction
.LP
The context of this work was the design of a software configuration
management system to be part of a kernel of an open
.UX
based software engineering environment.
Large scale software development requires a system
capable to store a big number of software objects, typically
evolving in a considerable number of versions.
.LP
The
.UX
filesystem is a good basis for this job but it has
some severe limitations.
It supports only a fixed set of attributes for filesystem
objects, stored in inodes and directory entries.
The (path-)name attribute is the sole means to identify
and access a filesystem object.
Version control systems had to be introduced as auxiliary tools,
to avoid name clashes and to store multiple versions
of files in an space efficient manner.
However, they do not overcome the fundamental shortcomings
of the
.UX
filesystem.
They represent partial solutions to particular problems
and integrate poorly with
.UX
tools such as \*(Mk [2].
.LP
As a try to overcome these limitations we designed the \fIattribute
filesystem\fR (\*(Af), the system described in this paper.
We use the name attribute \fIfilesystem\fR mainly for historical
reasons (because we are used to it and we haven't found a better
name yet).
So don't be confused when we subsequently refer to
\*(Af as an \fIobject base\fR rather than a filesystem.
Accordingly we will use the term \fIsoftware object\fR instead of
\fIfile\fR throughout this paper.
.LP
An object base is a hybrid of filesystem and database trying
to combine the advantages of both types of data storage systems.
The advantages of an object base over a filesystem
lie in its
.IP \(bu 0.2i
more general object identification scheme,
.IP \(bu
ability to store multiple versions of objects,
.IP \(bu
support for the management of arbitrary attributes for objects and
.IP \(bu
abstraction from the physical representation of objects.
.RE
.LP
Improvements in respect to database systems are
.IP \(bu 0.2i
the concept \fIobject\fR
as manageable, user identifyable, interchangeable piece of data
and a common understanding of how data looks like (a basis for integration
of existing and new tools),
.IP \(bu
no need for a schema (i.e. no problems with schema updates),
.IP \(bu
better network support (\fIobjects\fR are quite easyly interchangeable
between different machines) and
.IP \(bu
better performance (in most cases)
.RE
.LP
For a detailed discussion on how a persistent object base should
look like, see [6].
.LP
\*(Af is designed as basis for the \*(sh-toolkit, described in  [4]
and [5].
The \*(sh-toolkit is a configuration management toolkit
integrating a dedicated version control system and \*(sh, a
significantly enhanced \*(Mk program.
Enhancements include full access to the version control system.
\*(sh's procedure of identifying
appropriate component versions that together form a meaningful system 
configuration may be completely controlled by user-supplied \fIconfiguration
selection rules\fR. Selection rules are placed in the \fIShapefile\fR,
\*(sh's counterpart to the Makefile.
.LP
The next chapter gives an overview of the basic concepts of \*(Af.
In chapter 3, we briefly describe the interface and have a
look at two different implementations.
The last chapter contains an outlook on current development
efforts to make \*(Af a basis for object oriented applications.
.NH 1
General design
.LP
\*(Af is a system to store software objects as 
a complex of (from the AFS' point of view) unstructured
content data and an arbitrary
number of associated attributes.
We call these objects \fIattributed software objects\fR (ASOs).
\*(Af has a built-in version control system that supports the storage
and identification of different versions of \fIdesign objects\fR.
A design object consists of a group of
successive versions evolving by taking snapshots of the current
development state from time to time.
Throughout this paper we also use the term \fIline of development\fR
synonymously to \fIdesign object\fR.
Each version of a design object is an attributed software object on its own.
For a more detailed discussion of software engineering terms see [10].
.LP
Due to the requirements of a multi programmer software
development environment we introduced
a mechanism for reserving update rights for design objects
by setting a lock on this object.
Reserving the update right has
the effect, that updates can only be stored by the user
currently holding the lock.
.LP
\*(Af was designed to be a basis for integration of a large spectrum
of different software development tools.
These may be editors, compilers, formatters,
a software configuration management system, tools for
project planning and status accounting, test support, specification
and design tools \(em a potentially very long list.
In respect to tool integration, an
engineering environment has to offer some form of
intelligent support for the user in order to improve
the situation presented by mere toolbox systems.
However, it is not feasible for the object
management part of such an environment to understand the
formal semantics contained \fIin\fR the various types of
objects it manages.
The functional behavior of an environment's object manager
should rather be guided by simple information \fIabout\fR the
managed objects.
Attributes enable each \*(Af application program to store information
about a software object persistently either for later use or
leaving them for interpretation by other \*(Af applications (or both).
.LP
It is likely that the number of needed attributes will grow with each new
tool using \*(Af.
As we cannot foresee which new \*(Af applications will be
introduced in the future, we are not able to define a fixed set of
attributes serving all needs.
Instead, we decided to keep the number of attributes
for each stored object dynamically extensible.
Besides some standard attributes (such as name, size or version), 
each software object is stored with a potentially infinite number of
application-defined attributes.
.LP
Another important design goal was the introduction of a
concept for the integration of standard
.UX
tools and off\-the\-shelf tools that operate on regular files.
For this purpose, \*(Af is designed to be able to coexist with the
.UX
filesystem.
It allows regular
.UX
files to be treated as \*(Af objects and to be accessed through the \*(Af
interface.
This opens a way to exchange data between existing tools that operate on
.UX
files and tools on top of \*(Af (such as the \*(sh toolkit).
Figure 2.1 illustrates the tool integration on base
of \*(Af. \*(Af is a C\-language interface that abstracts from the
underlying data storage system (e.g. a filesystem or a database).
.KF
.sp 5p
.PS
    boxht=0.6i
    move right 0.9i
Ds: box wid 2.2i "Data Storage System" "(e.g. Filesystem or Database)"
    box wid 1.9i "UNIX filesystem"
    move to Ds.nw; move up 0.3i; move right 0.2i;
Af: box wid 2.6i "Attribute File System"; move up 0.3i; right
    box ht 1.2i wid 1i "other" "programs:" "Editors" "Compilers" "Formatters"
    move to Af.nw; move up 0.3i; move right 0.2i
    box wid 0.8i "Version" "Control" "Commands"
    box wid 0.8i "\*(sh"
    box wid 0.8i "other" "AFS" "Applications"
.PE
.sp 5p
.ce
\fBFig. 2.1:\fR The AFS and its applications
.sp 5p
.KE
.LP
Apart from versions and attributes, \*(Af looks very much like the
.UX
filesystem with a hierarchical directory structure, special files and so on.
.LP
.NH 2
Source objects and derived objects
.LP
\*(Af manages \fIlines of development\fR. A line of development
consists of a \fIbusy object\fR and a number of saved versions.
The busy object is an ordinary alterable
.UX
file.
It can be accessed via \*(Af \fIand\fR
.UX
filesytem operations.
Versions come into being by making a copy of the current state of
the busy object.
They can be stored as source objects or as derived objects.
.LP
Source objects are typically composed manually (e.g. by use of a
text editor).
\*(Af stores source objects as immutable objects.
Once saved, they cannot be modified any longer.
They can only be explicitly removed by their owner or author.
Source objects can be uniquely identified by the attribute values
for \fIhostname, system path, name, type, generation number,
revision number\fR and \fIvariant\fR.
.LP
Derived objects are typically derived automatically (e.g. by a
compiler) from a source object and thus be reproducible at any time.
They are kept in a \fIderived object pool\fR ( see also [3]
), a data store of limited
size that is administered in a cache fashion. The oldest (access
date) derived objects get removed if space runs short in the binary
pool. Unlike source objects, the tupel (\fIhostname, system path, name,
type, generation number, revision number, variant\fR) does not necessarily
have to be unique for derived objects. Derived
objects may differ only in user defined attributes !
.LP
\*(Af makes no assumptions whether a copy of a busy object shall be
stored as source object or as derived object.
This has to be decided by the application.
.NH 2
Attributed Software Objects
.LP
Attributes have the general form \fIname=[value [value ...]]\fR.
Figure 2.2 illustrates the term attributed software object.
.KF
.PS
    move right 1.1i
Da: box ht 2i wid 1.5i "\s+9\f(HBDATA\fR\s-9"
    line from Da.nw - 0,0.1 to Da.nw + 0.1,0
    line from Da.nw - 0,0.2 to Da.nw + 0.2,0
    line from Da.nw - 0,0.3 to Da.nw + 0.3,0
    line from Da.nw - 0,0.4 to Da.nw + 0.4,0
    line from Da.nw - 0,0.5 to Da.nw + 0.5,0
    line from Da.nw - 0,0.6 to Da.nw + 0.6,0
    line from Da.nw - 0,0.7 to Da.nw + 0.7,0
    line from Da.nw - 0,0.8 to Da.nw + 0.8,0
    line from Da.nw - 0,0.9 to Da.nw + 0.9,0
    line from Da.nw - 0,1.0 to Da.nw + 1.0,0
    line from Da.nw - 0,1.1 to Da.nw + 1.1,0
    line from Da.nw - 0,1.2 to Da.nw + 1.2,0
    line from Da.nw - 0,1.3 to Da.nw + 1.3,0
    line from Da.nw - 0,1.4 to Da.nw + 1.4,0
    line from Da.nw - 0,1.5 to Da.nw + 1.5,0
    line from Da.nw - 0,1.6 to Da.ne - 0,0.1
    line from Da.nw - 0,1.7 to Da.ne - 0,0.2
    line from Da.nw - 0,1.8 to Da.ne - 0,0.3
    line from Da.nw - 0,1.9 to Da.ne - 0,0.4
    line from Da.nw - 0,2.0 to Da.ne - 0,0.5
    line from Da.sw + 0.1,0 to Da.ne - 0,0.6
    line from Da.sw + 0.2,0 to Da.ne - 0,0.7
    line from Da.sw + 0.3,0 to Da.ne - 0,0.8
    line from Da.sw + 0.4,0 to Da.ne - 0,0.9
    line from Da.sw + 0.5,0 to Da.ne - 0,1.0
    line from Da.sw + 0.6,0 to Da.ne - 0,1.1
    line from Da.sw + 0.7,0 to Da.ne - 0,1.2
    line from Da.sw + 0.8,0 to Da.ne - 0,1.3
    line from Da.sw + 0.9,0 to Da.ne - 0,1.4
    line from Da.sw + 1.0,0 to Da.ne - 0,1.5
    line from Da.sw + 1.1,0 to Da.ne - 0,1.6
    line from Da.sw + 1.2,0 to Da.ne - 0,1.7
    line from Da.sw + 1.3,0 to Da.ne - 0,1.8
    line from Da.sw + 1.4,0 to Da.ne - 0,1.9
    move to Da.se + 0.5,0
At: line up 2.1i; line right 1.5i; line down 2i
    move left 1.45i; line right 1.5i; down
    arc from Here - 0,0.2i to Here rad 0.1i; move down 0.2i
    line left 1.5i; up; ellipsewid = 0.1i; ellipseht = 0.2i; ellipse
    move to Da.ne + 0.6i,0; move down 0.1i
    "name=otto" ljust; move down 0.12i
    "type=c" ljust; move down 0.12i
    "generation=4" ljust; move down 0.12i
    "revision=3" ljust; move down 0.12i
    "variant=" ljust; move down 0.12i
    "state=saved" ljust; move down 0.12i
    "author=andy" ljust; move down 0.12i
    "mode=0644" ljust; move down 0.12i
    "mdate=881001-12:22:34" ljust; move down 0.12i
    "sdate=881002-22:44:16" ljust; move down 0.12i
    "project=shape" ljust; move down 0.12i
    "testlevel=low" ljust; move down 0.12i
    "do_next=fix retrv-bug" ljust; move down 0.12i
    "..." ljust

    line from Da.ne - 0,0.9 right 0.5i up 0.1i
    line from Da.ne - 0,1.1 right 0.5i up 0.1i
.PE
.sp 5p
.ce
\fBFig. 2.2:\fR An Attributed software object
.sp 5p
.KE
.LP
\*(Af supports a set of standard attributes for each ASO.
These are
.IP \(bu 0.2i
hostname, system path, name, type,
.IP \(bu
generation number, revision number, variant name, version state,
.IP \(bu
owner, author,
.IP \(bu
size,
.IP \(bu
access permissions, lock,
.IP \(bu
date of last modification, \- last access, \- last status change,
\- saving and \- last lock change
.RE
.LP
The \fIsystem path\fR attribute is used to describe the (logical)
position of an ASO in a complex, hierarchically structured
system. \fISystem path, name\fR and
\fItype\fR are currently mapped to
.UX
pathnames where they take the place of path prefix, filename (without suffix)
and filename suffix. For example: the system path \fC/usr/axel\fR,
name \fCfoo\fR and type \fCc\fR are mapped to the
.UX
filename \fC/usr/axel/foo.c\fR.
Additionally to the \fIowner\fR attribute known from
.UX
files ASOs also have an \fIauthor\fR attribute.
\*(Af distinguishes the \fIowner\fR of an entire design object
and the \fIauthor\fR of a particular version. 
.LP
In addition to the standard attributes, an application may attach any
number of \fIuser defined attributes\fR to any ASO.
Interpretation and use of these attributes is left to the application
that uses them.
\*(Af manages user defined attributes as a structure containing
the attribute name and a (possibly empty) set of strings
holding the associated attribute value(s).
.LP
Attributes can be used for very different purposes.
The standard attributes are used mainly for ordering and 
identifying software objects and for general management.
User defined attributes will be used to store application
specific information with an ASO.
.LP
A typical example for the use of user defined attributes
can be found in the \*(sh program.
For each derived object (e.g. an object file that is produced by
compiling a C source file), the name of the transformation tool
and all given flags and parameters are protocoled in an
attribute.
Besides the description of the transformation process, the name(s)
and version(s) of the involved source
object(s) are recorded as list of values in another attribute.
This enables \*(sh to handle recompilations in a much more
sophisticated way than Make.
.LP
Another example might be a tiny program that allows a user
to associate any number of keywords with his software objects.
Such a program would allow a grouping of ASOs via keywords
independently of the directory structure.
User defined attributes can also be used to model references
between ASOs.
Attaching the identification of the corresponding source object
as attribute to a derived object actually \fIis\fR a reference.
.LP
The full power of the concept of user defined attributes is hardly 
used yet but we feel that there \fIis\fR a lot of power in this approach.
Our first application programs use this mechanism in a
straightforward manner (illustrated in the examples above) and it works fine.
User defined attributes may also be used in a more exotic way
such as to store patches (e.g. ed scripts generated by \fIdiff\fR)
to source objects.
.LP
On the basis of user defined attributes it will further be quite
easy to construct a general object class manager that
provides an interface for the storage of typed software
objects with type specific attributes.
This will be discussed in greater detail in chapter 4.
.NH 2
Identification and Object-Keys
.LP
Due to the introduction of versions, ASOs cannot be uniquely
identified by just giving their (path-)name (like in the
.UX
filesystem).
For the identification of attributed software objects, all attributes
are considered equally qualified.
\*(Af is equipped
with a retrieve interface for nonunique identification of sets of ASOs.
A retrieve operation is driven by an attribute pattern containing
all desired attribute values.
.LP
Once identified, an ASO is represented by a unique \fIObject-key\fR
by which it can be accessed further on.
Object keys can be fetched from a set, delivered by a retrieve
operation.
Selecting an object key from a set is supported by operations
for sorting sets by attribute values, recursive retrieve (a retrieve
operation with a set as search space) and building unions,
intersections, or differences between two sets.
.KF
.sp 5p
.PS
    boxwid = 0.6i; boxht = 0.6i; circlerad = 0.3i;
    circle "set of" "required" "attrs."; arrow right 0.15i
    box "AFS" "retrieve"; arrow right 0.15i
    circle "set of" "object" "keys"; arrow right 0.15i
    box "SELECT" "OBJECT" "KEY"; arrow right 0.15i
So: circle "single" "object key"
Ga: box "AFS" "get" "attributes" at So + 0.7i,0.4i
Ao: box "AFS" "open" at So + 0.7i,-0.4i; arrow right 0.15i
    circle "FILE" "descriptor"; arrow right 0.15i
    box "file-" "system" "I/O"
    arrow from So to Ao chop 
    arrow from So to Ga chop
.PE
.sp 5p
.ce
\fBFig. 2.3:\fR Access principle for ASOs
.sp 5p
.KE
.LP
Access to the attributes as well as the contents on an ASO is also
established via object keys.
To access its contents, an ASO has to be opened.
Once opened, the content data of an ASO can be read and written
as regular
.UX
files (see fig. 2.3).
.NH 2
Version Control
.LP
\*(Af maintains a sequence of \fIrevisions\fR (successive versions)
for each design object.
The numbering of revisions in a line of development is under control of
the \*(Af. Every time when a new revision is generated by saving
a copy of the busy object, it is assigned a version identification of the form
\fIgeneration.revision\fR (e.g. 1.0 or 4.3).
Generation numbers indicate major development steps that
are common to all components of a complex system.
The revision number serves as an update sequence number for individual
components within a generation.
.LP
Besides revisions, a version control system has to be able to store
\fIvariants\fR \- qualitatively equivalent versions differing in a
certain property \- of source objects.
A typical example for variants is a user interface module
that deals with different window systems.
Unlike the identification of revisions, where a generation.revision
numbering scheme turned out to be common sense, there is no
usual variant naming scheme.
We know systems, where variants are numbered, named (with single
or multiple names) or both.
.LP
The general management of variants is a major conceptual problem.
The idea of variants sounds quite simple, but
to actually handle them can be an extremely difficult task.
Up till now there doesn't seem to be a tool that conducts
the development of system variants in a really satisfying manner.
Nevertheless we want to establish a reasonable basis for
such a tool by providing an instructive and flexible
variant identification mechanism.
\*(Af supports a \fIvariant\fR attribute (a string) for each ASO.
The variant attribute is totally independent from the revision
numbering, i.e. each variant is stored in its own line of development
with independent revision numbering.
Any structure of the variant string (e.g. multiple variant names)
has to be maintained by the application(s) [5].
.NH 3
Branches
.LP
One major difference between the \*(Af builtin version control system
and classical systems like RCS [9]
and SCCS [8] 
is, that \*(Af establishes a user oriented view of versions
that abstracts from the physical derivation graph.
In contrary to RCS and SCCS,
version histories in \*(Af are essentially linear.
Logically, new versions are always appended to the end of the
version history.
Updates of older versions can be attached as leaves (not branches)
to the line of development (see fig 2.5).
Variants are stored in parallel lines of development.
.LP
At first glance, it looks like a loss of functionality of the \*(Af
version control system
compared to systems like RCS or SCCS (where are the branches).
A closer look shows, that there is only a different identification
scheme.
.LP
Figures 2.4 and 2.5.
show the same number of revisions/variants developed in the same way.
The first figure shows a RCS version tree and the second
shows its \*(Af pendant.
.KF
.sp 5p
.PS
    circlerad = 0.25i;
    box ht 3.1i wid 5.8i; move to 0.3i,0;
C1: circle "1.1"; arrow right 0.5i
C2: circle "1.2"; arrow right 0.5i
C3: circle "1.3"; arrow right 0.5i
C4: circle "2.1"; arrow right 0.5i
C5: circle "2.2"
C6: circle "1.1.1.1" at C1 + 0.5i,0.6i; arrow from C1 to C6 chop
C7: circle "1.2.1.1" at C2 + 0.5i,0.6i; arrow from C2 to C7 chop
C8: circle "1.3.1.1" at C3 + 0.5i,0.6i; arrow from C3 to C8 chop
C9: circle "1.2.3.1" at C2 + 0.5i,-0.6i; arrow from C2 to C9 chop
    move to right of C9; arrow right 0.4i;
C0: circle "1.2.3.2"; arrow right 0.4i; circle "1.2.3.3"
Ca: circle "1.2.2.1" at C2 + 0.3i,1.2i; arrow from C2 to Ca chop
    move to right of Ca; arrow right 1.8i; circle "1.2.2.2"
Cb: circle "1.2.3." "2.1.1" at C0 + 0.4i,-0.6i; arrow from C0 to Cb chop
.PE
.sp 5p
.ce
\fBFig. 2.4:\fR RCS version tree
.sp 5p
.KE
.KF
.sp 5p
.PS
    circlerad = 0.25i;
    move to 0,0.3i; box ht 1.3i wid 5.9i
    move to 0,1.4i; box ht 0.7i wid 5.9i
    move to 0,-1.1i; box ht 1.3i wid 5.9i; move to 0.3i,0;
C1: circle "1.0"; arrow right 0.5i
C2: circle "1.1"; arrow right 0.5i
C3: circle "1.2 / 2.0"; arrow right 0.5i
C4: circle "2.1"; arrow right 0.5i
C5: circle "2.2"
C6: circle "1.0" "fix1" at C1 + 0.5i,0.6i; arrow from C1 to C6 chop
C7: circle "1.1" "patch1" at C2 + 0.5i,0.6i; arrow from C2 to C7 chop
C8: circle "1.2" "fix1" at C3 + 0.5i,0.6i; arrow from C3 to C8 chop
    circle "1.0" "X" at C2 + 0.3i,1.4i; arrow right 1.8i; circle "1.2" "X"
C9: circle "1.1" "NeWS" at C2 + 0.5i,-1.4i; arrow right 0.4i;
C0: circle "1.2 / 2.0" "NeWS"; arrow right 0.4i; circle "2.1" "NeWS"
Cb: circle "1.2" "NeWS" "fix1" at C0 + 0.5i,0.6i; arrow from C0 to Cb chop
.PE
.sp 5p
.ce
\fBFig. 2.5:\fR AFS lines of development
.sp 5p
.KE
.LP
The version identification scheme of \*(Af abstracts from the
physical evolution of the single versions
(nevertheless, the physical links are there and maintained in
a way similar to RCS).
RCS and SCCS present a data structure oriented view
of version histories to the user.
Some nasty problems arise from mixing
logical and physical derivation graph in respect to numbering/naming
of revisions.
First, version numbers in branches get very complex (four or more numbers)
which is not very instructive. Second, although there are \(lqso many
numbers\(rq there is no generation number in branches !
.LP
Conceptually, \*(Af does not support arbitrary branching.
Branching off the main line of development happens most of the time 
because a developer wants to
.IP \(bu 0.2i
create a variant or
.IP \(bu
store modifications of older versions (bug-fixes or customizations) or
.IP \(bu
make experimental changes that should not necessarily
go into the main line of development.
.RE
.LP
The first case should be realized by parallel lines of development.
The latter two cases are not explicitly supported by
\*(Af itself.
A solution has to be given by an application program
either based on an extended use of
the \fIvariant\fR attribute or on storing patches in
user defined attributes.
.NH 3
The version status model
.LP
As a consequence of the original design of \*(Af as part of a
software development environment,
\*(Af provides a status model for saved source objects to support the
implementation of a general project organization scheme.
The project organization scheme we have in mind
distinguishes between private workspaces for each participating
programmer, and a central project database, where all the serious
results of the programmers' efforts are collected.
.LP
The basic status model that is built into the version control system
recognizes the following states:
.IP \fBbusy\fR 0.8i 
The object is under development and its contents may
be changed.
.IP \fBsaved\fR 
The object is saved and may be used for later backup.
.IP \fBproposed\fR
The object has been submitted for publication by the developer
but still needs formal approval by a quality assurance board
to become publically visible and accessible in the official
database.
.IP \fBpublished\fR
The object has passed the formal approval and is now accessible to
every member of the project. It is not yet accessed and may therefore
be withdrawn if necessary.
.IP \fBaccessed\fR 
The object has been published, and is now 
accessed by some members of the project.
.IP \fBfrozen\fR
The object may be part of a system configuration
that has been released to the outside world. This means it must under
no circumstances be destroyed.
.RE
.NH 1
Realization
.LP
Currently, we have two different implementations of \*(Af (in 
different development stages).
One on top of the
.UX
filesytem and another one on top of \*(Da,
a dedicated software engineering database [1].
Both are written in C and provide a library interface.
Further developments will be made in C++ and we will implement
a new interface in C++.
.LP
The interface of both implementations is nearly identical.
Differences exist only in marginal routines concerning the data
management. For example has the \*(Da implementation additional
routines for opening and closing the database.
.NH 2
The Interface
.LP
The main datatypes of \*(Af are:
.IP \(bu 0.2i
The \fIobject key\fR that uniquely identifies a software object.
The structure of this type is different in the two different
implementations. Consequently, application programs should handle
this type as opaque type and should not access single fields
(unfortunately this is a little bit clumsy in C \- an implementation
as C++ class would be more appropriate).
.IP \(bu
\fISet descriptors\fR represent a set of object keys.
A set descriptor contains information about the number of keys
in the set and a pointer to a list of object keys.
.IP \(bu
An \fIAttribute buffer\fR which is capable to hold all attributes of a
software object (standard attributes and user defined attributes).
Attribute buffers have two different purposes.
First, they can hold a retrieve pattern, i.e. they
may be (partially) filled with \fIdesired\fR attribute
values and then be passed as argument to a retrieve operation.
Second, an attribute buffer is used to return all attributes of
an identified ASO on demand.
.RE
.LP
The names of all operations of the \*(Af are preceded by \fIaf_\fR
(e.g. \fIaf_saverev\fR).
In the following sections, the most important (most interesting)
functions of \*(Af are described.
.NH 3
Retrieval
.LP
\*(Af provides two different retrieval operations, \fIaf_find\fR and
\fIaf_bpfind\fR. The first does retrieval of source objects and
the second of derived objects.
Both have to be parameterized with an attribute buffer containing
a retrieve pattern and both return a set holding the keys of all
ASOs matching the specified attribute pattern.
.LP
Due to the possibility to uniquely identify source objects by the
attributes \fIhostname, syspath, name, type, generation, revision\fR
and \fIvariant\fR, there is a shortcut (faster) operation to get the
key of well known object by specifying values for these seven
attributes. The name of the function is \fIaf_getkey\fR and it returns
an object key if the sought software object exists.
.NH 3
Sets
.LP
\*(Af contains a considerable number of operations on sets.
Although a set contains \fIobject keys\fR and not complete
objects, we speak of \(lqobjects in a set\(rq throughout this
chapter for reasons of simplicity.
.LP
\fIAf_sortset\fR sorts the objects in a set in respect to the
value of a single or compound attribute.
For example, objects can be ordered alphabetically by their
name attribute which is a single attribute.
A typical compound attribute is the \fIversion number\fR
consisting of generation number and revision number
(generation.revision).
Besides standard attributes one can pass any name of a user defined
attribute as argument to \fIaf_sortset\fR.
This works, even if the attribute is not defined for every
object in the set.
.LP
The call \fIaf_subset\fR performs a recursive retrieve operation on
an existing set. \fIAf_subset\fR is (like \fIaf_find\fR)
parameterized with an attribute buffer containing a retrieve pattern.
It results in a subset of the original set.
.LP
Other set commands provide
adding and deleting single objects to/from sets as well as
building intersections, unions and differences of two existing sets.
.NH 3
Reading and Manipulating Attributes
.LP
The manipulation of standard attributes for software objects
is under strict control of \*(Af.
Many standard attributes can only be modified implicitly
by performing a \*(Af operation.
The other standard attributes can only be manipulated in
a well defined manner.
.LP
The attributes \fIhostname, system path, name\fR and \fItype\fR
are immutable for saved objects (source or derived).
They are set once (at saving time) as inherited from the filesystem 
location of the file the object evolved from.
As busy objects are regular
.UX
files, they can be renamed by linking them to another place in
the filesystem.
.LP
Version number and the version state are only relevant
for source objects. 
A source object is automatically assigned a version number and state
\fIsaved\fR when it is
generated. The version number can subsequently only be increased
(set to a logically bigger number, e.g. from 1.2 to 1.4 or from
2.3 to 3.0).
The version state can be set to the logically following or
preceding (see states list in 2.4) state but it can never be
reset to \fIbusy\fR. 
Busy objects have no version number
and are always in state \fIbusy\fR.
Version number and state
of derived objects can be set arbitrarily (but \*(Af does not
care about their values).
.LP
The management of user defined attributes is entirely controlled by
the application program.
An application program called by the owner
or the author of an ASO can arbitrarily add, delete and modify
these attributes.
\*(Af supports the management of user defined attributes
by storing them as name/value(s) pairs.
A name (string) is associated with any number (zero to infinite)
of values (strings).
The function \fIaf_sudattr\fR allows the addition and deletion
of whole attribute entries and single values.
.NH 3
Locking
.LP
The locking mechanism for reserving update rights in a line
of development is reflected by the functions \fIaf_lock, af_unlock\fR
and \fIaf_testlock\fR.
Calling the function \fIaf_lock\fR, causes the identified ASO
to be locked by the caller, provided the object was available
for locking.
.LP
\fIAf_testlock\fR returns the user ID of the lock holder (if present). 
Locks can either be released by the lock holder of the design
object or be broken by the owner by means of \fIaf_unlock\fR.
.NH 3
Version Control
.LP
The version control system has been described in detail earlier in this paper.
The most important operations are \fIaf_saverev\fR and \fIaf_savebinary\fR
which create a copy of the given, busy, ASO and store it as
new source resp. derived version.
.LP
\fIAf_newgen\fR increases the generation number in a line of development.
It creates a pseudo revision which is identical to the last saved revision
and attaches a new version number to it.
The generated pseudo revision has the character of an alias (see also
figure 2.5).
The new version number is generated by increasing the generation number by 1
and resetting the revision number to 0 (e.g. 1.4 becomes 2.0).
.LP
If the busy object of a line of development was replaced by another file,
for example an older version or a variant,
\fIaf_setbusy\fR should be called with the key of the
old busy object and that of the new one, to inform \*(Af about the change.
This is necessary to keep track of the physical derivation structure of
a line of development which is substantially for an efficient delta
technique.
.NH 3
Filesystem Primitives
.LP
\fIAf_open\fR and \fIaf_close\fR are
filesystem primitives analogous to the
.UX
calls \fIfopen\fR and \fIfclose\fR.
The only difference is, that \fIaf_open\fR takes an object key instead
of a pathname as input parameter.
\fIAf_open\fR returns a pointer to a \fIFILE\fR structure, so that
the application program can use the whole
.UX
stdio interface on ASOs.
.LP
Additionally, ASOs can be created and removed (unlinked).
Derived files residing in a binary pool can be restored
at their former position with \fIaf_restore\fR.
.LP
The interface is completed by a number of miscellaneous
routines.
These are routines for error reporting and cleaning up
(removing tmp files and freeing memory) as well as functions
for splitting up
.UX
pathnames in the \*(Af attributes syspath, name and type.
.NH 2
\*(Af on top of the
.UX
filesystem
.LP
The first implementation of \*(Af was done on top of the
.UX
filesystem.
This implementation is ready and in use.
.LP
Saved ASOs are stored in archive files (like SCCS and RCS). \*(Af
maintains two archive files for each line of development of source
objects \- one holding the attributes and the other holding the data.
\*(Af stores its archives in a subdirectory called \*(Af. If the
archives shall be stored elsewhere but not in a subdirectory, an \*(Af
application can set an \fIarchive path\fR to specify the name of a
directory where all subsequently accessed or created archives are
stored. In this case, the application program
is responsible for maintaining the relative\-path relationship
between a busy object and the corresponding archive.
.LP
To save disk space,
Successive versions in a line of development are stored as deltas
(differences to the previous version).
For generating file deltas a new delta technique,
described in [7]
is employed.
Deltas computed by this method are about 30 percent smaller than deltas
generated by \fIdiff\fR (the standard
.UX
file comparison tool).
This delta technique uses characters rather than lines as atomic symbols.
.LP
We use a backward delta technique (like RCS),
i.e. only the most recent version of each line of development is
stored completely.
Older versions can be reconstructed by successively applying
all deltas from the most recent to the desired version.
In the filesystem implementation, deltas between parallel lines of
development are not supported (conceptually, they should be there).
This is because different lines of development are stored in
different archive files and we consider it too risky
to spread delta chains across different
.UX
files.
If the coherence of the two files gets lost (this may happen by simply
moving one file) and the chain gets broken, some revisions may
not be reproducible any more.
.LP
Derived files are stored physically unchanged.
Tests with our delta technique showed, that it makes not much
sense to build deltas between binary files.
On calling \fIaf_savebinary\fR, the identified file is linked into the
\*(Af subdirectory.
Additionally, the attribute buffer containing all the attributes
for the derived file is stored in a \fIndbm\fR Database.
.LP
If a saved source object shall be opened,
it is reconstructed and stored in a temporary file.
Due to the unalterability of saved ASOs, the temporary file is simply
removed on closing (changes have no effect on the stored ASO).
If one really wants to reconstruct a file, one has to create a
busy object, read the data from the tmp file and write it to the
created busy object.
.NH 2
\*(Af on top of \*(Da
.LP
The \*(Af implementation on top of \*(Da, is currently
under development.
In this implementation, saved revisions and binary pools are stored
in the database.
.LP
In the current implementation, the database is only used for storing the
internal data (archives and binary pools) of \*(Af.
Busy objects and temporary files (containing the data of reconstructed
older versions) are still stored in the
.UX
filesystem.
\*(Af applications have no direct access to the database.
Similar to the filesystem implementation, the contents of an ASO
has the form of a byte stream.
Up till now, there is no substantial difference of this impementation
to the filesystem implementation except that it will be slower.
.LP
The actual enhancement of \*(Af on \*(Da will be the possibility for
applications to use the structuring facilities of the database
for their internal data (the content data of ASOs).
But how shall a specific ASO be created, copied, or opened, and how
should a delta between two versions be constructed ?
Questions that can only be answered when the contents structure of the
corresponding ASO is known.
This problem can only be solved satisfactorily by following an
object oriented approach.
An \*(Af implementation taking this approach will provide a mechanism
for the definition of ASO classes, defining specific attributes
and virtual operations (e.g. compute delta, open, linearize)
on instances of these classes.
.LP
Another very practical problem is extensibility. In the current
state, a \*(Da database has \fIone\fR schema where all database
object types have to be defined.
Addition of a new application with the necessity of schema
updates requires the generation of an entire new database and the
(troublesome)
transfer of all the data from the old database to the new one.
.NH 1
The future of \*(Af
.LP
When we made the first design of \*(Af,
aimed primarily at facilitating the implementation of the
\*(sh\-toolkit,
we were not aware of the power of this approach.
Especially the mechanism of user defined attributes
inspired us to think of applications that go far beyond
the tasks \*(Af was originally designed for.
.LP
However, it is still a problem to make consistent use of user
defined attributes. Each application has to set them explicitly.
The exchange of information via user defined attributes
has to be subject of special agreements and naming conventions.
A good improvement will be the introduction of some kind of
ASO definition language.
This would be the input for a general class manager
that manages the storage of objects of well defined object classes.
The definition of an object class contains a specification
of all attributes attached to an object of this class.
The object classes will be part of a
class hierarchy with attribute inheritance.
This makes
\*(Af a basis for object\-oriented software engineering applications
that deal with software objects.
These are able to store
their objects persistently, identify them (uniquely) and share them
with other applications.
.LP
Subsequently we want to give an idea,
how a possible class hierarchy might look like.
Examples for classes are \fIsoftware object\fR, 
\fIsource object\fR, \fIderived object\fR or \fIrevisible object\fR.
The class \fIsoftware object\fR is the basic class.
All other classes are derived classes inheriting the attributes
of \fIsoftware object\fR.
\fISource objects\fR and \fIderived objects\fR
are direct subclasses of \fIsoftware object\fR.
\fIRevisible source object\fR would be a subclass of
\fIsource objects\fR  with the additional attributes 
\fIgeneration number, revision number\fR and \fIversion state\fR.
An example for defining a class hierarchy
for an object oriented database can be found in [11].
.LP
Another important topic is support for \*(Af
applications distributed over a local area network.
To support this, we need \fIpersistent keys\fR.
Unlike the current realization of object keys which are
only valid during the lifetime of the application process,
persistent keys are interchangeable between processes
and machines.
.NH 1
Conclusion
.LP
Properly speaking, \*(Af was invented by accident.
We needed a basic data storage system capable to hold the
software objects we deal with, plus some information about them
for use by our software configuration management toolkit.
After having made about 200 attempts\(dg
.FS
\(dg Actually we made only four or five, but 200 sounds better
.FE
to finally fix the set of attributes necessary to hold
sufficient information about
software objects, we gave up and invented the user
defined attributes instead.
One important inspiration for user defined attributes was the
environment concept known from the
.UX
shell.
Once available, the environment is extended by some new variable
almost each time a new tool is added to the system.
.LP
So we defined \*(Af as an internal interface.
While writing our first \*(Af applications, we got aware of
the power and the insufficiencies of the mechanism of
application defined attributes.
We believe that many applications might benefit from this concept,
and that it is too valuable to be just an internal interface.
Further development of \*(Af will primarily go into the direction
described in the previous chapter.
We are curious, where this way will lead us to.
.NH 1
Acknowledgement
.PP
This work is part of the \*(Un project. The project is supported by the
Bundesministerium f\*:ur Forschung und Technologie 
(Federal Ministry for Research and Technology) under grant ITS 8308.
.KS
.]<
.\"Dittrich.K-1986-1
.ds [F 1
.]-
.ds [A Klaus Dittrich
.as [A ", Willi Gotthard
.as [A ", and Peter C. Lockemann
.ds [T DAMOKLES. A Database System for Software Engineering Environments
.ds [J International Workshop on Advanced Programming Environments
.ds [P 351-371
.nr [P 1
.ds [I IFIP WG2.4
.ds [I Springer Verlag
.ds [C Trondheim, Norway
.ds [D June 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Feldman.S.I.-1979-2
.ds [F 2
.]-
.ds [A Stuart I. Feldman
.ds [T MAKE - A Program for Maintaining Computer Programs
.ds [J Software - Practice and Experience
.ds [V 9,3
.ds [P 255-265
.nr [P 1
.ds [D March 1979
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Leblang.D.B.-1985-3
.ds [F 3
.]-
.ds [A David B. Leblang
.as [A " and Gordon D. McLean, Jr.
.ds [T Configuration Management for Large-Scale Software Development Efforts
.ds [P 122-127
.nr [P 1
.ds [I GTE Laboratories
.ds [J Workshop on Software Engineering Environments for 
.as [J " Programming-in-the-Large
.ds [C Harwichport, Massachusets
.ds [D June 1985
.nr [T 0
.nr [A 1
.nr [O 0
.][ 1 journal-article
.\"Mahler.A-1988-4
.ds [F 4
.]-
.ds [A Axel Mahler
.as [A " and Andreas Lampen
.ds [T shape \- A Software Configuration Management Tool
.ds [J Proceedings of the International Workshop on Software Version and Configuration Control
.ds [I German Chapter of the ACM
.ds [I B.G. Teubner
.ds [P 228-243
.nr [P 1
.ds [C Grassau, West-Germany
.ds [D January 1988
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Mahler.A-1988-5
.ds [F 5
.]-
.ds [A Axel Mahler
.as [A " and Andreas Lampen
.ds [T A Toolkit for Software Configuration Management
.ds [J Proceedings of the Spring 1988 EUUG Conference
.ds [I European Unix systems User Group
.ds [P 185-202
.nr [P 1
.ds [C London, UK
.ds [D April 1988
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Nestor.J.R.-1986-6
.ds [F 6
.]-
.ds [A John R. Nestor
.ds [T Toward a Persistent Object Base
.ds [J International Workshop on Advanced Programming Environments
.ds [J Lecture Notes in Computer Science
.ds [C Trondheim, Norway
.ds [P 372-394
.nr [P 1
.ds [I Springer Verlag
.ds [D June 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Obst.W-1987-7
.ds [F 7
.]-
.ds [A Wolfgang Obst
.ds [T Delta Technique and String-to-String Correction
.ds [J Proceedings of the 1st European Software Engineering Conference
.ds [J Lecture Notes in Computer Science
.ds [P 69-73
.nr [P 1
.ds [I Springer Verlag
.ds [C Berlin
.ds [D September 1987
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Rochkind.M.J.-1975-8
.ds [F 8
.]-
.ds [A Marc J. Rochkind
.ds [T The Source Code Control System
.ds [J IEEE Transactions on Software Engineering
.ds [V SE-1
.ds [P 364-370
.nr [P 1
.ds [D 1975
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Tichy.W.F.-1985-9
.ds [F 9
.]-
.ds [A Walter F. Tichy
.ds [T RCS - A System for Version Control
.ds [J Software - Practice and Experience
.ds [V 15,7
.ds [P 637-654
.nr [P 1
.ds [D July 1985
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Tichy.W.F.-1988-10
.ds [F 10
.]-
.ds [A Walter F. Tichy
.ds [T Tools for Software Configuration Management
.ds [J Proceedings of the International Workshop on Software Version and Configuration Control
.ds [P 1-20
.nr [P 1
.ds [I B.G. Teubner
.ds [I German Chapter of the ACM
.ds [C Grassau, FRG
.ds [D January 1988
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.\"Zdonik.S.B.-1986-11
.ds [F 11
.]-
.ds [A Stanley B. Zdonik
.ds [T Version Management in an Object-Oriented Database
.ds [J Lecture Notes in Computer Science
.ds [J International Workshop on Advanced Programming Environments
.ds [C Trondheim, Norway
.ds [P 405-422
.nr [P 1
.ds [I Springer Verlag
.ds [D June 1986
.nr [T 0
.nr [A 0
.nr [O 0
.][ 1 journal-article
.]>
.KE
