/*
 * Copyright (C) 1989, 1990 W. Koch, A. Lampen, A. Mahler, W. Obst,
 *  and U. Pralle
 * 
 * This software is published on an as-is basis. There is ABSOLUTELY NO
 * WARRANTY for any part of this software to work correctly or as described
 * in the manuals. We do not accept any liability for any kind of damage
 * caused by use of this software, such as loss of data, time, money, or 
 * effort.
 * 
 * Permission is granted to use, copy, modify, or distribute any part of
 * this software as long as this is done without asking for charge, and
 * provided that this copyright notice is retained as part of the source
 * files. You may charge a distribution fee for the physical act of
 * transferring a copy, and you may at your option offer warranty
 * protection in exchange for a fee.
 * 
 * Direct questions to: Tech. Univ. Berlin
 * 		     Wilfried Koch
 * 		     Sekr. FR 5-6 
 * 		     Franklinstr. 28/29
 * 		     D-1000 Berlin 10, West Germany
 * 
 * 		     Tel: +49-30-314-22972
 * 		     E-mail: shape@coma.uucp or shape@db0tui62.bitnet
 */

/* ================================================== */
/* ================================================== */
/*                                                    */
/* MODULE-NAME: gedc        KEY : ge                  */
/*              = generate editor commands            */
/* ORIGINAL                                           */
/* AUTHOR : sibylle         DATE: 28/07/87            */
/*                                                    */
/* LAST UPDATE                                        */
/* AUTHOR :                 DATE:                     */
/*                                                    */
/* VERSION: 1.6.2                                     */
/*                                                    */
/* ================================================== */
/*                                                    */
/* PURPOSE:                                           */
/*                generation of editor commands;      */
/*                writing them into the delta file    */
/*                                                    */
/* SPECIALITIES:                                      */
/*                targetsize gets written into        */
/*                deltafile                           */                       
/*                                                    */
/* EXCEPTIONS, ERRORS:                                */
/*                none                                */
/*                                                    */
/* ================================================== */
/*                                                    */
/*
 * $Header: lcs.gedc.c[1.0] Wed Feb 22 16:14:22 1989 shape@coma save $
 */

# include "predef.h"
# include "typeconv.h"
# include <stdio.h>
# include "edcmd.h"


extern int fwrite();
extern int fclose();
extern FILE *fopen();


LOCAL char *trg_str = NIL;
LOCAL FILE *fdelta = (FILE *) NIL;


LOCAL void write_cmd (ecmd, indx)
     struct ed_cmd *ecmd;
     long indx;
{
  long cmd_ind;
  char *t_str = trg_str;
  
  cmd_ind = indx;
  if (ecmd->cmd == MV)
    {
      (void) fwrite ((char *)ecmd, sizeof (*ecmd), 1, fdelta);
      (void) fwrite ((char *)&cmd_ind, sizeof(cmd_ind), 1, fdelta);
    }
  else
    {
      (void) fwrite ((char *)ecmd, sizeof (*ecmd), 1, fdelta);
      (void) fwrite ((t_str = (t_str + cmd_ind)), sizeof(char), (Size_t)ecmd->length, fdelta);
    }

  return;
}



EXPORT void ge_init (deltafile, targetstr)
     char *deltafile, *targetstr;
{
  trg_str = targetstr;
  fdelta  = fopen (deltafile, "w");
  return;
}


EXPORT void ge_finit()
{
  (void) fclose (fdelta);
  return;
}


EXPORT void ge_move (indx, length)
     long indx, length;
{
  struct ed_cmd cmd;

  cmd.cmd = MV;
  cmd.length = length;
  write_cmd (&cmd, indx);

  return;
}


EXPORT void ge_add (indx, length)
     long indx, length;
{
  struct ed_cmd cmd;

  cmd.cmd = AD;
  cmd.length = length;
  write_cmd (&cmd, indx);
  return;
}



