/*
 * Copyright (C) 1989, 1990 W. Koch, A. Lampen, A. Mahler, W. Obst,
 *  and U. Pralle
 * 
 * This software is published on an as-is basis. There is ABSOLUTELY NO
 * WARRANTY for any part of this software to work correctly or as described
 * in the manuals. We do not accept any liability for any kind of damage
 * caused by use of this software, such as loss of data, time, money, or 
 * effort.
 * 
 * Permission is granted to use, copy, modify, or distribute any part of
 * this software as long as this is done without asking for charge, and
 * provided that this copyright notice is retained as part of the source
 * files. You may charge a distribution fee for the physical act of
 * transferring a copy, and you may at your option offer warranty
 * protection in exchange for a fee.
 * 
 * Direct questions to: Tech. Univ. Berlin
 * 		     Wilfried Koch
 * 		     Sekr. FR 5-6 
 * 		     Franklinstr. 28/29
 * 		     D-1000 Berlin 10, West Germany
 * 
 * 		     Tel: +49-30-314-22972
 * 		     E-mail: shape@coma.uucp or shape@db0tui62.bitnet
 */
/*
 * $Header: hash.h[2.1] Thu Feb 23 21:24:22 1989 axel@coma published $
 *
 * Log for /u/shape/dist-tape/src/misc/hash.h[1.1]
 * 	Thu Feb 23 21:24:22 1989 axel@coma save $
 *  --- empty log message ---
 *  hash.h[2.0] Thu Feb 23 21:24:22 1989 axel@coma published $
 *  --- empty log message ---
 *  hash.h[2.1] Thu Feb 23 21:24:22 1989 axel@coma published $
 *  --- empty log message ---
 */

/*
 * $Header: hash.h,v 2.0 88/06/29 16:14:46 axel Stable $
 *
 * $Log:	hash.h,v $
 * Revision 2.0  88/06/29  16:14:46  axel
 * New System Generation
 * 
 * Revision 1.1  88/06/07  17:10:11  axel
 * This version is part of a release
 * 
 */

#define NAMSZ 64   /* estimated max-size of names */
#define DEFHSIZE 521 /* default size of hashtable */

#define TRUE 1
#define FALSE 0

typedef struct hashent Hashent;		 

typedef struct hash Hash;

struct hashent { char    symbol[NAMSZ],
		         symval[NAMSZ];
		 Hashent *next;
	       };

struct hash { int     hsize,       /* No. of slots in hashtable */
		      (*fhash)();  /* Pointer to hash-function */
	      char    *cur_symval; /* Pointer to value of last retrvd. sym */
#ifdef CCOL
	      int     collcnt;
#endif
	      int     symcount;
	      Hashent *hashtb;     /* Anchor of hashtable */
	       };

