%a 40000
%p 20000
%o 10000

%{
/*
 * Copyright (C) 1989, 1990 W. Koch, A. Lampen, A. Mahler, W. Obst,
 *  and U. Pralle
 * 
 * This software is published on an as-is basis. There is ABSOLUTELY NO
 * WARRANTY for any part of this software to work correctly or as described
 * in the manuals. We do not accept any liability for any kind of damage
 * caused by use of this software, such as loss of data, time, money, or 
 * effort.
 * 
 * Permission is granted to use, copy, modify, or distribute any part of
 * this software as long as this is done without asking for charge, and
 * provided that this copyright notice is retained as part of the source
 * files. You may charge a distribution fee for the physical act of
 * transferring a copy, and you may at your option offer warranty
 * protection in exchange for a fee.
 * 
 * Direct questions to: Tech. Univ. Berlin
 * 		     Wilfried Koch
 * 		     Sekr. FR 5-6 
 * 		     Franklinstr. 28/29
 * 		     D-1000 Berlin 10, West Germany
 * 
 * 		     Tel: +49-30-314-22972
 * 		     E-mail: shape@coma.uucp or shape@db0tui62.bitnet
 */
/*
 *	Scanner for SHAPE
 */

#ifndef lint
static char *RCSid = "$Header: shape.l,v 3.1 89/02/14 11:06:40 wolfgang Exp $";
#endif
#ifndef lint
static char *ConfFlg = CFFLGS;	/* should be defined from within Makefile */
#endif
/*
 * $Log:	shape.l,v $
 * Revision 3.1  89/02/14  11:06:40  wolfgang
 * YYLMAX increased to 20000
 * 
 * Revision 3.0  89/01/24  11:35:50  wolfgang
 * New System Generation
 * 
 * Revision 2.13  89/01/18  13:17:10  wolfgang
 * bug fixed. didn't recognize lines with a single TAB as layout line.
 * 
 * Revision 2.12  89/01/03  13:10:56  wolfgang
 * changes done for lint
 * 
 * Revision 2.11  88/12/21  15:03:37  wolfgang
 * changes done for lint
 * 
 * Revision 2.10  88/11/21  15:49:23  wolfgang
 * return code of all malloc's checked
 * 
 * Revision 2.9  88/11/21  12:46:12  wolfgang
 * yyless deleted
 * 
 * Revision 2.8  88/10/18  17:42:31  wolfgang
 * new variant handling
 * 
 * Revision 2.7  88/10/06  15:41:10  wolfgang
 * no more macrodefs evaluated by lex
 * 
 * Revision 2.6  88/09/07  11:20:15  wolfgang
 * any2 changed ==> no comments are allowed within rule- or variant-section!
 * 
 * Revision 2.5  88/08/23  14:05:30  wolfgang
 * YYLMAX increased to 10000 (Scheiss LEX)
 * 
 * Revision 2.4  88/08/12  09:08:00  wolfgang
 * This version is part of a release
 * 
 * Revision 2.2  88/08/12  08:58:11  wolfgang
 * This version is part of a release
 * 
 */


#include <stdio.h>
#include <ctype.h>
#include "shape.h"

extern char *malloc();

extern struct hash *hashtab[];
extern char *sel_rule_name;
extern Bool synterrflg;
extern Bool Oldsuffs;
extern Bool Newsuffs;
extern char *shaperules;
extern char *stdsuff;
extern char *expandmacro();

extern int macrodef();
extern int ruledef();
extern int rulecont();
extern int ruleend();
extern int selruledef();
extern int vclassdef();
extern int errexit();
#undef YYLMAX
#define YYLMAX 20000  /* Scheiss LEX */
char *ppp;
extern char *suffs;
extern char *suffs;
Bool suffs_deleted = FALSE;
%}
%START RULEDEF RULESEC VARSEC
WhiteSpace	[ \t\n]
Layout		[ \t]
Blank		" "
Colon		":"
Period		"."
Semi		";"
Semiperiod	[;.]
Semicomma	[;,]
Layoutline	{Layout}*\n
Tab		\t
Notab		[^\t]
Any		.\n
Any2		[^#]
Anybutnewline	.
NC1		"\\\n"
NC3		"\\\n"
NC2		[^#\n]*
NC4		[^\n]*
Nocomment	({NC1}*|{NC2}?)*\n?
Nocomment2	({NC3}*|{NC4}?)*\n?
Macroname	[0-9a-zA-Z_-]
Vcl		"::=".*
Vclass		"vclass"{Layout}*{Ruledef}{Nocomment}
Macrodef	{Macroname}+{Layout}*"="{Layout}*{Nocomment}
Rulesecstart	"#%"{Layout}*"RULE-SECTION"{Layout}*
Rulesecend	"#%"{Layout}*"END-RULE-SECTION"{Layout}*
Selectionrule	{Rulesecstart}+{Any2}*{Rulesecend}+
Varsecstart	"#%"{Layout}*"VARIANT-SECTION"{Layout}*
Varsecend	"#%"{Layout}*"END-VARIANT-SECTION"{Layout}*
Depstart	[@%0-9a-zA-Z.\-/$("{""}")_~,]
Depcont		[@%0-9a-zA-Z.\-/\t $("{""}")_~,+]
Suff		[a-zA-Z0-9~,]
Ruledef		{Depstart}+{Depcont}*{Colon}+{Colon}*{Depcont}*{Nocomment}
Rulecont	{Tab}+{Nocomment2}
Others		[^#\n]
%%

{Selectionrule}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nSelection Rule: %s\n", yytext);
#endif DEBUG_LEX
(void) strcpy(yytext,expandmacro(yytext));
		selruledef(yytext);
		}

{Varsecstart}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nVariant Section Start: %s\n", yytext);
#endif DEBUG_LEX
		;
		BEGIN VARSEC;
		}

<VARSEC>^{Tab}{Macrodef}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nMacro in variant section: %s\n", yytext);
#endif DEBUG_LEX
		varmacrodef(yytext);
		}

<VARSEC>^{Layoutline}$	{
#ifdef DEBUG_LEX
		fprintf(yyout,"\n Layoutline in variant section\n");
#endif DEBUG_LEX
		}


<VARSEC>^"\n"	{
#ifdef DEBUG_LEX
		fprintf(yyout,"\n Empty line in variant section\n");
#endif DEBUG_LEX
		}

<VARSEC>{Ruledef}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nVariant name: %s\n", yytext);
#endif DEBUG_LEX
		varsec_name(yytext);
		}

<VARSEC>{Varsecend}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nVarsec end: %s\n", yytext);
#endif DEBUG_LEX
		;
		BEGIN 0;
		}

<VARSEC>{Vclass}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nvclass definition: %s\n", yytext);
#endif DEBUG_LEX
		vclassdef(yytext);		
		}


<RULEDEF>^{Macrodef}	{
		ruleend();
#ifdef DEBUG_LEX
		fprintf(yyout, "\n Ruledef end found\n");
		fprintf(yyout, "\nMacrodefinition: %s\n", yytext);
#endif DEBUG_LEX
		/* if (yytext[yyleng-1] == '\n')
		  	yytext[yyleng-1] = '\0';
		macrodef(yytext) */ ;
		BEGIN 0;
		}

<RULEDEF>{Varsecstart}	{
		ruleend();
#ifdef DEBUG_LEX
		fprintf(yyout, "\n Ruledef end found\n");
		fprintf(yyout, "\nVarsec start: %s\n", yytext);
#endif DEBUG_LEX
		/* if (yytext[yyleng-1] == '\n')
		  	yytext[yyleng-1] = '\0';
		macrodef(yytext) */ ;
		BEGIN VARSEC;
		}


^{Macrodef}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nMacrodefinition: %s\n", yytext);
#endif DEBUG_LEX
		/* if (yytext[yyleng-1] == '\n')
			yytext[yyleng-1] = '\0';
		macrodef(yytext) */ ;
		}

^{Rulesecstart}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\nRulesec starts: %s\n", yytext);
#endif DEBUG_LEX
		BEGIN RULESEC;
		}


^{Ruledef}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\n Rule: %s\n", yytext);
#endif DEBUG_LEX
		ruleend();
		if (yytext[yyleng-1] == '\n')
			yytext[yyleng-1] = '\0';
		if ((strncmp(yytext,".SUFFIXES:",10) == 0))
			{
			if((ppp = index(yytext,'%')) == NIL)
			/* old style suffix list */
				{
			        Oldsuffs = TRUE;
				ppp = yytext + 10;
				if (index(ppp,'.') != NIL)
					{
					if ((suffs = malloc((unsigned) 
					      (strlen(yytext) +
					       strlen(stdsuff) + 3))) == NIL)
					      errexit(10,"malloc");
					suffs[0] = '\0';
						(void) strcat(suffs,".SUFFIXES: ");
					if (!suffs_deleted)
						(void) strcat(suffs,stdsuff);
						(void) strcat(suffs,ppp);
					suffs_deleted = FALSE;
					}
				else
					{
					suffs_deleted = TRUE;
					}
				}
			else
				{
				/* new style suffixes */
				Newsuffs = TRUE;
				ppp = yytext + 10;
				if ((suffs =
				     malloc ((unsigned) 
				     (strlen(yytext) + strlen(shaperules)
					    + 3))) == NIL)
				      errexit(10,"malloc");
				suffs[0] = '\0';
					(void) strcat(suffs,".SUFFIXES");
				if (!suffs_deleted)
					(void) strcat(suffs,shaperules);
					(void) strcat(suffs,ppp);
				suffs_deleted = FALSE;
				}
#ifdef DEBUG_LEX
fprintf(yyout,"suffixes:%s\n", suffs);
#endif DEBUG_LEX
			}
		else	
			ruledef(yytext);		
		BEGIN RULEDEF;
		}

<RULEDEF>^{Layoutline}$	{
#ifdef DEBUG_LEX
		fprintf(yyout,"\n Layoutline in ruledef\n");
#endif DEBUG_LEX
		}

<RULEDEF>^{Rulecont}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\n Rulecont: %s\n", yytext);
#endif DEBUG_LEX
		/* strcpy(yytext,expandmacro(yytext)); */
		rulecont(yytext);		
		}



<RULEDEF>^{Notab}	{
#ifdef DEBUG_LEX
		fprintf(yyout, "\n Ruledef end found\n");
#endif DEBUG_LEX
		ruleend();
		yyless(yyleng-1);
		BEGIN 0;
		}
^{Layoutline}$	{
#ifdef DEBUG_LEX
		fprintf(yyout,"\n Layoutline\n");
#endif DEBUG_LEX
		}

^{Blank}*	{
#ifdef DEBUG_LEX
		fprintf(yyout,"\n Layoutline\n");
#endif DEBUG_LEX
		}

^{Tab}*		{
#ifdef DEBUG_LEX
		fprintf(yyout,"\n Layoutline\n");
#endif DEBUG_LEX
		}	

\n		{
		;
		}

^\n		{
		;
		}

{Others}*	{
		synterrflg = TRUE;
		errexit(14,yytext);
		BEGIN 0;
		}

%%
