/*
 * Copyright (C) 1989, 1990 W. Koch, A. Lampen, A. Mahler, W. Obst,
 *  and U. Pralle
 * 
 * This software is published on an as-is basis. There is ABSOLUTELY NO
 * WARRANTY for any part of this software to work correctly or as described
 * in the manuals. We do not accept any liability for any kind of damage
 * caused by use of this software, such as loss of data, time, money, or 
 * effort.
 * 
 * Permission is granted to use, copy, modify, or distribute any part of
 * this software as long as this is done without asking for charge, and
 * provided that this copyright notice is retained as part of the source
 * files. You may charge a distribution fee for the physical act of
 * transferring a copy, and you may at your option offer warranty
 * protection in exchange for a fee.
 * 
 * Direct questions to: Tech. Univ. Berlin
 * 		     Wilfried Koch
 * 		     Sekr. FR 5-6 
 * 		     Franklinstr. 28/29
 * 		     D-1000 Berlin 10, West Germany
 * 
 * 		     Tel: +49-30-314-22972
 * 		     E-mail: shape@coma.uucp or shape@db0tui62.bitnet
 */
/*
 * $Header: afsapp.h[3.10] Thu Feb 23 18:13:25 1989 axel@coma published $
 *
 * Log for /u/shape/dist-tape/src/vc/afsapp.h[3.7]
 * 	Thu Feb 23 18:13:25 1989 axel@coma published $
 *  --- empty log message ---
 *  afsapp.h[3.9] Thu Feb 23 18:13:25 1989 axel@coma published $
 *  --- empty log message ---
 *  afsapp.h[3.10] Thu Feb 23 18:13:25 1989 axel@coma published $
 *  --- empty log message ---
 */


/*
 *  The following definitions are used by most version control
 *  commands.
 */

#ifndef _TYPES_
#include <sys/types.h>
#define _TYPES_
#endif
#ifndef _TIME_
#include <sys/time.h>
#define _TIME_
#endif
#ifndef MAXNAMLEN
#include <sys/dir.h>
#endif
#include <setjmp.h>
#include "typeconv.h"

struct Transaction {
  char tr_fname[MAXNAMLEN];
  int tr_done;
  int tr_seqno;
  int tr_rc;
  jmp_buf tr_env;
};

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#define fail(x) ((x) == -1)
#define min(x,y) (((x) <= (y)) ? (x) : (y)) 
#define gen(x) (((x) >> 16) & 0x0000FFFF)
#define rev(x) ((x) & 0x0000FFFF)
#define vc_testlock_g(k) vc_testlock ((k), AF_GLOBALLOCK)
#define vc_testlock_v(k) vc_testlock ((k), AF_VERSIONLOCK)
#define vc_lock_g(k,u) vc_lock ((k), (u), AF_GLOBALLOCK)
#define vc_lock_v(k,u) vc_lock ((k), (u), AF_VERSIONLOCK)
#define vc_unlock_g(k) vc_unlock ((k), AF_GLOBALLOCK)
#define vc_unlock_v(k) vc_unlock ((k), AF_VERSIONLOCK)

#define NOSHELL 127

#define MAXTMPF 5
#define MAXSETS 64
#define MAXKEYS 64
#define MAXATTRBUFS 64

#define TYPEF 1
#define AFSET 2
#define AFKEY 3
#define AFATTRS 4
#define NEXT 1
#define REWIND 2

#define SYMNAME  "__SymbolicName__"
#define CLEAD  "__Clead__"
#define CLEADMAXLEN 32
#define INTENT "__Intent__=Intention for change:\n"
#define EMPTYINTENT "--- no intent expressed ---"
#define EMPTYNOTE "--- empty log message ---"

