c
c	draw - draw a line and set the hiding boundaries accorindingly
c
	subroutine draw(x1,y1,x2,y2)
	parameter(maxstp=8000)
	logical xaxs,yaxs,zaxs,abv,blw,xdir,ydir,print
	logical vertcl,hrzntl
	dimension above(maxstp),below(maxstp)
	common /b/ above,below
	common /d/ zlen,nx,ny,numstp,dlmnsm,dm,dl,small
	common /flag/ xaxs,yaxs,zaxs,abv,blw,xdir,ydir,print
	common /pos/ xpos,ypos
	if( x1 .eq. x2 .and. y1 .eq. y2 ) return
c		going left or right?
	isign = 1
	if ( x2 .lt. x1 ) isign = -1
	xpos = x1
	ypos = y1
	hrzntl	= .false.
c
c		if the line is vertical increase the number of points
c		in between.
c
	if ( abs(x2 - x1) .lt. dl ) then
		vertcl	= .true.
		dx	= (x2 - x1) / 30.0
		dy	= (y2 - y1) / 30.0
		if( abs(y2-y1) .lt. small ) hrzntl	= .true.
	else
		vertcl	= .false.
		dx	= isign * dl
		dy	= dl * (y2 - y1) / abs(x2 - x1)
	endif
	absdx	= abs( dx ) / 2.0 + small
	absdy	= abs( dy ) / 2.0 + small
	m	= ifix(x1*dm+1.01)
c
10	continue
	    if ( abv ) then
c
c			if hitting the boundary while approaching from above 
c			draw the line up to there.
c
		if ( y1 .lt. above(m) ) then
			if( print ) write(6,*)"		hit from above draw ",
     $							"to x1,y1",x1,y1
			call plot(xpos,ypos,3)
			call plot(x1,y1,2)
			abv	= .false.
			if( y1 .le. below(m) ) then
c			  	when no axis both flags are true in the begining
				blw = .true.
				if( blw ) below(m) = y1
			endif
		endif
c
c			if hitting the boundary while approaching from above 
c			draw the line up to there.
c
	    elseif( .not. blw ) then
		if( y1 .ge. above(m) ) then
			if( print ) write(6,*)"		hit abv fr mid dr ",
     $							"fr x1,y1",x1,y1
			xpos = x1
			ypos = y1
			abv	= .true.
		endif
		if( y1 .le. below(m) ) then
			if( print ) write(6,*)"		hit blw fr mid dr ",
     $							"fr x1,y1",x1,y1
			xpos = x1
			ypos = y1
			blw	= .true.
		endif
c					on the bottom 
	    else
		if ( y1 .gt. below(m) ) then
			call plot(xpos,ypos,3)
			call plot(x1,y1,2)
			if( print ) write(6,*)"		hit from below ", 
     $						"draw to x1,y1",x1,y1
			blw	= .false.
			if( y1 .ge. above(m) ) abv = .true.
		endif
	    endif
c		if line is vertical, the hiding limits have been or will 
c		be set by other segments below or above this segment,
c		unless it hits a line in the middle.
	    if( .not. vertcl ) then
		if( y1 .gt. above(m) ) then
			above(m) = y1
			abv	= .true.		
		endif
		if( y1 .lt. below(m) ) then
			below(m) = y1
			blw	= .true.
		endif
		m = m  +  isign
		if( m .lt. 1 .or. m .gt. maxstp ) then
			write(6,*)"exceeded the hiding boundary in draw.f"
			write(6,*)"draw(",x1,",",y1,",",x2,",",y2,")"
			stop
		endif
	    endif
c		JUST ADDED FOR TEST
	    if( .not. vertcl ) x1 = x1 + dx
	    y1 = y1 + dy
c	    if( vertcl ) then
c		if( y1 .gt. above(m) ) then
c			above(m) = y1
c		endif
c		if( y1 .lt. below(m) ) then
c			below(m) = y1
c		endif
c	    endif
c			if the line is vertical, compare the y components
	    if( vertcl ) then
		if( .not. hrzntl .and. abs(y2-y1) .gt. absdy ) go to 10
	    elseif( abs(x2 - x1) .gt. absdx ) then
		go to 10
	    endif
c
	if (abv .or. blw ) then
		if( print ) write(6,*)"		at end, draw to x1,y1",x2,y2
		call plot(xpos,ypos,3)
		call plot(x2,y2,2)
	else
		if( print ) write(6,*)"		at end, jump to x1,y1",x2,y2
		xpos = x2
		ypos = y2
	endif
	if( print ) then
		if( abv ) write(6,*)"				exit above" 
		if( blw ) write(6,*)"				exit below" 
		if( .not. (abv .or. blw) ) then
		  write(6,*)"					exit middle" 
		endif
	endif
	return
	end
