# @(#) descrip.mms 2.2 88/01/09 12:10:49
#Make Zoo for VAX/VMS
#
#The contents of this makefile are hereby released to the public domain.
#                                  -- Rahul Dhesi 1987/07/23

CC = cc
cswitch =
extra = /define=(BIG_MEM,NDEBUG,VMS)
ldswitch =

#List of all object files created for Zoo
ZOOOBJS = addbfcrc.obj, addfname.obj, basename.obj, comment.obj, -
 crcdefs.obj, getfile.obj, lzc.obj, lzd.obj, machine.obj, -
 makelist.obj, misc.obj, misc2.obj, nextfile.obj, -
 needed.obj, options.obj, parse.obj, portable.obj, prterror.obj, -
 version.obj, zoo.obj, zooadd.obj, zooadd2.obj, zoodel.obj, -
 zooext.obj, zoolist.obj, zoopack.obj

FIZOBJS = fiz.obj, addbfcrc.obj, portable.obj, crcdefs.obj

.c.obj :
	$(CC) $(cswitch) $(extra) $*.c

zoo.exe : $(ZOOOBJS)
	link/executable=zoo.exe $(ldswitch) $(ZOOOBJS), options/opt

#bigger but more portable across machines -- no shared libraries
zoobig.exe : $(ZOOOBJS)
	link/executable=zoobig.exe $(ldswitch) $(ZOOOBJS)

fiz : $(FIZOBJS)
	link/executable=fiz.exe $(ldswitch) $(FIZOBJS), options/opt

lzd.obj : lzd.c zoomem.h
	$(CC) $(cswitch) $(extra) $*.c

lzc.obj : lzc.c zoomem.h
	$(CC) $(cswitch) $(extra) $*.c

addbfcrc.obj : addbfcrc.c

addfname.obj : addfname.c

basename.obj : basename.c

comment.obj : comment.c zooio.h
	$(CC) $(cswitch) $(extra) $*.c

crcdefs.obj : crcdefs.c

getfile.obj : getfile.c zoomem.h
	$(CC) $(cswitch) $(extra) $*.c

machine.obj : machine.c nixtime.i vms.c
	$(CC) $(cswitch) $(extra) $*.c

makelist.obj : makelist.c

misc.obj : misc.c zooio.h
	$(CC) $(cswitch) $(extra) $*.c

misc2.obj : misc2.c zoomem.h
	$(CC) $(cswitch) $(extra) $*.c

options.obj : options.c

nextfile.obj :  nextfile.c

needed.obj : needed.c

parse.obj : parse.c

portable.obj : portable.c

prterror.obj : prterror.c

zoo.obj :   zoo.c zoomem.h errors.i
	$(CC) $(cswitch) $(extra) $*.c

zooadd.obj : zooio.h zooadd.c
	$(CC) $(cswitch) $(extra) $*.c

zooadd2.obj : zooio.h zooadd2.c
	$(CC) $(cswitch) $(extra) $*.c

zoodel.obj : zooio.h zoodel.c
	$(CC) $(cswitch) $(extra) $*.c

zooext.obj : zooext.c  errors.i zooio.h
	$(CC) $(cswitch) $(extra) $*.c

zoolist.obj : zooio.h zoolist.c
	$(CC) $(cswitch) $(extra) $*.c

zoopack.obj : zooio.h zoopack.c
	$(CC) $(cswitch) $(extra) $*.c
