.\"
.\" Copyright (C) 1989, 1990 W. Koch, A. Lampen, A. Mahler, W. Obst,
.\"  and U. Pralle
.\" 
.\" This software is published on an as-is basis. There is ABSOLUTELY NO
.\" WARRANTY for any part of this software to work correctly or as described
.\" in the manuals. We do not accept any liability for any kind of damage
.\" caused by use of this software, such as loss of data, time, money, or 
.\" effort.
.\" 
.\" Permission is granted to use, copy, modify, or distribute any part of
.\" this software as long as this is done without asking for charge, and
.\" provided that this copyright notice is retained as part of the source
.\" files. You may charge a distribution fee for the physical act of
.\" transferring a copy, and you may at your option offer warranty
.\" protection in exchange for a fee.
.\" 
.\" Direct questions to: Tech. Univ. Berlin
.\" 		     Wilfried Koch
.\" 		     Sekr. FR 5-6 
.\" 		     Franklinstr. 28/29
.\" 		     D-1000 Berlin 10, West Germany
.\" 
.\" 		     Tel: +49-30-314-22972
.\" 		     E-mail: shape@coma.uucp or shape@db0tui62.bitnet
.\" 
.IZ
.sp 1i
.nr PS 30
.ps \n(PS
.nr VS 33
.vs \n(VS
.ce 2
A tutorial introduction to the
\f(HB\s-1shape\s+1\fR-toolkit
.sp 1i
.nr PS 12
.ps \n(PS
.nr VS 14
.vs \n(VS
.ce 3
\fIWilfried Koch, Andreas Lampen, Axel Mahler, Wolfgang Obst, Uli Pralle\fR
Technische Universit\*:at Berlin
.sp 4i
.ce
Preliminary Draft (\n(dy.\n(mo.\n(yr)
.bp
.NH 1
About the status of this release
.PP
As you will see when going on reading, this tutorial is still very raw
and incomplete. Properly spoken it is just a small fragment of the
tutorial we plan to write. We put this on the distribution tape because
we think that a fragment of a tutorial is better than no
tutorial at all.
.NH 1
Introduction
.PP
The \*(sh-toolkit is a collection of programs to support
software configuration management in an
.UX
environment. It consists of a set of version control
commands and \*(sh, a significantly enhanced \fIMake-oid\fR. \*(sh and
the version control commands are integrated on top of AFS (Attributed
File System), a dedicated version object base. The system features
RCS-style version control and a configuration identification and
-build process that has full access to all revisions in the object
base (other than make which only knows about plain files).  AFS also
supports derived object management, i.e. it maintains a cache of
multiple versions of compiled object-files (e.g. compiled c-files with
different compile switches).
.PP
The \*(sh program itself is upward compatible to Make in that it can
properly handle conventional Makefiles. The \fIShapefile\fR however, uses
Makefile-style dependencies as (versionless) \fIabstract system model\fR
and employs \fIconfiguration selection rules\fR to dynamically bind
particular version objects in the object base to the names listed in
the system model. The version selection mechanism exploits AFS'
ability to maintain any number of arbitrary attributes for objects in
the object base.
On special request, \*(sh records an identified configuration in a
\fIconfiguration identification document\fR (CID) which has the form of
a completely bound Shapefile (all object-instances are explicit). This
makes it particularly easy to rebuild recorded configurations. As 
CID's are themselves documents, they can be placed under version control,
making it easy to maintain histories of entire software systems. 
.PP
The object base abstraction presented by AFS provides uniform access to
immutable revisions of data entities (files) stored in special
archives, and mutable regular
.UX
files. Consequently, the AFS based
toolkit lives peacefully (and meaningfully!) together with standard
filesystem applications (editors, compilers, formatters etc.).
Cooperative work within projects is supported by a build-in status
model, controlling visibility of version objects, and locking, a
primitive form of \fIlong transactions\fR. The general concept of object
attributes provides for passing information between individual tools
that would otherwise be lost. This mechanism is useful for building
integrated environments from a set of unrelated tools.
.bp
.so make2shape.ms
.bp
.so trouble.ms
